<?php
/**
 * @copyright	Copyright (C) 2009-2011 ACYBA SARL - All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingMightymembership extends JPlugin
{

	function plgAcymailingMightymembership(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin =& JPluginHelper::getPlugin('acymailing', 'mightymembership');
			$this->params = new JParameter( $plugin->params );
		}
	}

 	function onAcyDisplayFilters(&$type){
		$db =& JFactory::getDBO();
		$db->setQuery("SELECT `name`,`id` FROM #__jcs_plans ORDER BY `ordering` ASC");
		$allGroups = $db->loadObjectList();
		if(empty($allGroups)) return;

		$firstGroup = null;
		$firstGroup->name = JText::_('ACY_ALL');
		$firstGroup->id = 0;
		array_unshift($allGroups,$firstGroup);

		$type['mightymembership'] = 'Mighty Membership';

		$inoperator = acymailing::get('type.operatorsin');

		$return = '<div id="filter__num__mightymembership">';
		$inoperator->js = 'onchange="countresults(__num__)"';
		$return .= $inoperator->display("filter[__num__][mightymembership][type]").' '.JHTML::_('select.genericlist',   $allGroups, "filter[__num__][mightymembership][plan]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'id', 'name');
		$return .= '<br /><input name="filter[__num__][mightymembership][subscription_date_inf]" onchange="countresults(__num__)" value=""/> < '.JText::_('CREATED_DATE').' < <input name="filter[__num__][mightymembership][subscription_date_sup]" onchange="countresults(__num__)" value=""/>';
		$return .= '<br /><input name="filter[__num__][mightymembership][expiry_date_inf]" onchange="countresults(__num__)" value="'.date('Y-m-d').'"/> < '.JText::_('EXPIRY_DATE').' < <input name="filter[__num__][mightymembership][expiry_date_sup]" onchange="countresults(__num__)" value=""/>';

		$return .= '</div>';
		return $return;

	 }
	 function onAcyProcessFilterCount_mightymembership(&$query,$filter,$num){
		$db = JFactory::getDBO();
	 	$lj = "SELECT count(sub.subid) FROM #__acymailing_subscriber as sub LEFT JOIN ";
	 	$lj .= $this->_wherelj($filter,$num);

	 	$operator = ($filter['type'] == 'IN') ? 'IS NOT NULL' : "IS NULL";
	 	$lj .= " WHERE mightymembership$num.`user_id` ".$operator;

	 	$db->setQuery($lj);
	 	$nbSubscribers = $db->loadResult();
	 	return JText::sprintf('SELECTED_USERS',$nbSubscribers);
	 }

	 function onAcyProcessFilter_mightymembership(&$query,$filter,$num){

	 	$query->leftjoin['mightymembership_'.$num] =  $this->_wherelj($filter,$num);

	 	$operator = ($filter['type'] == 'IN') ? 'IS NOT NULL' : "IS NULL";
	 	$query->where[] = "mightymembership$num.`user_id` ".$operator;
	 }

	 function _wherelj($filter,$num){
	 	$db = JFactory::getDBO();
	 	$lj = "`#__jcs_user_subscr` as mightymembership$num ON mightymembership$num.`user_id` = sub.`userid`";
	 	if(!empty($filter['plan']))
	 	{
	 		  $lj .= " AND mightymembership$num.subscription_id = ".$filter['plan'];
	 	}

	 	if(!empty($filter['subscription_date_inf'])){
	 		$filter['subscription_date_inf'] = acymailing::replaceDate($filter['subscription_date_inf']);
	 		if(is_numeric($filter['subscription_date_inf'])) $filter['subscription_date_inf'] = date('Y-m-d H:i',$filter['subscription_date_inf']);
	 		$lj .= " AND mightymembership$num.`ctime` > ".$db->Quote($filter['subscription_date_inf']);
	 	}
	 	if(!empty($filter['subscription_date_sup'])){
	 		$filter['subscription_date_sup'] = acymailing::replaceDate($filter['subscription_date_sup']);
	 		if(is_numeric($filter['subscription_date_sup'])) $filter['subscription_date_sup'] = date('Y-m-d H:i',$filter['subscription_date_sup']);
	 		$lj .= " AND mightymembership$num.`ctime` < ".$db->Quote($filter['subscription_date_sup']);
	 	}
	 	if(!empty($filter['expiry_date_inf'])){
	 		$filter['expiry_date_inf'] = acymailing::replaceDate($filter['expiry_date_inf']);
	 		if(is_numeric($filter['expiry_date_inf'])) $filter['expiry_date_inf'] = date('Y-m-d H:i',$filter['expiry_date_inf']);
	 		$lj .= " AND mightymembership$num.`extime` > ".$db->Quote($filter['expiry_date_inf']);
	 	}
	 	if(!empty($filter['expiry_date_sup'])){
	 		$filter['expiry_date_sup'] = acymailing::replaceDate($filter['expiry_date_sup']);
	 		if(is_numeric($filter['expiry_date_sup'])) $filter['expiry_date_sup'] = date('Y-m-d H:i',$filter['expiry_date_sup']);
	 		$lj .= " AND mightymembership$num.`extime` < ".$db->Quote($filter['expiry_date_sup']);
	 	}

	 	return $lj;
	 }
}//endclass