<?php
class acyboard extends acymailingClass
{
	var $width;
	var $height;
	var $format;

	function  __construct( $config = array() ){
		$this->db = JFactory::getDBO();
		return parent::__construct($config);
	}

	private function create_div($id){
		echo '<div id="'.$id.'" style="width:'.$this->width.'px; height:'.$this->height.'px;float:left;margin-top:10px;" ></div>';
	}

	/**
	 * Shows the number of new users per month
	 */
	function new_user_month(){
		$this->db->setQuery('SELECT COUNT(subid) AS subnb, DATE_FORMAT(FROM_UNIXTIME(created),"%Y-%m") AS month FROM #__acymailing_subscriber WHERE created > '.(time()-63072000).' GROUP BY month');
		$allSubscribers = $this->db->loadObjectList('month');

		$currentDate = explode('-',date('m-Y'));
		$datetmp = $currentDate;
		$arraydate = array();
		for($i=0 ; $i<24 ; $i++){
			$arraydate[$i] = array();
			$arraydate[$i]['date'] = date($this->format, strtotime($datetmp[1].'-'.$datetmp[0].'-01'));
			if(isset($allSubscribers[$datetmp[1].'-'.$datetmp[0]])) $arraydate[$i]['new_users'] = $allSubscribers[$datetmp[1].'-'.$datetmp[0]]->subnb;
			else $arraydate[$i]['new_users'] = 0;

			if($datetmp[0] == 1){
				$datetmp[0] = 12;
				$datetmp[1]--;
			}else{
				$datetmp[0]--;
			}

			if(strlen($datetmp[0]) < 2) $datetmp[0] = '0'.$datetmp[0];
		}

		// Remove empty values from the oldest date
		while($arraydate[count($arraydate)-1]['new_users'] == 0){
			unset($arraydate[count($arraydate)-1]);
			if(count($arraydate)-1 < 0) break;
		}
		if(empty($arraydate)) return;
		?>
		<script type="text/javascript">
		<!--
			// Load the Visualization API and the piechart package.
			google.load('visualization', '1.0', {'packages':['corechart']});

			// Set a callback to run when the Google Visualization API is loaded.
			google.setOnLoadCallback(drawChart);

			// Callback that creates and populates a data table,
			// instantiates the pie chart, passes in the data and
			// draws it.
			function drawChart() {

				// Create the data table
				var data = google.visualization.arrayToDataTable([
					['Month', 'New Users'],
					<?php
						for($i=count($arraydate)-1 ; $i>=0 ; $i--){
							$var = "['".$arraydate[$i]['date']."',".$arraydate[$i]['new_users']."]";
							if($i!=0){$var = $var.",\n\t\t\t\t\t\t";}
							echo $var;
						}
					?>
				]);

				// Set chart options
				var options = {
					'title':'New users per month',
					'width':<?php echo $this->width; ?>,
					'height':<?php echo $this->height; ?>,
					'legend':'none'
				};
				// Instantiate and draw our chart, passing in some options.
				var chart = new google.visualization.LineChart(document.getElementById('new_user_month'));
				chart.draw(data, options);
			}
		-->
		</script>
		<?php
		$this->create_div('new_user_month');
	}

	/**
	 * Shows the number of new users per week
	 */
	function new_user_week(){
		$this->db->setQuery('SELECT COUNT(subid) AS subnb, DATE_FORMAT(FROM_UNIXTIME(created),"%Y-%u") AS week FROM #__acymailing_subscriber WHERE created > '.(time()-14515200).' GROUP BY week');
		$allSubscribers = $this->db->loadObjectList('week');

		$currentDayInWeek = date('N')-1;
		// Week number - day - month - year of the current week's monday
		$datetmp = explode('-',date('W-d-m-Y', time()-(86400*$currentDayInWeek)));

		$arraydate = array();
		for($i=0 ; $i<24 ; $i++){
			$arraydate[$i] = array();
			$arraydate[$i]['date'] = date($this->format, strtotime($datetmp[3].'-'.$datetmp[2].'-'.$datetmp[1]));
			if(isset($allSubscribers[$datetmp[3].'-'.$datetmp[0]])) $arraydate[$i]['new_users'] = $allSubscribers[$datetmp[3].'-'.$datetmp[0]]->subnb;
			else $arraydate[$i]['new_users'] = 0;

			$datetmp = explode('-',date('W-d-m-Y', time()-(86400*($currentDayInWeek+7*($i+1)))));
		}

		while($arraydate[count($arraydate)-1]['new_users'] == 0){
			unset($arraydate[count($arraydate)-1]);
			if(count($arraydate)-1 < 0) break;
		}
		if(empty($arraydate)) return;
		?>
		<script type="text/javascript">
		<!--
			// Load the Visualization API and the piechart package.
			google.load('visualization', '1.0', {'packages':['corechart']});

			// Set a callback to run when the Google Visualization API is loaded.
			google.setOnLoadCallback(drawChart);

			// Callback that creates and populates a data table,
			// instantiates the pie chart, passes in the data and
			// draws it.
			function drawChart() {
				// Create the data table.
				var data = google.visualization.arrayToDataTable([
					['Week', 'New Users'],
					<?php
						for($i=count($arraydate)-1 ; $i>=0 ; $i--){
							$var = "['".$arraydate[$i]['date']."',".$arraydate[$i]['new_users']."]";
							if($i!=0){$var = $var.",\n\t\t\t\t\t\t";}
							echo $var;
						}
					?>
				]);

				// Set chart options
				var options = {
					'title':'New users per week',
					'width':<?php echo $this->width; ?>,
					'height':<?php echo $this->height; ?>,
					'legend':'none'
				};
				// Instantiate and draw our chart, passing in some options.
				var chart = new google.visualization.LineChart(document.getElementById('new_user_week'));
				chart.draw(data, options);
			}
		-->
		</script>
		<?php
		$this->create_div('new_user_week');
	}

	/**
	 * Last newsletter's stats
	 */
	function last_news(){
		$this->db->setQuery('SELECT m.subject, s.senthtml, senttext, s.openunique, s.bounceunique, s.fail, s.clickunique
							FROM #__acymailing_stats AS s
							JOIN #__acymailing_mail AS m
								ON s.mailid = m.mailid
							WHERE m.type = "news"
							ORDER BY s.senddate DESC');
		$stats = $this->db->loadObject();

		if($this->db->getAffectedRows() < 1) return;
		?>
		<script type="text/javascript">
		<!--
			// Load the Visualization API and the piechart package.
			google.load('visualization', '1.0', {'packages':['corechart']});

			// Set a callback to run when the Google Visualization API is loaded.
			google.setOnLoadCallback(drawChart);

			// Callback that creates and populates a data table,
			// instantiates the pie chart, passes in the data and
			// draws it.
			function drawChart() {
				// Create the data table.
				var data = new google.visualization.DataTable();
				data.addColumn('string', 'State');
				data.addColumn('number', 'People');
				data.addRows([
					['<?php echo $this->jtext('FAILED'); ?>', <?php echo $stats->fail; ?>],
					['<?php echo $this->jtext('ACTION_BOUNCE'); ?>', <?php echo $stats->bounceunique; ?>],
					['<?php echo $this->jtext('NOT_OPEN'); ?>', <?php echo $stats->senthtml + $stats->senttext - $stats->fail - $stats->bounceunique - $stats->openunique; ?>],
					['<?php echo $this->jtext('OPEN').' (That didn\\\'t click a link)'; ?>', <?php echo $stats->openunique - $stats->clickunique; ?>],
					['<?php echo $this->jtext('OPEN').' ('.JText::_('CLICKED_LINK').')'; ?>', <?php echo $stats->clickunique; ?>]
				]);

				// Set chart options
				var options = {
					'title':'<?php echo $this->jtext('NEWSLETTER'); ?> : <?php echo $stats->subject; ?>',
					'width':<?php echo $this->width; ?>,
					'height':<?php echo $this->height; ?>
				};
				// Instantiate and draw our chart, passing in some options.
				var chart = new google.visualization.PieChart(document.getElementById('last_news'));
				chart.draw(data, options);
			}
		-->
		</script>

		<?php
		$this->create_div('last_news');
	}

	/**
	 * Amount of users per list
	 */
	function user_list(){
		$this->db->setQuery('SELECT l.listid, l.name, ls.status, COUNT(ls.subid) AS usernb
							FROM #__acymailing_listsub AS ls
							JOIN #__acymailing_list AS l
								ON l.listid = ls.listid
							WHERE l.type = "list"
							GROUP BY ls.listid, ls.status');
		$statisticsList = $this->db->loadObjectList();

		$stat_userlist = array();
		foreach($statisticsList as $list){
			if(empty($stat_userlist[$list->listid])){
				$stat_userlist[$list->listid] = array();
				$stat_userlist[$list->listid]['name'] = $list->name;
			}
			$stat_userlist[$list->listid][$list->status] = $list->usernb;
		}

		if(empty($stat_userlist)) return;
		?>
		<script type="text/javascript">
			// Load the Visualization API and the piechart package.
			google.load('visualization', '1.0', {'packages':['corechart']});

			// Set a callback to run when the Google Visualization API is loaded.
			google.setOnLoadCallback(drawChart);

			// Callback that creates and populates a data table,
			// instantiates the pie chart, passes in the data and
			// draws it.
			function drawChart() {
				// Create the data table.
				var data = google.visualization.arrayToDataTable([
					['<?php echo $this->jtext('ACY_TYPE'); ?>','<?php echo $this->jtext('SUBSCRIBED'); ?>','<?php echo $this->jtext('UNSUBSCRIBED'); ?>','<?php echo $this->jtext('PENDING_SUBSCRIPTION'); ?>'],
					<?php
						foreach($stat_userlist as $listid => $listInfo ){
							$var = "['".str_replace("'", "\'", $listInfo['name'])."',";
							$var .= (!empty($listInfo['1'])?$listInfo['1']:'0').",";
							$var .= (!empty($listInfo['-1'])?$listInfo['-1']:'0').",";
							$var .= (!empty($listInfo['2'])?$listInfo['2']:'0')."]";
							$var .= ",\n\t\t\t\t\t\t";
							echo $var;
						}
					?>
				]);

				// Set chart options
				var options = {
					'title':'<?php echo $this->jtext('STATS_PER_LIST'); ?>',
					'width':<?php echo $this->width; ?>,
					'height':<?php echo $this->height; ?>,
					'isStacked': true
				};
				// Instantiate and draw our chart, passing in some options.
				var chart = new google.visualization.ColumnChart(document.getElementById('user_list'));
				chart.draw(data, options);
			}
		</script>
		<?php
		$this->create_div('user_list');
	}

	/**
	 * Emails sent per week
	 */
	function mail_sent(){
		//$this->db->setQuery('SELECT senthtml,senttext,senddate FROM #__acymailing_stats');
		$this->db->setQuery('SELECT COUNT(subid) sentnb, DATE_FORMAT(FROM_UNIXTIME(senddate),"%Y-%u") AS week FROM #__acymailing_userstats WHERE senddate > '.(time()-14515200).' GROUP BY week');
		$statistics = $this->db->loadObjectList('week');

		$currentDayInWeek = date('N')-1;
		// Week number - day - month - year of the current week's monday
		$datetmp = explode('-',date('W-d-m-Y', time()-(86400*$currentDayInWeek)));

		$arraydate = array();
		for($i=0 ; $i<24 ; $i++){
			$arraydate[$i] = array();
			$arraydate[$i]['date'] = date($this->format, strtotime($datetmp[3].'-'.$datetmp[2].'-'.$datetmp[1]));
			if(isset($statistics[$datetmp[3].'-'.$datetmp[0]])) $arraydate[$i]['sentnb'] = $statistics[$datetmp[3].'-'.$datetmp[0]]->sentnb;
			else $arraydate[$i]['sentnb'] = 0;

			$datetmp = explode('-',date('W-d-m-Y', time()-(86400*($currentDayInWeek+7*($i+1)))));
		}

		while(count($arraydate) > 0 && $arraydate[count($arraydate)-1]['sentnb'] == 0){
			unset($arraydate[count($arraydate)-1]);
		} ?>
		<script type="text/javascript">
			// Load the Visualization API and the piechart package.
			google.load('visualization', '1.0', {'packages':['corechart']});

			// Set a callback to run when the Google Visualization API is loaded.
			google.setOnLoadCallback(drawChart);

			// Callback that creates and populates a data table,
			// instantiates the pie chart, passes in the data and
			// draws it.
			function drawChart() {
				// Create the data table.
				var data = google.visualization.arrayToDataTable([
					['Week', '<?php echo $this->jtext('ACY_SENT_EMAILS'); ?>'],
					<?php
						for($i=count($arraydate)-1 ; $i>=0 ; $i--){
							$var = "['".$arraydate[$i]['date']."',".$arraydate[$i]['sentnb']."]";
							if($i!=0){$var = $var.",\n\t\t\t\t\t\t";}
							echo $var;
						}
					?>
				]);

				// Set chart options
				var options = {
					'title':'Emails sent per week',
					'width':<?php echo $this->width; ?>,
					'height':<?php echo $this->height; ?>,
					'legend':'none'
				};
				// Instantiate and draw our chart, passing in some options.
				var chart = new google.visualization.ColumnChart(document.getElementById('mail_sent'));
				chart.draw(data, options);
			}
		</script>
		<?php
		$this->create_div('mail_sent');
	}

	/**
	 * Stats per newsletter
	 */
	function email_news(){
		$this->db->setQuery('SELECT m.subject, s.*
							FROM #__acymailing_stats AS s
							JOIN #__acymailing_mail AS m
								ON s.mailid = m.mailid
							WHERE m.type = "news"
							ORDER BY s.senddate DESC
							LIMIT 10');
		$statistics = $this->db->loadObjectList();
		$j = 0;
		$stat_email_news = array();
		foreach($statistics as $list){
			$stat_email_news[$j] = array();
			$stat_email_news[$j]['news_name'] = $list->subject;
			$stat_email_news[$j]['fail'] = $list->fail;
			$stat_email_news[$j]['bounce'] = $list->bounceunique;
			$stat_email_news[$j]['not_open'] = $list->senthtml + $list->senttext - $list->fail - $list->bounceunique - $list->openunique;
			$stat_email_news[$j]['open_no_click'] = $list->openunique - $list->clickunique;
			$stat_email_news[$j]['open_click'] = $list->clickunique;
			$stat_email_news[$j]['unsub'] = $list->unsub;
			$j++;
		}
		if(empty($stat_email_news)) return;
		?>
		<script type="text/javascript">
			// Load the Visualization API and the piechart package.
			google.load('visualization', '1.0', {'packages':['corechart']});

			// Set a callback to run when the Google Visualization API is loaded.
			google.setOnLoadCallback(drawChart);

			// Callback that creates and populates a data table,
			// instantiates the pie chart, passes in the data and
			// draws it.
			function drawChart() {
				// Create the data table.
				var data = google.visualization.arrayToDataTable([
					['Newsletter','<?php echo $this->jtext('FAILED'); ?>','<?php echo $this->jtext('ACTION_BOUNCE'); ?>','<?php echo $this->jtext('NOT_OPEN'); ?>','<?php echo $this->jtext('OPEN').' (That didn\\\'t click a link)'; ?>','<?php echo $this->jtext('OPEN').' ('.JText::_('CLICKED_LINK').')'; ?>','<?php echo $this->jtext('UNSUBSCRIBED'); ?>', { role: 'annotation' } ],
					<?php
						for($i = 0;$i<count($stat_email_news);$i++){
							$var = "['".$stat_email_news[$i]['news_name']."',".$stat_email_news[$i]['fail'].",".$stat_email_news[$i]['bounce'].",".$stat_email_news[$i]['not_open'].",".$stat_email_news[$i]['open_no_click'].",".$stat_email_news[$i]['open_click'].",".$stat_email_news[$i]['unsub'].",'']";
							if($i != count($stat_email_news)-1){$var = $var.",\n\t\t\t\t\t\t";}
							echo $var;
						}
					?>
				]);

				// Set chart options
				var options = {
					'title':'<?php echo $this->jtext('STATISTICS'); ?>',
					'width':<?php echo $this->width; ?>,
					'height':<?php echo $this->height; ?>,
					'isStacked': true
				};
				// Instantiate and draw our chart, passing in some options.
				var chart = new google.visualization.ColumnChart(document.getElementById('email_news'));
				chart.draw(data, options);
			}
		</script>
		<?php
		$this->create_div('email_news');
	}

	function jtext($key){
		return str_replace("'","\\'",JText::_($key));
	}
}