<?php
/**
 * @copyright	Copyright (C) 2009-2015 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingAdagency extends JPlugin
{
	function plgAcymailingAdagency(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'adagency');
			$this->params = new JParameter( $plugin->params );
		}
	}

	function onAcyDisplayFilters(&$type,$context="massactions"){

		if($this->params->get('displayfilter_'.$context,true) == false) return;
		$type['adagency'] = 'Ad Agency';

		$db = JFactory::getDBO();
		$fields = acymailing_getColumns('#__ad_agency_advertis');
		if(empty($fields)) return '<div id="filter__num__adagency">The AD Agency fields couls not be found. This component may have changed its database structure, please contact us at support@acyba.com and send us the latest version of AD Agency so we can test it and update this pluign.</div>';

		$dispfield = array();
		foreach($fields as $oneField => $fieldType){
			$dispfield[] = JHTML::_('select.option',$oneField,$oneField);
		}

		$jsOnChange = "displayCondFilter('displayAdAgencyValues', 'toChange__num__',__num__,'map='+document.getElementById('filter__num__adagencymap').value+'&cond='+document.getElementById('filter__num__adagencyoperator').value+'&value='+document.getElementById('filter__num__adagencyvalue').value);";

		$operators = acymailing_get('type.operators');
		$operators->extra = 'onchange="'.$jsOnChange.'"';

		$return = '<div id="filter__num__adagency">'.JHTML::_('select.genericlist',   $dispfield, "filter[__num__][adagency][map]", 'onchange="'.$jsOnChange.'" class="inputbox" size="1"', 'value', 'text');
		$return.= ' '.$operators->display("filter[__num__][adagency][operator]").' <span id="toChange__num__"><input onchange="countresults(__num__)" class="inputbox" type="text" name="filter[__num__][adagency][value]" style="width:200px" value="" id="filter__num__adagencyvalue"/></span></div>';

	 	return $return;
	}

	function onAcyTriggerFct_displayAdAgencyValues(){
 		$num = JRequest::getInt('num');
		$map = JRequest::getCmd('map');
		$cond = JRequest::getVar('cond','','','string',JREQUEST_ALLOWHTML);
		$value = JRequest::getVar('value','','','string',JREQUEST_ALLOWHTML);

		// Default return: empty input field
		$emptyInputReturn = '<input onchange="countresults('.$num.')" class="inputbox" type="text" name="filter['.$num.'][adagency][value]" id="filter'.$num.'adagencyvalue" style="width:200px" value="'.$value.'">';

		if(empty($map) || $map == 'key' || !in_array($cond, array('=','!='))) return $emptyInputReturn;

		$db = JFactory::getDBO();
		$db->setQuery('SELECT DISTINCT `'.acymailing_secureField($map).'` AS value FROM #__ad_agency_advertis LIMIT 100');
 		$prop = $db->loadObjectList();

		// No enough or too much values -> default return
 		if(empty($prop) || count($prop) >= 100 || (count($prop) == 1 && (empty($prop[0]->value) || $prop[0]->value == '-'))) return $emptyInputReturn;

 		return JHTML::_('select.genericlist', $prop, "filter[$num][adagency][value]", 'onchange="countresults('.$num.')" class="inputbox" size="1" style="width:200px"', 'value', 'value', $value, 'filter'.$num.'adagencyvalue');
	}

	function onAcyProcessFilterCount_adagency(&$query,$filter,$num){
		$this->onAcyProcessFilter_adagency($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_adagency(&$query,$filter,$num){
	 	$query->leftjoin['adagency'] = '#__ad_agency_advertis AS adagency ON adagency.user_id = sub.userid';
	 	$query->where[] = $query->convertQuery('adagency',$filter['map'],$filter['operator'],$filter['value']);
	}

}//endclass