<?php
/**
 * @copyright	Copyright (C) 2009-2015 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingAlphauserpoints extends JPlugin
{

	function onAcySubscribe($subid,$listids){

		$api_AUP = JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php';
		if(!file_exists($api_AUP)) return;

		$userClass=acymailing_get('class.subscriber');
		$currentUser = $userClass->get($subid);
		if(empty($currentUser->userid)) return;

		require_once($api_AUP);
		$now1 = date("d.m.Y H:i:s");
		AlphaUserPointsHelper::newpoints( 'plgaup_com_acymailing_subscriptionok', AlphaUserPointsHelper::getAnyUserReferreID( $currentUser->userid ), '', 'Subscribed our Mailinglist on '.$now1);

	}

	function onAcyUnsubscribe($subid,$listids){
		$api_AUP = JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php';
		if (!file_exists($api_AUP)) return;

		$userClass=acymailing_get('class.subscriber');
		$currentUser = $userClass->get($subid);
		if(empty($currentUser->userid)) return;

		require_once($api_AUP);
		$now1 = date("d.m.Y H:i:s");
		AlphaUserPointsHelper::newpoints( 'plgaup_com_acymailing_subscriptionoff', AlphaUserPointsHelper::getAnyUserReferreID( $currentUser->userid ), '', 'Unsubscribed from our Mailinglist on '.$now1);

	}

	function acymailing_getPluginType() {

	 	$onePlugin = new stdClass();
	 	$onePlugin->name = 'AlphaUserPoints';
	 	$onePlugin->function = 'acymailingalphauserpoints_show';
	 	$onePlugin->help = 'plugin-alphauserpoints';

	 	return $onePlugin;
	 }

	 function acymailingalphauserpoints_show(){
		$text = '<table class="adminlist table table-striped table-hover" cellpadding="1">';
		$fields = acymailing_getColumns('#__alpha_userpoints');

		if(empty($fields)) return;

		$k = 0;
		foreach($fields as $fieldname => $oneField){
			$type = '';
			if(strpos(strtolower($oneField),'date') !== false) $type = '|type:date';
			$text .= '<tr style="cursor:pointer" class="row'.$k.'" onclick="setTag(\'{alphauserpoints:'.$fieldname.$type.'}\');insertTag();" ><td class="acytdcheckbox"></td><td>'.$fieldname.'</td></tr>';
			$k = 1-$k;
		}
		$text .= '</table>';

		echo $text;
	 }

	function acymailing_replaceusertags(&$email,&$user,$send = true){

		$match = '#{alphauserpoints:(.*)}#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything...
		if(!$found) return;

		$pluginsHelper = acymailing_get('helper.acyplugins');

		$values = null;
		if(!empty($user->userid)){
			$db= JFactory::getDBO();
			$db->setQuery('SELECT * FROM `#__alpha_userpoints` WHERE `userid` = '.$user->userid.' LIMIT 1');
			$values = $db->loadObject();
		}

		$tags = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset($tags[$oneTag])) continue;

				//We explode each argument of the tag
				$arguments = explode('|',$allresults[1][$i]);
				$field = $arguments[0];
				unset($arguments[0]);
				$mytag = new stdClass();
				//We get the default value with the params plugin
				$mytag->default = $this->params->get('default_'.$field,'');
				if(!empty($arguments)){
					foreach($arguments as $onearg){
						$args = explode(':',$onearg);
						if(isset($args[1])){
							$mytag->$args[0] = $args[1];
						}else{
							$mytag->$args[0] = 1;
						}
					}
				}
				$replaceme = isset($values->$field) ? $values->$field : $mytag->default;
				$pluginsHelper->formatString($replaceme,$mytag);

				$tags[$oneTag] = $replaceme;
			}
		}

		foreach($results as $var => $allresults){
			$email->$var = str_replace(array_keys($tags),$tags,$email->$var);
		}
	 }//endfct
}