<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingAltauserpoints extends JPlugin{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'altauserpoints';
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new acyParameter($plugin->params);
		}

		$this->db = JFactory::getDBO();
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_altauserpoints');
	}

	function acymailing_getPluginType(){
		if(!$this->component_installed) return '';

		$onePlugin = new stdClass();
		$onePlugin->name = 'AltaUserPoints';
		$onePlugin->function = 'acymailingaltauserpoints_show';
		$onePlugin->help = 'plugin-altauserpoints';

		return $onePlugin;
	}

	function acymailingaltauserpoints_show(){
		$text = '<div class="onelineblockoptions"><table class="acymailing_table" cellpadding="1">';
		$fields = acymailing_getColumns('#__alpha_userpoints');

		if(empty($fields)) return;

		$k = 0;
		foreach($fields as $fieldname => $oneField){
			$type = '';
			if(strpos(strtolower($oneField), 'date') !== false) $type = '|type:date';
			$text .= '<tr style="cursor:pointer" class="row'.$k.'" onclick="setTag(\'{altauserpoints:'.$fieldname.$type.'}\');insertTag();" ><td class="acytdcheckbox"></td><td>'.$fieldname.'</td></tr>';
			$k = 1 - $k;
		}
		$text .= '</table></div>';

		echo $text;
	}

	function acymailing_replaceusertags(&$email, &$user, $send = true){

		$tags = $this->acypluginsHelper->extractTags($email, $this->name);

		//If we didn't find anything...
		if(empty($tags)) return;

		$values = new stdClass();
		if(!empty($user->userid)){
			$this->db->setQuery('SELECT * FROM `#__alpha_userpoints` WHERE `userid` = '.intval($user->userid).' LIMIT 1');
			$values = $this->db->loadObject();
		}

		$this->tags = array();
		foreach($tags as $oneTag => $tag){
			//Don't need to process twice a tag we already have!
			if(isset($this->tags[$oneTag])) continue;

			$field = $tag->id;
			$replaceme = isset($values->$field) ? $values->$field : $tag->default;
			$this->acypluginsHelper->formatString($replaceme, $tag);

			$tags[$oneTag] = $replaceme;
		}

		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}//endfct

	function onAcySubscribe($subid, $listids){

		$api_AUP = JPATH_SITE.'/components/com_altauserpoints/helper.php';
		if(!file_exists($api_AUP)) return;

		$userClass = acymailing_get('class.subscriber');
		$currentUser = $userClass->get($subid);
		if(empty($currentUser->userid)) return;

		require_once $api_AUP;
		$now1 = date("d.m.Y H:i:s");
		AltaUserPointsHelper::newpoints('plgaup_com_acymailing_subscriptionok', AltaUserPointsHelper::getAnyUserReferreID($currentUser->userid), '', 'Subscribed our Mailinglist on '.$now1);
	}

	function onAcyUnsubscribe($subid, $listids){
		$api_AUP = JPATH_SITE.'/components/com_altauserpoints/helper.php';
		if(!file_exists($api_AUP)) return;

		$userClass = acymailing_get('class.subscriber');
		$currentUser = $userClass->get($subid);
		if(empty($currentUser->userid)) return;

		require_once($api_AUP);
		$now1 = date("d.m.Y H:i:s");
		AltaUserPointsHelper::newpoints('plgaup_com_acymailing_subscriptionoff', AltaUserPointsHelper::getAnyUserReferreID($currentUser->userid), '', 'Unsubscribed from our Mailinglist on '.$now1);
	}
}