<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingCcuser extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'ccuser');
			$this->params = new acyParameter( $plugin->params );
		}
	}

	function acymailing_replaceusertags(&$email,&$user,$send = true){
		//We won't send the message? well, we just skip it then
		if(!$send) return;

		//Can we use the AddCC method?
		if(!method_exists($email,'AddCC')) return;

		//We will need it to check the e-mail address...
		$userHelper = acymailing_get('helper.user');

		//Vars we should check to extract the e-mail address if there is one...
		$vars = array('email1','email2','email3','email4','email5');
		foreach($vars as $oneVar){
			if(empty($user->$oneVar)) continue;

			$emailAddress= trim($user->$oneVar);

			//We have a value... is that a valid e-mail address?
			if(!$userHelper->validEmail($emailAddress)) continue;

			//Is the user using the same e-mail address as the main one?
			if($user->$oneVar == $user->email) continue;

			//We now have a valid e-mail address, let's add it!
			$email->AddCC($emailAddress,$user->name);
		}

		// Same thing with the CB fields
		// Is CB installed and option checked
		if($this->params->get('checkCBFields', 0) == 0 || !file_exists(ACYMAILING_ROOT .'components'.DS.'com_comprofiler'.DS.'comprofiler.php')) return;

		$db = JFactory::getDBO();
		if(!empty($user->userid)){
			$db->setQuery('SELECT * FROM #__comprofiler WHERE user_id = '.$user->userid.' LIMIT 1');
			$uservalues = $db->loadObject();
			$vars = array('cb_email','cb_email1','cb_email2','cb_email3','cb_email4','cb_email5');
			foreach($vars as $oneVar){
				if(empty($uservalues->$oneVar)) continue;

				$emailAddress= trim($uservalues->$oneVar);

				//We have a value... is that a valid e-mail address?
				if(!$userHelper->validEmail($emailAddress)) continue;

				//Is the user using the same e-mail address as the main one?
				if($uservalues->$oneVar == $user->email) continue;

				//We now have a valid e-mail address, let's add it!
				$email->AddCC($emailAddress,$user->name);
			}
		}
	}//endfct
}//endclass