<?php
/**
 * @copyright	Copyright (C) 2009-2015 ACYBA SARL - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php
class plgAcymailingCivicrm extends JPlugin
{
	var $civiprefix = '';
	function plgAcymailingCivicrm(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'civicrm');
			$this->params = new JParameter( $plugin->params );
		}
	}

	 function acymailing_getPluginType() {
	 	$onePlugin = new stdClass();
	 	$onePlugin->name = 'CiviCRM';
	 	$onePlugin->function = 'acymailingcivicrm_show';
	 	$onePlugin->help = 'plugin-civicrm';
	 	return $onePlugin;
	 }

	 function setciviprefix(){
	 	if(!empty($this->civiprefix)) return;
	 	$this->civiprefix = 'civicrm_';
	 	$importHelper = acymailing_get('helper.import');
		if(method_exists($importHelper,'setciviprefix')){
			$importHelper->setciviprefix();
			$this->civiprefix = $importHelper->civiprefix;
		}
	 }

	 function acymailingcivicrm_show(){

	 	$config = acymailing_config();
		if($config->get('version') < '4.7.2'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.civicrm';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order', 'a.id', 'cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir','asc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->titlelink = $app->getUserStateFromRequest( $paramBase.".titlelink", 'titlelink','1','string' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->autotitlelink = $app->getUserStateFromRequest( $paramBase.".autotitlelink", 'autotitlelink','1','string' );
		$pageInfo->automaxvalue = $app->getUserStateFromRequest( $paramBase.".max", 'max','20','int' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->autopict = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );


		$this->setciviprefix();
		$db = JFactory::getDBO();
		$allfields['contact'] = acymailing_getColumns(str_replace('`', '', $this->civiprefix).'contact');

		$allfields['address'] = acymailing_getColumns(str_replace('`', '', $this->civiprefix).'address');

		$tabs = acymailing_get('helper.acytabs');


		$searchFields = array('a.id','a.title','b.label');

		if(!empty($pageInfo->search))
		{
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displaypub','all') == 'onlypub')
		{
			$filters[] = "a.is_active = 1";
		}

		//load events
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.id, a.title, a.start_date, b.label ' .
				'FROM '.$this->civiprefix.'event AS a ' .
				'JOIN '.$this->civiprefix.'option_value AS b ' .
				'ON a.event_type_id = b.value ' .
				'JOIN '.$this->civiprefix.'option_group AS c ' .
				'ON b.option_group_id = c.id ';

		$filters[] = 'c.name LIKE "event_type"';

		if(!empty($pageInfo->filter_cat))
		{
			$filters[] = "a.event_type_id = ".$pageInfo->filter_cat;
		}

		if(!empty($filters))
		{
			$query .= ' WHERE ('.implode(') AND (',$filters).')';
		}

		$db->setQuery($query);
		$events = $db->loadObjectList();

		if(!empty($pageInfo->search))
		{
			$events = acymailing_search($pageInfo->search,$events);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($events);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$type = JRequest::getString('type');
?>

		<script language="javascript" type="text/javascript">
		<!--
			var tmp = '';
			var selectedContents = new Array();
			function applyContent(contentid,rowClass)
			{
				tmp = selectedContents.indexOf(contentid)
				if(tmp != -1)
				{
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass)
			{
				if(catid == 'all')
				{
					if(window.document.getElementById('cat'+catid).className == 'selectedrow')
					{
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						for(key in selectedCat)
						{
							if(!isNaN(key))
							{
								window.document.getElementById('cat'+key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid])
					{
						window.document.getElementById('cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;
				for(var i=0; i < document.adminForm.cbdisplay.length; i++)
				{
					if (document.adminForm.cbdisplay[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp+=1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }
					}
				}
				for(var i=0; i < document.adminForm.titlelink.length; i++)
				{
					 if (document.adminForm.titlelink[i].checked && document.adminForm.titlelink[i].value == '1')
					 {
					 	otherinfo += '| link';
					 }
				}
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0)
				{
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				for(var i=0; i < document.adminForm.readmore.length; i++)
				{
					 if (document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '1')
					 {
						 otherinfo += '| readmore';
					 }
				}

				for(var i=0; i < document.adminForm.pict.length; i++)
				{
					if (document.adminForm.pict[i].checked)
					{
						if(document.adminForm.pict[i].value != '0')
							otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized')
						{
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}
				for(var i in selectedContents)
				{
					if(selectedContents[i] && !isNaN(i))
					{
						tag = tag + '{civicrmevent:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto()
			{
				var tmp=0;
				tag = '{autocivicrmevent:';

				for(var icat in selectedCat)
				{
					if(selectedCat[icat] == 'selectedone')
					{
						tag += icat+'-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value!=0)
				{
					tag += '| min:'+document.adminForm.min_article.value;
				}
				if(document.adminForm.max_article.value && document.adminForm.max_article.value != 0)
				{
					tag += '| max:'+document.adminForm.max_article.value;
				}
				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++)
				{
					if(document.adminForm.cbdisplayauto[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp += 1;
							 tag += "| display:";
							 tag += document.adminForm.cbdisplayauto[i].value;
						 }else{
							 tag += ", ";
							 tag += document.adminForm.cbdisplayauto[i].value;
						 }
					}
				}
				for(var i=0; i < document.adminForm.autotitlelink.length; i++)
				{
					 if(document.adminForm.autotitlelink[i].checked && document.adminForm.autotitlelink[i].value == '1')
					 {
					 	tag += '| link';
					 }
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++)
				{
					 if(document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '1')
					 {
					 	tag += '| readmore';
					 }
				}
				for(var i=0; i < document.adminForm.autopict.length; i++)
				{
					 if (document.adminForm.autopict[i].checked)
					 {
					 	if(document.adminForm.autopict[i].value != '0')
					 		tag += '| pict:'+document.adminForm.autopict[i].value;

						if(document.adminForm.autopict[i].value == 'resized')
						{
					 		document.getElementById('pictsizeauto').style.display = '';
					 		if(document.adminForm.pictwidthauto.value) tag += '| maxwidth:'+document.adminForm.pictwidthauto.value;
					 		if(document.adminForm.pictheightauto.value) tag += '| maxheight:'+document.adminForm.pictheightauto.value;
					 	}else{
					 		document.getElementById('pictsizeauto').style.display = 'none';
					 	}
					 }
				}
				if(document.adminForm.autowrap.value && document.adminForm.autowrap.value!=0){ tag += "| wrap:"+document.adminForm.autowrap.value; }
				if(document.adminForm.cols.value){ tag += "| cols:"+document.adminForm.cols.value; }
				if(document.adminForm.contentorder.value){ tag += "| order:"+document.adminForm.contentorder.value; }
				if(document.adminForm.delayevent && document.adminForm.delayevent.value && document.adminForm.delayevent.value>0){ tag += '| delay:'+document.adminForm.delayevent.value; }
				if(document.adminForm.from_date && document.adminForm.from_date.value){ tag += '| from:'+document.adminForm.from_date.value; }
				if(document.adminForm.to_date && document.adminForm.to_date.value){ tag += '| to:'+document.adminForm.to_date.value; }

				tag += '}';

				setTag(tag);
			}
		//-->
		</script>
		<?php

		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized",JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$choice = array();
		$choice[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$column = array();
		for($i=1;$i<11;$i++)
		{
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		$ordering = array();
		$ordering[] = JHTML::_('select.option', "id,DESC",JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "created_date,ASC",JText::_('CREATED_DATE'));
		$ordering[] = JHTML::_('select.option', "title,ASC",JText::_('ACY_TITLE'));
		$ordering[] = JHTML::_('select.option', "start_date,DESC",JText::_('FIELD_DATE'));
		$ordering[] = JHTML::_('select.option', "end_date,ASC",JText::_('EXPIRY_DATE'));
		$ordering[] = JHTML::_('select.option', "rand",JText::_('ACY_RANDOM'));


		echo $tabs->startPane( 'civicrm_tab');

		foreach($allfields as $name => $fields)
		{
			echo $tabs->startPanel( ucfirst($name).' ', 'civicrm_'.$name);
			$text = '<table class="adminlist table table-striped table-hover" cellpadding="1">';
			$k = 0;
			foreach($fields as $fieldname => $oneField)
			{
				if(substr($fieldname,-2) == 'id' || substr($fieldname,0,3) == 'is_' || substr($fieldname,0,6) == 'do_not') continue;
				$ttype = '';
				if($fieldname == 'created') $ttype = '|type:time';
				$text .= '<tr style="cursor:pointer" class="row'.$k.'" onclick="setTag(\'{civicrm:'.$name.'|field:'.$fieldname.$ttype.'}\');insertTag();" ><td>'.$fieldname.'</td></tr>';
				$k = 1-$k;
			}
			$text .= '</table>';
			echo $text;
			echo $tabs->endPanel();
		}
		echo $tabs->startPanel( JText::_('JOOMEXT_EVENT'), 'civicrm_elements');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="title" id="title" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="title" id="title-lbl"><?php echo JText::_('FIELD_TITLE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="intro" id="intro" onclick="updateTag();"/><label style="margin-left:5px" for="intro" id="intro-lbl"><?php echo JText::_('INTRO_TEXT');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="description" id="description" onclick="updateTag();"/><label style="margin-left:5px" for="description" id="description-lbl"><?php echo JText::_('ACY_DESCRIPTION');?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="location" id="location" onclick="updateTag();"/><label style="margin-left:5px" for="location" id="location-lbl"><?php echo JText::_('ADDRESSCAPTION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="contact" id="contact" onclick="updateTag();"/><label style="margin-left:5px" for="contact" id="contact-lbl"><?php echo JText::_('ACY_AUTHOR');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="dates" id="dates" onclick="updateTag();"/><label style="margin-left:5px" for="dates" id="dates-lbl"><?php echo JText::_('FIELD_DATE');?></label></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td nowrap="nowrap" valign="top">
					<?php echo JHTML::_('acyselect.radiolist', $choice, 'titlelink' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->titlelink);?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th class="title">
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('ACY_TITLE'), 'a.link_name', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('ACY_TYPE'), 'b.label', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('FIELD_DATE'), 'a.start_date', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					for($i = 0 ; $i<count($events) ; $i++)
					{
						$row =& $events[$i];
				?>
					<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
						<?php
							echo $row->title;
						?>
						</td>
						<td>
						<?php
							echo $row->label;
						?>
						</td>
						<td>
						<?php
							echo acymailing_getDate(acymailing_getTime($row->start_date));
						?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->id; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
	<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel( JText::_('UPCOMING_EVENTS'), 'civicrm_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="title" id="titleauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="titleauto" id="titleauto-lbl"><?php echo JText::_('FIELD_TITLE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="intro" id="introauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="introauto" id="introauto-lbl"><?php echo JText::_('INTRO_TEXT');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="description" id="descriptionauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="descriptionauto" id="descriptionauto-lbl"><?php echo JText::_('ACY_DESCRIPTION');?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="location" id="locationauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="locationauto" id="locationauto-lbl"><?php echo JText::_('ADDRESSCAPTION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="contact" id="contactauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="contactauto" id="contactauto-lbl"><?php echo JText::_('ACY_AUTHOR');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="dates" id="datesauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="datesauto" id="datesauto-lbl"><?php echo JText::_('FIELD_DATE');?></label></td>
			</tr>
			<tr>
				<td valign="top" nowrap="nowrap">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
				<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td nowrap="nowrap" valign="top">
					<?php echo JHTML::_('acyselect.radiolist', $choice, 'autotitlelink' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autotitlelink);?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="autowrap" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('FIELD_COLUMNS'); ?></td>
				<td nowrap="nowrap" colspan="3">
				 	<?php echo JHTML::_('select.genericlist', $column, 'cols' , 'style="width:50px;" size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				 </td>
				 <td nowrap="nowrap">
				 	<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
				<?php echo JText::_('ACY_ORDER'); ?>
				 </td>
				 <td nowrap="nowrap">
				 	<?php echo JHTML::_('acyselect.genericlist', $ordering, 'contentorder' , 'size="1" style="width:150px" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
		<?php if($type == 'autonews') { ?>
		<tr>
			<td nowrap="nowrap">
			<?php 	echo JText::_('MIN_ARTICLE'); ?>
			 </td>
			 <td>
			 <input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
			</td>
			<td nowrap="nowrap">
			<?php echo JText::_('MAX_STARTING_DATE'); ?>
			 </td>
			 <td nowrap="nowrap">
			 	<?php $delayType = acymailing_get('type.delay'); $delayType->onChange = "updateTagAuto();"; echo $delayType->display('delayevent',7776000,3); ?>
			</td>
		</tr>
		<?php }else{ ?>
			<tr>
			<td>
			<?php 	echo JText::_('ACY_FROM_DATE'); ?>
			</td>
			 <td>
			<?php echo JHTML::_('calendar', '', 'from_date','from_date','%Y-%m-%d',array('style'=>'width:80px', 'onchange'=>'updateTagAuto()')); ?>
			</td>
			<td>
			<?php 	echo JText::_('ACY_TO_DATE'); ?>
			 </td>
			 <td>
			 <?php echo JHTML::_('calendar', '', 'to_date','to_date','%Y-%m-%d',array('style'=>'width:80px', 'onchange'=>'updateTagAuto()')); ?>
			</td>
		</tr>
		<?php } ?>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
		<?php $k=0;
			?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo JText::_('ACY_ALL');
				?>
				</td>
			</tr>
			<?php
			 foreach($this->catvalues as $oneCat){
			 if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();

	}

	function _categories($filter_cat)
	{
		//select all cats (types)
		$db = JFactory::getDBO();
		$query = 'SELECT a.label, a.value ' .
				'FROM '.$this->civiprefix.'option_value AS a ' .
				'JOIN '.$this->civiprefix.'option_group AS b ' .
				'ON a.option_group_id = b.id ' .
				'WHERE b.name LIKE "event_type"';
		$db->setQuery($query);
		$mosetCats = $db->loadObjectList();

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		foreach($mosetCats as $oneCat)
		{
			$this->catvalues[] = JHTML::_('select.option', $oneCat->value,$oneCat->label);
		}
		return JHTML::_('select.genericlist',   $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int) $filter_cat);
	}

	 function acymailing_replacetags(&$email,$send = true)
	 {
	 	$this->setciviprefix();
	 	$this->_replaceAuto($email);
	 	$this->_replaceEvents($email);
	 }

	function _replaceAuto(&$email)
	{
		$this->acymailing_generateautonews($email);
		if(!empty($this->tags))
		{
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
		}
	}

	function acymailing_generateautonews(&$email)
	{
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$db = JFactory::getDBO();
		$time = time();

		//load the tags with the helper
		$tags = $acypluginsHelper->extractTags($email,'autocivicrmevent');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags))
		{
			return $return;
		}
		foreach($tags as $oneTag => $parameter)
		{
			if(isset($this->tags[$oneTag]))
				continue;
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat)
			{
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}
			//Select the events
			$query = 'SELECT a.id FROM '.$this->civiprefix.'event AS a ';
			$where = array();
			if(!empty($selectedArea))
			{
				$where[] = 'a.event_type_id IN ('.implode(',',$selectedArea).')';
			}
			$where[] = 'a.is_active = 1';

			if(!empty($parameter->from))
				$where[] = 'a.`start_date` >= '.$db->Quote($parameter->from);
			if(!empty($parameter->delay))
				$where[] = 'a.`start_date` <= '.$db->Quote(date('Y-m-d',$time+$parameter->delay));
			if(!empty($parameter->to))
				$where[] = 'a.`end_date` <= '.$db->Quote($parameter->to);

			if(!empty($parameter->addcurrent))
			{
				//not finished and next events
				$where[] = 'a.end_date >= '.$db->Quote(date('Y-m-d H:i:s', $time));
			}else{
				//not started events
				$where[] = 'a.start_date >= '.$db->Quote(date('Y-m-d H:i:s', $time));
			}

			//should we display only events starting in the sending day ?
			if(!empty($parameter->todaysevent))
			{
				$where[] = 'a.start_date <= '.$db->Quote(date('Y-m-d 23:59:59', $time));
			}

			if(!empty($where))
			{
				$query .= ' WHERE ('.implode(') AND (',$where).')';
			}

			if(!empty($parameter->order))
			{
				if($parameter->order == 'rand')
				{
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			if(!empty($parameter->max))
				$query .= ' LIMIT '.intval($parameter->max);
			else
				$query .= ' LIMIT 20';

			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);
			if(!empty($parameter->min) && count($allArticles) < intval($parameter->min))
			{
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough CiviCRM events for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles))
			{
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autocivicrmevent.php'))
				{
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autocivicrmevent.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the article tag one after the other in a table as they are already sorted
					$arrayElements = array();
					foreach($allArticles as $oneArticleId)
					{
						$args = array();
						$args[] = 'civicrmevent:'.$oneArticleId;
						if(!empty($parameter->link)) $args[] = 'link';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(!empty($parameter->readmore)) $args[] = 'readmore';
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}

	 function _replaceEvents(&$email)
	 {
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'civicrmevent');
		if(empty($tags))
		{
			return;
		}
		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more link:
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$htmlreplace = array();
		$textreplace = array();
		foreach($tags as $i => $params)
		{
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceEvent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content,true);
		}
		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
	 }

	 function _replaceEvent(&$tag)
	 {
		$acypluginsHelper = acymailing_get('helper.acyplugins');

	 	//load display options
		if(!empty($tag->display))
			$tag->display = explode(',',$tag->display);
		foreach($tag->display as $oneDisplay)
		{
			$oneDisplay = trim($oneDisplay);
			$tag->$oneDisplay = 1;
		}
		$tag->display = '';
		//1 : Load the content

		$data = array();

		$db = JFactory::getDBO();
		//load the event
		$query = 'SELECT a.*, b.label ' .
				'FROM '.$this->civiprefix.'event AS a ' .
				'JOIN '.$this->civiprefix.'option_value AS b ' .
				'ON a.event_type_id = b.value ' .
				'JOIN '.$this->civiprefix.'option_group AS c ' .
				'ON b.option_group_id = c.id ' .
				'WHERE c.name LIKE "event_type" ' .
				'AND a.id = '.$tag->id.' LIMIT 1';
		$db->setQuery($query);
		$event = $db->loadObject();
		//In case of we could not load the article for any reason...
		if(empty($event))
		{
			$app = JFactory::getApplication();
			if($app->isAdmin())
			{
				$app->enqueueMessage('The event "'.$tag->id.'" could not be loaded','notice');
			}
			return '';
		}

		$varFields = array();
		foreach($event as $field => $oneValue)
		{
			$varFields['{'.$field.'}'] = $oneValue;
		}

		$link = ACYMAILING_LIVE.'index.php?option=com_civicrm&task=civicrm/event/info&id='.$tag->id;
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';
		if(!empty($tag->title))
		{
			$result .= '<tr><td colspan="2">';
			if(!empty($tag->link))
			{
				$result.= '<a style="text-decoration:none;" href="'.$link.'">';
			}
			$result .= '<h2 class="acymailing_title">'.$event->title.'</h2>';
			if(!empty($tag->link))
			{
				$result.= '</a>';
			}
			$result .= '</td></tr>';
		}

		if(!empty($tag->intro) && !empty($event->summary))
		{
			$result .= '<tr><td colspan="2">'.$event->summary.'</td></tr>';
		}
		if(!empty($tag->description) && !empty($event->description))
		{
			$result .= '<tr><td colspan="2">'.$acypluginsHelper->wrapText($event->description, $tag).'</td></tr>';
		}
		if(!empty($tag->dates) && !empty($event->start_date))
		{
			$dates = acymailing_getDate(acymailing_getTime($event->start_date));
			if(!empty($event->end_date))
			{
				$dates .= ' '.JText::_('ACY_TO_DATE').' '.acymailing_getDate(acymailing_getTime($event->end_date));
			}
			$result .= '<tr><td><br />'.JText::_('FIELD_DATE').' : </td><td><br />'.$dates.'</td></tr>';
		}
		if(!empty($event->loc_block_id))
		{//TODO LEFT JOIN dans la premiere requete ?
			$db->setQuery('SELECT * FROM '.$this->civiprefix.'loc_block WHERE id='.$event->loc_block_id);
			$locBlock = $db->loadObject();
			if(!empty($tag->location))
			{
				$location = array();
				if(!empty($locBlock->address_id))
				{
					$db->setQuery('SELECT * FROM '.$this->civiprefix.'address WHERE id='.$locBlock->address_id);
					$address = $db->loadObject();
					if(!empty($address->street_address))
						$location[] = $address->street_address;
					if(!empty($address->supplemental_address_1))
						$location[] = $address->supplemental_address_1;
					if(!empty($address->supplemental_address_2))
						$location[] = $address->supplemental_address_2;
					$tmpLoc = array();
					if(!empty($address->city))
						$tmpLoc[] = $address->city;
					if(!empty($address->postal_code))
						$tmpLoc[] = $address->postal_code;
					$location[] = implode(', ',$tmpLoc);
					if(!empty($address->country_id))
					{
						$db->setQuery('SELECT name FROM '.$this->civiprefix.'country WHERE id='.$address->country_id);
						$country = $db->loadObject();
						$location[] = $country->name;
					}
				}
				if(!empty($locBlock->address_2_id))
				{
					$db->setQuery('SELECT * FROM '.$this->civiprefix.'address WHERE id='.$locBlock->address_2_id);
					$address = $db->loadObject();
					if(!empty($address->street_address))
						$location[] = $address->street_address;
					if(!empty($address->supplemental_address_1))
						$location[] = $address->supplemental_address_1;
					if(!empty($address->supplemental_address_2))
						$location[] = $address->supplemental_address_2;
					$tmpLoc = array();
					if(!empty($address->city))
						$tmpLoc[] = $address->city;
					if(!empty($address->postal_code))
						$tmpLoc[] = $address->postal_code;
					$location[] = implode(', ',$tmpLoc);
					if(!empty($address->country_id))
					{
						$db->setQuery('SELECT name FROM '.$this->civiprefix.'country WHERE id='.$address->country_id);
						$country = $db->loadObject();
						$location[] = $country->name;
					}
				}
				$varFields['{location}'] = implode('<br />',$location);
				$result .= '<tr><td valign="top">'.JText::_('ADDRESSCAPTION').' : </td><td>'.$varFields['{location}'].'</td></tr>';
			}
			if(!empty($tag->contact))
			{
				$contact = array();
				if(!empty($locBlock->phone_id))
				{//TODO LEFT JOIN dans la premiere requete ?
					$phoneExt = array();
					if(ACYMAILING_J16)
						$db->setQuery('SELECT phone, phone_ext FROM '.$this->civiprefix.'phone WHERE id='.$locBlock->phone_id);
					else
						$db->setQuery('SELECT phone FROM '.$this->civiprefix.'phone WHERE id='.$locBlock->phone_id);
					$phone = $db->loadObject();
					if(!empty($phone->phone))
						$phoneExt[] = $phone->phone;
					if(ACYMAILING_J16)
					{
						if(!empty($phone->phone_ext))
							$phoneExt[] = 'Ext. '.$phone->phone_ext;
					}
					if(!empty($phoneExt))
						$contact[] = implode(', ',$phoneExt);
				}
				if(!empty($locBlock->phone_2_id))
				{//TODO LEFT JOIN dans la premiere requete ?
					$phoneExt = array();
					if(ACYMAILING_J16)
						$db->setQuery('SELECT phone, phone_ext FROM '.$this->civiprefix.'phone WHERE id='.$locBlock->phone_2_id);
					else
						$db->setQuery('SELECT phone FROM '.$this->civiprefix.'phone WHERE id='.$locBlock->phone_2_id);
					$phone = $db->loadObject();
					if(!empty($phone->phone))
						$phoneExt[] = $phone->phone;
					if(ACYMAILING_J16)
					{
						if(!empty($phone->phone_ext))
							$phoneExt[] = 'Ext. '.$phone->phone_ext;
					}
					if(!empty($phoneExt))
						$contact[] = implode(', ',$phoneExt);
				}
				if(!empty($locBlock->email_id))
				{//TODO LEFT JOIN dans la premiere requete ?
					$db->setQuery('SELECT email FROM '.$this->civiprefix.'email WHERE id='.$locBlock->email_id);
					$email = $db->loadObject();
					$contact[] = $email->email;
				}
				if(!empty($locBlock->email_2_id))
				{//TODO LEFT JOIN dans la premiere requete ?
					$db->setQuery('SELECT email FROM '.$this->civiprefix.'email WHERE id='.$locBlock->email_2_id);
					$email = $db->loadObject();
					$contact[] = $email->email;
				}
				$result .= '<tr><td valign="top">Contact : </td><td>'.implode('<br />',$contact).'</td></tr>';
			}
		}



		if(!empty($tag->readmore))
		{
			$readMoreText = empty($this->readmore) ? JText::_('JOOMEXT_READ_MORE') : $this->readmore;
			$result .= '<tr><td colspan="2"><br /><a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$readMoreText.'</span></a></td></tr>';
		}

		$result .= '</table></div><br />';

		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'civicrmevent.php'))
		{
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'civicrmevent.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}
	 	$acypluginsHelper = acymailing_get('helper.acyplugins');
		$result = $acypluginsHelper->removeJS($result);

		//resize pictures
		if(isset($tag->pict))
		{
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? 150 : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? 150 : $tag->maxwidth;
			if($tag->pict == 'resized')
			{
				if($pictureHelper->available())
				{
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}
		}else{
			$result = $pictureHelper->removePictures($result);
		}
		return $result;
	}

	function acymailing_replaceusertags(&$email,&$user,$send = true){
		//TODO extracttags
		$match = '#(?:{|%7B)civicrm:(.*)(?:}|%7D)#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			if(empty($results[$var][0])) unset($results[$var]);
		}
		if(!$found) return;

		$this->setciviprefix();

		$this->userinfo = new stdClass();
		$tags = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($tags[$oneTag])) continue;
				$tags[$oneTag] = $this->_replaceCiviInfo($allresults,$i,$user);
			}
		}
		foreach(array_keys($results) as $var){
			$email->$var = str_replace(array_keys($tags),$tags,$email->$var);
		}
	}

	function _replaceCiviInfo(&$allresults,$i,&$user){
		$arguments = explode('|',strip_tags($allresults[1][$i]));
		$table = $arguments[0];
		unset($arguments[0]);
		$mytag = new stdClass();
		$mytag->default = '';
		if(!empty($arguments)){
			foreach($arguments as $onearg){
				$args = explode(':',$onearg);
				if(isset($args[1])){
					$mytag->$args[0] = $args[1];
				}else{
					$mytag->$args[0] = 1;
				}
			}
		}
		if(empty($mytag->field)) return "field not found";
		$field = $mytag->field;

		if(empty($user->email)) return $mytag->default;

		$db = JFactory::getDBO();
		if(empty($this->userinfo->contact_id)){
			//Let's load the civicrmid user ID...
			$db->setQuery('SELECT contact_id FROM '.$this->civiprefix.'email WHERE email = '.$db->Quote($user->email).' AND contact_id IS NOT NULL ORDER BY is_primary DESC LIMIT 1');
			$this->userinfo->contact_id = $db->loadResult();
		}

		if(empty($this->userinfo->contact_id)) return $mytag->default;

		if(empty($this->userinfo->$table)){
			//We need to load info for that user from that table...
			$query = 'SELECT * FROM '.$this->civiprefix.$table.' WHERE ';
			if($table == 'address') $query .= 'contact_id = '.$this->userinfo->contact_id.' ORDER BY is_primary DESC';
			elseif($table == 'contact') $query .= 'id = '.$this->userinfo->contact_id;
			else return 'table '.$table.' not supported';

			$db->setQuery($query);
			$this->userinfo->$table = $db->loadObject();
		}


		$replaceme = (isset($this->userinfo->$table->$field) && strlen($this->userinfo->$table->$field) > 0) ? $this->userinfo->$table->$field : $mytag->default;
		if(!empty($mytag->part)){
			$parts = explode(' ',$replaceme);
			if($mytag->part == 'last'){
				$replaceme = count($parts)>1 ? end($parts) : '';
			}else{
				$replaceme = reset($parts);
			}
		}
		if(!empty($mytag->type)){
			if(empty($mytag->format)) $mytag->format = JText::_('DATE_FORMAT_LC3');
			if($mytag->type == 'date'){
				$replaceme = acymailing_getDate(acymailing_getTime($replaceme),$mytag->format);
			}elseif($mytag->type == 'time'){
				$replaceme = acymailing_getDate($replaceme,$mytag->format);
			}
		}
		if(!empty($mytag->lower)) $replaceme = strtolower($replaceme);
		if(!empty($mytag->ucwords)) $replaceme = ucwords($replaceme);
		if(!empty($mytag->ucfirst)) $replaceme = ucfirst($replaceme);
		if(!empty($mytag->urlencode)) $replaceme = urlencode($replaceme);
		return $replaceme;
	}

	function onAcyDisplayFilters(&$type){

		$db = JFactory::getDBO();
		$return = '';
		$inoperator = acymailing_get('type.operatorsin');
		$inoperator->js = 'onchange="countresults(__num__)"';

		$this->setciviprefix();

		$fields = array();
		$field = array();
		$field[] = JHTML::_('select.option', 0, '- - -');

		//$fields = acymailing_getColumns($this->civiprefix.'contact');
		$db->setQuery('SELECT * FROM '.$this->civiprefix.'contact');
		$contactFields = $db->loadObject();
		if(!empty($contactFields))
		{
			$fields = array_keys((array) $contactFields);
			foreach($fields as $oneField){
				$field[] = JHTML::_('select.option', $oneField, $oneField);
			}
		}

		$fields = array();

		//$fields = acymailing_getColumns($this->civiprefix.'email');
		$db->setQuery('SELECT * FROM '.$this->civiprefix.'email');
		$emailFields = $db->loadObject();
		if(!empty($emailFields))
		{
			$fields = array_keys((array) $emailFields);
			foreach($fields as $oneField){
				$field[] = JHTML::_('select.option', 'emailfield_'.$oneField, $oneField);
			}
		}

		//We load extra fields from the right table...
		$db->setQuery('SELECT column_name, label FROM '.$this->civiprefix.'custom_field');
		$extraFields = $db->loadObjectList();
		if(!empty($extraFields)){
			foreach($extraFields as $oneField){
				$field[] = JHTML::_('select.option', 'customfield_'.$oneField->column_name, $oneField->label);
			}
		}

		if(!empty($field))
		{
			$jsOnChange = "displayCondFilter('displayCiviUserValues', 'toChange__num__',__num__,'map='+document.getElementById('filter__num__civicrmfieldmap').value+'&cond='+document.getElementById('filter__num__civicrmfieldoperator').value+'&value='+document.getElementById('filter__num__civicrmfieldvalue').value); ";
			$operators = acymailing_get('type.operators');
			$operators->extra = 'onchange="'.$jsOnChange.'countresults(__num__)"';

			$return .= '<div id="filter__num__civicrmfield">'.JHTML::_('select.genericlist',   $field, "filter[__num__][civicrmfield][map]", 'class="inputbox" size="1" onchange="'.$jsOnChange.'countresults(__num__)"', 'value', 'text');
			$return .= ' '.$operators->display("filter[__num__][civicrmfield][operator]").' <span id="toChange__num__"><input onchange="countresults(__num__)" class="inputbox" type="text" name="filter[__num__][civicrmfield][value]" id="filter__num__civicrmfieldvalue" style="width:200px" value=""></span></div>';
			$type['civicrmfield'] = 'CiviCRM : Contact field';
		}

		//GROUPS
		$db->setQuery('SELECT id, title FROM '.$this->civiprefix.'group ORDER BY id ASC');
		$allGroups = $db->loadObjectList();
		if(!empty($allGroups)){
			$any = new stdClass();
			$any->id = 0;
			$any->title = 'Any group';
			$allGroups = array_merge(array($any), $allGroups);
			$type['civicrmgroup'] = 'CiviCRM : Group';
			$return .= '<div id="filter__num__civicrmgroup">';
			$return .= $inoperator->display("filter[__num__][civicrmgroup][type]").' ';
			$return .= JHTML::_('select.genericlist',   $allGroups, "filter[__num__][civicrmgroup][value]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'id', 'title');
			$return .= '<input type="checkbox" value="1" id="filter__num__civicrmgroupsubgroups" name="filter[__num__][civicrmgroup][subgroups]" onchange="countresults(__num__)"/><label for="filter__num__civicrmgroupsubgroups">Include sub-groups (it won\'t work for smart groups)</label>';
			$return .= '</div>';
		}

		//TAGS
		$db->setQuery("SELECT id,name FROM ".$this->civiprefix."tag WHERE used_for LIKE '%_contact%' ORDER BY name ASC");
		$allTags = $db->loadObjectList();
		if(!empty($allTags)){
			$type['civicrmtag'] = 'CiviCRM : Tag';
			$return .= '<div id="filter__num__civicrmtag">';
			$return .= $inoperator->display("filter[__num__][civicrmtag][type]").' ';
			$return .= JHTML::_('select.genericlist',   $allTags, "filter[__num__][civicrmtag][value]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'id', 'name');
			$return .= '</div>';
		}

		//CONTACTTYPE
		$db->setQuery("SELECT name FROM ".$this->civiprefix."contact_type ORDER BY name ASC");
		$allContactTypes = $db->loadObjectList();
		if(!empty($allContactTypes)){
			$type['civicrmcontacttype'] = 'CiviCRM : Contact type';
			$return .= '<div id="filter__num__civicrmcontacttype">';
			$return .= $inoperator->display("filter[__num__][civicrmcontacttype][type]").' ';
			$return .= JHTML::_('select.genericlist',   $allContactTypes, "filter[__num__][civicrmcontacttype][value]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'name', 'name');
			$return .= '</div>';
		}

		//MEMBERSHIP
		$db->setQuery("SELECT id,name FROM ".$this->civiprefix."membership_type ORDER BY name ASC");
		$allMemberships = $db->loadObjectList();
		if(!empty($allMemberships)){
			$type['civicrmmembership'] = 'CiviCRM : Membership';
			$return .= '<div id="filter__num__civicrmmembership">';
			$return .= $inoperator->display("filter[__num__][civicrmmembership][type]").' ';
			$return .= JHTML::_('select.genericlist',   $allContactTypes, "filter[__num__][civicrmmembership][value]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'id', 'name');
			$return .= '</div>';
		}

	 	return $return;
	}

	function onAcyTriggerFct_displayCiviUserValues()
	{
 		$num = JRequest::getInt('num');
		$map = JRequest::getCmd('map');
		$cond = JRequest::getVar('cond','','','string',JREQUEST_ALLOWHTML);
		$value = JRequest::getVar('value','','','string',JREQUEST_ALLOWHTML);

		// Default return: empty input field
		$emptyInputReturn = '<input onchange="countresults('.$num.')" class="inputbox" type="text" name="filter['.$num.'][civicrmfield][value]" id="filter'.$num.'civicrmfieldvalue" style="width:200px" value="'.$value.'">';

		// Display first 100 values for some fields
		if(empty($map) || !in_array($cond, array('=','!=')) || strpos($map,'customfield_') !== false) return $emptyInputReturn;

		$this->setciviprefix();
		$db = JFactory::getDBO();

		if(strpos($map,'emailfield_') !== false){
			$db->setQuery('SELECT DISTINCT `'.acymailing_secureField(str_replace('emailfield_', '', $map)).'` AS value FROM '.$this->civiprefix.'email LIMIT 100');
		}else{
			$db->setQuery('SELECT DISTINCT `'.acymailing_secureField($map).'` AS value FROM '.$this->civiprefix.'contact LIMIT 100');
		}
 		$prop = $db->loadObjectList();

		// No values -> default return
 		if(empty($prop) || count($prop) >= 100 || (count($prop) == 1 && ($prop[0]->value === NULL || (empty($prop[0]->value) && $prop[0]->value != 0) || $prop[0]->value == '-'))) return $emptyInputReturn;

 		return JHTML::_('select.genericlist', $prop, "filter[$num][civicrmfield][value]", 'onchange="countresults('.$num.')" class="inputbox" size="1" style="width:200px"', 'value', 'value', $value, 'filter'.$num.'civicrmfieldvalue');
	}

	function onAcyProcessFilterCount_civicrmfield(&$query,$filter,$num){
	 	$this->onAcyProcessFilter_civicrmfield($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_civicrmfield(&$query,$filter,$num)
	{
		if(empty($filter['map'])) return;
		$this->setciviprefix();

		$query->leftjoin['civiemail'.$num] = $this->civiprefix.'email AS civiemail'.$num.' ON sub.email = CONVERT(civiemail'.$num.'.email USING utf8)';
		if(strpos($filter['map'],'customfield_') !== false)
		{
			$filter['map'] = str_replace('customfield_', '', $filter['map']);
			$db = JFactory::getDBO();
			$db->setQuery('SELECT a.table_name FROM '.$this->civiprefix.'custom_group AS a JOIN '.$this->civiprefix.'custom_field AS b ON a.id = b.custom_group_id WHERE b.column_name LIKE '.$db->Quote($filter['map']));
			$tableName = $db->loadResult();
			if(empty($tableName)) return;

			$query->leftjoin['civifield'.$num] = str_replace('civicrm_', '', $this->civiprefix).$tableName.' as civifield'.$num.' ON civiemail'.$num.'.contact_id = civifield'.$num.'.entity_id';
		 	$query->where[] = $query->convertQuery('civifield'.$num, $filter['map'], $filter['operator'], $filter['value']);
		}else{
		 	if(in_array($filter['map'], array('created_date','modified_date','reset_date','hold_date'))){
		 		$filter['value'] = acymailing_replaceDate($filter['value']);
		 		if(!is_numeric($filter['value'])) $filter['value'] = strtotime($filter['value']);
				$filter['value'] = strftime('%Y-%m-%d %H:%M:%S',$filter['value']);
			}

			if(strpos($filter['map'],'emailfield_') !== false){
		 		$query->where[] = $query->convertQuery('civiemail'.$num, str_replace('emailfield_', '', $filter['map']), $filter['operator'], $filter['value']);
			}else{
				$query->leftjoin['civicontact'.$num] = $this->civiprefix.'contact AS civicontact'.$num.' ON civiemail'.$num.'.contact_id = civicontact'.$num.'.id';
		 		$query->where[] = $query->convertQuery('civicontact'.$num, $filter['map'], $filter['operator'], $filter['value']);
			}
		}
	}

	function _addOtherConditions(&$query){
		//We auto import users if needed...
		$this->_importcivi();

		if($this->params->get('onlyaccept',1)){
			$query->where['cividonotemail'] = 'sub.email IN ( SELECT CONVERT(civiemail.email USING utf8) FROM '.$this->civiprefix.'contact as civicontact JOIN '.$this->civiprefix.'email as civiemail ON civiemail.contact_id = civicontact.id WHERE civicontact.do_not_email = 0)';
		}
	}

	//This function will import all civi users in Acy
	function _importcivi(){
		$importHelper = acymailing_get('helper.import');
		if(!method_exists($importHelper,'civi')){
			echo 'Could not find the civi import function, please update AcyMailing to its latest version';
			return;
		}
		$this->setciviprefix();
		//We make sure to not trigger a sync since less than 12 hours.
		$config = acymailing_config();
		if($config->get('civi_lastimport',0) > (time()-43200)) return;

		//We save the last time we triggered the sync
		$newConfig = new stdClass();
		$newConfig->civi_lastimport = time();
		$config->save($newConfig);

		//We import users...
		$importHelper->civi_import();

		//We gonna make sure they are subscribed to the lists selected in the plugin...
		$listids = explode(',',$this->params->get('listids'));
		$subscribeTo = array();
		$db = JFactory::getDBO();
		foreach($listids as $oneListId){
			$oneListId = intval($oneListId);
			if(empty($oneListId)) continue;
			//Trigger the subscription for each list...
			$db->setQuery('INSERT IGNORE INTO #__acymailing_listsub (listid,subid,status,subdate) SELECT '.intval($oneListId).',sub.subid,1,'.time().' FROM '.$this->civiprefix.'email as civiemail JOIN '.acymailing_table('subscriber').' as sub on CONVERT(civiemail.email USING utf8) = sub.email');
			$db->query();
		}
	}

	function onAcyProcessFilter_civicrmgroup(&$query,$filter,$num){
		//We use CONVERT(civiemail.email USING utf8) to avoid collation issues...
		$this->setciviprefix();

		if(!in_array($filter['type'], array('IN', 'NOT IN'))) return;
		$filter['value'] = intval($filter['value']);

		$db = JFactory::getDBO();

		if(empty($filter['value']))
		{
			if($filter['type'] == 'IN')
			{
				$query->join[] = $this->civiprefix.'email as civicrm_email ON sub.email = CONVERT(civicrm_email.email USING utf8)';
				$query->join[] = $this->civiprefix.'contact as contact_a ON civicrm_email.contact_id = contact_a.id';
				$query->join[] = $this->civiprefix.'group_contact as civigroupcontact ON civigroupcontact.contact_id = contact_a.id';
				$query->where[] = 'civicrm_email.is_primary = 1';
				$query->where[] = 'civigroupcontact.status = "Added"';
				$query->where[] = 'contact_a.is_deleted = 0';
			}else{
				$query->leftjoin[] = $this->civiprefix.'email as civicrm_email ON sub.email = CONVERT(civicrm_email.email USING utf8)';
				$query->leftjoin[] = $this->civiprefix.'contact as contact_a ON civicrm_email.contact_id = contact_a.id';
				$query->leftjoin[] = $this->civiprefix.'group_contact as civigroupcontact ON civigroupcontact.contact_id = contact_a.id';
				$query->where[] = 'civigroupcontact.contact_id IS NULL';
			}
		}else{
			$db->setQuery('SELECT b.* FROM '.$this->civiprefix.'group AS a JOIN '.$this->civiprefix.'saved_search AS b ON a.saved_search_id = b.id WHERE a.id = '.$filter['value']);
			$search = $db->loadObject();
			if(!empty($search))
			{
				$search->select_tables = unserialize($search->select_tables);
				foreach($search->select_tables as $table => $oneTable)
				{
					if(!empty($oneTable) && $oneTable != 1)
					{
						if(strpos($oneTable, 'LEFT JOIN'))
						{
							if(!preg_match('#.+LEFT JOIN#i', trim($oneTable)))
							{
								$query->leftjoin[] = str_replace('LEFT JOIN civicrm_', $this->civiprefix, $oneTable);
							}else{
								$crapyTables = explode('LEFT', trim($oneTable));
								foreach($crapyTables as $crapyTable)
								{
									if(!empty($crapyTable))
										$query->leftjoin[] = str_replace('JOIN civicrm_', $this->civiprefix, trim($crapyTable));
								}
							}
						}else{
							$query->join[] = str_replace('JOIN civicrm_', $this->civiprefix, $oneTable);
						}
					}elseif($oneTable === 1){
						if($table == 'civicrm_address')
							$query->leftjoin[] = $this->civiprefix.'address AS civicrm_address ON contact_a.id = civicrm_address.contact_id ';
						elseif($table == 'civicrm_state_province')
							$query->leftjoin[] = $this->civiprefix.'state_province AS civicrm_state_province ON civicrm_state_province.id = civicrm_address.state_province_id ';
						elseif($table == 'civicrm_country')
							$query->leftjoin[] = $this->civiprefix.'country AS civicrm_country ON civicrm_state_province.country_id = civicrm_country.id ';
						elseif($table == 'civicrm_worldregion')
							$query->leftjoin[] = $this->civiprefix.'worldregion AS civicrm_worldregion ON civicrm_worldregion.id = civicrm_country.region_id ';
						elseif($table == 'civicrm_phone')
							$query->leftjoin[] = $this->civiprefix.'phone AS civicrm_phone ON civicrm_phone.contact_id = contact_a.id ';
						elseif($table == 'civicrm_participant')
							$query->leftjoin[] = $this->civiprefix.'participant AS civicrm_participant ON civicrm_participant.contact_id = contact_a.id ';
						elseif($table == 'civicrm_event')
							$query->leftjoin[] = $this->civiprefix.'event AS civicrm_event ON civicrm_participant.event_id = civicrm_event.id ';
						elseif($table == 'civicrm_im')
							$query->leftjoin[] = $this->civiprefix.'im AS civicrm_im ON civicrm_im.contact_id = contact_a.id ';
					}
				}

				$query->join[] = $this->civiprefix.'email as civicrm_email ON sub.email = CONVERT(civicrm_email.email USING utf8)';
				$query->join[] = $this->civiprefix.'contact as contact_a ON civicrm_email.contact_id = contact_a.id';
				$query->where[] = 'civicrm_email.is_primary = 1';
				$query->where[] = 'contact_a.is_deleted = 0';
				if(!empty($search->where_clause))
					$query->where[] = $search->where_clause;

				if($filter['type'] != 'IN')
				{
					echo 'The "NOT IN" feature does not currently work with smart groups.';
				}
			}else{
				if($filter['type'] == 'IN')
				{
					$query->join[] = $this->civiprefix.'email as civicrm_email ON sub.email = CONVERT(civicrm_email.email USING utf8)';
					$query->join[] = $this->civiprefix.'contact as contact_a ON civicrm_email.contact_id = contact_a.id';
					$query->join[] = $this->civiprefix.'group_contact as civigroupcontact ON civigroupcontact.contact_id = contact_a.id';
					$query->where[] = 'civicrm_email.is_primary = 1';
					$query->where[] = 'civigroupcontact.status = "Added"';
					$query->where[] = 'contact_a.is_deleted = 0';
				}else{
					$query->leftjoin[] = $this->civiprefix.'email as civicrm_email ON sub.email = CONVERT(civicrm_email.email USING utf8)';
					$query->leftjoin[] = $this->civiprefix.'contact as contact_a ON civicrm_email.contact_id = contact_a.id';
					$query->leftjoin[] = $this->civiprefix.'group_contact as civigroupcontact ON civigroupcontact.contact_id = contact_a.id';
					$query->where[] = 'civicrm_email.is_primary = 1 OR civicrm_email.is_primary IS NULL';
					$query->where[] = 'civigroupcontact.status = "Added" OR civigroupcontact.status IS NULL';
					$query->where[] = 'contact_a.is_deleted = 0 OR contact_a.is_deleted IS NULL';
				}
				if(!empty($filter['subgroups']))
				{
					if(empty($this->listGroups))
					{
						$db->setQuery('SELECT id, parents FROM '.$this->civiprefix.'group');
						$groups = $db->loadObjectList();
						$this->listGroups = array();
						foreach($groups as $oneGroup)
							$this->listGroups[intval($oneGroup->parents)][$oneGroup->id] = $oneGroup->id;
					}
					$this->finalGroupList = array();
					$this->addChildren($filter['value']);
					JArrayHelper::toInteger($this->finalGroupList);

					if($filter['type'] == 'IN')
						$query->where[] = 'civigroupcontact.group_id IN ('.implode(',', $this->finalGroupList).')';
					else
						$query->where[] = 'civigroupcontact.group_id NOT IN ('.implode(',', $this->finalGroupList).') OR civigroupcontact.group_id IS NULL';
				}else{
					if($filter['type'] == 'IN')
						$query->where[] = 'civigroupcontact.group_id IN ('.$filter['value'].')';
					else
						$query->where[] = 'civigroupcontact.group_id NOT IN ('.$filter['value'].') OR civigroupcontact.group_id IS NULL';
				}
			}
		}

		$this->_addOtherConditions($query);
	}

	function addChildren($id)
	{
		if(!empty($this->listGroups[$id]))
			foreach($this->listGroups[$id] as $oneID)
				$this->addChildren(intval($oneID));
		$this->finalGroupList[] = $id;
	}

	function onAcyProcessFilterCount_civicrmgroup(&$query,$filter,$num){
		$this->onAcyProcessFilter_civicrmgroup($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_civicrmtag(&$query,$filter,$num){
		$this->setciviprefix();
		$query->where[] = 'sub.email '.$filter['type'].' ( SELECT CONVERT(civiemail.email USING utf8) FROM '.$this->civiprefix.'entity_tag as civitag JOIN '.$this->civiprefix.'contact as civicontact ON civitag.entity_id = civicontact.id JOIN '.$this->civiprefix.'email as civiemail ON civiemail.contact_id = civicontact.id WHERE civitag.tag_id = '.intval($filter['value']).' AND civiemail.is_primary = 1 AND civitag.entity_table LIKE \'%contact\')';
		$this->_addOtherConditions($query);
	}

	function onAcyProcessFilterCount_civicrmtag(&$query,$filter,$num){
		$this->onAcyProcessFilter_civicrmtag($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_civicrmcontacttype(&$query,$filter,$num){
		$this->setciviprefix();
		$query->where[] = 'sub.email '.$filter['type'].' ( SELECT CONVERT(civiemail.email USING utf8) FROM '.$this->civiprefix.'contact as civicontact JOIN '.$this->civiprefix.'email as civiemail ON civiemail.contact_id = civicontact.id WHERE civicontact.contact_type = '.$query->db->Quote($filter['value']).' AND civiemail.is_primary = 1)';
		$this->_addOtherConditions($query);
	}

	function onAcyProcessFilterCount_civicrmcontacttype(&$query,$filter,$num){
		$this->onAcyProcessFilter_civicrmcontacttype($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_civicrmmembership(&$query,$filter,$num){
		$this->setciviprefix();
		$query->where[] = 'sub.email '.$filter['type'].' ( SELECT CONVERT(civiemail.email USING utf8) FROM '.$this->civiprefix.'membership as civimembership JOIN '.$this->civiprefix.'contact as civicontact ON civimembership.contact_id = civicontact.id JOIN '.$this->civiprefix.'email as civiemail ON civiemail.contact_id = civicontact.id WHERE civimembership.membership_type_id = '.intval($filter['value']).' AND civiemail.is_primary = 1)';
		$this->_addOtherConditions($query);
	}

	function onAcyProcessFilterCount_civicrmmembership(&$query,$filter,$num){
		$this->onAcyProcessFilter_civicrmmembership($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyCronTrigger(){
		//Block civi crm users based on AcyMailing users
		if(!$this->params->get('blockcivi',0)) return;

		$this->setciviprefix();

		$db = JFactory::getDBO();
		$db->setQuery('UPDATE '.$this->civiprefix.'email as civiemail JOIN #__acymailing_subscriber as sub ON CONVERT(civiemail.email USING utf8) = sub.email SET civiemail.on_hold = 1 WHERE sub.enabled = 0');
		$db->query();
	}

	//Let's remove from the queue users which are not allowed from CiviCRM
	function onAcySendNewsletter($mailid){

		if(!$this->params->get('onlysendaccept',true)) return;
		$this->setciviprefix();
		$db = JFactory::getDBO();
		$query = 'DELETE a.* FROM #__acymailing_queue as a JOIN #__acymailing_subscriber as b ON a.subid = b.subid ';
		$query .= 'JOIN '.$this->civiprefix.'email as civiemail ON b.email = CONVERT(civiemail.email USING utf8) ';
		$query .= 'JOIN '.$this->civiprefix.'contact as civicontact ON civiemail.contact_id = civicontact.id ';
		$query .= 'WHERE civicontact.do_not_email = 1 AND a.mailid = '.intval($mailid);
		$db->setQuery($query);
		$db->query();

		$result = $db->getAffectedRows();
		$app = JFactory::getApplication();
		if(!empty($result) AND $app->isAdmin()){
			$app->enqueueMessage($result.' e-mails removed from the queue as the user did not accept to receive e-mails on CiviCRM','notice');
		}
	}

}//endclass