<?php
/**
 * @copyright    .
 * @license        http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingCjblog extends JPlugin{

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'cjblog';
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new acyParameter($plugin->params);
		}

		$this->db = JFactory::getDBO();
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_cjblog');
	}

	function acymailing_getPluginType(){

		$onePlugin = new stdClass();
		$onePlugin->name = 'CJBlog';
		$onePlugin->function = 'acymailingcjblog_show';
		$onePlugin->help = 'plugin-cjblog';

		return $onePlugin;
	}

	function acymailingcjblog_show(){
		$fields = acymailing_getColumns('#__cjblog_users');
		echo '<div class="onelineblockoptions"><table class="acymailing_table" cellpadding="1">';

		$k = 0;
		foreach($fields as $fieldname => $oneField){
			echo '<tr style="cursor:pointer" class="row'.$k.'" onclick="setTag(\'{'.$this->name.':'.$fieldname.'}\');insertTag();" ><td class="acytdcheckbox"></td><td>'.$fieldname.'</td></tr>';
			$k = 1 - $k;
		}
		echo '</table></div>';
	}

	function acymailing_replaceusertags(&$email, &$user, $send = true){

		$tags = $this->acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags)) return;

		if(!empty($user->userid)){
			$appparams = JComponentHelper::getParams('com_cjblog');
			require_once JPATH_ROOT.'/components/com_cjblog/api.php';
			$userData = CjBlogApi::get_user_profile($user->userid);

			if(!empty($userData['about'])){
				$bbcode = $appparams->get('default_editor', 'wysiwygbb') == 'wysiwygbb' ? true : false;
				$userData['about'] = '<div>'.CJFunctions::preprocessHtml($userData['about'], false, $bbcode).'</div>';
			}

			$api = new CjLibApi();
			$avatarApp = $appparams->get('avatar_component', 'cjblog');
			$avatar = $api->getUserAvatarImage($avatarApp, $userData['id'], $user->email, 96);

			if(!empty($avatar)) $userData['avatar'] = '<img alt="" src="'.$avatar.'" />';
		}

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			if(empty($user->userid)){
				$tagsReplaced[$i] = $oneTag->default;
				continue;
			}

			$tagsReplaced[$i] = in_array($oneTag->id, array_keys($userData)) ? $tagsReplaced[$i] = $userData[$oneTag->id] : $oneTag->default;
		}

		$this->acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}
}
