<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingDMS extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'dms');
			$this->params = new acyParameter($plugin->params);
		}

		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_dms');
	}

 	function onAcyDisplayFilters(&$type,$context="massactions"){
		if($this->params->get('displayfilter_'.$context,true) == false || !$this->component_installed) return;

		$lang = JFactory::getLanguage();
		$lang->load('com_dms', JPATH_ADMINISTRATOR);

		$status = array();
		$status[] = JHTML::_('select.option', '1', JText::_('JOOMEXT_YES'));
		$status[] = JHTML::_('select.option', '0', JText::_('JOOMEXT_NO'));

		$controller = JFactory::getApplication()->isAdmin() ? 'cpanel' : 'fronttag';

		$return = '<div id="filter__num__dms">'.JText::_('DMS_DATE_DOWNLOADED_COLUMN').' '.JHTML::_('select.genericlist', $status, "filter[__num__][dms][status]", 'style="width:75px;" class="inputbox" onchange="countresults(__num__)" size="1"').' ' .
				'<input readonly type="text" name="filter[__num__][dms][document]" id="filter__num__dmsdocument" class="inputbox" style="width:100px" size="1" value="'.JText::_('DMS_DOCUMENT_TITLE_COLUMN').'"/>' .
				'<input type="hidden" name="filter[__num__][dms][documentid]" id="filter__num__dmsdocumentid" value="0"/>' .
				'<a class="modal" onclick="window.acymailing_js.openBox(this,\'index.php?option=com_acymailing&tmpl=component&ctrl='.$controller.'&task=plgtrigger&plg=dms&fctName=displayDMSDocuments&param=__num__\'); return false;" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">' .
				'<img class="icon16" src="'.ACYMAILING_IMAGES.'icons/icon-16-edit.png" />' .
				'</a>' .
				'<br /><input type="text" name="filter[__num__][dms][dateinf]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:100px" /> < '.JText::_('DMS_DATE_DOWNLOADED_COLUMN').' < <input type="text" name="filter[__num__][dms][datesup]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:100px" />' .
				'</div>';
		$type['dms'] = 'DMS';
		return $return;
	}

	function onAcyProcessFilterCount_dms(&$query,$filter,$num){
		$this->onAcyProcessFilter_dms($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_dms(&$query,$filter,$num){
		$datesVar = array('datesup','dateinf');
		foreach($datesVar as $oneDate){
			if(empty($filter[$oneDate])) continue;
			$filter[$oneDate] = acymailing_replaceDate($filter[$oneDate]);
			if(!is_numeric($filter[$oneDate])) $filter[$oneDate] = strtotime($filter[$oneDate]);
			if(is_numeric($filter[$oneDate])) $filter[$oneDate] = strftime('%Y-%m-%d %H:%M:%S',$filter[$oneDate]);
		}

		$leftJoin = '#__dms_bank_log AS dbl_'.$num.' ON sub.userid = dbl_'.$num.'.user_id';
		if(!empty($filter['documentid'])){
			$leftJoin .= ' AND dbl_'.$num.'.doc_id = '.$query->db->Quote($filter['documentid']);
		}

		if(!empty($filter['dateinf'])) $leftJoin .= ' AND dbl_'.$num.'.added > '.$query->db->Quote($filter['dateinf']);
		if(!empty($filter['datesup'])) $leftJoin .= ' AND dbl_'.$num.'.added < '.$query->db->Quote($filter['datesup']);

		if(!empty($filter['status'])){
			$query->join['dms_'.$num] = $leftJoin;
		}else{
			$query->leftjoin['dms_'.$num] = $leftJoin;
			$query->where['dms_'.$num] = 'dbl_'.$num.'.doc_id IS NULL';
		}
	}

	function onAcydisplayDMSDocuments($num){
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();

		$lang = JFactory::getLanguage();
		$lang->load('com_dms', JPATH_ADMINISTRATOR);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'dms';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order', 'doc_id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc',	'word' );
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));

		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );

		$searchMap = array('doc_id','doc_title','doc_type');
		$query = 'SELECT * FROM #__dms_bank';

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchMap)." LIKE $searchVal";
		}
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (',$filters).')';
		if(!empty ($pageInfo->filter->order->value)) {
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();

		//pagination
		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );
	?>

	<script language="javascript" type="text/javascript">
		function addDocument(selectedId, selectedName){
			parent.window.document.getElementById("filter<?php echo $num; ?>dmsdocument").value = selectedName;
			parent.window.document.getElementById("filter<?php echo $num; ?>dmsdocumentid").value = selectedId;

			parent.countresults(<?php echo $num; ?>);
			parent.acymailing_js.closeBox(true);
		}
	</script>


	<div id="acy_content">
		<div class="acytagpopup">
			<form action="#" method="post" name="adminForm"  id="adminForm"  autocomplete="off">
			 	<table class="adminlist table table-striped table-hover adminform" cellpadding="1" width="100%">
					<tr>
						<td width="100%">
							<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="search" value="<?php echo htmlspecialchars($pageInfo->search, ENT_COMPAT, 'UTF-8');?>" class="text_area" />
							<button class="btn" onclick="document.adminForm.limitstart.value=0;document.adminForm.task.value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
						</td>
					</tr>
				</table>
				<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
					<thead>
							<th/>
							<th class="title titlename">
								<?php echo JHTML::_('grid.sort', JText::_( 'DMS_DOCUMENT_TITLE_COLUMN'), 'doc_title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
							</th>
							<th class="title titletype">
								<?php echo JHTML::_('grid.sort', JText::_( 'ACY_TYPE'), 'doc_type', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
							</th>
							<th class="title titleid">
								<?php echo JHTML::_('grid.sort',   JText::_( 'ACY_ID' ), 'doc_id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
							</th>
						</tr>
					</thead>
					<tfoot>
						<tr>
							<td colspan="4">
								<?php
									echo $pagination->getListFooter();
									if(ACYMAILING_J30){
										$paginationNb = array();
										foreach(array(5,10,15,20,25,30,50,100) as $oneOption){
											$paginationNb[] = JHTML::_('select.option', $oneOption, $oneOption);
										}
										$paginationNb[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
										echo 'Display #'.JHTML::_('select.genericlist', $paginationNb, 'limit' , 'size="1" style="width:60px" onchange="Joomla.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
									}
									echo $pagination->getResultsCounter();
								?>
							</td>
						</tr>
					</tfoot>
					<tbody>
						<?php if(empty($pageInfo->limit->start)){ ?>
							<tr class="<?php echo "row0"; ?>" onclick="addDocument('0','<?php echo JText::_('ACY_ONE_PRODUCT'); ?>');">
								<td class="acytdcheckbox"></td>
								<td align="center">
									<?php
										echo JText::_('ACY_ONE_PRODUCT');
									?>
								</td>
								<td align="center">
									<?php
										echo JText::_('FIELD_DEFAULT');
									?>
								</td>
								<td align="center">0</td>
							</tr>
						<?php }
							$k = 1;
							for($i = 0,$a = count($rows);$i<$a;$i++){
								$row = $rows[$i];
						?>
							<tr class="<?php echo "row$k"; ?>" onclick="addDocument('<?php echo $row->doc_id; ?>','<?php echo htmlspecialchars(str_replace("'", "", $row->doc_title), ENT_COMPAT | ENT_IGNORE, 'UTF-8'); ?>');">
								<td class="acytdcheckbox"></td>
								<td align="center">
									<?php
										echo $row->doc_title;
									?>
								</td>
								<td align="center">
									<?php
										echo $row->doc_type;
									?>
								</td>
								<td align="center">
									<?php
										echo $row->doc_id;
									?>
								</td>
							</tr>
						<?php
								$k = 1-$k;
							}
						?>
					</tbody>
				</table>
				<input type="hidden" name="boxchecked" value="0" />
				<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
				<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
			</form>
		</div>
	</div>
	<?php
	}
}//endclass