<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingeasyprofile extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'easyprofile';
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new acyParameter( $plugin->params );
		}

		//check if the component is installed
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_jsn');
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
	 	if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !$app->isAdmin())) return;
		$onePlugin = new stdClass();
		//change the name
		$onePlugin->name = 'Easy Profile';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	//change the name
	function acymailing_easyprofile_show(){
		$config = acymailing_config();
		if($config->get('version') < '5.5.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();
		$lang = JFactory::getLanguage();
		$lang->load('com_jsn',JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order','a.id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir','desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_type = $app->getUserStateFromRequest( $paramBase.".filter_type", 'filter_type','','int' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id,DESC','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->pictauto = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );

		$db = JFactory::getDBO();

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.id, a.*, c.title ' .
				'FROM #__jsn_users AS a ' .
				'JOIN #__user_usergroup_map AS b ON a.id = b.user_id ' .
				'JOIN #__usergroups AS c ON b.group_id = c.id ' .
				'JOIN #__users AS d ON a.id = d.id ';

		//search fields...
		$searchFields = array('a.firstname','a.secondname','a.lastname','a.id','c.title','d.name','d.email','d.username');

		//apply search fields
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaycontent','all') == 'onlypub'){
			$filters[] = "d.block = 0";
		}

		//if the user filtered by group
		if(!empty($pageInfo->filter_cat)) $filters[] = "c.id = ".$pageInfo->filter_cat;

		//apply filters
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (',$filters).')';

		$query .= ' GROUP BY a.id ';


		//apply ordering
		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);

		//load results
		$rows = $db->loadObjectList();

		//yellow highlighting on search matches
		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search,$rows);

		//pagination
		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		//is this a Smart-Newsletter or a simple one ?
		$type = JRequest::getString('type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass)
			{
				<?php
					//we insert contents in the order the user selected it
				?>
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1)
				{
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass)
			{
				if(catid == 'all')
				{
					if(window.document.getElementById('cat'+catid).className == 'selectedrow')
					{
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						for(key in selectedCat)
						{
							if(!isNaN(key))
							{
								window.document.getElementById('cat'+key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid])
					{
						window.document.getElementById('cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				<?php
					//add the fields the user want to be displayed
				?>
				for(var i=0; i < document.adminForm.cbdisplay.length; i++)
				{
					if (document.adminForm.cbdisplay[i].checked)
					{
						 if(tmp == 0)
						 {
							 tmp += 1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }
					}
				}

				<?php
					//is the title clickable ?
				?>
				for(var i=0; i < document.adminForm.clickable.length; i++)
				{
					 if (document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '1')
					 {
						 otherinfo += '| link';
					 }
				}

				<?php
					//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value!=0)
				{
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				<?php
					//do we have to add a "read more" button ?
				?>
				for(var i=0; i < document.adminForm.readmore.length; i++)
				{
					 if (document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '1')
					 {
						 otherinfo += '| readmore';
					 }
				}

				<?php
					//picture management
				?>
				for(var i=0; i < document.adminForm.pict.length; i++)
				{
					if (document.adminForm.pict[i].checked)
					{
					 	if(document.adminForm.pict[i].value != '0')
							otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized')
						{
							 document.getElementById('pictsize').style.display = '';
							 if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							 if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				<?php
					//insert the tags with the right order
				?>
				for(var i in selectedContents)
				{
					if(selectedContents[i] && !isNaN(i))
					{
						tag = tag + '{<?php echo $this->name; ?>:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++)
				{
					if (document.adminForm.cbdisplayauto[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp+=1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }
					}
				}

				for(var i=0; i < document.adminForm.clickableauto.length; i++)
				{
					if (document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '1')
					{
						 otherinfo += '| link';
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value!=0)
				{
					otherinfo += "| wrap:"+document.adminForm.wrapauto.value;
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++)
				{
					 if (document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '1')
					 {
						 otherinfo += '| readmore';
					 }
				}

				tmp=0;
				for(var i=0; i < document.adminForm.autopict.length; i++)
				{
					if (document.adminForm.autopict[i].checked)
					{
						if(document.adminForm.autopict[i].value != '0')
							otherinfo += '| pict:'+document.adminForm.autopict[i].value;

						if(document.adminForm.autopict[i].value == 'resized')
						{
							 document.getElementById('pictsizeauto').style.display = '';
							 if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
							 if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				<?php
					//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value)
				{
					otherinfo += "| cols:"+document.adminForm.cols.value;
				}

				<?php
					//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value)
				{
					otherinfo += "| max:"+document.adminForm.max_article.value;
				}

				<?php
					//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value)
				{
					otherinfo += "| order:"+document.adminForm.contentorder.value;
				}

				<?php if($type == 'autonews'){

					//minimum number of content for the newsletter to be displayed... yes, a perfect english !
				?>
					if(document.adminForm.min_article.value)
					{
						otherinfo += "| min:"+document.adminForm.min_article.value;
					}

					<?php
						//filter the content : only newly created/modified
					?>
					if(document.adminForm.contentfilter && document.adminForm.contentfilter.value != 0)
					{
						otherinfo += "| filter:"+document.adminForm.contentfilter.value;
					}
				<?php }
					//insert the tag
				?>
				tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat)
				{
					if(selectedCat[icat] == 'selectedone')
					{
						tag += icat+'-';
					}
				}
				tag += otherinfo+'}<br />';

				setTag(tag);
			}
		//-->
		</script>
<?php
		// yes/no for the options
		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// here are the possible orderings
		$ordering = array();
		$ordering[] = JHTML::_('select.option', "id,DESC", JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "registerDate,DESC", JText::_('CREATED_DATE'));
		$ordering[] = JHTML::_('select.option', "name,ASC", JText::_('NAME'));
		$ordering[] = JHTML::_('select.option', "rand", JText::_('ACY_RANDOM'));

		// filter options
		$contentfilter = array();
		$contentfilter[] = JHTML::_('select.option', "0", JText::_('ACY_ALL'));
		$contentfilter[] = JHTML::_('select.option', "created", JText::_('ONLY_NEW_CREATED'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i=1;$i<11;$i++){
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane( $this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), $this->name.'_listings');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="username" id="username" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="username" id="username"><?php echo JText::_('ACY_USERNAME');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="firstname" id="firstname" onclick="updateTag();"/><label style="margin-left:5px" for="firstname" id="firstname"><?php echo JText::_('NAME');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="secondname" id="secondname" onclick="updateTag();"/><label style="margin-left:5px" for="secondname" id="secondname-lbl"><?php echo JText::_('SECONDNAME');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="lastname" id="lastname" onclick="updateTag();"/><label style="margin-left:5px" for="lastname" id="lastname-lbl"><?php echo JText::_('LASTNAME');?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="email" id="email" onclick="updateTag();"/><label style="margin-left:5px" for="email" id="email-lbl"><?php echo JText::_('EMAIL');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="groups" id="groups" onclick="updateTag();"/><label style="margin-left:5px" for="groups" id="groups-lbl"><?php echo JText::_('ACY_GROUP');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="regdate" id="regdate" onclick="updateTag();"/><label style="margin-left:5px" for="regdate" id="regdate-lbl"><?php echo JText::_('REGISTEREDDATE'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="avatar" id="avatar" onclick="updateTag();"/><label style="margin-left:5px" for="avatar" id="avatar-lbl"><?php echo JText::_('AVATAR');?></label></td>
			</tr>
			<tr>
				<td/>
				<?php
					$db->setQuery('SELECT title, alias FROM #__jsn_fields WHERE core = 0 AND level = 2 AND type <> "hide"');
					$extraFields = $db->loadObjectList();
					$position = 1;
					foreach($extraFields as $oneField){
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="'.$oneField->alias.'" id="'.$oneField->alias.'" onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneField->alias.'" id="'.$oneField->alias.'-lbl">'.$oneField->title.'</label></td>';
						if($position == 4){
							echo '</tr><tr><td/>';
							$position = 0;
						}
						$position++;
					}

					while($position != 5){
						$position++;
						echo '<td/>';
					}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
				<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
							echo JHTML::_('grid.sort', JText::_('NAME'), 'a.firstname', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('ACY_GROUP'), 'c.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php
							echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value );
						?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					if(!empty($rows)){
						foreach($rows as $row){
				?>
							<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
								<td class="acytdcheckbox"></td>
								<td>
									<?php
										if(!empty($row->firstname)) echo $row->firstname;
									?>
								</td>
								<td>
									<?php
										if(!empty($row->title)) echo $row->title;
									?>
								</td>
								<td align="center" style="text-align:center" >
									<?php
										// change field title
										echo $row->id;
									?>
								</td>
							</tr>
				<?php
							// this enables to know if we have to set the line background grey or white
							$k = 1-$k;
						}
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
<?php

		echo $tabs->endPanel();

		// start category tab
		echo $tabs->startPanel( JText::_('ACY_GROUP'), $this->name.'_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="username" id="usernameauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="usernameauto" id="usernameauto"><?php echo JText::_('ACY_USERNAME');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="firstname" id="firstnameauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="firstnameauto" id="firstnameauto-lbl"><?php echo JText::_('NAME');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="secondname" id="secondnameauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="secondnameauto" id="secondnameauto-lbl"><?php echo JText::_('SECONDNAME');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="lastname" id="lastnameauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="lastnameauto" id="lastnameauto-lbl"><?php echo JText::_('LASTNAME');?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="avatar" id="avatarauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="avatarauto" id="avatarauto-lbl"><?php echo JText::_('AVATAR');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="email" id="emailauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="emailauto" id="emailauto-lbl"><?php echo JText::_('EMAIL');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="groups" id="groupsauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="groupsauto" id="groupsauto-lbl"><?php echo JText::_('ACY_GROUP');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="regdate" id="regdateauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="regdateauto" id="regdateauto-lbl"><?php echo JText::_('REGISTEREDDATE'); ?></label></td>
			</tr>
			<tr>
				<td/>
				<?php
					$position = 1;
					foreach($extraFields as $oneField){
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField->alias.'" id="'.$oneField->alias.'auto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField->alias.'auto" id="'.$oneField->alias.'auto-lbl">'.$oneField->title.'</label></td>';
						if($position == 4){
							echo '</tr><tr><td/>';
							$position = 0;
						}
						$position++;
					}

					while($position != 5){
						$position++;
						echo '<td/>';
					}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
				<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td nowrap="nowrap">
					<?php 	echo JText::_('MIN_ARTICLE'); ?>
				</td nowrap="nowrap">
				<td nowrap="nowrap" colspan="2">
					<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('JOOMEXT_FILTER'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
					 <?php echo JHTML::_('select.genericlist', $contentfilter, 'contentfilter' , 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentfilter); ?>
				</td>
			</tr>
			<?php }else{ ?>
			<tr>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
<?php $k=0;
			?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo JText::_('ACY_ALL');
				?>
				</td>
			</tr>
			<?php
			if(!empty($this->catvalues))
			foreach($this->catvalues as $oneCat)
			{
			 if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->startPanel(JText::_('USER_FIELDS'), $this->name.'_fields');
		echo '<br style="font-size:1px"/>
		<table class="adminlist table table-hover" cellpadding="1" width="100%">';

		$db->setQuery('SELECT a.* FROM #__jsn_fields AS a WHERE a.published = 1 AND a.type NOT LIKE "'.implode('%" AND a.type NOT LIKE "', array("password", "delimeter", "hide")).'%" ORDER BY a.id ASC');
		$fields = $db->loadObjectList();
		$k = 0;
		foreach ($fields as $oneField){
			if(!empty($oneField->type)){
				echo '<tr class="row'.$k.'" onclick="setTag(\'{easyprofilefield:'.$oneField->id.'}\');insertTag();" ><td class="acytdcheckbox"/><td>'.ucfirst(strtolower($oneField->title)).'</td></tr>';
				$k = 1-$k;
			}
		}

		echo '</table>';
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		$db = JFactory::getDBO();
		$db->setQuery('SELECT id, parent_id, title FROM #__usergroups ORDER BY id ASC');
		$mosetCats = $db->loadObjectList();
		$this->cats = array();
		if(!empty($mosetCats))
			foreach($mosetCats as $oneCat)
				$this->cats[$oneCat->parent_id][] = $oneCat;

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist',$this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function _handleChildrens($parent_id=0,$level=0){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			$this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->title);
			$this->_handleChildrens($cat->id,$level+1);
		}
	}

	function acymailing_replaceusertags(&$email,&$user,$send = true){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$db = JFactory::getDBO();
		$time = time();
		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'easyprofilefield');
		$this->tags = array();

		if(empty($tags)) return $return;

		$db->setQuery('SELECT * FROM #__jsn_fields');
		$fields = $db->loadObjectList('id');
		foreach($fields as $i => $oneField){
			$fields[$i]->params = json_decode($oneField->params);
		}

		$db->setQuery('SELECT a.*, b.username, b.email, b.registerDate AS registereddate, b.lastvisitDate AS lastvisitdate FROM #__jsn_users AS a JOIN #__users AS b ON a.id = b.id WHERE a.id = '.intval($user->userid));
		$userData = $db->loadObject();
		$originalUserData = $userData;
		$specified = false;

		foreach($tags as $oneTag => $parameter){
			if(!empty($parameter->email)){
				$db->setQuery('SELECT a.*, b.username, b.email, b.registerDate AS registereddate, b.lastvisitDate AS lastvisitdate FROM #__jsn_users AS a JOIN #__users AS b ON a.id = b.id WHERE b.email = '.$db->Quote($parameter->email));
				$userData = $db->loadObject();
				$specified = true;
			}elseif($specified){
				$userData = $originalUserData;
			}

			$column = $fields[$parameter->id]->alias;
			if(empty($userData->$column)){
				$this->tags[$oneTag] = ''; continue;
			}

			if($fields[$parameter->id]->type == 'image'){
				$this->tags[$oneTag] = '<img src="'.$userData->$column.'"/>'; continue;
			}

			if($fields[$parameter->id]->type == 'checkboxlist'){
				$options = array();
				$optionsBrutes = explode("\n", $fields[$parameter->id]->params->checkbox_options);
				foreach($optionsBrutes as $oneOpt){
					$values = explode('|', $oneOpt);
					$options[$values[0]] = $values[1];
				}
				$selected = json_decode($userData->$column);
				foreach($selected as $i => $oneOpt){
					$selected[$i] = $options[$oneOpt];
				}
				$this->tags[$oneTag] = implode(', ', $selected); continue;
			}

			if(in_array($fields[$parameter->id]->type, array('date', 'registerdate', 'lastvisitdate'))){
				$this->tags[$oneTag] = acymailing_getDate(acymailing_getTime($userData->$column), JText::_('DATE_FORMAT_LC')); continue;
			}

			if($fields[$parameter->id]->type == 'radiolist'){
				$allOptions = explode("\n", $fields[$parameter->id]->params->radio_options);
				foreach($allOptions as $oneOpt){
					$values = explode('|', $oneOpt);
					if($values[0] != $userData->$column) continue;
					$this->tags[$oneTag] = $values[1];
				}

				if(!empty($this->tags[$oneTag])) continue;

				$this->tags[$oneTag] = '';
				continue;
			}

			if($fields[$parameter->id]->type == 'link'){
				$this->tags[$oneTag] = '<a href="'.$userData->$column.'">'.$userData->$column.'</a>';
				continue;
			}

			if($fields[$parameter->id]->type == 'email' || $fields[$parameter->id]->type == 'usermail'){
				$this->tags[$oneTag] = '<a href="mailto:'.$userData->$column.'">'.$userData->$column.'</a>';
				continue;
			}

			if($fields[$parameter->id]->type == 'selectlist'){
				$allOptions = explode("\n", $fields[$parameter->id]->params->select_options);
				foreach($allOptions as $oneOpt){
					$values = explode('|', $oneOpt);
					$uservalue = json_decode($userData->$column);
					if(($uservalue !== NULL && $values[0] != $uservalue) || ($uservalue === NULL && $values[0] != $userData->$column)) continue;
					$this->tags[$oneTag] = $values[1];
				}

				if(!empty($this->tags[$oneTag])) continue;

				$this->tags[$oneTag] = '';
				continue;
			}

			$this->tags[$oneTag] = $userData->$column;
		}

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags), $this->tags, $email->body);
			$this->mailerHelper = acymailing_get('helper.mailer');
			$textTags = array();
			$subjectTags = array();

			foreach($this->tags as $tag => $result){
				$subjectTags[$tag] = strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result));
				$textTags[$tag] = $this->mailerHelper->textVersion($result);
			}

			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($textTags), $textTags, $email->altbody);
			$email->subject = str_replace(array_keys($subjectTags), $subjectTags, $email->subject);
		}

		return $return;
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags)) return;

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$db = JFactory::getDBO();
		$query = 'SELECT * FROM #__jsn_fields WHERE level = 2 AND core = 0 AND type <> "hide"';
		$db->setQuery($query);
		$this->fields = $db->loadObjectList();

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params){
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content,true);
				$subjectreplace[$i] = strip_tags($content);
		}
		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
	}

	function _replaceContent(&$tag){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		$lang = JFactory::getLanguage();
		$lang->load('com_jsn',JPATH_SITE);

	 	// extract the fields selected
		if(!empty($tag->display)){
			$tag->display = explode(',',$tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
			unset($tag->display);
		}

		// load content

		$db = JFactory::getDBO();
		$query = 'SELECT a.*, d.email, c.title, d.username, d.registerDate ' .
				'FROM #__jsn_users AS a ' .
				'JOIN #__user_usergroup_map AS b ON a.id = b.user_id ' .
				'JOIN #__usergroups AS c ON b.group_id = c.id ' .
				'JOIN #__users AS d ON a.id = d.id ' .
				'WHERE a.id = '.intval($tag->id).' LIMIT 1';

		$db->setQuery($query);
		$content = $db->loadObject();

		//In case of we could not load the article for any reason...
		if(empty($content)){
			$app = JFactory::getApplication();
			if($app->isAdmin()) $app->enqueueMessage('The profile "'.$tag->id.'" could not be loaded','notice');
			return '';
		}

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		// create the link for the title and the read more button
		$link = ACYMAILING_LIVE.'index.php?option=com_jsn&view=profile&id='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

		if(!empty($tag->link)){
			$linkLeft = '<a href="'.$link.'">';
			$linkRight = '</a>';
		}else{
			$linkLeft = '';
			$linkRight = '';
		}

		$result .= '<tr><td colspan="2">'.$linkLeft;

		if(!empty($tag->avatar) && !empty($content->avatar) && file_exists(JPATH_SITE.DS.str_replace('/', DS, $content->avatar))){
			$varFields['{avatarhtml}'] = '<img style="float:left;" src="'.$content->avatar.'"/>';
			$result .= $varFields['{avatarhtml}'];
		}

		// display the title
		if(!empty($tag->firstname) && !empty($content->firstname)){
			$result .= '<h2 class="acymailing_title">'.$content->firstname.'</h2>';
		}

		$result .= $linkRight.'</td></tr>';

		if(!empty($tag->username) && !empty($content->username)){
			$result .= '<tr><td nowrap="nowrap" style="text-align:right;padding-right:5px;" valign="top"><b>'.JText::_('ACY_USERNAME').'</b></td><td>'.$content->username.'</td></tr>';
		}

		if(!empty($tag->secondname) && !empty($content->secondname)){
			$result .= '<tr><td nowrap="nowrap" style="text-align:right;padding-right:5px;" valign="top"><b>'.JText::_('SECONDNAME').'</b></td><td>'.$content->secondname.'</td></tr>';
		}

		if(!empty($tag->lastname) && !empty($content->lastname)){
			$result .= '<tr><td nowrap="nowrap" style="text-align:right;padding-right:5px;" valign="top"><b>'.JText::_('LASTNAME').'</b></td><td>'.$content->lastname.'</td></tr>';
		}

		if(!empty($tag->email) && !empty($content->email)){
			$result .= '<tr><td nowrap="nowrap" style="text-align:right;padding-right:5px;" valign="top"><b>'.JText::_('EMAIL').'</b></td><td>'.$content->email.'</td></tr>';
		}

		if(!empty($tag->groups)){
			$db->setQuery('SELECT a.title FROM #__usergroups AS a JOIN #__user_usergroup_map AS b ON a.id = b.group_id WHERE b.user_id = '.intval($tag->id));
			$allGroups = $db->loadObjectList();
			$listGroups = array();
			foreach($allGroups as $oneGroup){
				$listGroups[] = $oneGroup->title;
			}
			$varFields['{groups}'] = implode(', ', $listGroups);
			$result .= '<tr><td nowrap="nowrap" style="text-align:right;padding-right:5px;" valign="top"><b>'.JText::_('ACY_GROUP').'</b></td><td>'.$varFields['{groups}'].'</td></tr>';
		}

		if(!empty($tag->regdate) && !empty($content->registerDate)){
			$result .= '<tr><td nowrap="nowrap" style="text-align:right;padding-right:5px;" valign="top"><b>'.JText::_('REGISTEREDDATE').'</b></td><td>'.acymailing_getDate(acymailing_getTime($content->registerDate), JText::_('DATE_FORMAT_LC')).'</td></tr>';
		}

		foreach($this->fields as $oneField){
			$alias = $oneField->alias;
			if(!empty($tag->$alias) && !empty($content->$alias) && $content->$alias != '0000-00-00 00:00:00' && $content->$alias != '""'){
				$oneField->params_decoded = json_decode($oneField->params);

				$result .= '<tr><td nowrap="nowrap" style="text-align:right;padding-right:5px;" valign="top"><strong>';
				if(empty($oneField->params_decoded->hidetitle)) $result .= $oneField->title;
				$result .= '</strong></td><td>';

				if($oneField->type == 'checkboxlist'){
					$options = explode("\n", $oneField->params_decoded->checkbox_options);
					$optionsOrdered = array();
					foreach($options as $i => $oneOPT){
						$options[$i] = explode('|', $oneOPT);
						$optionsOrdered[$options[$i][0]] = $options[$i][1];
					}
					preg_match_all('/"([^"]*)"/', $content->$alias, $selected);
					$displayResult = array();
					foreach($selected[1] as $oneOPT){
						$displayResult[] = $optionsOrdered[$oneOPT];
					}

					if(!empty($displayResult)) $varFields['{'.$oneField->alias.'}'] = implode(', ', $displayResult);

				}elseif($oneField->type == 'date'){
					$varFields['{'.$oneField->alias.'}'] = acymailing_getDate(acymailing_getTime($content->$alias), JText::_('DATE_FORMAT_LC'));
				}elseif($oneField->type == 'image'){
					$varFields['{'.$oneField->alias.'}'] = '<img src="'.$content->$alias.'"/>';
				}elseif($oneField->type == 'link'){
					$varFields['{'.$oneField->alias.'}'] = '<a href="'.$content->$alias.'">'.$content->$alias.'</a>';
				}elseif($oneField->type == 'radiolist' && !empty($oneField->params_decoded->radio_options)){
					$options = explode("\n", $oneField->params_decoded->radio_options);
					$optionsOrdered = array();
					foreach($options as $i => $oneOPT)
					{
						$options[$i] = explode('|', $oneOPT);
						$optionsOrdered[$options[$i][0]] = $options[$i][1];
					}

					if(!empty($optionsOrdered[$content->$alias])) $varFields['{'.$oneField->alias.'}'] = $optionsOrdered[$content->$alias];

				}elseif($oneField->type == 'selectlist'){
					$options = explode("\n", $oneField->params_decoded->select_options);
					$optionsOrdered = array();
					foreach($options as $i => $oneOPT){
						$options[$i] = explode('|', $oneOPT);
						$optionsOrdered[$options[$i][0]] = $options[$i][1];
					}

					if(!empty($optionsOrdered[trim($content->$alias,'"')])) $varFields['{'.$oneField->alias.'}'] = $optionsOrdered[trim($content->$alias,'"')];

				}elseif($oneField->type == 'text' || $oneField->type == 'textarea'){
					$varFields['{'.$oneField->alias.'}'] = $acypluginsHelper->wrapText($content->$alias, $tag);
				}else{
					$varFields['{'.$oneField->alias.'}'] = $content->$alias;
				}
				if(empty($varFields['{'.$oneField->alias.'}'])) $varFields['{'.$oneField->alias.'}'] = JText::_('COM_USERS_PROFILE_VALUE_NOT_FOUND');

				$result .= $varFields['{'.$oneField->alias.'}'].'</td></tr>';
			}
		}

		if(!empty($tag->readmore)){
			$result .= '<tr><td colspan="2"><br /><a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a></td></tr>';
		}

		$result .= '</table></div><br />';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $acypluginsHelper->removeJS($result);

		//resize or remove pictures
		if(!isset($tag->pict)) $tag->pict = 0;
		$result = $acypluginsHelper->managePicts($tag, $result);
		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);

			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);

			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag,strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result)),$email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		$db = JFactory::getDBO();
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT DISTINCT a.id ' .
				'FROM #__jsn_users AS a ' .
				'JOIN #__user_usergroup_map AS b ON a.id = b.user_id ' .
				'JOIN #__usergroups AS c ON b.group_id = c.id ' .
				'JOIN #__users AS d ON a.id = d.id ';

			$where = array();

			// load only needed content
			if(!empty($selectedArea)){
				$where[] = 'b.group_id IN ('.implode(',',$selectedArea).')';
			}

			// filter results created or modified
			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate']) && $parameter->filter == 'created'){
				$where[] = 'd.registerDate > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
			}

			// Only published content
			$where[] = 'd.block = 0';

			// Apply filters
			if(!empty($where)) $query .= ' WHERE ('.implode(') AND (',$where).')';

			// Ordering
			if(!empty($parameter->order)){
				if($parameter->order == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY d.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			// If there is no limit, then we add one
			if(!empty($parameter->max))
				$query .= ' LIMIT '.intval($parameter->max);
			else
				$query .= ' LIMIT 20'; // limit, because we do not want to display one bilion contents in the newsletter...

			// load content IDs
			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);

			// Check the number of results
			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We will not generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough '.$this->name.' content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles)){
				// If the user created its own template...
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = $this->name.':'.$oneArticleId;
						if(!empty($parameter->link)) $args[] = 'link';
						if(!empty($parameter->readmore)) $args[] = 'readmore';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}

	function onAcyDisplayFilters(&$type){
		if(!$this->component_installed) return '';

		$config = acymailing_config();

		if($config->get('version') < '4.8.1'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this Easy Profile plugin will NOT work','error');
			return;
		}

		$db = JFactory::getDBO();
		$fields = acymailing_getColumns('#__jsn_users');
		if(empty($fields)) return;

		$field = array();
		foreach($fields as $oneField => $i){
			$field[] = JHTML::_('select.option',$oneField,$oneField);
		}

		$type['easyprofilefield'] = 'Easy Profile fields';

		$jsOnChange = "displayCondFilter('displayEasyProfileValues', 'toChange__num__',__num__,'map='+document.getElementById('filter__num__easyprofilefieldfield').value+'&cond='+document.getElementById('filter__num__easyprofilefieldoperator').value+'&value='+document.getElementById('filter__num__easyprofilefieldvalue').value);";
		$operators = acymailing_get('type.operators');
		$operators->extra = 'onchange="'.$jsOnChange.'"';

		$return = '<div id="filter__num__easyprofilefield">'.JHTML::_('select.genericlist', $field, "filter[__num__][easyprofilefield][field]", 'onchange="'.$jsOnChange.'" class="inputbox" size="1"', 'value', 'text');
		$return .= ' '.$operators->display("filter[__num__][easyprofilefield][operator]").' <span id="toChange__num__"><input onchange="countresults(__num__)" class="inputbox" type="text" name="filter[__num__][easyprofilefield][value]" style="width:200px" value="" id="filter__num__easyprofilefieldvalue"></span></div>';

	 	return $return;
	}

	function onAcyTriggerFct_displayEasyProfileValues(){
 		$num = JRequest::getInt('num');
		$map = JRequest::getCmd('map');
		$cond = JRequest::getVar('cond','','','string',JREQUEST_ALLOWHTML);
		$value = JRequest::getVar('value','','','string',JREQUEST_ALLOWHTML);

		// Default return: empty input field
		$emptyInputReturn = '<input onchange="countresults('.$num.')" class="inputbox" type="text" name="filter['.$num.'][easyprofilefield][value]" id="filter'.$num.'easyprofilefieldvalue" style="width:200px" value="'.$value.'">';

		if(empty($map) || $map == 'params' || !in_array($cond, array('=','!='))) return $emptyInputReturn;

		$db = JFactory::getDBO();
		$db->setQuery('SELECT DISTINCT `'.acymailing_secureField($map).'` AS value FROM #__jsn_users LIMIT 100');
 		$prop = $db->loadObjectList();

		// No enough or too much values -> default return
 		if(empty($prop) || count($prop) >= 100 || (count($prop) == 1 && (empty($prop[0]->value) || $prop[0]->value == '-'))) return $emptyInputReturn;

 		return JHTML::_('select.genericlist', $prop, "filter[$num][easyprofilefield][value]", 'onchange="countresults('.$num.')" class="inputbox" size="1" style="width:200px"', 'value', 'value', $value, 'filter'.$num.'easyprofilefieldvalue');
	}

	function onAcyProcessFilterCount_easyprofilefield(&$query,$filter,$num){
		$this->onAcyProcessFilter_easyprofilefield($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_easyprofilefield(&$query,$filter,$num){
		$value = acymailing_replaceDate($filter['value']);

		if(strpos($filter['value'],'{time}') !== false){
			//We had a dynamic date... we need to convert it into another format as it's not a numeric one
			$value = strftime('%Y-%m-%d',$value);
		}

	 	$query->leftjoin['easyprofile'] = '#__jsn_users AS easyprofile ON easyprofile.id = sub.userid';
	 	$query->where[] = $query->convertQuery('easyprofile',$filter['field'],$filter['operator'],$value);
	}
}//endclass
?>