<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingJomsocial extends JPlugin{
	var $lastuserid = 0;

	function __construct(& $subject, $config){
		parent::__construct($subject, $config);
		if(!isset ($this->params)){
			$plugin =& JPluginHelper::getPlugin('acymailing', 'jomsocial');
			$this->params = new acyParameter($plugin->params);
		}

		if(file_exists(rtrim(JPATH_ADMINISTRATOR, DS).DS.'components'.DS.'com_community'.DS.'manifest.xml')){
			$xml = JFactory::getXML(rtrim(JPATH_ADMINISTRATOR, DS).'/components/com_community/manifest.xml');
			if(!empty($xml->version)) $this->jsVersion = $xml->version;
		}

		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_community');
	}

	function acymailing_getPluginType(){

		$onePlugin = new stdClass();
		$onePlugin->name = JText::_('JomSocial');
		$onePlugin->function = 'acymailingjomsocial_show';
		$onePlugin->help = 'plugin-jomsocial';

		return $onePlugin;
	}

	function acymailingjomsocial_show(){

		// Load Jomsocial language file
		$lang = JFactory::getLanguage();
		$lang->load('com_community', JPATH_SITE);

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane('joomlacontent_tab');

		// Render tabs
		$this->_showUsersTab($tabs);
		$this->_showVideosTab($tabs);
		$this->_showGroupsTab($tabs);
		$this->_showDiscussTab($tabs);
		$this->_showEventsTab($tabs);
		$this->_showAlbumsTab($tabs);
		$this->_showPhotosTab($tabs);
		$this->_showGeneralWallTab($tabs);
		$this->_showUserFieldsTab($tabs);

		// Load javascript
		$this->_loadJavascript();

		echo $tabs->endPane();
	}

	/**
	 * DEPRECATED : Old function... use $send = true/false instead in the acymailing_replaceusertags function
	 */
	function acymailing_replaceusertagspreview(& $email, & $user){
		return $this->acymailing_replaceusertags($email, $user);
	}

	function acymailing_replacetags(& $email, $send = true){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags), $this->tags, $email->body);
			$this->mailerHelper = acymailing_get('helper.mailer');
			$textTags = array();
			$subjectTags = array();

			foreach($this->tags as $tag => $result){
				//$subjectTags[$tag] = str_replace($tag, strip_tags(str_replace('</tr><tr>', ' | ', $result)));

				$subjectTags[$tag] = strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis', ' | ', $result));
				$textTags[$tag] = $this->mailerHelper->textVersion($result);
			}

			if(!empty($email->altbody)){
				$email->altbody = str_replace(array_keys($textTags), $textTags, $email->altbody);
			}
			$email->subject = str_replace(array_keys($subjectTags), $subjectTags, $email->subject);
		}
	}

	function acymailing_generateautonews(& $email){
		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		$time = time();

		//Check if we should generate the SmartNewsletter or not...
		$match = '#{jomsocial(users|videos|groups|discuss|events|albums|photos|wall):(.*)}#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty ($email->$var)){
				continue;
			}
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty ($results[$var][0])){
				unset ($results[$var]);
			}
		}

		//If we didn't find anything... so we won't try to stop the generation
		if(!$found) return $return;

		$jspath = JPATH_ROOT.DS.'components'.DS.'com_community';
		include_once($jspath.DS.'libraries'.DS.'core.php');
		include_once($jspath.DS.'libraries'.DS.'karma.php');

		// Load Jomsocial language file
		$lang = JFactory::getLanguage();
		$lang->load('com_community', JPATH_SITE);

		$this->tags = array();

		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset ($this->tags[$oneTag])) continue;

				$arguments = explode('|', strip_tags($allresults[2][$i]));
				$parameter = array();

				if(!empty ($email->params['lastgenerateddate'])) $parameter['lastgenerateddate'] = $email->params['lastgenerateddate'];

				$parameter['time'] = $time;

				//The first argument is a list of categories
				$parameter['cats'] = explode('-', $arguments[0]);

				for($a = 1; $a < count($arguments); $a++){
					$args = explode(':', $arguments[$a]);
					$arg0 = trim($args[0]);
					if(isset($args[1])){
						$parameter[$arg0] = $args[1];
					}else{
						$parameter[$arg0] = true;
					}
				}

				$methodName = '_replace'.strtolower($allresults[1][$i]);
				if(!method_exists($this, $methodName)){
					$this->tags[$oneTag] = 'method '.$methodName.' not found';
				}else{
					$ret = $this->$methodName ($oneTag, $parameter);
					if(is_object($ret) && isset($ret->status) && !$ret->status){
						$return->status = false;
						$return->message .= !empty($ret->message) ? $ret->message.' ' : '';
					}
				}
			}
		}

		return $return;
	}

	function _replaceusers($oneTag, $params){
		// Clean parameters
		$allowedOrders = array('u.registerDate,DESC', 'u.lastvisitDate,DESC', 'c.view,DESC', 'c.points,DESC', 'rand()');
		$allowedFields = array(// Fields from #__community_fields
							   // (only here for compatibility with a previous version of this plugin)
							   'birthdate' => 'field_birthdate', 'about' => 'field_aboutme', 'address' => 'field_address', 'website' => 'field_website', 'college' => 'field_college', 'graduation' => 'field_graduation', // Fields from #__users and #__community_users
							   'karma' => 'c.points', 'avatar' => 'c.avatar', 'email' => 'u.email', 'registerdate' => 'u.registerDate', 'lastvisitdate' => 'u.lastvisitDate', 'views' => 'c.view', 'friends' => 'c.friendcount');

		// Get extra fields from #__community_fields
		$db = JFactory::getDBO();
		$db->setQuery("SELECT `fieldcode`
			FROM `#__community_fields`
			WHERE `type` != 'group'
			ORDER BY `ordering` ASC");
		$extraFields = $db->loadObjectList();
		// Group extra fields by fieldcode
		$extra = array();
		foreach($extraFields as $field){
			$extra[strtolower($field->fieldcode)] = strtolower($field->fieldcode);
		}
		// Merge extra fields with allowed fields
		$allowedFields = array_merge($allowedFields, $extra);

		$params = $this->_cleanCommonParams($params, $allowedOrders, $allowedFields);
		unset($allowedOrders);
		unset($allowedFields);
		$fields = $params['fields'];

		// Only valid users
		$where = 'u.block = 0';

		// Only users with public profile
		if(empty($params['noprivacy'])) $where .= ' AND (c.params LIKE "%\"privacyProfileView\":0%" OR c.params LIKE "%\"privacyProfileView\":\"0%" OR c.params LIKE "%privacyProfileView=0%")';

		// Auto-newsletter's filter (time limit)
		if(!empty($params['lastgenerateddate'])){
			switch($params['filter']){
				case 'created':
				case 'modify';
					$where .= ' AND u.registerDate > \''.date('Y-m-d H:i:s', $params['lastgenerateddate'] - date('Z')).'\'';
					break;
				default:
					break;
			}
		}

		// Image required ?
		if(!empty($params['image']->required)) $where .= ' AND LENGTH(c.thumb) > 0';

		// Set the final query
		$query = 'SELECT DISTINCT c.userid AS id
			FROM #__community_users AS c
			JOIN #__users AS u ON c.userid = u.id';
		if(!empty($params['group'])){
			$query .= '
			JOIN #__community_groups_members AS ug ON ug.memberid = c.userid AND ug.groupid = '.intval($params['group']);
		}
		$query .= '
			WHERE '.$where.'
			ORDER BY '.$params['order'].' LIMIT '.$params['start'].','.$params['max'];

		// Submit the query
		$db = JFactory::getDBO();
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$db->setQuery($query);
		$loadedUsers = $db->loadObjectList();

		// Display the result
		$stringTag = '';
		if(empty($loadedUsers)){
			$return->status = false;
		}else{
			if(count($loadedUsers) < $params['min']){
				// We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough elements for the tag '.$oneTag.' : '.count($loadedUsers).' / '.$params['min'];
				$return->message .= ' between '.acymailing_getDate($params['lastgenerateddate']).' and '.acymailing_getDate($params['time']);
			}

			// Fetch users
			$elements = array();
			foreach($loadedUsers as $oneUser){
				$user = CFactory::getUser($oneUser->id);
				$juser = JFactory::getUser($oneUser->id);

				$profileLink = ACYMAILING_LIVE.'index.php?option=com_community&view=profile&userid='.$oneUser->id.'&Itemid=1';
				$username = $user->getDisplayName();

				// Thumbnail
				$image = null;
				if($params['image'] !== false){
					$thumbnail = $user->getThumbAvatar();
					$original = $user->getAvatar();
					$image = $this->_resizeImage($thumbnail, $original, $params['image']);
				}

				// Get extra fields
				$db->setQuery('SELECT f.name AS name, f.fieldcode AS fieldcode, v.value AS value
					FROM #__community_fields AS f
					JOIN #__community_fields_values AS v ON f.id = v.field_id
					WHERE v.user_id = '.intval($oneUser->id).' AND v.access = 0');
				$extraFields = $db->loadObjectList();

				// Group extra fields by fieldcode
				$extra = array();
				foreach($extraFields as $field){
					$field->name = JText::_($field->name);
					$extra[strtolower($field->fieldcode)] = $field;
				}

				// Render HTML
				$attributes = array();
				$model = CFactory::getModel('profile');
				foreach($fields as $field){
					switch($field){
						case 'birthdate':
						case 'field_birthdate':
							if(!empty($extra['field_birthdate']->value)){
								$attributes['birthdate'] = ($params['nolabel']) ? '' : '<h3>'.$extra['field_birthdate']->name.'</h3>';
								$attributes['birthdate'] .= $model->formatDate($extra['field_birthdate']->value);
							}
							break;
						case 'about':
						case 'field_aboutme':
							if(!empty($extra['field_aboutme']->value)){
								if(!empty($params['chars']) && strlen($extra['field_aboutme']->value) > $params['chars']){
									$extra['field_aboutme']->value = substr($extra['field_aboutme']->value, 0, $params['chars']).'...';
								}
								$attributes['about'] = ($params['nolabel']) ? '' : '<h3>'.$extra['field_aboutme']->name.'</h3>';
								$attributes['about'] .= $extra['field_aboutme']->value;
							}
							break;
						case 'address':
						case 'field_address':
							if(!empty($extra['field_address']->value)){
								$attributes['address'] = ($params['nolabel']) ? '' : '<h3>'.$extra['field_address']->name.'</h3>';
								if(strstr($user->getAddress(), 'COM_COMMUNITY') == false){
									$attributes['address'] .= $user->getAddress();
								}else{
									if(empty($lang)){
										$lang = JFactory::getLanguage();
										$lang->load('com_community.country', JPATH_SITE);
									}
									preg_match('/COM_COMMUNITY[A-Z_]*/', $user->getAddress(), $language);
									$attributes['address'] .= trim(str_replace($language[0], '', $user->getAddress()), ',');
								}
							}
							break;
						case 'website':
						case 'field_website':
							if(!empty($extra['field_website']->value)){
								$attributes['website'] = ($params['nolabel']) ? '' : '<h3>'.$extra['field_website']->name.'</h3>';
								$attributes['website'] .= '<a href="'.$extra['field_website']->value.'">'.$extra['field_website']->value.'</a>';
							}
							break;
						case 'college':
						case 'field_college':
							if(!empty($extra['field_college']->value)){
								$attributes['college'] = ($params['nolabel']) ? '' : '<h3>'.$extra['field_college']->name.'</h3>';
								$attributes['college'] .= $extra['field_college']->value;
							}
							break;
						case 'graduation':
						case 'field_graduation':
							if(!empty($extra['field_graduation']->value)){
								$attributes['graduation'] = ($params['nolabel']) ? '' : '<h3>'.$extra['field_graduation']->name.'</h3>';
								$attributes['graduation'] .= $extra['field_graduation']->value;
							}
							break;
						case 'karma':
							$attributes['karma'] = ($params['nolabel']) ? '' : '<h3>'.JTEXT::_('COM_COMMUNITY_KARMA').'</h3>';
							$attributes['karma'] .= '<img src="'.str_replace('/administrator', '', CKarma::getKarmaImage($user)).'" />';
							break;
						case 'email':
							$attributes['email'] = ($params['nolabel']) ? '' : '<h3>'.JTEXT::_('COM_COMMUNITY_EMAIL').'</h3>';
							$attributes['email'] .= '<a href="mailto:'.$juser->email.'">'.$juser->email.'</a>';
							break;
						case 'registerdate':
							$attributes['registerdate'] = ($params['nolabel']) ? '' : '<h3>'.JTEXT::_('COM_COMMUNITY_MEMBER_SINCE').'</h3>';
							$attributes['registerdate'] .= JHTML::_('date', $juser->registerDate, JText::_('DATE_FORMAT_LC2'));
							break;
						case 'lastvisitdate':
							$attributes['lastvisitdate'] = ($params['nolabel']) ? '' : '<h3>'.JTEXT::_('COM_COMMUNITY_LAST_LOGIN').'</h3>';
							$attributes['lastvisitdate'] .= JHTML::_('date', $juser->lastvisitDate, JText::_('DATE_FORMAT_LC2'));
							break;
						case 'views':
							$attributes['views'] = ($params['nolabel']) ? '' : '<h3>'.JTEXT::_('COM_COMMUNITY_PROFILE_VIEW').'</h3>';
							$attributes['views'] .= $user->getViewCount();
							break;
						case 'friends':
							$attributes['friends'] = ($params['nolabel']) ? '' : '<h3>'.JTEXT::_('COM_COMMUNITY_PROFILE_FRIENDS').'</h3>';
							$attributes['friends'] .= $user->getFriendCount();
							break;
						default:
							if(!empty($extra[$field]->value)){
								if($field != 'field_country' || ($field == 'field_country' && strstr($extra[$field]->value, 'COM_COMMUNITY_LANG') == false)){
									$attributes[$field] = ($params['nolabel']) ? '' : '<h3>'.$extra[$field]->name.'</h3>';
									$attributes[$field] .= $extra[$field]->value;
								}else if($field == 'field_country' && strstr($extra[$field]->value, 'COM_COMMUNITY_LANG') != false){

									if(empty($lang)){
										$lang = JFactory::getLanguage();
										$lang->load('com_community.country', JPATH_SITE);
									}
									$attributes[$field] = ($params['nolabel']) ? '' : '<h3>'.$extra[$field]->name.'</h3>';
									$attributes[$field] .= JText::_($extra[$field]->value);
								}
							}
							break;
					}
				}

				$oneElement = '<table class="jomsocialuser">';
				$oneElement .= $this->_displayElement($profileLink, $username, $image, $params['title'], $attributes);
				$oneElement .= '</table>';

				// Alternative template
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialuser.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialuser.php');
					$oneElement = ob_get_clean();
				}

				$elements[] = $oneElement;
			}

			// Display users as a table
			$opt = new stdClass();
			$opt->cols = $params['cols'];
			$stringTag = $this->displayTable($elements, $opt);
		}

		$this->tags[$oneTag] = $stringTag;

		return $return;
	}

	function _replacevideos($oneTag, $params){
		// Clean parameters
		$allowedOrders = array('v.created,DESC', 'v.hits,DESC', 'rand()');
		$allowedFields = array('description' => 'v.description', 'duration' => 'v.duration', 'uploadedby' => 'v.creator', 'uploadedon' => 'v.created', 'views' => 'v.hits', 'category' => 'v.category_id',);
		$params = $this->_cleanCommonParams($params, $allowedOrders, $allowedFields);
		unset($allowedOrders);
		unset($allowedFields);
		$fields = $params['fields'];

		// Only published videos
		$where = ' AND v.published = 1';

		// Only public videos
		$where .= ' AND (u.params LIKE "%\"privacyVideoView\":0%" OR u.params LIKE "%\"privacyVideoView\":\"0%" OR u.params LIKE "%privacyVideoView=0%")';

		// Auto-newsletter's filter (time limit)
		if(!empty($params['lastgenerateddate'])){
			switch($params['filter']){
				case 'created':
				case 'modify':
					$where .= ' AND v.created > \''.date('Y-m-d H:i:s', $params['lastgenerateddate'] - date('Z')).'\'';
					break;
				default:
					break;
			}
		}

		// Image required ?
		if(!empty($params['image']->required)) $where .= ' AND LENGTH(v.thumb) > 0';

		// Categories restriction
		if(!empty($params['cats'])) $where .= ' AND v.category_id IN ('.implode(',', $params['cats']).')';

		if(!empty($params['group'])) $where .= ' AND v.groupid = ('.intval($params['group']).')';

		// Set the final query
		$query = 'SELECT DISTINCT v.id AS id
			FROM #__community_videos AS v
			JOIN #__community_users AS u ON v.creator = u.userid
			WHERE 1'.$where.'
			ORDER BY '.$params['order'].' LIMIT '.$params['start'].','.$params['max'];

		// Submit the query
		$db = JFactory::getDBO();
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$db->setQuery($query);
		$loadedVideos = $db->loadObjectList();

		// Display the result
		$stringTag = '';
		if(empty($loadedVideos)){
			$return->status = false;
		}else{
			if(count($loadedVideos) < $params['min']){
				// We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough elements for the tag '.$oneTag.' : '.count($loadedVideos).' / '.$params['min'];
				$return->message .= ' between '.acymailing_getDate($params['lastgenerateddate']).' and '.acymailing_getDate($params['time']);
			}

			// Fetch videos
			$elements = array();
			foreach($loadedVideos as $oneVideo){
				$video = JTable::getInstance('Video', 'CTable');
				$video->load($oneVideo->id);

				// Link to the video
				$videoLink = ACYMAILING_LIVE.'index.php?option=com_community&view=videos&task=video&videoid='.$oneVideo->id;

				// Thumbnail
				$image = null;
				if($params['image'] !== false){
					$thumbnail = $video->getThumbnail();
					$original = null;
					$image = $this->_resizeImage($thumbnail, $original, $params['image']);
				}

				// Render HTML
				$attributes = array();
				foreach($fields as $field){
					switch($field){
						case 'description':
							if(!empty($video->description)){
								if(!empty($params['chars']) && strlen($video->description) > $params['chars']){
									$video->description = substr($video->description, 0, $params['chars']).'...';
								}
								$attributes['description'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_VIDEOS_DESCRIPTION').'</h3>';
								$attributes['description'] .= $video->description;
							}
							break;
						case 'duration':
							if(!empty($video->duration)){
								$minutes = str_pad(floor($video->duration / 60), 2, '0', STR_PAD_LEFT);
								$seconds = str_pad($video->duration % 60, 2, '0', STR_PAD_LEFT);
								$attributes['duration'] = ($params['nolabel']) ? '' : '<h3>'.str_replace(':', '', JText::_('COM_COMMUNITY_VIDEOS_DURATION')).'</h3>';
								$attributes['duration'] .= $minutes.':'.$seconds;
							}
							break;
						case 'uploadedby':
							$creator = new stdClass();
							if($video->creator_type === 'user'){
								$user = &CFactory::getUser($video->creator);
								$creator->name = $user->getDisplayName();
								$creator->link = ACYMAILING_LIVE.'index.php?option=com_community&view=profile&userid='.$video->creator;
							}elseif($video->creator_type === 'group'){
								$db->setQuery('SELECT name FROM #__community_groups WHERE id='.$video->creator);
								$group = $db->loadObject();
								$creator->name = $group->name;
								$creator->link = ACYMAILING_LIVE.'index.php?option=com_community&view=groups&task=viewgroup&groupid='.$video->creator;
							}else{
								$creator->name = $video->creator_type.$video->creator;
								$creator->link = '#';
							}
							$attributes['uploadedby'] = ($params['nolabel']) ? '' : '<h3>'.JText::sprintf('COM_COMMUNITY_PHOTOS_UPLOADED_BY', '').'</h3>';
							$attributes['uploadedby'] .= '<a href="'.$creator->link.'">'.$creator->name.'</a>';
							break;
						case 'uploadedon':
							if(!empty($video->created)){
								$attributes['uploadedon'] = ($params['nolabel']) ? '' : '<h3>'.str_replace(':', '', JText::_('COM_COMMUNITY_VIDEOS_CREATED')).'</h3>';
								$attributes['uploadedon'] .= JHTML::_('date', $video->created, JText::_('DATE_FORMAT_LC3'));
							}
							break;
						case 'views':
							if(!empty($video->hits)){
								$attributes['views'] = ($params['nolabel']) ? '' : '<h3>'.ucfirst(trim(JText::sprintf('COM_COMMUNITY_VIDEOS_HITS_COUNT', ''))).'</h3>';
								$attributes['views'] .= $video->hits;
							}
							break;
						case 'category':
							$db->setQuery('SELECT name FROM #__community_videos_category WHERE id='.$video->category_id);
							$category = $db->loadObject();
							$attributes['category'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_VIDEOS_CATEGORY').'</h3>';
							$attributes['category'] .= $category->name;
							break;
						default:
							break;
					}
				}

				$oneElement = '<table class="jomsocialvideo">';
				$oneElement .= $this->_displayElement($videoLink, $video->title, $image, $params['title'], $attributes);
				$oneElement .= '</table>';

				// Alternative template
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialvideo.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialvideo.php');
					$oneElement = ob_get_clean();
				}

				$elements[] = $oneElement;
			}

			// Display videos as a table
			$opt = new stdClass();
			$opt->cols = $params['cols'];
			$stringTag = $this->displayTable($elements, $opt);
		}
		$this->tags[$oneTag] = $stringTag;

		return $return;
	}

	function _replacegroups($oneTag, $params){
		// Clean parameters
		$allowedOrders = array('g.discusscount,DESC', 'g.wallcount,DESC', 'g.created,DESC', 'g.membercount,DESC', 'activitiescount,DESC', 'rand()');
		$allowedFields = array('description' => 'g.description', 'category' => 'g.categoryid', 'created' => 'g.created', 'membercount' => 'g.membercount', 'discusscount' => 'g.discusscount', 'wallcount' => 'g.wallcount', 'activitiescount' => 'activitiescount', 'creator' => 'g.ownerid');
		$params = $this->_cleanCommonParams($params, $allowedOrders, $allowedFields);
		unset($allowedOrders);
		unset($allowedFields);
		$fields = $params['fields'];

		$where = '';

		// Only published groups
		$where .= ' g.published = 1';

		// Activities related to the group (and filters unused groups)
		$where .= ' AND a.app LIKE "groups%" ';

		// Only public groups
		$where .= ' AND g.approvals = 0';

		// Auto-newsletter's filter (time limit)
		if(!empty($params['lastgenerateddate'])){
			switch($params['filter']){
				case 'created':
				case 'modify';
					$where .= ' AND created > \''.date('Y-m-d H:i:s', $params['lastgenerateddate'] - date('Z')).'\'';
					break;
				default:
					break;
			}
		}

		// Image required ?
		if(!empty($params['image']->required)) $where .= ' AND LENGTH(g.thumb) > 0';

		// Categories restriction
		if(!empty($params['cats'])) $where .= ' AND g.categoryid IN ('.implode(',', $params['cats']).')';

		if(!empty($params['group'])) $where .= ' AND (g.id = '.intval($params['group']).')';

		// Set the final query
		$query = 'SELECT g.id AS id, COUNT(a.app) AS activitiescount '.'FROM #__community_groups AS g '.'LEFT JOIN #__community_activities AS a ON g.id = a.cid '.'WHERE '.$where.' '.'GROUP BY g.id '.'ORDER BY '.$params['order'].' LIMIT '.$params['start'].','.$params['max'];

		// Submit the query
		$db = JFactory::getDBO();
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$db->setQuery($query);
		$loadedGroups = $db->loadObjectList();

		// Display the result
		$stringTag = '';
		if(empty($loadedGroups)){
			$return->status = false;
		}else{
			if(count($loadedGroups) < $params['min']){
				// We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough elements for the tag '.$oneTag.' : '.count($loadedGroups).' / '.$params['min'];
				$return->message .= ' between '.acymailing_getDate($params['lastgenerateddate']).' and '.acymailing_getDate($params['time']);
			}

			// Fetch groups
			$elements = array();
			$group = JTable::getInstance('Groups', 'CommunityTable');
			foreach($loadedGroups as $oneGroup){
				$group->load($oneGroup->id);
				$group->path = ACYMAILING_LIVE.'index.php?option=com_community&view=groups&task=viewgroup&groupid='.$oneGroup->id;

				// Thumbnail
				$image = null;
				if($params['image'] !== false){
					if(empty($this->jsVersion) || version_compare($this->jsVersion, '4.0.0', '<')){
						$thumbnail = $group->getThumbAvatar();
					}else $thumbnail = $group->get('cover');
					$original = $group->getAvatar();
					$image = $this->_resizeImage($thumbnail, $original, $params['image']);
				}

				// Render HTML
				$attributes = array();
				foreach($fields as $field){
					switch($field){
						case 'description':
							if(!empty($group->description)){
								if(!empty($params['chars']) && strlen($group->description) > $params['chars']){
									$group->description = substr($group->description, 0, $params['chars']).'...';
								}
								$attributes['description'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_GROUPS_DESCRIPTION').'</h3>';
								$attributes['description'] .= $group->description;
							}
							break;
						case 'category':
							$db->setQuery('SELECT name FROM #__community_groups_category WHERE id='.$group->categoryid);
							$category = $db->loadObject();
							$attributes['category'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_GROUPS_CATEGORY').'</h3>';
							$attributes['category'] .= $category->name;
							break;
						case 'created':
							$attributes['created'] = ($params['nolabel']) ? '' : '<h3>'.str_replace(':', '', JText::sprintf('COM_COMMUNITY_GROUPS_CREATE_TIME_ON', '')).'</h3>';
							$attributes['created'] .= JHTML::_('date', $group->created, JText::_('DATE_FORMAT_LC'));
							break;
						case 'membercount':
							$attributes['membercount'] = ($params['nolabel']) ? '' : '<h3>'.JText::sprintf('COM_COMMUNITY_GROUPS_MEMBER_COUNT_MANY', '').'</h3>';
							$attributes['membercount'] .= $group->membercount;
							break;
						case 'discusscount':
							$attributes['discusscount'] = ($params['nolabel']) ? '' : '<h3>'.JText::sprintf('COM_COMMUNITY_GROUPS_DISCUSSION_COUNT_MANY', '').'</h3>';
							$attributes['discusscount'] .= $group->discusscount;
							break;
						case 'wallcount':
							$attributes['wallcount'] = ($params['nolabel']) ? '' : '<h3>'.JText::sprintf('COM_COMMUNITY_GROUPS_WALL_COUNT_MANY', '').'</h3>';
							$attributes['wallcount'] .= $group->wallcount;
							break;
						case 'activitiescount':
							$attributes['activitiescount'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_ACTIVITIES').'</h3>';
							$attributes['activitiescount'] .= $oneGroup->activitiescount;
							break;
						case 'creator':
							$creator = new stdClass();
							$user = &CFactory::getUser($group->ownerid);
							$creator->name = $user->getDisplayName();
							$creator->link = ACYMAILING_LIVE.'index.php?option=com_community&view=profile&userid='.$group->ownerid;
							$attributes['creator'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_GROUPS_CREATOR').'</h3>';
							$attributes['creator'] .= '<a href="'.$creator->link.'">'.$creator->name.'</a>';
							break;
						default:
							break;
					}
				}

				$oneElement = '<table class="jomsocialgroup">';
				$oneElement .= $this->_displayElement($group->path, $group->name, $image, $params['title'], $attributes);
				$oneElement .= '</table>';

				// Alternative template
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialgroup.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialgroup.php');
					$oneElement = ob_get_clean();
				}

				$elements[] = $oneElement;
			}

			// Display groups as a table
			$opt = new stdClass();
			$opt->cols = $params['cols'];
			$stringTag = $this->displayTable($elements, $opt);
		}
		$this->tags[$oneTag] = $stringTag;

		return $return;
	}

	function _replacediscuss($oneTag, $params){
		// Clean parameters
		$allowedOrders = array('d.lastreplied,DESC', 'd.created,DESC', 'repliescount,DESC', 'rand()');
		$allowedFields = array('content' => 'd.message', 'lastreplied' => 'd.lastreplied', 'created' => 'd.created', 'creator' => 'd.creator', 'group' => 'c.name', 'replies' => 'repliescount');

		$params = $this->_cleanCommonParams($params, $allowedOrders, $allowedFields);
		unset($allowedOrders);
		unset($allowedFields);
		$fields = $params['fields'];

		// Only discussions from published groups
		$where = ' AND g.published = 1';

		// Auto-newsletter's filter (time limit)
		if(!empty($params['lastgenerateddate'])){
			switch($params['filter']){
				case 'created':
					$where .= ' AND d.created > \''.date('Y-m-d H:i:s', $params['lastgenerateddate'] - date('Z')).'\'';
					break;
				case 'modify';
					$where .= ' AND (d.created > \''.date('Y-m-d H:i:s', $params['lastgenerateddate'] - date('Z')).'\'';
					$where .= ' OR d.lastreplied > \''.date('Y-m-d H:i:s', $params['lastgenerateddate'] - date('Z')).'\')';
					break;
				default:
					break;
			}
		}

		// Image required ?
		if(!empty($params['image']->required)) $where .= ' AND LENGTH(g.thumb) > 0';

		if(!empty($params['group'])) $where .= ' AND (d.groupid = '.intval($params['group']).')';

		// Set the final query
		$query = 'SELECT d.id AS id, COUNT(w.id) AS repliescount
			FROM #__community_groups_discuss AS d
			LEFT JOIN #__community_wall AS w ON d.id = w.contentid
			JOIN #__community_groups AS g ON d.groupid = g.id
			JOIN #__community_groups_category AS c ON g.categoryid = c.id
			WHERE 1'.$where.'
			GROUP BY d.id
			ORDER BY '.$params['order'].' LIMIT '.$params['start'].','.$params['max'];

		// Submit the query
		$db = JFactory::getDBO();
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$db->setQuery($query);
		$loadedDiscuss = $db->loadObjectList();

		// Display the result
		$stringTag = '';
		if(empty($loadedDiscuss)){
			$return->status = false;
		}else{
			if(count($loadedDiscuss) < $params['min']){
				// We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough elements for the tag '.$oneTag.' : '.count($loadedDiscuss).' / '.$params['min'];
				$return->message .= ' between '.acymailing_getDate($params['lastgenerateddate']).' and '.acymailing_getDate($params['time']);
			}

			$discuss =& JTable::getInstance('Discussion', 'CTable');
			$group =& JTable::getInstance('Groups', 'CommunityTable');

			// Fetch discussions
			$elements = array();
			foreach($loadedDiscuss as $oneDiscuss){
				$discuss->load($oneDiscuss->id);
				$discuss->path = ACYMAILING_LIVE.'index.php?option=com_community&view=groups&task=viewdiscussion&groupid='.$discuss->groupid.'&topicid='.$discuss->id;

				// Thumbnail
				$image = null;
				if($params['image'] !== false){
					$group->load($discuss->groupid);
					$thumbnail = $group->getThumbAvatar();
					$original = $group->getAvatar();
					$image = $this->_resizeImage($thumbnail, $original, $params['image']);
				}

				// Render HTML
				$attributes = array();
				foreach($fields as $field){
					switch($field){
						case 'content':
							if(!empty($discuss->message)){
								if(!empty($params['chars']) && strlen($discuss->message) > $params['chars']){
									$discuss->message = substr($discuss->message, 0, $params['chars']).'...';
								}
								$attributes['content'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_MESSAGE').'</h3>';
								$attributes['content'] .= $discuss->message;
							}
							break;
						case 'lastreplied':
							if(!empty($discuss->lastreplied)){
								$attributes['lastreplied'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_GROUPS_DISCUSSION_UPDATED').'</h3>';
								$attributes['lastreplied'] .= JHTML::_('date', $discuss->lastreplied, JText::_('DATE_FORMAT_LC'));
							}
							break;
						case 'created':
							$attributes['created'] = ($params['nolabel']) ? '' : '<h3>'.trim(JText::sprintf('COM_COMMUNITY_GROUPS_CREATE_TIME_ON', ''), ': ').'</h3>';
							$attributes['created'] .= JHTML::_('date', $discuss->created, JText::_('DATE_FORMAT_LC'));
							break;
						case 'creator':
							$creator = new stdClass();
							$user = &CFactory::getUser($discuss->creator);
							$creator->name = $user->getDisplayName();
							$creator->link = ACYMAILING_LIVE.'index.php?option=com_community&view=profile&userid='.$discuss->creator;
							$attributes['creator'] = ($params['nolabel']) ? '' : '<h3>'.trim(JText::sprintf('COM_COMMUNITY_GROUPS_DISCUSSION_CREATOR', ''), '.').'</h3>';
							$attributes['creator'] .= '<a href="'.$creator->link.'">'.$creator->name.'</a>';
							break;
						case 'group':
							$group->load($discuss->groupid);
							$group->link = ACYMAILING_LIVE.'index.php?option=com_community&view=groups&task=viewgroup&groupid='.$discuss->groupid;
							$attributes['group'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_SINGULAR_GROUP').'</h3>';
							$attributes['group'] .= '<a href="'.$group->link.'">'.$group->name.'</a>';
							break;
						case 'replies':
							$attributes['replies'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_REPLIES').'</h3>';
							$attributes['replies'] .= $oneDiscuss->repliescount;
							break;
						default:
							break;
					}
				}

				$oneElement = '<table class="jomsocialdiscussion">';
				$oneElement .= $this->_displayElement($discuss->path, $discuss->title, $image, $params['title'], $attributes);
				$oneElement .= '</table>';

				// Alternative template
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialdiscussion.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialdiscussion.php');
					$oneElement = ob_get_clean();
				}

				$elements[] = $oneElement;
			}

			// Display dicussions as a table
			$opt = new stdClass();
			$opt->cols = $params['cols'];
			$stringTag = $this->displayTable($elements, $opt);
		}
		$this->tags[$oneTag] = $stringTag;

		return $return;
	}

	function _replaceevents($oneTag, $params){
		CFactory::load('helpers', 'time');

		// Clean parameters
		$allowedOrders = array('e.created,ASC', 'e.startdate,ASC', 'e.hits,DESC', 'rand()');
		$allowedFields = array('description' => 'e.description', 'startdate' => 'e.startdate', 'enddate' => 'e.enddate', 'creator' => 'e.creator', 'created' => 'e.created', 'category' => 'c.name', 'ticket' => 'e.ticket', 'confirmed' => 'e.confirmedcount', 'maybe' => 'e.maybecount', 'invited' => 'e.invitedcount', 'location' => 'e.location');

		$params = $this->_cleanCommonParams($params, $allowedOrders, $allowedFields);
		unset($allowedOrders);
		unset($allowedFields);
		$fields = $params['fields'];

		// Only published events
		$where = ' AND e.published = 1';

		// Auto-newsletter's filter (time limit)
		if(!empty($params['lastgenerateddate'])){
			switch($params['filter']){
				case 'created':
				case 'modify':
					$where .= ' AND e.created > \''.date('Y-m-d H:i:s', $params['lastgenerateddate'] - date('Z')).'\'';
					break;
				default:
					break;
			}
		}

		// Image required ?
		if(!empty($params['image']->required)){
			$where .= ' AND LENGTH(e.thumb) > 0';
		}

		// Upcoming ?
		if(!empty($params['upcoming'])){
			$where .= ' AND e.startdate > NOW()';
		}

		// Which type of event ?
		if(!empty($params['type'])){
			$types = explode(',', $params['type']);
			$allowedTypes = array('profile', 'group');
			foreach($types as $index => $type){
				if(!in_array($type, $allowedTypes)){
					unset($params[$index]);
				}
			}
			if(!empty($types)){
				$types = implode('" OR e.type = "', $types);
				$where .= ' AND (e.type = "'.$types.'")';
			}
			if($params['type'] == 'group' && !empty($params['group'])) $where .= ' AND (e.contentid = '.intval($params['group']).')';
		}

		// Categories restriction
		if(!empty($params['cats'])){
			$where .= ' AND e.catid IN ('.implode(',', $params['cats']).')';
		}

		// Set the final query
		$query = 'SELECT e.id AS id
			FROM #__community_events AS e
			JOIN #__community_events_category AS c ON e.catid = c.id';
		if(empty($params['singleevent'])){
			$query .= '	WHERE 1'.$where.'
			ORDER BY '.$params['order'].' LIMIT '.$params['start'].','.$params['max'];
		}else{
			$query .= ' WHERE e.id = '.intval($params['singleevent']);
		}

		// Submit the query
		$db = JFactory::getDBO();
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$db->setQuery($query);
		$loadedEvents = $db->loadObjectList();

		// Display the result
		$stringTag = '';
		if(empty($loadedEvents)){
			$return->status = false;
		}else{
			if(count($loadedEvents) < $params['min']){
				// We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough elements for the tag '.$oneTag.' : '.count($loadedEvents).' / '.$params['min'];
				$return->message .= ' between '.acymailing_getDate($params['lastgenerateddate']).' and '.acymailing_getDate($params['time']);
			}

			$event =& JTable::getInstance('Event', 'CTable');

			// Fetch events
			$elements = array();
			foreach($loadedEvents as $oneEvent){
				$event->load($oneEvent->id);
				$event->path = ACYMAILING_LIVE.'index.php?option=com_community&view=events&task=viewevent&eventid='.$event->id;

				// Thumbnail
				$image = null;
				if($params['image'] !== false){
					if(empty($this->jsVersion) || version_compare($this->jsVersion, '4.0.0', '<')){
						$thumbnail = $event->getThumbAvatar();
					}else $thumbnail = $event->getCover();
					$original = $event->getAvatar();
					$image = $this->_resizeImage($thumbnail, $original, $params['image']);
				}

				// All day event?
				$dateFormat = JText::_('COM_COMMUNITY_DATE_FORMAT_LC2_12H');
				$start = explode(' ', $event->startdate);
				$end = explode(' ', $event->enddate);
				if($start[0] == $end[0] && $start[1] == '00:00:00' && $end[1] == '23:59:59'){
					$dateFormat = JText::_('COM_COMMUNITY_EVENT_TIME_FORMAT_LC1');
				}

				// Render HTML
				$attributes = array();
				foreach($fields as $field){
					switch($field){
						case 'description':
							if(!empty($event->description)){
								if(!empty($params['chars']) && strlen($event->description) > $params['chars']){
									$event->description = substr($event->description, 0, $params['chars']).'...';
								}
								$attributes['content'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_EVENTS_DESCRIPTION').'</h3>';
								$attributes['content'] .= $event->description;
							}
							break;
						case 'startdate':
							$attributes['startdate'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_EVENTS_START_DATE').'</h3>';
							$attributes['startdate'] .= CTimeHelper::getFormattedTime($event->startdate, $dateFormat);
							break;
						case 'enddate':
							$attributes['enddate'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_EVENTS_END_DATE').'</h3>';
							$attributes['enddate'] .= CTimeHelper::getFormattedTime($event->enddate, $dateFormat);
							break;
						case 'creator':
							$creator = new stdClass();
							$user = &CFactory::getUser($event->creator);
							$creator->name = $user->getDisplayName();
							$creator->link = ACYMAILING_LIVE.'index.php?option=com_community&view=profile&userid='.$event->creator;
							$attributes['creator'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_EVENTS_CREATOR').'</h3>';
							$attributes['creator'] .= '<a href="'.$creator->link.'">'.$creator->name.'</a>';
							break;
						case 'created':
							$attributes['created'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('ACY_CREATED').'</h3>';
							$attributes['created'] .= JHTML::_('date', $event->created, JText::_('DATE_FORMAT_LC'));
							break;
						case 'category':
							$db->setQuery('SELECT name FROM #__community_events_category WHERE id='.$event->catid);
							$category = $db->loadObject();
							$attributes['category'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_EVENTS_CATEGORY').'</h3>';
							$attributes['category'] .= $category->name;
						case 'ticket':
							$attributes['ticket'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_EVENTS_SEATS_AVAILABLE').'</h3>';
							if($event->ticket){
								$eventMembersCount = $event->getMembersCount(COMMUNITY_EVENT_STATUS_ATTEND);
								$attributes['ticket'] .= JText::sprintf('COM_COMMUNITY_EVENTS_TICKET_STATS', $event->ticket, $eventMembersCount, ($event->ticket - $eventMembersCount));
							}else{
								$attributes['ticket'] .= JText::sprintf('COM_COMMUNITY_EVENTS_UNLIMITED_SEAT');
							}
						case 'confirmed':
							$attributes['confirmed'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_EVENTS_CONFIRMED').'</h3>';
							$attributes['confirmed'] .= $event->confirmedcount;
							break;
						case 'maybe':
							$attributes['maybe'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_EVENTS_MAYBE').'</h3>';
							$attributes['maybe'] .= $event->maybecount;
							break;
						case 'invited':
							$attributes['invited'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_EVENTS_PENDING_INVITATIONS').'</h3>';
							$attributes['invited'] .= $event->invitedcount;
							break;
						case 'location':
							if(!empty($event->location)){
								$attributes['location'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_EVENTS_LOCATION').'</h3>';
								$attributes['location'] .= $event->location;
							}
							break;
						default:
							break;
					}
				}

				$oneElement = '<table class="jomsocialevent">';
				$oneElement .= $this->_displayElement($event->path, $event->title, $image, $params['title'], $attributes);
				$oneElement .= '</table>';

				// Alternative template
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialevent.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialevent.php');
					$oneElement = ob_get_clean();
				}

				$elements[] = $oneElement;
			}

			// Display events as a table
			$opt = new stdClass();
			$opt->cols = $params['cols'];
			$stringTag = $this->displayTable($elements, $opt);
		}
		$this->tags[$oneTag] = $stringTag;

		return $return;
	}

	function _replacealbums($oneTag, $params){
		// Clean parameters
		$allowedOrders = array('a.created,DESC', 'a.name,ASC', 'a.hits,DESC', 'rand()');
		$allowedFields = array('description' => 'a.description', 'creator' => 'a.creator', 'created' => 'a.created', 'group' => 'g.name', 'hits' => 'a.hits', 'location' => 'a.location');
		$params = $this->_cleanCommonParams($params, $allowedOrders, $allowedFields);
		unset($allowedOrders);
		unset($allowedFields);
		$fields = $params['fields'];
		$where = '1 = 1 ';

		// Only public albums
		if(empty($params['private'])){
			$where .= ' AND (u.params LIKE "%\"privacyPhotoView\":0%" OR u.params LIKE "%\"privacyPhotoView\":\"0%" OR u.params LIKE "%privacyPhotoView=0%") AND a.permissions < 20';
		}

		if(!empty($params['group'])) $where .= ' AND a.groupid = '.intval($params['group']).' ';

		// Auto-newsletter's filter (time limit)
		if(!empty($params['lastgenerateddate'])){
			switch($params['filter']){
				case 'created':
				case 'modify':
					$where .= ' AND a.created > \''.date('Y-m-d H:i:s', $params['lastgenerateddate'] - date('Z')).'\'';
					break;
				default:
					break;
			}
		}

		// Image required ?
		if(!empty($params['image']->required)){
			$where .= ' AND p.published = 1';
		}

		// Which type of album ?
		if(!empty($params['type'])){
			$types = explode(',', $params['type']);
			$allowedTypes = array('user', 'group');
			foreach($types as $index => $type){
				if(!in_array($type, $allowedTypes)){
					unset($params[$index]);
				}
			}
			if(!empty($types)){
				$types = implode('" OR a.type = "', $types);
				$where .= ' AND (a.type = "'.$types.'")';
			}
		}

		// Set the final query
		$query = 'SELECT a.id AS id, p.image AS image, p.thumbnail AS thumb
			FROM #__community_photos_albums AS a
			LEFT JOIN #__community_photos AS p ON a.photoid = p.id
			JOIN #__community_users AS u ON a.creator = u.userid
			WHERE '.$where.'
			ORDER BY '.$params['order'].' LIMIT '.$params['start'].','.$params['max'];

		// Submit the query
		$db = JFactory::getDBO();
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$db->setQuery($query);
		$loadedAlbums = $db->loadObjectList();

		// Display the result
		$stringTag = '';
		if(empty($loadedAlbums)){
			$return->status = false;
		}else{
			if(count($loadedAlbums) < $params['min']){
				// We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough elements for the tag '.$oneTag.' : '.count($loadedAlbums).' / '.$params['min'];
				$return->message .= ' between '.acymailing_getDate($params['lastgenerateddate']).' and '.acymailing_getDate($params['time']);
			}

			$album = JTable::getInstance('Album', 'CTable');
			$group = JTable::getInstance('Groups', 'CommunityTable');

			// Fetch albums
			$elements = array();
			foreach($loadedAlbums as $oneAlbum){
				$album->load($oneAlbum->id);
				$album->path = ACYMAILING_LIVE.'index.php?option=com_community&view=photos&task=album&albumid='.$album->id;
				if($album->groupid){
					$album->path .= '&groupid='.$album->groupid;
				}

				// Thumbnail
				$image = null;
				if($params['image'] !== false){
					$thumbnail = $album->getCoverThumbPath();
					//Method not available any more apparently...?
					if(method_exists($album, 'getRawCoverThumbPath')){
						$original = $album->getRawCoverThumbPath();
					}else{
						$original = $thumbnail;
					}
					$image = $this->_resizeImage($thumbnail, $original, $params['image']);
				}

				// Render HTML
				$attributes = array();
				foreach($fields as $field){
					switch($field){
						case 'description':
							if(!empty($album->description)){
								if(!empty($params['chars']) && strlen($album->description) > $params['chars']){
									$album->description = substr($album->description, 0, $params['chars']).'...';
								}
								$attributes['description'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_PHOTOS_ALBUM_DESC').'</h3>';
								$attributes['description'] .= $album->description;
							}
							break;
						case 'creator':
							$creator = new stdClass();
							$user = &CFactory::getUser($album->creator);
							$creator->name = $user->getDisplayName();
							$creator->link = ACYMAILING_LIVE.'index.php?option=com_community&view=profile&userid='.$album->creator;
							$attributes['creator'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('CREATOR').'</h3>';
							$attributes['creator'] .= '<a href="'.$creator->link.'">'.$creator->name.'</a>';
							break;
						case 'created':
							$attributes['created'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('ACY_CREATED').'</h3>';
							$attributes['created'] .= JHTML::_('date', $album->created, JText::_('DATE_FORMAT_LC'));
							break;
						case 'group':
							if($album->groupid){
								$group->load($album->groupid);
								$attributes['group'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_SINGULAR_GROUP').'</h3>';
								$attributes['group'] .= $group->name;
							}
							break;
						case 'hits':
							$attributes['hits'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_VIDEOS_HITS').'</h3>';
							$attributes['hits'] .= $album->hits;
							break;
						case 'location':
							if(!empty($album->location)){
								$attributes['location'] = ($params['nolabel']) ? '' : '<h3>'.JText::_('COM_COMMUNITY_PHOTOS_ALBUM_LOCATION').'</h3>';
								$attributes['location'] .= $album->location;
							}
							break;
						default:
							break;
					}
				}

				$oneElement = '<table class="jomsocialalbum">';
				$oneElement .= $this->_displayElement($album->path, $album->name, $image, $params['title'], $attributes);
				$oneElement .= '</table>';

				// Alternative template
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialalbum.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialalbum.php');
					$oneElement = ob_get_clean();
				}

				$elements[] = $oneElement;
			}

			// Display events as a table
			$opt = new stdClass();
			$opt->cols = $params['cols'];
			$stringTag = $this->displayTable($elements, $opt);
		}
		$this->tags[$oneTag] = $stringTag;

		return $return;
	}

	function _replacewall($oneTag, $params){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$allowedOrders = array('a.created,DESC', 'a.id,ASC', 'a.actor,ASC', 'rand()');
		$allowedFields = array();
		$params = $this->_cleanCommonParams($params, $allowedOrders, $allowedFields);
		unset($allowedOrders);
		unset($allowedFields);

		$params['com'] = empty($params['com']) ? 20 : intval($params['com']);

		$query = 'SELECT a.*, u.avatar, user.name '.'FROM #__community_activities AS a '.'JOIN #__community_users AS u '.'ON a.actor = u.userid '.'JOIN #__users AS user '.'ON a.actor = user.id ';

		$where = array();

		if(!empty($params['users'])){
			if(strpos($params['users'], ',')){
				$users = explode(',', $params['users']);
				JArrayHelper::toInteger($users);
				$where[] = 'a.actor IN ('.implode(',', $users).')';
			}else{
				$where[] = 'a.actor = '.intval($params['users']);
			}
		}

		// Only public content
		$where[] = 'a.access < 30';

		if(!empty($params['display'])){
			$content = '';
			$options = explode(',', $params['display']);
			$unavailable = array_diff($options, array("profile", "photos", "videos", "events"));
			if(empty($unavailable)){
				$where[] = 'a.app IN ("'.implode('","', $options).'")';
			}else $where[] = 'a.app IN ("profile","photos","videos","events")';
		}else{
			$where[] = 'a.app IN ("profile","photos","videos","events")';
		}

		if(!empty($params['lastgenerateddate']) && $params['lastgenerateddate'] == 'created'){
			$where[] = 'a.created > \''.date('Y-m-d H:i:s', $params['lastgenerateddate'] - date('Z')).'\'';
		}

		if(!empty($where)) $query .= 'WHERE ('.implode(') AND (', $where).') ';

		$query .= 'ORDER BY '.$params['order'].' LIMIT '.$params['start'].','.$params['max'];

		$db = JFactory::getDBO();
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$db->setQuery($query);
		$wallPosts = $db->loadObjectList();

		if(!empty($params['min']) && count($wallPosts) < $params['min']){
			//We will not generate the Newsletter
			$return->status = false;
			$return->message = 'Not enough '.$this->name.' posts for the tag '.$oneTag.' : '.count($wallPosts).' / '.$params['min'];
		}

		$tag = new stdClass();
		$tag->wrap = 150;
		$elements = array();
		foreach($wallPosts as $onePost){
			$link = 'index.php?option=com_community&view=profile&userid='.$onePost->actor;
			$imgPath = empty($onePost->avatar) ? 'components/com_community/assets/user-Male-thumb.png' : $onePost->avatar;
			$oneElement = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">'.'<tr><td valign="top" style="padding:0px 10px 10px 10px;width:64px;"><div style="border: 1px solid #BDBDBD;padding: 4px;border-radius: 4px;"><a href="'.$link.'"><img style="width:64px;height:64px;" src="'.$imgPath.'"/></a></div></td><td valign="top"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

			$oneElement .= '<tr><td colspan="2"><a style="text-decoration:none;" href="'.$link.'">'.$onePost->name.'</a>';
			if($onePost->app == 'videos'){
				$oneElement .= JText::_('COM_COMMUNITY_ACTIVITY_VIDEO_UPLOAD_TITLE');
			}elseif($onePost->app == 'photos') $oneElement .= JText::_('COM_COMMUNITY_ACTIVITY_PHOTO_UPLOAD_TITLE');
			elseif($onePost->app == 'events') $oneElement .= JText::_('COM_COMMUNITY_EVENTS_ACTIVITIES_NEW_EVENT');
			$oneElement .= '</td></tr>';
			$oneElement .= '<tr><td colspan="2"'.(empty($params['nocolor']) ? ' style="color: #b2b2b2;"' : '').'>'.acymailing_getDate(acymailing_getTime($onePost->created), 'd F Y, H:i').'</td></tr>';
			$oneElement .= '<tr><td colspan="2">';

			// Replace JS tags
			$onePost->title = str_ireplace('{target}', '<a href="'.JURI::root().'index.php?option=com_community&view=profile&userid='.$onePost->target.'" target="_blank">'.$onePost->name.'</a>', $onePost->title);
			$onePost->title = preg_replace('/\{multiple\}(.*)\{\/multiple\}/i', '', $onePost->title);
			$search = array('{single}', '{/single}');
			$onePost->title = str_ireplace($search, '', $onePost->title);
			$onePost->title = str_ireplace('{actor}', '<a href="'.JURI::root().'index.php?option=com_community&view=profile&userid='.$onePost->actor.'" target="_blank">'.$onePost->name.'</a>', $onePost->title);
			$onePost->title = str_ireplace('{app}', $onePost->app, $onePost->title);
			$onePost->title = str_ireplace('_QQQ_', '', $onePost->title);

			if(!empty($onePost->title)) $oneElement .= '<br />'.$onePost->title;

			if($onePost->app == 'photos'){
				$decodedParams = json_decode($onePost->params);
				$db->setQuery('SELECT image FROM #__community_photos WHERE id = '.intval($decodedParams->photosId));
				$imagePath = $db->loadResult();
				$oneElement .= '<br /><img src="'.$imagePath.'"/>';
			}

			if($onePost->app == 'videos'){
				$db->setQuery('SELECT * FROM #__community_videos WHERE id = '.intval($onePost->cid));
				$video = $db->loadObject();
				$oneElement .= '<br /><table style="border: 1px solid #e3e3e3;margin: 12px 0;padding: 12px 15px;" cellspacing="0" cellpadding="0" border="0" width="100%"><tr><td valign="top" style="padding:0px 5px 5px 5px;width:64px;"><a href="'.$video->path.'"><img style="width:110px;max-height:110px;" src="'.$video->thumb.'"/></a></td><td valign="top"><table cellspacing="0" cellpadding="0" border="0" width="100%">';
				$oneElement .= '<tr><td><a style="text-decoration:none;" href="'.$video->path.'">'.$video->title.'</a></td></tr>';
				$oneElement .= '<tr><td'.(empty($params['nocolor']) ? ' style="color: #b2b2b2;"' : '').'>'.$acypluginsHelper->wrapText($video->description, $tag).'</td></tr></table></td></tr></table>';
			}

			if($onePost->app == 'events'){
				$db->setQuery('SELECT * FROM #__community_events WHERE id = '.intval($onePost->cid));
				$event = $db->loadObject();
				$oneElement .= '<table style="border: 1px solid #e3e3e3;margin: 12px 0;padding: 12px 15px;" cellspacing="0" cellpadding="0" border="0" width="100%">';
				$oneElement .= '<tr><td><a style="text-decoration:none;" href="index.php?option=com_community&view=events&task=viewevent&eventid='.$event->id.'">'.$event->title.'</a></td></tr>';
				$oneElement .= '<tr><td'.(empty($params['nocolor']) ? ' style="color: #b2b2b2;"' : '').'>'.$acypluginsHelper->wrapText($event->description, $tag).'</td></tr>';
				$oneElement .= '<tr><td><strong>'.acymailing_getDate(acymailing_getTime($event->startdate), 'd F Y, H:i').'</strong></td></tr>';
				$oneElement .= '<tr><td><strong>'.$event->location.'</strong></td></tr></table>';
			}

			$oneElement .= '</td></tr></table></td></tr></table></div>';


			if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialwall.php')){
				ob_start();
				require(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialwall.php');
				$oneElement = ob_get_clean();
			}

			$elements[] = $oneElement;
		}

		// Display events as a table
		$opt = new stdClass();
		$opt->cols = 1;
		$stringTag = $this->displayTable($elements, $opt);
		$opt->pict = 'resized';
		$opt->maxwidth = 250;
		$opt->maxheight = 250;

		$stringTag = $acypluginsHelper->managePicts($opt, $stringTag);
		$this->tags[$oneTag] = $stringTag;

		return $return;
	}

	function _replacephotos($oneTag, $params){
		// Clean parameters
		$allowedOrders = array('p.created,DESC', 'p.hits,DESC', 'rand()');
		$allowedFields = array();
		$params = $this->_cleanCommonParams($params, $allowedOrders, $allowedFields);
		unset($allowedOrders);
		unset($allowedFields);

		$where = array();
		// Only public images
		$where[] = '(u.params LIKE "%\"privacyPhotoView\":0%" OR u.params LIKE "%\"privacyPhotoView\":\"0%" OR u.params LIKE "%privacyPhotoView=0%")';

		// Auto-newsletter's filter (time limit)
		if(!empty($params['lastgenerateddate'])){
			switch($params['filter']){
				case 'created':
				case 'modify':
					$where[] = 'p.created > \''.date('Y-m-d H:i:s', $params['lastgenerateddate'] - date('Z')).'\'';
					break;
				default:
					break;
			}
		}

		// Only published images
		$where[] = 'p.published = 1';

		// Set the final query
		$query = 'SELECT p.id AS id, p.thumbnail AS thumb, p.original AS original, p.caption AS caption, p.albumid AS albumid '.'FROM #__community_photos AS p '.'JOIN #__community_users AS u ON p.creator = u.userid ';

		if(!empty($params['cats']) && is_array($params['cats'])){
			JArrayHelper::toInteger($params['cats']);
			$where[] = 'p.creator IN ('.implode(',', $params['cats']).')';
		}

		if(!empty($where)) $query .= 'WHERE ('.implode(') AND (', $where).') ';

		$query .= 'ORDER BY '.$params['order'].' LIMIT '.$params['start'].','.$params['max'];

		// Submit the query
		$db = JFactory::getDBO();
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$db->setQuery($query);
		$loadedPhotos = $db->loadObjectList();

		// Display the result
		$stringTag = '';
		if(empty($loadedPhotos)){
			$return->status = false;
		}else{
			if(count($loadedPhotos) < $params['min']){
				// We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough elements for the tag '.$oneTag.' : '.count($loadedPhotos).' / '.$params['min'];
				$return->message .= ' between '.acymailing_getDate($params['lastgenerateddate']).' and '.acymailing_getDate($params['time']);
			}

			// Fetch photos
			$photoModel = CFactory::getModel('photos');
			$elements = array();
			foreach($loadedPhotos as $onePhoto){
				$link = ACYMAILING_LIVE.'index.php?option=com_community&view=photos&task=photo&albumid='.$onePhoto->albumid.'#photoid='.$onePhoto->id;

				$caption = '';
				if(!empty($onePhoto->caption)){
					if(!empty($params['chars']) && strlen($onePhoto->caption) > $params['chars']){
						$onePhoto->caption = substr($onePhoto->caption, 0, $params['chars']).'...';
					}
					$caption = $onePhoto->caption;
				}

				// Thumbnail
				$photo = $photoModel->getPhoto($onePhoto->id);
				$thumbnail = $photo->getThumbURI();
				$original = $photo->getImageURI();
				$image = $this->_resizeImage($thumbnail, $original, $params['image']);

				// Render HTML
				$oneElement = '<table class="jomsocialphoto">';
				$oneElement .= $this->_displayElement($link, $caption, $image, (isset($params['addtitle'])), false);
				$oneElement .= '</table>';

				// Alternative template
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialphoto.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'jomsocialphoto.php');
					$oneElement = ob_get_clean();
				}

				$elements[] = $oneElement;
			}

			// Display events as a table
			$opt = new stdClass();
			$opt->cols = $params['cols'];
			$stringTag = $this->displayTable($elements, $opt);
		}
		$this->tags[$oneTag] = $stringTag;

		return $return;
	}

	function _showUsersTab($tabs){
		echo $tabs->startPanel(JText::_('ACY_SUBSCRIBER'), 'josusers');

		$this->_showTabStart('users');

		$orderBy = array();
		$orderBy[] = JHTML::_('select.option', 'u.registerDate,DESC', JText::_('CREATED_DATE'));
		$orderBy[] = JHTML::_('select.option', 'u.lastvisitDate,DESC', JText::_('COM_COMMUNITY_LAST_LOGIN'));
		$orderBy[] = JHTML::_('select.option', 'c.view,DESC', JText::_('COM_COMMUNITY_PROFILE_VIEW'));
		$orderBy[] = JHTML::_('select.option', 'c.points,DESC', JText::_('COM_COMMUNITY_KARMA'));
		$orderBy[] = JHTML::_('select.option', 'rand()', JText::_('ACY_RANDOM'));

		$charLimitTitle = JText::_('CAPTCHA_NBCHAR').' ('.JText::_('COM_COMMUNITY_ABOUT_ME').')';

		?>
		<tr>
			<td><label for="josusers_order"><?php echo JText::_('ACY_ORDER'); ?></label></td>
			<td><?php echo JHTML::_('select.genericlist', $orderBy, 'josusers_order', 'style="margin-bottom: 0;width:150px;" onchange="updateJosTag(\'users\');"'); ?></td>
			<td><label for="josusers_chars"><?php echo $charLimitTitle ?></label></td>
			<td><input name="josusers_chars" id="josusers_chars" type="text" onchange="updateJosTag('users');" value="150" style="width:50px;"/></td>
		</tr>
		<?php

		$attributes = array('karma' => JText::_('COM_COMMUNITY_KARMA'), 'email' => JText::_('COM_COMMUNITY_EMAIL'), 'registerdate' => JText::_('COM_COMMUNITY_MEMBER_SINCE'), 'lastvisitdate' => JText::_('COM_COMMUNITY_LAST_LOGIN'), 'views' => JText::_('COM_COMMUNITY_PROFILE_VIEW'), 'friends' => JText::_('COM_COMMUNITY_PROFILE_FRIENDS'));

		// Get extra fields
		$db = JFactory::getDBO();
		$db->setQuery("SELECT `name`, `fieldcode`
			FROM `#__community_fields`
			WHERE `type` != 'group'
			ORDER BY `ordering` ASC");
		$extraFields = $db->loadObjectList();

		// Group fields by fieldcode
		$extra = array();
		foreach($extraFields as $field){
			$extra[strtolower($field->fieldcode)] = JText::_($field->name);
		}

		// Merge extra fields with the others attributes
		$attributes = array_merge($attributes, $extra);

		$this->_showTabAttributes('users', $attributes);

		echo '</table>';
		echo $tabs->endPanel();
	}

	function _showVideosTab($tabs){
		echo $tabs->startPanel(JText::_('COM_COMMUNITY_VIDEOS'), 'josvideos');

		$this->_showTabStart('videos');

		$orderBy = array();
		$orderBy[] = JHTML::_('select.option', 'v.created,DESC', JText::_('COM_COMMUNITY_VIDEOS_SORT_LATEST'));
		$orderBy[] = JHTML::_('select.option', 'v.hits,DESC', JText::_('COM_COMMUNITY_VIDEOS_SORT_POPULAR'));
		$orderBy[] = JHTML::_('select.option', 'rand()', JText::_('ACY_RANDOM'));

		?>
		<tr>
			<td><label for="josvideos_order"><?php echo JText::_('ACY_ORDER'); ?></label></td>
			<td><?php echo JHTML::_('select.genericlist', $orderBy, 'josvideos_order', 'style="margin-bottom: 0;width:150px;" onchange="updateJosTag(\'videos\');"'); ?></td>
			<td><label for="josvideos_chars"><?php echo JText::_('CAPTCHA_NBCHAR'), ' (', JText::_('COM_COMMUNITY_VIDEOS_DESCRIPTION'), ')' ?></label></td>
			<td><input name="josvideos_chars" id="josvideos_chars" type="text" onchange="updateJosTag('videos');" value="150" style="width:50px;"/></td>
		</tr>
		<?php

		$attributes = array('description' => JText::_('COM_COMMUNITY_VIDEOS_DESCRIPTION'), 'duration' => trim(JText::_('COM_COMMUNITY_VIDEOS_DURATION'), ': '), 'uploadedby' => JText::sprintf('COM_COMMUNITY_PHOTOS_UPLOADED_BY', ''), 'uploadedon' => trim(JText::_('COM_COMMUNITY_VIDEOS_CREATED'), ': '), 'views' => ucfirst(trim(JText::sprintf('COM_COMMUNITY_VIDEOS_HITS_COUNT', ''))), 'category' => JText::_('COM_COMMUNITY_VIDEOS_CATEGORY'));

		$this->_showTabAttributes('videos', $attributes);

		// Get and show categories
		$this->_showCategories('videos');

		echo '</table>';
		echo $tabs->endPanel();
	}

	function _showGroupsTab($tabs){
		echo $tabs->startPanel(JText::_('COM_COMMUNITY_GROUPS'), 'josgroups');

		$orderBy = array();
		$orderBy[] = JHTML::_('select.option', 'g.created,DESC', JText::_('COM_COMMUNITY_GROUPS_SORT_LATEST'));
		if(JText::_('COM_COMMUNITY_GROUPS_SORT_MOST_DISCUSSED') == 'COM_COMMUNITY_GROUPS_SORT_MOST_DISCUSSED'){
			$orderBy[] = JHTML::_('select.option', 'g.discusscount,DESC', JText::_('COM_COMMUNITY_VIDEOS_SORT_MOST_WALL_POST'));
			$orderBy[] = JHTML::_('select.option', 'g.wallcount,DESC', trim(JText::_('COM_COMMUNITY_VIDEOS_WALL_POSTS'), ':'));
			$orderBy[] = JHTML::_('select.option', 'g.membercount,DESC', JText::_('COM_COMMUNITY_GROUPS_MEMBERS'));
		}else{
			$orderBy[] = JHTML::_('select.option', 'g.discusscount,DESC', JText::_('COM_COMMUNITY_GROUPS_SORT_MOST_DISCUSSED'));
			$orderBy[] = JHTML::_('select.option', 'g.wallcount,DESC', JText::_('COM_COMMUNITY_GROUPS_SORT_MOST_WALLS'));
			$orderBy[] = JHTML::_('select.option', 'g.membercount,DESC', JText::_('COM_COMMUNITY_GROUPS_SORT_MOST_MEMBERS'));
		}
		$orderBy[] = JHTML::_('select.option', 'activitiescount,DESC', JText::_('COM_COMMUNITY_GROUPS_SORT_MOST_ACTIVE'));
		$orderBy[] = JHTML::_('select.option', 'rand()', JText::_('ACY_RANDOM'));

		$this->_showTabStart('groups');

		?>
		<tr>
			<td><label for="josgroups_order"><?php echo JText::_('ACY_ORDER'); ?></label></td>
			<td><?php echo JHTML::_('select.genericlist', $orderBy, 'josgroups_order', 'style="margin-bottom: 0;width:150px;" onchange="updateJosTag(\'groups\');"'); ?></td>
			<td><label for="josgroups_chars"><?php echo JText::_('CAPTCHA_NBCHAR'), ' (', JText::_('COM_COMMUNITY_GROUPS_DESCRIPTION'), ')' ?></label></td>
			<td><input name="josgroups_chars" id="josgroups_chars" type="text" onchange="updateJosTag('groups');" value="150" style="width:50px;"/></td>
		</tr>
		<?php

		$attributes = array('description' => JText::_('COM_COMMUNITY_GROUPS_DESCRIPTION'), 'category' => JText::_('COM_COMMUNITY_GROUPS_CATEGORY'), 'created' => trim(JText::sprintf('COM_COMMUNITY_GROUPS_CREATE_TIME_ON', ''), ': '), 'membercount' => trim(JText::sprintf('COM_COMMUNITY_GROUPS_MEMBER_COUNT_MANY', '')), 'discusscount' => trim(JText::sprintf('COM_COMMUNITY_GROUPS_DISCUSSION_COUNT_MANY', '')), 'wallcount' => trim(JText::sprintf('COM_COMMUNITY_GROUPS_WALL_COUNT_MANY', '')), 'activitiescount' => JText::_('COM_COMMUNITY_ACTIVITIES'), 'creator' => JText::_('COM_COMMUNITY_GROUPS_CREATOR'));

		$this->_showTabAttributes('groups', $attributes);

		// Get and show categories
		$this->_showCategories('groups');

		echo '</table>';
		echo $tabs->endPanel();
	}

	function _showDiscussTab($tabs){
		echo $tabs->startPanel(JText::_('COM_COMMUNITY_GROUPS_DISCUSSION'), 'josdiscuss');

		$orderBy = array();
		$orderBy[] = JHTML::_('select.option', 'd.lastreplied,DESC', JText::_('COM_COMMUNITY_GROUPS_DISCUSS_ORDER_LAST_REPLIED'));
		$orderBy[] = JHTML::_('select.option', 'd.created,DESC', JText::_('COM_COMMUNITY_GROUPS_DISCUSS_ORDER_CREATION_DATE'));
		$orderBy[] = JHTML::_('select.option', 'repliescount,DESC', JText::_('COM_COMMUNITY_REPLIES'));
		$orderBy[] = JHTML::_('select.option', 'rand()', JText::_('ACY_RANDOM'));

		$this->_showTabStart('discuss');

		?>
		<tr>
			<td><label for="josdiscuss_order"><?php echo JText::_('ACY_ORDER'); ?></label></td>
			<td><?php echo JHTML::_('select.genericlist', $orderBy, 'josdiscuss_order', 'style="margin-bottom: 0;width:150px;" onchange="updateJosTag(\'discuss\');"'); ?></td>
			<td><label for="josdiscuss_chars"><?php echo JText::_('CAPTCHA_NBCHAR'), ' (', JText::_('COM_COMMUNITY_INVITE_MESSAGE'), ')' ?></label></td>
			<td><input name="josdiscuss_chars" id="josdiscuss_chars" type="text" onchange="updateJosTag('discuss');" value="150" style="width:50px;"/></td>
		</tr>
		<?php

		$attributes = array('content' => JText::_('COM_COMMUNITY_INVITE_MESSAGE'), 'lastreplied' => JText::_('COM_COMMUNITY_GROUPS_DISCUSSION_UPDATED'), 'created' => trim(JText::sprintf('COM_COMMUNITY_GROUPS_CREATE_TIME_ON', ''), ': '), 'creator' => trim(JText::sprintf('COM_COMMUNITY_GROUPS_DISCUSSION_CREATOR', ''), '.'), 'group' => JText::_('COM_COMMUNITY_SINGULAR_GROUP'), 'replies' => JText::_('COM_COMMUNITY_REPLIES'));

		$this->_showTabAttributes('discuss', $attributes);

		echo '</table>';
		echo $tabs->endPanel();
	}

	function _showEventsTab($tabs){
		echo $tabs->startPanel(JText::_('COM_COMMUNITY_EVENTS'), 'josevents');

		$orderBy = array();
		$orderBy[] = JHTML::_('select.option', 'e.created,ASC', JText::_('COM_COMMUNITY_EVENTS_SORT_CREATED'));
		$orderBy[] = JHTML::_('select.option', 'e.startdate,ASC', JText::_('COM_COMMUNITY_EVENTS_SORT_START_DATE'));
		$orderBy[] = JHTML::_('select.option', 'e.hits,DESC', JText::_('COM_COMMUNITY_SORT_POPULAR'));
		$orderBy[] = JHTML::_('select.option', 'rand()', JText::_('ACY_RANDOM'));
		$this->_showTabStart('events');

		?>
		<tr>
			<td><label for="josevents_order"><?php echo JText::_('ACY_ORDER'); ?></label></td>
			<td><?php echo JHTML::_('select.genericlist', $orderBy, 'josevents_order', 'style="margin-bottom: 0;width:150px;" onchange="updateJosTag(\'events\');"'); ?></td>
			<td><label for="josevents_chars"><?php echo JText::_('CAPTCHA_NBCHAR'), ' (', JText::_('COM_COMMUNITY_EVENTS_DESCRIPTION'), ')' ?></label></td>
			<td><input name="josevents_chars" id="josevents_chars" type="text" onchange="updateJosTag('events');" value="150" style="width:50px;"/></td>
		</tr>
		<tr>
			<td colspan="2">
				<input type="checkbox" name="josevents_upcoming" id="josevents_upcoming" onclick="updateJosTag('events');" checked="checked"/>
				<label for="josevents_upcoming"><?php echo JText::_('COM_COMMUNITY_EVENTS_UPCOMING'); ?></label>
			</td>
			<td>
				<label for="josevents_type"><?php echo JText::_('COM_COMMUNITY_EVENTS_TYPE'); ?></label>
			</td>
			<td>
				<input type="checkbox" name="josevents_type" id="josevents_type1" onclick="updateJosTag('events');" checked="checked"/>
				<label for="josevents_type1"><?php echo JText::_('COM_COMMUNITY_PROFILE') ?></label>
				<input type="checkbox" name="josevents_type" id="josevents_type2" onclick="updateJosTag('events');" checked="checked"/>
				<label for="josevents_type2"><?php echo JText::_('COM_COMMUNITY_SINGULAR_GROUP') ?></label>
			</td>
		</tr>
		<?php

		$attributes = array('description' => JText::_('COM_COMMUNITY_EVENTS_DESCRIPTION'), 'startdate' => JText::_('COM_COMMUNITY_EVENTS_START_DATE'), 'enddate' => JText::_('COM_COMMUNITY_EVENTS_END_DATE'), 'creator' => JText::_('COM_COMMUNITY_EVENTS_CREATOR'), 'created' => JText::_('ACY_CREATED'), 'category' => JText::_('COM_COMMUNITY_EVENTS_CATEGORY'), 'ticket' => JText::_('COM_COMMUNITY_EVENTS_SEATS_AVAILABLE'), 'confirmed' => JText::_('COM_COMMUNITY_EVENTS_CONFIRMED'), 'maybe' => JText::_('COM_COMMUNITY_EVENTS_MAYBE'), 'invited' => JText::_('COM_COMMUNITY_EVENTS_PENDING_INVITATIONS'), 'location' => JText::_('COM_COMMUNITY_EVENTS_LOCATION'));

		$this->_showTabAttributes('events', $attributes);

		// Get and show categories
		$this->_showCategories('events');

		echo '</table>';
		echo $tabs->endPanel();
	}

	function _showAlbumsTab($tabs){
		echo $tabs->startPanel(JText::_('COM_COMMUNITY_PHOTOS_PHOTO_ALBUMS'), 'josalbums');

		$orderBy = array();
		$orderBy[] = JHTML::_('select.option', 'a.created,DESC', JText::_('ACY_CREATED'));
		$orderBy[] = JHTML::_('select.option', 'a.name,ASC', trim(JText::_('COM_COMMUNITY_PHOTOS_ALBUM_NAME'), ': '));
		$orderBy[] = JHTML::_('select.option', 'a.hits,DESC', JText::_('COM_COMMUNITY_SORT_POPULAR'));
		$orderBy[] = JHTML::_('select.option', 'rand()', JText::_('ACY_RANDOM'));
		$this->_showTabStart('albums');

		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		?>
		<tr>
			<td><label for="josalbums_order"><?php echo JText::_('ACY_ORDER'); ?></label></td>
			<td><?php echo JHTML::_('select.genericlist', $orderBy, 'josalbums_order', 'style="margin-bottom: 0;width:150px;" onchange="updateJosTag(\'albums\');"'); ?></td>
			<td><label for="josalbums_chars"><?php echo JText::_('CAPTCHA_NBCHAR'), ' (', trim(JText::_('COM_COMMUNITY_PHOTOS_ALBUM_DESC'), ': '), ')' ?></label></td>
			<td><input name="josalbums_chars" id="josalbums_chars" type="text" onchange="updateJosTag('albums');" value="150" style="width:50px;"/></td>
		</tr>
		<tr>
			<td>Include private albums</td>
			<td nowrap="nowrap" colspan="3"><?php echo JHTML::_('acyselect.radiolist', $choice, 'albums_private', 'size="1" onclick="updateJosTag(\'albums\');"', 'value', 'text', '0'); ?>
		</tr>
		<tr>
			<td>
				<label for="josalbums_type"><?php echo JText::_('COM_COMMUNITY_EVENTS_TYPE'); ?></label>
			</td>
			<td>
				<input type="checkbox" name="josalbums_type" onclick="updateJosTag('albums');" checked="checked"/> <?php echo JText::_('ACY_USER') ?>
				<input type="checkbox" name="josalbums_type" onclick="updateJosTag('albums');" checked="checked"/> <?php echo JText::_('COM_COMMUNITY_SINGULAR_GROUP') ?>
			</td>
			<td colspan="2">
				<span id="groupdown">
					<?php
					$db = JFactory::getDBO();
					$db->setQuery('SELECT id, name FROM #__community_groups WHERE published = 1');
					$allgroups = $db->loadObjectList();
					if(!empty($allgroups)){
						$groups = array();
						$groups[] = JHTML::_('select.option', '0', JText::_('ACY_ANY_CATEGORY'));
						foreach($allgroups as $oneGroup){
							$groups[] = JHTML::_('select.option', $oneGroup->id, $oneGroup->name);
						}
						echo JHTML::_('select.genericlist', $groups, 'josalbums_group', 'style="margin-bottom: 0;width:150px;" onchange="updateJosTag(\'albums\');"');
					}
					?>
				</span>
			</td>
		</tr>
		<?php

		$attributes = array('description' => trim(JText::_('COM_COMMUNITY_PHOTOS_ALBUM_DESC'), ': '), 'creator' => JText::_('CREATOR'), 'created' => JText::_('ACY_CREATED'), 'group' => JText::_('COM_COMMUNITY_SINGULAR_GROUP'), 'hits' => JText::_('COM_COMMUNITY_VIDEOS_HITS'), 'location' => JText::_('COM_COMMUNITY_PHOTOS_ALBUM_LOCATION'));

		$this->_showTabAttributes('albums', $attributes);

		echo '</table>';
		echo $tabs->endPanel();
	}

	function _showPhotosTab($tabs){
		echo $tabs->startPanel(JText::_('COM_COMMUNITY_PHOTOS'), 'josphotos');

		$this->_showTabStart('photos');

		$orderBy = array();
		$orderBy[] = JHTML::_('select.option', 'p.created,DESC', JText::_('ACY_CREATED'));
		$orderBy[] = JHTML::_('select.option', 'p.hits,DESC', JText::_('COM_COMMUNITY_SORT_POPULAR'));
		$orderBy[] = JHTML::_('select.option', 'rand()', JText::_('ACY_RANDOM'));

		?>
		<tr>
			<td>
				<input name="josphotos_resizeimage" id="josphotos_resizeimage" type="checkbox" onclick="updateJosTag('photos'); togglePhotoResize();" />
				<label for="josphotos_resizeimage"><?php echo JText::_('RESIZED') ?></label>
			</td>
			<td colspan="3" id="josphotos_imagesize" style="display: none">

				<?php echo JText::_('CAPTCHA_WIDTH') ?>
				<input name="josphotos_imgwidth" type="text" onchange="updateJosTag('photos');" value="160" size="4" style="width:50px;"/>
				x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
				<input name="josphotos_imgheight" type="text" onchange="updateJosTag('photos');" value="160" size="4" style="width:50px;"/>
			</td>
			<td colspan="3" id="josphotos_imagesize_complement">
			</td>
		</tr>
		<tr>
			<td><label for="josphotos_order"><?php echo JText::_('ACY_ORDER'); ?></label></td>
			<td colspan="3"><?php echo JHTML::_('select.genericlist', $orderBy, 'josphotos_order', 'style="margin-bottom: 0;" onchange="updateJosTag(\'photos\');"'); ?></td>
		</tr>
		</table>
		<?php

		$this->_showUsers();
		echo $tabs->endPanel();
	}

	function _showUsers(){
		$db = JFactory::getDBO();
		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.jomsocial';

		$pageInfo->filter->order->value = $app->getUserStateFromRequest($paramBase.".filter_order", 'filter_order', 'u.name', 'cmd');
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest($paramBase.".filter_order_Dir", 'filter_order_Dir', 'ASC', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->limit->value = $app->getUserStateFromRequest($paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$searchFields = array('u.id', 'u.name');
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE ".$searchVal;
		}

		$query = 'SELECT u.id, u.name '.'FROM #__community_users AS cu '.'JOIN #__users AS u ON cu.userid = u.id ';

		$filter[] = 'cu.params LIKE "%\"privacyPhotoView\":0%" OR cu.params LIKE "%\"privacyPhotoView\":\"0%" OR cu.params LIKE "%privacyPhotoView=0%"';
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (', $filters).')';
		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		$db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);
		$users = $db->loadObjectList();

		if(ACYMAILING_J30){
			$paginationNb = array();
			$paginationNb[] = JHTML::_('select.option', 5, 5);
			$paginationNb[] = JHTML::_('select.option', 10, 10);
			$paginationNb[] = JHTML::_('select.option', 15, 15);
			$paginationNb[] = JHTML::_('select.option', 20, 20);
			$paginationNb[] = JHTML::_('select.option', 25, 25);
			$paginationNb[] = JHTML::_('select.option', 30, 30);
			$paginationNb[] = JHTML::_('select.option', 50, 50);
			$paginationNb[] = JHTML::_('select.option', 100, 100);
			$paginationNb[] = JHTML::_('select.option', 0, JText::_('ACY_ALL'));
		}

		//yellow highlighting on search matches
		if(!empty($pageInfo->search)) $users = acymailing_search($pageInfo->search, $users);

		//pagination
		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($users);

		jimport('joomla.html.pagination');
		$pagination = new JPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		?>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();"/>
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_('JOOMEXT_GO'); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_('JOOMEXT_RESET'); ?></button>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
			<tr>
				<th/>
				<th class="title">
					<?php
					echo JText::_('ACY_SUBSCRIBER');
					?>
				</th>
				<th class="title titleid">
					<?php
					echo JText::_('ACY_ID');
					?>
				</th>
			</tr>
			</thead>
			<tbody>
			<?php $k = 0;
			foreach($users as $index => $user){ ?>
				<tr id="content<?php echo $user->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $user->id.",'row$k'" ?>);" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td><?php echo $user->name; ?></td>
					<td><?php echo $user->id; ?></td>
				</tr>
				<?php $k = 1 - $k;
			} ?>
			</tbody>
			<tfoot>
			<tr>
				<td colspan="3">
					<?php
					echo $pagination->getListFooter();
					if(ACYMAILING_J30) echo 'Display #'.JHTML::_('select.genericlist', $paginationNb, 'limit', 'size="1" style="width:60px" onchange="Joomla.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
					echo $pagination->getResultsCounter();
					?>
				</td>
			</tr>
			</tfoot>
		</table>
	<?php
	}

	function _showGeneralWallTab($tabs){
		echo $tabs->startPanel(JText::_('COM_COMMUNITY_WALL'), 'joswall');
		$orderBy = array();
		$orderBy[] = JHTML::_('select.option', 'a.id,ASC', JText::_('ACY_ID'));
		$orderBy[] = JHTML::_('select.option', 'a.created,DESC', JText::_('ACY_CREATED'));
		$orderBy[] = JHTML::_('select.option', 'a.actor,ASC', JText::_('ACY_AUTHOR'));
		$orderBy[] = JHTML::_('select.option', 'rand()', JText::_('ACY_RANDOM'));
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
		<tr>
			<td><?php echo JText::_('DISPLAY');?></td>
			<td><input type="checkbox" name="joswall_cbdisplay" value="profile" id="posts" checked="checked" onclick="updateJosTag('wall');"/><label style="margin-left:5px" for="posts" id="posts-lbl"><?php echo JText::_('COM_COMMUNITY_COMMENTS');?></label></td>
			<td><input type="checkbox" name="joswall_cbdisplay" value="photos" id="photos" checked="checked" onclick="updateJosTag('wall');"/><label style="margin-left:5px" for="photos" id="photos-lbl"><?php echo JText::_('COM_COMMUNITY_FILTERBAR_PHOTO');?></label></td>
			<td><input type="checkbox" name="joswall_cbdisplay" value="videos" id="videos" checked="checked" onclick="updateJosTag('wall');"/><label style="margin-left:5px" for="videos" id="videos-lbl"><?php echo JText::_('COM_COMMUNITY_FILTERBAR_VIDEO');?></label></td>
			<td><input type="checkbox" name="joswall_cbdisplay" value="events" id="events" checked="checked" onclick="updateJosTag('wall');"/><label style="margin-left:5px" for="events" id="events-lbl"><?php echo JText::_('COM_COMMUNITY_FILTERBAR_EVENT');?></label></td>
		</tr>
		<tr>
			<td nowrap><label for="joswall_max"><?php echo JText::_('MAX_ARTICLE')?></label></td>
			<td><input name="joswall_max" id="joswall_max" type="text" onchange="updateJosTag('wall');" value="20" style="width:50px;"/></td>
			<td><label for="joswall_order"><?php echo JText::_('ACY_ORDER'); ?></label></td>
			<td colspan="2"><?php echo JHTML::_('select.genericlist', $orderBy, 'joswall_order', 'style="margin-bottom: 0;width:150px;" onchange="updateJosTag(\'wall\');"'); ?></td>
		</tr>
		<?php if(JRequest::getString('type') === 'autonews'){ ?>
			<tr>
				<td nowrap><label for="joswall_min"><?php echo JText::_('MIN_ARTICLE') ?></label></td>
				<td><input name="joswall_min" id="joswall_min" type="text" onchange="updateJosTag('wall');" value="1" style="width:50px;"/></td>
				<td><?php echo JText::_('JOOMEXT_FILTER'); ?></td>
				<td colspan="2">
					<?php
					$filters = array();
					$filters[] = JHTML::_('select.option', "", JText::_('ACY_ALL'));
					$filters[] = JHTML::_('select.option', "|filter:created", JText::_('ONLY_NEW_CREATED'));
					echo JHTML::_('select.genericlist', $filters, 'joswall_filter', 'size="1" onchange="updateJosTag(\'wall\');"', 'value', 'text', '|filter:created');
					?>
				</td>
			</tr>
		<?php
		}
		echo '</table>';
		echo $tabs->endPanel();
	}

	function _showUserFieldsTab($tabs){
		echo $tabs->startPanel(JText::_('USER_FIELDS'), 'jomsocial_userfields');
		echo '<br style="font-size:1px"/>';
		$text = '<table class="adminlist table table-striped table-hover" cellpadding="1">';

		$db = JFactory::getDBO();
		$fields = acymailing_getColumns('#__community_users');
		$db->setQuery("SELECT `name`, `id` FROM `#__community_fields` WHERE `type` != 'group' ORDER BY `ordering` ASC");
		$extraFields = $db->loadObjectList();

		$k = 0;

		foreach($extraFields as $oneField){
			$text .= '<tr style="cursor:pointer" class="row'.$k.'" onclick="setTag(\'{jomsocialfield:'.$oneField->id.'}\');insertTag();" ><td>'.$oneField->name.'</td></tr>';
			$k = 1 - $k;
		}

		foreach($fields as $fieldname => $oneField){
			if(in_array($fieldname, array('params'))){
				continue;
			}
			$type = '';
			if(strpos(strtolower($oneField), 'date') !== false){
				$type = '|type:date';
			}
			$text .= '<tr style="cursor:pointer" class="row'.$k.'" onclick="setTag(\'{jomsocialfield:'.$fieldname.$type.'}\');insertTag();" ><td>'.$fieldname.'</td></tr>';
			$k = 1 - $k;
		}
		$text .= '</table>';

		echo $text;
		echo $tabs->endPanel();
	}

	function displayTable($elements, $parameter){
		$beforeAll = array('table' => '<table cellspacing="0" cellpadding="0" border="0">');
		$beforeBlock = array('table' => '<tr>');
		$beforeOne = array('table' => '<td valign="top">');

		$afterOne = array('table' => '</td>');
		$afterBlock = array('table' => '</tr>');
		$afterAll = array('table' => '</table>');

		$type = 'table';
		$cols = 1;
		if(!empty ($parameter->displaytype)){
			$type = $parameter->displaytype;
		}
		if(!empty ($parameter->cols)){
			$cols = $parameter->cols;
		}

		$string = $beforeAll[$type];
		$a = 0;
		foreach($elements as $oneElement){
			if($a == 0){
				$string .= $beforeBlock[$type];
			}
			$string .= $beforeOne[$type].$oneElement.$afterOne[$type];
			$a++;
			if($a == $cols){
				$string .= $afterBlock[$type];
				$a = 0;
			}
		}
		if(!empty ($a)){
			while($cols > $a){
				$string .= $beforeOne[$type].$afterOne[$type];
				$a++;
			}
		}

		$string .= $afterBlock[$type];
		$string .= $afterAll[$type];

		return $string;
	}

	function acymailing_replaceusertags(& $email, & $user, $send = true){
		$db = JFactory::getDBO();

		$match = '#{jomsocialfield:(.*)}#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty ($email->$var)){
				continue;
			}
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty ($results[$var][0])){
				unset ($results[$var]);
			}
		}

		//If we didn't find anything...
		if(!$found){
			return;
		}

		$tags = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset ($tags[$oneTag])){
					continue;
				}

				//We explode each argument of the tag
				$arguments = explode('|', $allresults[1][$i]);
				$field = trim($arguments[0]);
				unset ($arguments[0]);
				$mytag = new stdClass();
				//We get the default value with the params plugin
				$mytag->default = $this->params->get('default_'.$field, '');
				$mytag->userid = @ $user->userid;
				if(!empty ($arguments)){
					foreach($arguments as $onearg){
						$args = explode(':', $onearg);
						if(isset ($args[1])){
							$mytag->{$args[0]} = $args[1];
						}else{
							$mytag->{$args[0]} = 1;
						}
					}
				}

				//We get the default value with the params plugin
				$tags[$oneTag] = $mytag->default;
				$mytag->userid = intval($mytag->userid);
				if(empty ($mytag->userid)){
					continue;
				}
				if($mytag->userid != $this->lastuserid){
					$this->lastuserid = $mytag->userid;
					$this->valuesNum = null;
					$this->valuesString = null;
				}


				if(is_numeric($field)){
					if($this->valuesNum === null){
						$db->setQuery('SELECT `field_id`,`value` FROM '.acymailing_table('community_fields_values', false).' WHERE user_id = '.intval($mytag->userid));
						$this->valuesNum = $db->loadObjectList('field_id');
					}
					if(isset($this->valuesNum[$field]->value)){
						$tags[$oneTag] = $this->valuesNum[$field]->value;
					}
				}else{
					if($this->valuesString === null){
						$db->setQuery('SELECT * FROM '.acymailing_table('community_users', false).' WHERE userid = '.intval($mytag->userid).' LIMIT 1');
						$this->valuesString = $db->loadObject();
					}

					if(isset($this->valuesString->$field)){
						$tags[$oneTag] = $this->valuesString->$field;
					}

					//Special fields...
					if(in_array($field, array('avatar', 'thumb')) && !empty($this->valuesString->$field)){
						$tags[$oneTag] = '<img src="'.ACYMAILING_LIVE.$this->valuesString->$field.'"/>';
						if(!empty($mytag->maxheight) || !empty($mytag->maxwidth)){
							$pictureHelper = acymailing_get('helper.acypict');
							$pictureHelper->maxHeight = empty($mytag->maxheight) ? 999 : $mytag->maxheight;
							$pictureHelper->maxWidth = empty($mytag->maxwidth) ? 999 : $mytag->maxwidth;
							$tags[$oneTag] = $pictureHelper->resizePictures($tags[$oneTag]);
						}
					}
				}
			}
		}

		foreach($results as $var => $allresults){
			$email->$var = str_replace(array_keys($tags), $tags, $email->$var);
		}
	}

	function onAcyDisplayFilters(&$type){
		if(!$this->component_installed) return;
		$db = JFactory::getDBO();
		$db->setQuery("SELECT `id`,`name` FROM #__community_fields WHERE `type` != 'group' ORDER BY `ordering` ASC");
		$fields = $db->loadObjectList();
		if(empty($fields)) return;

		$type['jomsocialfield'] = 'JomSocial';
		$jomsocialfields = array();
		foreach($fields as $oneField => $fieldType){
			$jomsocialfields[] = JHTML::_('select.option', $fieldType->id, $fieldType->name);
		}

		$jsOnChange = "displayCondFilter('displayJomSocialValues', 'toChange__num__',__num__,'map='+document.getElementById('filter__num__jomsocialfieldmap').value+'&cond='+document.getElementById('filter__num__jomsocialfieldoperator').value+'&value='+document.getElementById('filter__num__jomsocialfieldvalue').value); ";
		//countResults done on success of ajax call

		$operators = acymailing_get('type.operators');
		$operators->extra = 'onchange="'.$jsOnChange.'"';

		$return = '<div id="filter__num__jomsocialfield">'.JHTML::_('select.genericlist', $jomsocialfields, "filter[__num__][jomsocialfield][map]", 'class="inputbox" size="1" onchange="'.$jsOnChange.'" ', 'value', 'text');
		$return .= ' '.$operators->display("filter[__num__][jomsocialfield][operator]").'  <span id="toChange__num__"><input class="inputbox" type="text" name="filter[__num__][jomsocialfield][value]" onchange="countresults(__num__)" style="width:200px" value="" id="filter__num__jomsocialfieldvalue"></span></div>';

		//Load groups and categories
		$db->setQuery('SELECT a.id as groupid, a.name as groupname, b.name as categoryname, a.categoryid, a.membercount FROM #__community_groups as a LEFT JOIN #__community_groups_category as b on a.categoryid = b.id ORDER BY categoryname ASC, groupname ASC');
		$allGroups = $db->loadObjectList();

		if(!empty($allGroups)){
			$type['jomsocialgroup'] = 'JomSocial Group';
			$currentCat = '';
			$dispGroups = array();
			foreach($allGroups as $oneGroup){
				if($currentCat != $oneGroup->categoryid){
					if(!empty ($dispGroups)){
						$dispGroups[] = JHTML::_('select.option', '</OPTGROUP>');
					}
					$dispGroups[] = JHTML::_('select.option', '<OPTGROUP>', $oneGroup->categoryname);
					$currentCat = $oneGroup->categoryid;
				}
				$dispGroups[] = JHTML::_('select.option', $oneGroup->groupid, $oneGroup->groupname.'	( '.$oneGroup->membercount.' )');
			}

			$inoperator = acymailing_get('type.operatorsin');
			$inoperator->js = 'onchange="countresults(__num__)"';

			$return .= '<div id="filter__num__jomsocialgroup">';
			$return .= $inoperator->display("filter[__num__][jomsocialgroup][type]").' '.JHTML::_('select.genericlist', $dispGroups, "filter[__num__][jomsocialgroup][group]", 'class="inputbox" size="1" onchange="countresults(__num__)" ', 'value', 'text');
			$return .= '</div>';
		}

		//Load JomSocial profiles
		$db->setQuery('SELECT id,name FROM #__community_profiles ORDER BY ordering ASC');
		$allProfiles = $db->loadObjectList();
		if(!empty($allProfiles)){
			$type['jomsocialprofile'] = 'JomSocial Profile';
			$inoperator = acymailing_get('type.operatorsin');
			$inoperator->js = 'onchange="countresults(__num__)"';
			$return .= '<div id="filter__num__jomsocialprofile">';
			$return .= $inoperator->display("filter[__num__][jomsocialprofile][type]").' '.JHTML::_('select.genericlist', $allProfiles, "filter[__num__][jomsocialprofile][group]", 'class="inputbox" size="1" onchange="countresults(__num__)" ', 'id', 'name');
			$return .= '</div>';
		}

		return $return;
	}

	// Change the input field to display suggestions
	function onAcyTriggerFct_displayJomSocialValues(){
		$num = JRequest::getInt('num');
		$map = JRequest::getString('map');
		$cond = JRequest::getVar('cond', '', '', 'string', JREQUEST_ALLOWHTML);
		$value = JRequest::getString('value');

		// Default return: empty input field
		$emptyInputReturn = '<input onchange="countresults('.$num.')" class="inputbox" type="text" name="filter['.$num.'][jomsocialfield][value]" id="filter'.$num.'jomsocialfieldvalue" style="width:200px" value="'.$value.'">';

		// Display first 100 values for some fields
		if(empty($map) || !in_array($cond, array('=', '!='))) return $emptyInputReturn;

		$db = JFactory::getDBO();
		$query = 'SELECT DISTINCT value FROM #__community_fields_values as a WHERE a.field_id = '.intval($map).' LIMIT 100';
		$db->setQuery($query);
		$prop = $db->loadObjectList();

		// No values -> default return
		if(empty($prop) || count($prop) >= 100 || (count($prop) == 1 && (empty($prop[0]->value) || $prop[0]->value == '-'))) return $emptyInputReturn;

		return JHTML::_('select.genericlist', $prop, "filter[$num][jomsocialfield][value]", 'onchange="countresults('.$num.')" class="inputbox" size="1" style="width:200px"', 'value', 'value', $value, 'filter'.$num.'jomsocialfieldvalue');
	}

	function onAcyProcessFilterCount_jomsocialprofile(&$query, $filter, $num){
		$this->onAcyProcessFilter_jomsocialprofile($query, $filter, $num);
		return JText::sprintf('SELECTED_USERS', $query->count());
	}

	function onAcyProcessFilter_jomsocialprofile(&$query, $filter, $num){
		$query->join['jomsocialusers'] = "`#__community_users` as jomsocialusers ON jomsocialusers.`userid` = sub.`userid`";
		$operator = ($filter['type'] == 'IN') ? '=' : "!=";
		$query->where[] = "jomsocialusers.`profile_id` ".$operator.intval($filter['group']);
	}

	function onAcyProcessFilterCount_jomsocialgroup(&$query, $filter, $num){
		$this->onAcyProcessFilter_jomsocialgroup($query, $filter, $num);
		return JText::sprintf('SELECTED_USERS', $query->count());
	}

	function onAcyProcessFilter_jomsocialgroup(& $query, $filter, $num){
		$query->leftjoin['jomsocial_group_'.$num] = "`#__community_groups_members` as jomsocialgroup$num ON jomsocialgroup$num.`memberid` = sub.`userid` AND jomsocialgroup$num.`groupid` = ".(int)$filter['group']." AND jomsocialgroup$num.`approved` = 1";
		$query->where['member'] = 'sub.userid > 0';

		$operator = ($filter['type'] == 'IN') ? 'IS NOT NULL' : "IS NULL";
		$query->where[] = "jomsocialgroup$num.`memberid` ".$operator;
	}

	function onAcyProcessFilterCount_jomsocialfield(&$query, $filter, $num){
		$this->onAcyProcessFilter_jomsocialfield($query, $filter, $num);
		return JText::sprintf('SELECTED_USERS', $query->count());
	}

	function onAcyProcessFilter_jomsocialfield(& $query, $filter, $num){
		$query->leftjoin['jomsocialfields'] = '#__community_fields_values as jomsocialfields'.$num.' ON sub.userid = jomsocialfields'.$num.'.user_id AND jomsocialfields'.$num.'.field_id = '.intval($filter['map']);
		$query->where['jomsocialfields'] = $query->convertQuery('jomsocialfields'.$num, 'value', $filter['operator'], $filter['value']);
	}

	function _showTabStart($name){
		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = JHTML::_('select.option', "$i", $i);
		}
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
		<tr>
			<td nowrap><label for="jos<?php echo $name ?>_max"><?php echo JText::_('MAX_ARTICLE')?></label></td>
			<td><input name="jos<?php echo $name ?>_max" id="jos<?php echo $name ?>_max" type="text" onchange="updateJosTag('<?php echo $name ?>');" value="20" style="width:50px;"/></td>
			<td><label for="jos<?php echo $name ?>_cols"><?php echo JText::_('FIELD_COLUMNS')?></label></td>
			<td>
				<?php echo JHTML::_('select.genericlist', $column, 'jos'.$name.'_cols', 'style="width:50px;" size="1" onchange="updateJosTag(\''.$name.'\');"', 'value', 'text', 'jos'.$name.'_cols'); ?>
			</td>
		</tr>
		<?php if(JRequest::getString('type') === 'autonews'){
			?>
			<tr>
				<td nowrap>
					<label for="jos<?php echo $name ?>_min"><?php echo JText::_('MIN_ARTICLE') ?></label>
				</td>
				<td>
					<input name="jos<?php echo $name ?>_min" id="jos<?php echo $name ?>_min" type="text" onchange="updateJosTag('<?php echo $name ?>');" value="1" style="width:50px;"/>
				</td>
				<td>
					<?php echo JText::_('JOOMEXT_FILTER'); ?>
				</td>
				<td>
					<?php
					$filters = array();
					$filters[] = JHTML::_('select.option', "", JText::_('ACY_ALL'));
					$filters[] = JHTML::_('select.option', "|filter:created", JText::_('ONLY_NEW_CREATED'));
					if($name === 'discuss'){
						$filters[] = JHTML::_('select.option', "|filter:modify", JText::_('ONLY_NEW_MODIFIED'));
					}
					echo JHTML::_('select.genericlist', $filters, 'jos'.$name.'_filter', 'size="1" onchange="updateJosTag(\''.$name.'\');"', 'value', 'text', '|filter:created');
					?>
				</td>
			</tr>
		<?php
		}
	}

	function _showTabAttributes($tabname, $attributes){
		if(!is_array($attributes)){
			return;
		}

		echo '<tr><td>'.JText::_('DISP_FIELDS').'</td><td colspan="3">';

		// Display title ?
		echo '<input name="jos', $tabname, '_attr_title" id="jos', $tabname, '_attr_title" class="jos', $tabname, '_attr" type="checkbox" checked="checked" onclick="updateJosTag(\'', $tabname, '\');" /> ';
		$title = JText::_('COM_COMMUNITY_VIDEOS_TITLE');
		if($tabname === 'users'){
			$title = JText::_('COM_COMMUNITY_NAME');
		}
		echo '<label for="jos', $tabname, '_attr_title">'.$title.'</label><br />';

		// Display image ?
		$title = JText::_('COM_COMMUNITY_PICTURE_THUMB_HEADING');
		?>
		<span class="displayimage">
			<input name="jos<?php echo $tabname ?>_attr_image" id="jos<?php echo $tabname ?>_attr_image" class="jos<?php echo $tabname ?>_attr"
				   type="checkbox" checked="checked" onclick="updateJosTag('<?php echo $tabname ?>');"/>
			<label for="jos<?php echo $tabname ?>_attr_image"><?php echo $title ?></label>
		</span>
		<span class="resizeimage">(

			<input name="jos<?php echo $tabname ?>_resizeimage" id="jos<?php echo $tabname ?>_resizeimage" type="checkbox" onclick="updateJosTag('<?php echo $tabname ?>');"/>
			<label for="jos<?php echo $tabname ?>_resizeimage"><?php echo JText::_('RESIZED') ?></label>
			<span class="imagesize">:
				<?php echo JText::_('CAPTCHA_WIDTH') ?>
				<input name="jos<?php echo $tabname ?>_imgwidth" type="text" onchange="updateJosTag('<?php echo $tabname ?>');" value="160" size="4" style="width:50px;"/>
			x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
				<input name="jos<?php echo $tabname ?>_imgheight" type="text" onchange="updateJosTag('<?php echo $tabname ?>');" value="160" size="4" style="width:50px;"/>
			</span>

			<?php if($tabname == 'users'){ ?> /
				<input name="jos<?php echo $tabname ?>_imagerequired" id="jos<?php echo $tabname ?>_imagerequired" type="checkbox" checked="checked" onclick="updateJosTag('<?php echo $tabname ?>');"/>
				<label for="jos<?php echo $tabname ?>_imagerequired"><?php echo JText::_('REQUIRED') ?></label>
			<?php } ?>

			)</span>
		<br/>
		<?php

		foreach($attributes as $id => $title){
			if(empty($title)) continue;
			echo '<input name="jos', $tabname, '_attr_'.$id.'" id="jos', $tabname, '_attr_'.$id.'" class="jos', $tabname, '_attr" type="checkbox" onclick="updateJosTag(\'', $tabname, '\');" /> ';
			echo '<label for="jos', $tabname, '_attr_'.$id.'">'.$title.'</label><br />'."\n";
		}

		echo '</td></tr>';
	}

	function _showCategories($tabname){
		// Retrieve categories from the database
		$db = JFactory::getDBO();
		$db->setQuery('SELECT id, name, description FROM #__community_'.$tabname.'_category');
		$categories = $db->loadObjectList();

		?>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
			<tr>
				<th class="title"></th>
				<th class="title">
					<?php echo JText::_('TAG_CATEGORIES'); ?>
				</th>
			</tr>
			</thead>
			<tbody class="joscategories">
			<?php
			foreach($categories as $index => $cat){
				?>
			<tr tabid="<?php echo $tabname ?>" catid="<?php echo $cat->id ?>" class="jos<?php echo $tabname ?>_cat row<?php echo $index % 2; ?>" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td title="<?php echo $cat->description ?>"><?php echo $cat->name; ?></td>
				</tr><?php
			}
			?>
			</tbody>
		</table>
	<?php
	}

	function _loadJavascript(){
		?>
		<script language="javascript" type="text/javascript">
		<!--
		var selectedContents = new Array();
		function applyContent(contentid,rowClass){
			var tmp = selectedContents.indexOf(contentid)
			if(tmp != -1){
				window.document.getElementById('content'+contentid).className = rowClass;
				delete selectedContents[tmp];
			}else{
				window.document.getElementById('content'+contentid).className = 'selectedrow';
				selectedContents.push(contentid);
			}
			updateJosTag("photos");
		}

		function updateJosTag(tabname)
		{
			tag = '{jomsocial'+tabname+':';

			if(tabname == "wall"){
				var tmp=0;

				for(var i=0; i < document.adminForm.joswall_cbdisplay.length; i++){
					if(!document.adminForm.joswall_cbdisplay[i].checked) continue;
					if(tmp==0){
						tmp+=1;
						tag += "| display:"+document.adminForm.joswall_cbdisplay[i].value;
					}else{
						tag += ","+document.adminForm.joswall_cbdisplay[i].value;
					}
				}
			}

			if(tabname == "photos"){
				var ids = '';
				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						if(ids != ''){
							ids += selectedContents[i] + '-';
						}else{
							ids += selectedContents[i];
						}
					}
				}
				if(ids != ''){ tag += ids; }
			}

			// Categories to search in (only for videos, events and groups)
			var cats = [];
			$$('.jos'+tabname+'_cat').each(function(item) {
				if(item.hasClass('selectedrow') && item.get('catid') != undefined){
					cats.push(parseInt(item.get('catid')));
				}
			});
			tag += cats.join('-');

			// Display settings
			<?php if(JRequest::getString('type') === 'autonews'){ ?>
			if(document.adminForm['jos' + tabname + '_min'] && document.adminForm['jos' + tabname + '_min'].value){
				tag += '|min:' + document.adminForm['jos' + tabname + '_min'].value;
			}
		<?php } ?>
			if(document.adminForm['jos' + tabname + '_max'] && document.adminForm['jos' + tabname + '_max'].value){
				tag += '|max:' + document.adminForm['jos' + tabname + '_max'].value;
			}
			if(document.adminForm['jos' + tabname + '_cols'] && document.adminForm['jos' + tabname + '_cols'].value){
				tag += '|cols:' + document.adminForm['jos' + tabname + '_cols'].value;
			}
			if(document.adminForm['jos' + tabname + '_order'] && document.adminForm['jos' + tabname + '_order'].value){
				tag += '|order:' + document.adminForm['jos' + tabname + '_order'].value;
			}
			if(document.adminForm['jos' + tabname + '_chars'] && document.adminForm['jos' + tabname + '_chars'].value){
				tag += '|chars:' + document.adminForm['jos' + tabname + '_chars'].value;
			}

			if(document.adminForm[tabname+'_private'] && document.adminForm[tabname+'_private'].length)
			{
				for(var i=0; i < document.adminForm[tabname+'_private'].length; i++)
				{
					 if(document.adminForm[tabname+'_private'][i].checked && document.adminForm[tabname+'_private'][i].value == '1')
					 {
						 tag += '|private';
					 }
				}
			}

			// Display image ?
			var image = document.adminForm['jos'+tabname+'_attr_image'] || document.adminForm['jos'+tabname+'_image'];
			if (image && image.checked)
			{
			tag += '|image:';

			var required = document.adminForm['jos'+tabname+'_imagerequired'];
				if(required && required.checked){
					tag += 'required,';
				}

			if (document.adminForm['jos'+tabname+'_resizeimage'] && document.adminForm['jos'+tabname+'_resizeimage'].checked
				&& document.adminForm['jos'+tabname+'_imgwidth'] && document.adminForm['jos'+tabname+'_imgheight'])
			{
				var width = parseInt(document.adminForm['jos'+tabname+'_imgwidth'].value)
				var height = parseInt(document.adminForm['jos'+tabname+'_imgheight'].value)
				if(!isNaN(width) && !isNaN(height)){
					tag += width + 'x' + height;
				}
			}
			}

			// Event's type
			if (tabname === 'events' && document.adminForm['josevents_type'])
			{
				if (document.adminForm['josevents_type'][0].checked || document.adminForm['josevents_type'][1].checked) {
					tag += '|type:';
					var entities = [];
					if(document.adminForm['josevents_type'][0].checked){
						entities.push('profile');
					}
					if(document.adminForm['josevents_type'][1].checked){
						entities.push('group');
					}
					tag += entities.join(',');
				}
			}

			// Upcoming events ?
			if(tabname === 'events' && document.adminForm['josevents_upcoming']){
				tag += document.adminForm['josevents_upcoming'].checked ? '|upcoming' : '';
			}

			// Photo albums type
			if (tabname === 'albums' && document.adminForm['josalbums_type'])
			{
				if (document.adminForm['josalbums_type'][0].checked || document.adminForm['josalbums_type'][1].checked)
				{
					tag += '|type:';

					var entities = [];
					if(document.adminForm['josalbums_type'][0].checked){
						entities.push('user');
					}
					if(document.adminForm['josalbums_type'][1].checked){
						entities.push('group');
					}
					tag += entities.join(',');
				}
				if(document.adminForm['josalbums_type'][1].checked)
				{
					document.getElementById('groupdown').style.display = '';
					if(document.adminForm['jos' + tabname + '_group'] && document.adminForm['jos' + tabname + '_group'].value && document.adminForm['jos' + tabname + '_group'].value != 0){
						tag += '|group:' + document.adminForm['jos' + tabname + '_group'].value;
					}
				}else{
					document.getElementById('groupdown').style.display = 'none';
				}
			}

			// Photo size
			if (document.adminForm['josphotos_resizeimage'] && document.adminForm['josphotos_resizeimage'].checked
				&& document.adminForm['josphotos_imgwidth'] && document.adminForm['josphotos_imgheight'])
			{
			var width = parseInt(document.adminForm['josphotos_imgwidth'].value)
			var height = parseInt(document.adminForm['josphotos_imgheight'].value)
				if(!isNaN(width) && !isNaN(height)){
					tag += '|image:' + width + 'x' + height;
				}
			}

			// Fields to display
			var fields = [];
			$$('.jos'+tabname+'_attr').each(function(item)
			{
			var itemname = item.name.substr(9 + tabname.length);
			if (item.checked && itemname !== 'image')
			{
				fields.push(item.name.substr(9 + tabname.length));
			}
			}, this);
			if(fields.length){
				tag += '|fields:' + fields.join();
			}

			<?php if(JRequest::getString('type') === 'autonews'){ ?>

			var filter = document.adminForm['jos' + tabname + '_filter'];
			if(['|filter:created', '|filter:modify'].contains(filter.value)){
				tag += filter.value;
			}

		<?php } ?>

			tag += '}';

			setTag(tag);
		}

		// Select / unselect a category on click
		$$('.joscategories').each(function(tabcats)
		{
			tabcats.getChildren().each(function(catrow)
			{
			catrow.addEvent('click', function()
			{
				catrow.toggleClass('selectedrow');
				updateJosTag(catrow.get('tabid'));
			});
			});
		});

		// Hide resize checkbox if display image is set to none
		$$('.displayimage').each(function(item)
		{
			var resize = item.getNext();
			var tabname = resize.getChildren('input')[0].id.split('_')[0].substring(3);

			item.getChildren('input').each(function(input)
			{
			input.addEvent('change', function()
			{
				if (input.checked)
				{
				resize.setStyle('display', 'inline');
				}
				else
				{
				resize.setStyle('display', 'none');
				}
			});
			});
		});

		// Toggle image resize options
		$$('.resizeimage').each(function(item)
		{
			var widthHeight = item.getChildren()[2];
			widthHeight.setStyle('display', 'none');
			item.addEvent('change', function()
			{
			if (item.getChildren('input')[0].checked)
			{
				widthHeight.setStyle('display', 'inline');
			}
			else
			{
				widthHeight.setStyle('display', 'none');
			}
			});
		});

		// Toggle photo resize option
		function togglePhotoResize()
		{
			var display = $('josphotos_imagesize').getStyle('display');
			if(display === 'none')
			{
				display = '';
				$('josphotos_imagesize_complement').setStyle('display', 'none');
			}else{
				display = 'none';
				$('josphotos_imagesize_complement').setStyle('display', '');
			}
			$('josphotos_imagesize').setStyle('display', display);
		}

		//-->
		</script>
		<?php
	}

	/**
	 * Clean parameters common to all _replace{tag}() function
	 */
	function _cleanCommonParams($params, $allowedOrders, $allowedFields){
		if(!empty ($params)){
			foreach($params as $index => $value){
				unset($params[$index]);
				$params[strtolower($index)] = $value;
			}
		}

		// Hide labels ?
		$params['nolabel'] = !empty($params['nolabel']);

		// Query offset
		$params['start'] = !empty($params['start']) ? max(intval($params['start']), 0) : 0;

		// Auto-newsletter's filter
		$allowedFilters = array('created', 'modify');
		if(empty($params['filter']) || !in_array($params['filter'], $allowedFilters)){
			$params['filter'] = false;
		}

		// Min number of elements to display (Smart-Newsletters only)
		if(!empty($params['lastgenerateddate'])){
			$params['min'] = !empty ($params['min']) ? max(intval($params['min']), 0) : 0;
		}else{
			$params['min'] = 0;
		}


		// Max number of elements to display
		$params['max'] = !empty ($params['max']) ? intval($params['max']) : 20;
		$params['max'] = max($params['max'], 1);

		// Max number of columns to display
		$params['cols'] = !empty ($params['cols']) ? intval($params['cols']) : 1;
		$params['cols'] = max($params['cols'], 1);

		// categories to search in
		$cats = array();
		if(!empty($params['cats']) && is_array($params['cats'])){
			foreach($params['cats'] as $cat){
				$cat = abs(intval($cat));
				if($cat > 0){
					$cats[] = $cat;
				}
			}
		}
		$params['cats'] = $cats;

		// Max number of characters for the description
		$params['chars'] = !empty ($params['chars']) ? abs(intval(trim($params['chars']))) : false;

		// Image size
		$image = false;
		if(isset($params['image'])){
			$image = new stdClass();

			if(strpos($params['image'], ',') === false){
				$params['image'] = 'optional,'.$params['image'];
			}

			$options = explode(',', $params['image']);
			$image->required = ($options[0] === 'required');

			if(!empty($options[1])){
				$imgSize = explode('x', $options[1]);

				if(count($imgSize) === 2){
					$image->maxWidth = abs($imgSize[0]);
					$image->maxHeight = abs($imgSize[1]);
				}
			}
		}
		$params['image'] = $image;

		// Ordering
		$params['order'] = !empty($params['order']) ? $params['order'] : '';

		$wantedOrder = explode(',', $params['order']);
		$allowed = $params['order'] == 'rand()';

		foreach($allowedOrders as $index => $order){
			if($allowed){
				break;
			}

			$order = explode(',', $order);
			if($wantedOrder[0] == $order[0]){
				if(!empty($wantedOrder[1]) && ($wantedOrder[1] == 'ASC' || $wantedOrder[1] == 'DESC')){
					$params['order'] = $wantedOrder[0].' '.$wantedOrder[1];
				}else{
					$params['order'] = $wantedOrder[0].' DESC';
				}
				$allowed = true;
				break;
			}
		}

		if(!$allowed){
			$params['order'] = str_replace(',', ' ', $allowedOrders[0]);
		}

		// Clean required fields
		$params['title'] = false;
		$fields = array();
		if(!empty($params['fields'])){
			$fields = explode(',', $params['fields']);

			// Display element's title ?
			$params['title'] = in_array('title', $fields);

			foreach($fields as $index => $field){
				$fields[$index] = strtolower($field);

				if(!isset($allowedFields[$fields[$index]])){
					unset($fields[$index]);
				}
			}
		}

		$params['fields'] = $fields;

		return $params;
	}

	function _resizeImage($thumbnail, $original, $options){
		if(empty($thumbnail) || !is_string($thumbnail)){
			return '';
		}

		$image =& $thumbnail;

		if(!empty($options->maxHeight) && !empty($options->maxWidth)){
			$size = getimagesize($image);

			// If the thumbnail dimensions are lower than the requested size, we use the full size image
			if(($options->maxHeight > $size[0] || $options->maxHeight > $size[1]) && !empty($original) && is_string($original)){
				$image =& $original;
			}

			// Resize the image
			$img = '<img src="'.$image.'" />';
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = $options->maxHeight;
			$pictureHelper->maxWidth = $options->maxWidth;
			if($pictureHelper->available()){
				$img = $pictureHelper->resizePictures($img);
			}
			$img = explode('"', $img);
			$image = $img[1];
		}

		return $image;
	}

	/**
	 * Display an element like a photo album, a group...
	 * Set $showTitle and $properties to false to only display the image
	 * Set $imagePath to false to not display the image
	 */
	function _displayElement($elementUrl, $elementTitle, $imagePath, $showTitle, $properties){
		$ret = '<tr>';

		if(!empty($imagePath)){
			$imageTitle = addslashes($elementTitle);

			$ret .= '<td class="figure" valign="top">';
			$ret .= '<a href="'.$elementUrl.'" title="'.$imageTitle.'" class="image">';
			$ret .= '<img src="'.$imagePath.'" alt="'.$imageTitle.'" /></a></td>';
		}

		if(!empty($showTitle) || !empty($properties)){
			$ret .= '<td class="figcaption" valign="top">';
			if(!empty($showTitle)){
				$ret .= '<h2><a href="'.$elementUrl.'">'.$elementTitle.'</a></h2>';
			}
			if(!empty ($properties) && is_array($properties)){
				foreach($properties as $name => $value){
					$ret .= '<div class="'.$name.'">'.$value.'</div>';
				}
			}
			$ret .= '</td>';
		}

		return $ret.'</tr>';
	}
} //endclass