<?php
/**
 * @copyright	Copyright (C) 2009-2015 ACYBA SARL - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingjoomshopping extends JPlugin
{
	function plgAcymailingjoomshopping(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'joomshopping';
		$lang = JFactory::getLanguage();
		$this->langTable = $lang->get('tag');
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new JParameter( $plugin->params );
		}

		//check if the component is installed
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_jshopping');
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
	 	if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !$app->isAdmin())) return;

		$onePlugin = new stdClass();
		$onePlugin->name = 'JoomShopping';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_joomshopping_show(){
		$config = acymailing_config();

		if($config->get('version') < '4.9.2'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order','a.product_id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir','desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_type = $app->getUserStateFromRequest( $paramBase.".filter_type", 'filter_type','','int' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id','string' );
		$pageInfo->contentorderdir = $app->getUserStateFromRequest( $paramBase.".contentorderdir", 'contentorderdir','DESC','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->pictauto = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );

		$db = JFactory::getDBO();

		require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jshopping'.DS.'lang'.DS.'en-GB.php');

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, a.`name_'.$this->langTable.'` AS title, b.*, b.`name_'.$this->langTable.'` AS cattitle ' .
				'FROM #__jshopping_products AS a ' .
				'JOIN #__jshopping_products_to_categories AS c ON a.product_id = c.product_id ' .
				'JOIN #__jshopping_categories AS b ON c.category_id = b.category_id ';

		//search fields...
		$searchFields = array('a.`name_'.$this->langTable.'`', 'a.`alias_'.$this->langTable.'`', 'a.product_id', 'b.category_id', 'b.`name_'.$this->langTable.'`', 'b.`alias_'.$this->langTable.'`');

		//apply search fields
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaycontent','all') == 'onlypub') $filters[] = "a.product_publish = 1";

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat)) $filters[] = "b.category_id = ".$pageInfo->filter_cat;

		//apply filters
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (',$filters).')';

		//apply ordering
		if(!empty($pageInfo->filter->order->value) && strpos($pageInfo->filter->order->value, 'coupon') === false) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);

		//load results
		$rows = $db->loadObjectList();

		//yellow highlighting on search matches
		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search,$rows);

		//pagination
		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		//is this an auto newsletter or a simple one ?
		$type = JRequest::getString('type');
	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass)
			{
				<?php
					//we insert contents in the order the user selected it
				?>
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1)
				{
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('cat'+catid).className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						for(key in selectedCat)
						{
							if(!isNaN(key))
							{
								window.document.getElementById('cat'+key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				<?php
					//add the fields the user want to be displayed
				?>
				for(var i=0; i < document.adminForm.cbdisplay.length; i++)
				{
					if (document.adminForm.cbdisplay[i].checked)
					{
						 if(tmp == 0)
						 {
							 tmp += 1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }
					}
				}

				<?php
					//is the title clickable ?
				?>
				for(var i=0; i < document.adminForm.clickable.length; i++)
				{
					 if (document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '1')
					 {
						 otherinfo += '| link';
					 }
				}

				<?php
					//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value!=0)
				{
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				<?php
					//do we have to add a "read more" button ?
				?>
				for(var i=0; i < document.adminForm.readmore.length; i++)
				{
					 if (document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '1')
					 {
						 otherinfo += '| readmore';
					 }
				}

				<?php
					//picture management
				?>
				for(var i=0; i < document.adminForm.pict.length; i++)
				{
					if (document.adminForm.pict[i].checked)
					{
					 	if(document.adminForm.pict[i].value != '0')
							otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized')
						{
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				if(window.document.getElementById('jlang')  && window.document.getElementById('jlang').value != ''){
					otherinfo += '| lang:'+window.document.getElementById('jlang').value;
				}

				<?php
					//insert the tags with the right order
				?>
				for(var i in selectedContents)
				{
					if(selectedContents[i] && !isNaN(i))
					{
						tag = tag + '{<?php echo $this->name; ?>:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto()
			{
				var tag = '';
				var otherinfo = '';
				var tmp = 0;

				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++)
				{
					if (document.adminForm.cbdisplayauto[i].checked)
					{
						 if(tmp == 0)
						 {
							 tmp += 1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }
					}
				}

				for(var i=0; i < document.adminForm.clickableauto.length; i++)
				{
					if (document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '1')
					{
						 otherinfo += '| link';
					}
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++)
				{
					 if (document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '1')
					 {
						 otherinfo += '| readmore';
					 }
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value!=0)
				{
					otherinfo += "| wrap:"+document.adminForm.wrapauto.value;
				}

				tmp = 0;
				for(var i=0; i < document.adminForm.autopict.length; i++)
				{
					if (document.adminForm.autopict[i].checked)
					{
						if(document.adminForm.autopict[i].value != '0')
							otherinfo += '| pict:'+document.adminForm.autopict[i].value;

						if(document.adminForm.autopict[i].value == 'resized')
						{
							 document.getElementById('pictsizeauto').style.display = '';
							 if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
							 if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				if(document.adminForm.label.value != 0){
					otherinfo += "| label:"+document.adminForm.label.value;
				}

				<?php
					//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value)
				{
					otherinfo += "| cols:"+document.adminForm.cols.value;
				}

				<?php
					//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value)
				{
					otherinfo += "| max:"+document.adminForm.max_article.value;
				}

				<?php
					//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value){
					otherinfo += "| order:"+document.adminForm.contentorder.value+","+document.adminForm.contentorderdir.value;
				}

				if(window.document.getElementById('jlangauto')  && window.document.getElementById('jlangauto').value != ''){
					otherinfo += '| lang:'+window.document.getElementById('jlangauto').value;
				}

				<?php if($type == 'autonews'){

					//minimum number of content for the newsletter to be displayed... yes, a perfect english !
				?>
					if(document.adminForm.min_article.value)
					{
						otherinfo += "| min:"+document.adminForm.min_article.value;
					}

					<?php
						//filter the content : only newly created/modified
					?>
					if(document.adminForm.contentfilter && document.adminForm.contentfilter.value != 0)
					{
						otherinfo += "| filter:"+document.adminForm.contentfilter.value;
					}
				<?php }
					//insert the tag
				?>
				tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat)
				{
					if(selectedCat[icat] == 'selectedone')
					{
						tag += icat+'-';
					}
				}
				tag += otherinfo+'}<br />';

				setTag(tag);
			}
		//-->
		</script>
<?php
		// yes/no for the options
		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$db->setQuery('SELECT id, name FROM #__jshopping_product_labels');
		$allLabels = $db->loadObjectList();

		// Filter by label
		$labels = array();
		$labels[] = JHTML::_('select.option', "0", '- - -');
		foreach($allLabels as $oneLabel){
			$labels[] = JHTML::_('select.option', $oneLabel->id, $oneLabel->name);
		}

		// filter options
		$contentfilter = array();
		$contentfilter[] = JHTML::_('select.option', "0", JText::_('ACY_ALL'));
		$contentfilter[] = JHTML::_('select.option', "created", JText::_('ONLY_NEW_CREATED'));
		$contentfilter[] = JHTML::_('select.option', "modified", JText::_('ONLY_NEW_MODIFIED'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i=1;$i<11;$i++)
		{
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane( $this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), $this->name.'_listings');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="title" id="title" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="title" id="title-lbl"><?php echo JText::_('ACY_TITLE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="intro" id="intro" onclick="updateTag();"/><label style="margin-left:5px" for="intro" id="intro-lbl"><?php echo JText::_('INTRO_TEXT'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="text" id="text" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="text" id="text-lbl"><?php echo JText::_('ACY_DESCRIPTION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="code" id="code" onclick="updateTag();"/><label style="margin-left:5px" for="code" id="code-lbl"><?php echo _JSHOP_EAN_PRODUCT; ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="rating" id="rating" onclick="updateTag();"/><label style="margin-left:5px" for="rating" id="rating-lbl"><?php echo _JSHOP_SORT_RATING; ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="hits" id="hits" onclick="updateTag();"/><label style="margin-left:5px" for="hits" id="hits-lbl"><?php echo _JSHOP_HITS; ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="availability" id="availability" onclick="updateTag();"/><label style="margin-left:5px" for="availability" id="availability-lbl"><?php echo _JSHOP_AVILABILITY_PRODUCT; ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="manufacturer" id="manufacturer" onclick="updateTag();"/><label style="margin-left:5px" for="manufacturer" id="manufacturer-lbl"><?php echo _JSHP_STPAGE_manufacturer; ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="image" id="image" onclick="updateTag();"/><label style="margin-left:5px" for="image" id="image-lbl"><?php echo JText::_('ACY_IMAGE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="site" id="site" onclick="updateTag();"/><label style="margin-left:5px" for="site" id="site-lbl"><?php echo _JSHOP_URL;?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="prevprice" id="prevprice" onclick="updateTag();"/><label style="margin-left:5px" for="prevprice" id="prevprice-lbl"><?php echo ACYMAILING_J16 ? _JSHOP_OLD_PRICE : _JSHOP_PRODUCT_OLD_PRICE; ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="price" id="price" onclick="updateTag();"/><label style="margin-left:5px" for="price" id="price-lbl"><?php echo _JSHOP_PRODUCT_PRICE;?></label></td>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
			</tr>
			<tr>
				<?php
					$jflanguages = acymailing_get('type.jflanguages');
					if($jflanguages->multilingue){
				?>
				<td>
					<?php
						echo JText::_('LANGUAGES');
					?>
				</td>
				<td>
					<?php
						$jflanguages->onclick = 'onchange="updateTag();"';
						$jflanguages->jid = 'jlang';
						echo $jflanguages->displayJLanguages('jlang');
					?>
				</td>
				<?php } ?>
				<td nowrap="nowrap" colspan="<?php echo $jflanguages->multilingue ? '3' : '5' ?>"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap" colspan="4"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
				<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'cattitle', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php
							echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'a.product_id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value );
						?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="4">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					if(!empty($rows))
					{
						foreach($rows as $row)
						{
				?>
							<tr id="content<?php echo $row->product_id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->product_id.",'row$k'"?>);" style="cursor:pointer;">
								<td class="acytdcheckbox"></td>
								<td>
									<?php
										if(!empty($row->title))
										{
											echo $row->title;
										}
									?>
								</td>
								<td>
									<?php
										if(!empty($row->cattitle))
										{
											echo $row->cattitle;
										}
									?>
								</td>
								<td align="center" style="text-align:center" >
									<?php
										echo $row->product_id;
									?>
								</td>
							</tr>
				<?php
							// this enables to know if we have to set the line background grey or white
							$k = 1-$k;
						}
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
<?php

		echo $tabs->endPanel();

		// start category tab
		echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), $this->name.'_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="title" id="titleauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="titleauto" id="titleauto-lbl"><?php echo JText::_('ACY_TITLE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="intro" id="introauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="introauto" id="introauto-lbl"><?php echo JText::_('INTRO_TEXT'); ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="text" id="textauto" checked="checked" onclick="updateTagAuto();"/><label style="margin-left:5px" for="textauto" id="textauto-lbl"><?php echo JText::_('ACY_DESCRIPTION');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="code" id="codeauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="codeauto" id="codeauto-lbl"><?php echo _JSHOP_EAN_PRODUCT; ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="rating" id="ratingauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="ratingauto" id="ratingauto-lbl"><?php echo _JSHOP_SORT_RATING; ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="hits" id="hitsauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="hitsauto" id="hitsauto-lbl"><?php echo _JSHOP_HITS; ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="availability" id="availabilityauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="availabilityauto" id="availabilityauto-lbl"><?php echo _JSHOP_AVILABILITY_PRODUCT; ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="manufacturer" id="manufacturerauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="manufacturerauto" id="manufacturerauto-lbl"><?php echo _JSHP_STPAGE_manufacturer; ?></label></td>
			</tr>
			<tr>
				<td/>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="image" id="imageauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="imageauto" id="imageauto-lbl"><?php echo JText::_('ACY_IMAGE');?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="site" id="siteauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="siteauto" id="siteauto-lbl"><?php echo _JSHOP_URL;?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="prevprice" id="prevpriceauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="prevpriceauto" id="prevpriceauto-lbl"><?php echo ACYMAILING_J16 ? _JSHOP_OLD_PRICE : _JSHOP_PRODUCT_OLD_PRICE; ?></label></td>
				<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="price" id="priceauto" onclick="updateTagAuto();"/><label style="margin-left:5px" for="priceauto" id="priceauto-lbl"><?php echo _JSHOP_PRODUCT_PRICE;?></label></td>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
			</tr>
			<tr>
				<?php
					if($jflanguages->multilingue){
				?>
				<td>
					<?php
						echo JText::_('LANGUAGES');
					?>
				</td>
				<td>
					<?php
						$jflanguages->onclick = 'onchange="updateTagAuto();"';
						$jflanguages->jid = 'jlangauto';
						echo $jflanguages->displayJLanguages('jlangauto');
					?>
				</td>
				<?php } ?>
				<td nowrap="nowrap" colspan="<?php echo $jflanguages->multilingue ? '3' : '5' ?>"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
					<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td valign="top">
					<?php echo _JSHOP_LABEL;?>
				</td>
				<td valign="top">
					 <?php echo JHTML::_('select.genericlist', $labels, 'label' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text'); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap" nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					<?php
						$values = array('product_id' => 'ACY_ID', 'product_date_added' => 'CREATED_DATE', 'date_modify' => 'MODIFIED_DATE', "name_".$this->langTable => 'FIELD_TITLE', 'hits' => _JSHOP_HITS);
						echo $this->acypluginsHelper->getOrderingField($values, $pageInfo->contentorder, $pageInfo->contentorderdir);
					?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td nowrap="nowrap">
					<?php 	echo JText::_('MIN_ARTICLE'); ?>
				</td nowrap="nowrap">
				<td nowrap="nowrap" colspan="2">
					<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('JOOMEXT_FILTER'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
					 <?php echo JHTML::_('select.genericlist', $contentfilter, 'contentfilter' , 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentfilter); ?>
				</td>
			</tr>
			<?php }else{ ?>
			<tr>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
<!--====================================================================================LISTE CATEGORIES===========================================================================-->
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
<?php
		$k=0;
?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
					<?php
						echo JText::_('ACY_ALL');
					?>
				</td>
			</tr>
<?php
		if(!empty($this->catvalues))
		{
			foreach($this->catvalues as $oneCat)
			{
				if(empty($oneCat->value)) continue;
?>
				<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
					<?php
						echo $oneCat->text;
					?>
					</td>
				</tr>
<?php
				$k = 1 - $k;
			}
		}
?>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->startPanel(JText::_('ACY_COUPON'),'jshopcoupon');
		$value = array();
	 	$value[] = JHTML::_('select.option', 'percent',JText::_('COUPON_PERCENT'));
	 	$value[] = JHTML::_('select.option', '1',JText::_('COUPON_TOTAL'));
	 	$percent_total = JHTML::_('acyselect.radiolist', $value, 'coupon_percent' , 'onclick="updateTagCoupon();"', 'value', 'text', 'percent');

	 	$value = array();
	 	$value[] = JHTML::_('select.option', 'permanent',JText::_('COUPON_PERMANENT'));
	 	$value[] = JHTML::_('select.option', '1',JText::_('COUPON_GIFT'));
	 	$permanent = JHTML::_('acyselect.radiolist', $value, 'coupon_permanent' , 'onclick="updateTagCoupon();"', 'value', 'text', '1');

		?>
		<script language="javascript" type="text/javascript">
		<!--
			function updateTagCoupon(){
				tagname = document.adminForm.coupon_name.value;

				for(var i=0; i < document.adminForm.coupon_percent.length; i++){
					 if (document.adminForm.coupon_percent[i].checked){ tagname += '| tcoupon:'+document.adminForm.coupon_percent[i].value; }
				}

				for(var i=0; i < document.adminForm.coupon_permanent.length; i++){
					 if (document.adminForm.coupon_permanent[i].checked){ tagname += '| type:'+document.adminForm.coupon_permanent[i].value; }
				}

				tagname += '| value:'+document.adminForm.coupon_value.value;

				for(var i=0; i < document.adminForm.start.length; i++){
					if(document.adminForm.start[i].checked && document.adminForm.start[i].value != '0'){
						tagname += '| start:'+document.adminForm.start[i].value;
						if(document.adminForm.start[i].value == 'chosen'){
							tagname += '| valstart:'+document.adminForm.to_start_date.value;
						}else{
							tagname += '| valstart:'+document.adminForm.start_date.value;
						}
					}
				}

				for(var i=0; i < document.adminForm.expiry.length; i++){
					if(document.adminForm.expiry[i].checked && document.adminForm.expiry[i].value != '0'){
						tagname += '| expiry:'+document.adminForm.expiry[i].value;
						if(document.adminForm.expiry[i].value == 'chosen'){
							tagname += '| valexpiry:'+document.adminForm.to_expiry_date.value;
						}else{
							tagname += '| valexpiry:'+document.adminForm.expiry_date.value;
						}
					}
				}

				setTag('{jshopcoupon:'+tagname+'}');
			}

			function showCouponTab(){
				if(document.getElementById('coupon_modeinsert').checked){
					document.getElementById('insert_coupon').style.display = '';
					document.getElementById('new_coupon').style.display = 'none';
				}else{
					document.getElementById('insert_coupon').style.display = 'none';
					document.getElementById('new_coupon').style.display = '';
				}
			}
		//-->
		</script>
		<?php

			$pageInfoCoupon = new stdClass();
			$pageInfoCoupon->limit = new stdClass();
			$pageInfoCoupon->elements = new stdClass();

			$paramBaseCoupon = ACYMAILING_COMPONENT.'.coupon_'.$this->name;

			$pageInfoCoupon->limit->value = $app->getUserStateFromRequest( $paramBaseCoupon.'.list_limit', 'coupon_limit', $app->getCfg('list_limit'), 'int' );
			$pageInfoCoupon->limit->start = $app->getUserStateFromRequest( $paramBaseCoupon.'.limitstart', 'coupon_limitstart', 0, 'int' );


			$query = 'SELECT SQL_CALC_FOUND_ROWS * FROM #__jshopping_coupons ' .
						'WHERE for_user_id = 0 ' .
							'AND (coupon_expire_date = "0000-00-00" OR coupon_expire_date > "'.date('Y-m-d').'") ' .
							'AND (finished_after_used = 0) ' .
							'AND coupon_publish = 1';
			if(!empty($pageInfo->filter->order->value) && strpos($pageInfo->filter->order->value, 'coupon') !== false) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
			$db->setQuery($query,$pageInfoCoupon->limit->start,$pageInfoCoupon->limit->value);
			$allCoupons = $db->loadObjectList();

			$db->setQuery('SELECT FOUND_ROWS()');
			$pageInfoCoupon->elements->total = $db->loadResult();
			$pageInfoCoupon->elements->page = count($rows);
			$paginationCoupon = new JPagination( $pageInfoCoupon->elements->total, $pageInfoCoupon->limit->start, $pageInfoCoupon->limit->value );


			$value = array();
		 	$value[] = JHTML::_('select.option', 'insert', JText::_('INSERT'));
		 	$value[] = JHTML::_('select.option', 'new', JText::_('ACY_NEW'));
			echo JHTML::_('acyselect.radiolist', $value, 'coupon_mode' , 'onclick="showCouponTab();"', 'value', 'text', 'insert');
		?>
		<table id="insert_coupon" class="adminlist table table-striped table-hover" cellpadding="1">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'COUPON_NAME'), 'coupon_code', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'COUPON_VALUE'), 'coupon_value', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_DATE'), 'coupon_start_date', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'EXPIRY_DATE'), 'coupon_expire_date', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'coupon_id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value );
						?>
					</th>
				</tr>
			</thead>
			<tbody>
		<?php
			$db->setQuery('SELECT currency_code FROM #__jshopping_currencies ORDER BY currency_ordering ASC LIMIT 1');
			$currency = $db->loadResult();
			$k = 0;
			foreach($allCoupons as $oneCoupon){
				if($oneCoupon->coupon_start_date == '0000-00-00') $oneCoupon->coupon_start_date = JText::_('ACY_NONE');
				if($oneCoupon->coupon_expire_date == '0000-00-00') $oneCoupon->coupon_expire_date = JText::_('ACY_NONE');
				echo '<tr style="cursor:pointer" class="row'.$k.'" onclick="setTag(\''.$oneCoupon->coupon_code.'\');insertTag();" ><td class="acytdcheckbox"/><td>'.$oneCoupon->coupon_code.'</td><td>'.$oneCoupon->coupon_value.(empty($oneCoupon->coupon_type) ? '%' : ' '.$currency).'</td><td>'.$oneCoupon->coupon_start_date.'</td><td>'.$oneCoupon->coupon_expire_date.'</td><td>'.$oneCoupon->coupon_id.'</td></tr>';
				$k = 1-$k;
			}
		?>
			</tbody>
			<tfoot>
				<tr>
					<td colspan="6">
						<?php
							echo $paginationCoupon->getListFooter();
							if(ACYMAILING_J30){
								$paginationNb = array();
								$paginationNb[] = JHTML::_('select.option', 5,5);
								$paginationNb[] = JHTML::_('select.option', 10,10);
								$paginationNb[] = JHTML::_('select.option', 15,15);
								$paginationNb[] = JHTML::_('select.option', 20,20);
								$paginationNb[] = JHTML::_('select.option', 25,25);
								$paginationNb[] = JHTML::_('select.option', 30,30);
								$paginationNb[] = JHTML::_('select.option', 50,50);
								$paginationNb[] = JHTML::_('select.option', 100,100);
								$paginationNb[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
								echo 'Display #'.JHTML::_('select.genericlist', $paginationNb, 'coupon_limit' , 'size="1" style="width:60px" onchange="Joomla.submitform();"', 'value', 'text', $pageInfoCoupon->limit->value).'<br />';
							}
							echo $paginationCoupon->getResultsCounter();
						?>
					</td>
				</tr>
			</tfoot>
		</table>

		<table style="display:none;" id="new_coupon" class="adminlist table table-striped table-hover" cellpadding="1">
			<tr><td><?php echo JText::_('COUPON_NAME'); ?></td><td><input id="coupon_name" onchange="updateTagCoupon();" type="text" style="width:160px" value="[name][key][value]"></td><td><?php echo $permanent; ?></td></tr>
			<tr><td><?php echo JText::_('COUPON_VALUE'); ?></td><td><input id="coupon_value" onchange="updateTagCoupon();" type="text" style="width:50px" value=""></td><td><?php echo $percent_total; ?></td></tr>
			<tr>
				<td>
					<?php echo JText::_('FIELD_DATE'); ?>
				</td>
				<td>
					<input checked type="radio" name="start" id="start0" value="0" size="1" onclick="updateTagCoupon();">
					<label for="start0" id="start0-lbl" class="radiobtn"><?php echo JText::_('ACY_NONE'); ?></label><br />

					<input type="radio" name="start" id="startchosen" value="chosen" size="1" onclick="updateTagCoupon();">
					<?php
						echo JHTML::_('calendar', '', 'to_start_date','to_date','%Y-%m-%d',array('style'=>'width:80px', 'onchange'=>'document.adminForm.start[1].checked = true;updateTagCoupon()', 'onclick'=>'document.adminForm.start[1].checked = true;updateTagCoupon();'));
					?>
					<br />

					<input type="radio" name="start" id="startdelayed" value="delayed" size="1" onclick="updateTagCoupon();">
					<?php
						$delayType = acymailing_get('type.delay');
						$delayType->onChange = "document.adminForm.start[2].checked = true;updateTagCoupon();";
						echo $delayType->display('start_date',7776000,3);
					?>
				</td>
				<td/>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('EXPIRY_DATE'); ?>
				</td>
				<td>
					<input checked type="radio" name="expiry" id="expiry0" value="0" size="1" onclick="updateTagCoupon();">
					<label for="expiry0" id="expiry0-lbl" class="radiobtn"><?php echo JText::_('ACY_NONE'); ?></label><br />

					<input type="radio" name="expiry" id="expirychosen" value="chosen" size="1" onclick="updateTagCoupon();">
					<?php
						echo JHTML::_('calendar', '', 'to_expiry_date','from_date','%Y-%m-%d',array('style'=>'width:80px', 'onchange'=>'document.adminForm.expiry[1].checked = true;updateTagCoupon()', 'onclick'=>'document.adminForm.expiry[1].checked = true;updateTagCoupon();'));
					?>
					<br />

					<input type="radio" name="expiry" id="expirydelayed" value="delayed" size="1" onclick="updateTagCoupon();">
					<?php
						$delayType = acymailing_get('type.delay');
						$delayType->onChange = "document.adminForm.expiry[2].checked = true;updateTagCoupon();";
						echo $delayType->display('expiry_date',7776000,3);
					?>
				</td>
				<td/>
			</tr>
		</table>

		<?php

		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat)
	{
		//select all cats
		$db = JFactory::getDBO();
		$db->setQuery('SELECT *, category_id AS id, category_parent_id AS parent_id FROM #__jshopping_categories ORDER BY category_id ASC');
		$mosetCats = $db->loadObjectList();
		$this->cats = array();
		if(!empty($mosetCats))
			foreach($mosetCats as $oneCat)
				$this->cats[$oneCat->parent_id][] = $oneCat;

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist',$this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function _handleChildrens($parent_id = 0,$level = 0)
	{
		if(!empty($this->cats[$parent_id]))
		{
			foreach($this->cats[$parent_id] as $cat)
			{
				$title = 'name_'.$this->langTable;
				if(empty($cat->$title))
				{
					foreach($cat as $column => $value)
					{
						if(preg_match('/^name_/', $column) && !empty($value))
						{
							$cat->title = $value;
							break;
						}
					}
				}else{
					$cat->title = $cat->$title;
				}
				if(empty($cat->title)) $cat->title = 'Category '.$cat->id;
				$this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->title);
				$this->_handleChildrens($cat->id, $level+1);
			}
		}
	}

	 function acymailing_replacetags(&$email)
	 {
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	 }

	 function _replaceOne(&$email)
	 {
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags))
			return;

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params)
		{
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content,true);
			$subjectreplace[$i] = strip_tags($content);
		}
		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
	 }

	 function _replaceContent(&$tag){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		if(!defined('_JSHOP_SORT_RATING')){
			require_once(JPATH_ROOT."/components/com_jshopping/lib/factory.php");
			if(!empty($tag->lang) && file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jshopping'.DS.'lang'.DS.$tag->lang.'.php'))
				require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jshopping'.DS.'lang'.DS.$tag->lang.'.php');
			elseif(file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jshopping'.DS.'lang'.DS.$this->langTable.'.php'))
				require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jshopping'.DS.'lang'.DS.$this->langTable.'.php');
			elseif(file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jshopping'.DS.'lang'.DS.'en-GB.php'))
				require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jshopping'.DS.'lang'.DS.'en-GB.php');
		}

	 	// extract the fields selected
		if(!empty($tag->display)){
			$tag->display = explode(',',$tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
			unset($tag->display);
		}

		// load content

		$db = JFactory::getDBO();
		$query = 'SELECT a.*, b.category_id, c.currency_code, c.currency_value, d.`'.acymailing_secureField('name_'.(empty($tag->lang) ? $this->langTable : $tag->lang)).'` AS manufacturer ' .
				'FROM #__jshopping_products AS a ' .
				'JOIN #__jshopping_products_to_categories AS b ON a.product_id = b.product_id ';
		if(ACYMAILING_J16) $query .= 'JOIN #__jshopping_currencies AS c ON a.currency_id = c.currency_id ';
		else $query .= 'JOIN #__jshopping_config AS config ' .
						'JOIN #__jshopping_currencies AS c ON config.mainCurrency = c.currency_id ';
		$query .= 'LEFT JOIN #__jshopping_manufacturers AS d ON a.product_manufacturer_id = d.manufacturer_id ' .
					'WHERE a.product_id = '.intval($tag->id).' LIMIT 1';
		$db->setQuery($query);
		$content = $db->loadObject();

		//In case of we could not load the article for any reason...
		if(empty($content)){
			$app = JFactory::getApplication();
			if($app->isAdmin()) $app->enqueueMessage('The content "'.$tag->id.'" could not be loaded','notice');
			return '';
		}

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		// create the link for the title and the read more button
		$link = ACYMAILING_LIVE.'index.php?option=com_jshopping&controller=product&task=view&category_id='.$content->category_id.'&product_id='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;
		$varFields['{link}'] = $link;

		$tag->cellspacing = empty($tag->cellspacing) ? 0 : $tag->cellspacing;
		$tag->cellpadding = empty($tag->cellpadding) ? 0 : $tag->cellpadding;
		$result = '<div class="acymailing_content"><table cellspacing="'.$tag->cellspacing.'" cellpadding="'.$tag->cellpadding.'" border="0" width="100%">';

		// display the title
		$resultTitle = array();

		if(!empty($tag->title)){
			$title = 'name_'.(empty($tag->lang) ? $this->langTable : $tag->lang);
			$resultTitle[] = $content->$title;
		}

		if(!empty($tag->code) && !empty($content->product_ean)) $resultTitle[] = '<small>(Code:'.$content->product_ean.')</small>';

		if(!empty($resultTitle)){
			$result .= '<tr><td colspan="2"><h2 class="acymailing_title">';
			if(!empty($tag->link)) $result .= '<a href="'.$link.'">';
			$result .= implode(' ', $resultTitle);
			if(!empty($tag->link)) $result .= '</a>';
			$result .= '</h2></td></tr>';
		}

		if( !( empty($tag->image) && empty($tag->intro) && empty($tag->text) ) ){
			$result .= '<tr><td colspan="2">';

			if( !empty($tag->image) && ( (!ACYMAILING_J30 && !empty($content->product_full_image)) || (ACYMAILING_J30 && !empty($content->image)) ) ){
				$jshopConfig = JSFactory::getConfig();
				$varFields['{imagehtml}'] = '<img alt="" src="'.trim(str_replace(JPATH_SITE, '', $jshopConfig->image_product_path), '\\/').'/'.(ACYMAILING_J30 ? $content->image : $content->product_full_image).'" style="float:left; margin-right:5px;" />';
				$result .= '<a href="'.$link.'">'.$varFields['{imagehtml}'].'</a>';
			}

			// display the main text wraped or not
			$introdescription = 'short_description_'.(empty($tag->lang) ? $this->langTable : $tag->lang);
			$description = 'description_'.(empty($tag->lang) ? $this->langTable : $tag->lang);
			if(!empty($tag->intro) && !empty($content->$introdescription)) $result .= $content->$introdescription;
			if(!empty($tag->text) && !empty($content->$description)) $result .= $acypluginsHelper->wrapText($content->$description, $tag);

			$result .= '<br /></td></tr>';
		}

		if(!empty($tag->rating) && $content->average_rating != '0.00') $result .= '<tr><td>'._JSHOP_SORT_RATING.' :</td><td>'.$content->average_rating.'/10</td></tr>';

		if(!empty($tag->site) && !empty($content->product_url)) $result .= '<tr><td>'._JSHOP_URL.' :</td><td><a href="'.(strpos($content->product_url, 'http') ? '' : 'http://').$content->product_url.'">'.$content->product_url.'</a></td></tr>';

		if(!empty($tag->prevprice) && !empty($content->product_old_price)) $result .= '<tr><td>'.(ACYMAILING_J16 ? _JSHOP_OLD_PRICE : _JSHOP_PRODUCT_OLD_PRICE).' :</td><td><strike>'.number_format($content->product_old_price*$content->currency_value, 2).' '.$content->currency_code.'</stike></td></tr>';

		if(!empty($tag->price) && !empty($content->product_price)) $result .= '<tr><td style="width:50%;">'._JSHOP_PRODUCT_PRICE.' :</td><td>'.number_format($content->product_price*$content->currency_value, 2).' '.$content->currency_code.'</td></tr>';

		if(!empty($tag->availability)){
			if($content->unlimited == 1) $result .= '<tr><td>'._JSHOP_AVILABILITY_PRODUCT.' :</td><td>'._JSHOP_UNLIMITED.'</td></tr>';
			else $result .= '<tr><td>'._JSHOP_AVILABILITY_PRODUCT.' :</td><td>'.intval($content->product_quantity).'</td></tr>';
		}

		if(!empty($tag->manufacturer) && !empty($content->manufacturer)) $result .= '<tr><td>'._JSHOP_MANUFACTURER.' :</td><td>'.$content->manufacturer.'</td></tr>';

		if(!empty($tag->hits)) $result .= '<tr><td>'._JSHOP_HITS.' :</td><td>'.$content->hits.'</td></tr>';

		if(!empty($tag->readmore)){
			$result .= '<tr><td colspan="2"><br /><a style="text-decoration:none;" target="_blank" href="'.$link.'" class="acymailing_readmore">'.$this->readmore.'</a></td></tr>';
		}

		$result .= '</table></div><br />';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $acypluginsHelper->removeJS($result);

		//resize or remove pictures
		$pictureHelper = acymailing_get('helper.acypict');
		if(isset($tag->pict)){
			if($tag->pict == 'resized'){
				$pictureHelper->maxHeight = empty($tag->maxheight) ? 150 : $tag->maxheight;
				$pictureHelper->maxWidth = empty($tag->maxwidth) ? 150 : $tag->maxwidth;
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}
		}else{
			$result = $pictureHelper->removePictures($result);
		}
		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);

			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);

			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag,strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result)),$email->subject);
			}
		}
	}

	private function _includeSubCats($catId){
		if(empty($this->JShopCategories)){
			$db = JFactory::getDBO();
			$db->setQuery('SELECT * FROM #__jshopping_categories');
			$JShopCategories = $db->loadObjectList();
			$this->JShopCategories = array();
			foreach($JShopCategories as $oneCat){
				$this->JShopCategories[$oneCat->category_parent_id][] = $oneCat->category_id;
			}
		}
		$return = array();
		if(empty($this->JShopCategories[$catId])) return $return;
		$return = array_merge($return, $this->JShopCategories[$catId]);
		foreach($this->JShopCategories[$catId] as $oneCatId){
			$return = array_merge($return, $this->_includeSubCats($oneCatId));
		}
		return $return;
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		$db = JFactory::getDBO();
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;

			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
				if(!empty($parameter->subcats)){
					$subCats = $this->_includeSubCats($oneCat);
					if(empty($subCats)) continue;
					foreach($subCats as $oneSubCat){
						$selectedArea[] = intval($oneSubCat);
					}
				}
			}

			if(!empty($email->language) && empty($parameter->lang)){
				$db->setQuery('SELECT lang_code FROM #__languages WHERE sef = '.$db->quote($email->language).' LIMIT 1');
				$emaillangcode = $db->loadResult();
				if(!empty($emaillangcode)){
					$parameter->lang = $emaillangcode;
				}
			}

			$query = 'SELECT DISTINCT a.product_id ' .
					'FROM #__jshopping_products AS a ' .
					'JOIN #__jshopping_products_to_categories AS c ON a.product_id = c.product_id ' .
					'JOIN #__jshopping_categories AS b ON c.category_id = b.category_id ';

			$where = array();

			// load only needed content
			if(!empty($selectedArea)) $where[] = 'b.category_id IN ('.implode(',',$selectedArea).')';

			if(!empty($parameter->excludedcats)){
				$excluded = explode(',', $parameter->excludedcats);
				JArrayHelper::toInteger($excluded);
				$where[] = 'b.category_id NOT IN ('.implode(',', $excluded).')';
			}

			// filter results created or modified
			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate']))
			{
				if($parameter->filter == 'created')
					$where[] = 'a.product_date_added > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				elseif($parameter->filter == 'modified')
					$where[] = 'a.product_date_added > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\' OR a.date_modify > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
			}

			// Only published content
			$where[] = "a.product_publish = 1";

			if(!empty($parameter->label)) $where[] = 'a.label_id = '.intval($parameter->label);

			// Not empty content
			$where[] = 'a.`'.acymailing_secureField('name_'.(empty($parameter->lang) ? $this->langTable : $parameter->lang)).'` <> ""';

			if(!empty($parameter->label)){
				$where[] = 'a.label_id = '.intval($parameter->label);
			}

			// Apply filters
			if(!empty($where)){
				$query .= ' WHERE ('.implode(') AND (',$where).')';
			}

			// Ordering
			if(!empty($parameter->order)){
				$ordering = explode(',',$parameter->order);
				if($parameter->order == 'rand' || $ordering[0] == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			// If there is no limit, then we add one
			if(!empty($parameter->max))
				$query .= ' LIMIT '.intval($parameter->max);
			else
				$query .= ' LIMIT 20'; // limit, because we do not want to display one bilion contents in the newsletter...

			// load content IDs
			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);

			// Check the number of results
			if(!empty($parameter->min) && count($allArticles) < $parameter->min)
			{
				//We will not generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough '.$this->name.' content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles))
			{
				// If the user created its own template...
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php'))
				{
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					foreach($allArticles as $oneArticleId)
					{
						$args = array();
						$args[] = $this->name.':'.$oneArticleId;
						if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
						if(!empty($parameter->link)) $args[] = 'link';
						if(!empty($parameter->readmore)) $args[] = 'readmore';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						if(!empty($parameter->cellspacing)) $args[] = 'cellspacing:'.$parameter->cellspacing;
						if(!empty($parameter->cellpadding)) $args[] = 'cellpadding:'.$parameter->cellpadding;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}

	public function acymailing_replaceusertags(&$email,&$user,$send = true){
		$this->_replaceCoupon($email,$user,$send);
	}

	private function _replaceCoupon(&$email,&$user,$send){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		$this->db = JFactory::getDBO();
		$this->app = JFactory::getApplication();
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'jshopcoupon');
		$this->tags = array();

		if(empty($tags)) return;

		foreach($tags as $i => $oneTag){
			if(isset($this->tags[$i])) continue;
			if(empty($user->subid) || !$send){
				$this->tags[$i] = '<i>Please check your e-mail to see the coupon</i>';
			}else{
				$this->tags[$i] = $this->generateCoupon($oneTag, $user);
			}
		}

		$acypluginsHelper->replaceTags($email, $this->tags);
	}

	private function generateCoupon(&$tag, &$user){
		$key = JUserHelper::genrandompassword(5);
		$tag->value = str_replace(',','.',$tag->value);
		$tag->id = preg_replace('#[^a-z0-9]#', '', strtolower(str_replace(array('[name]', '[subid]', '[email]', '[key]', '[value]'), array($user->name, $user->subid, $user->email, $key, $tag->value), $tag->id)));

		if(empty($tag->id)){
			if($this->app->isAdmin()) $this->app->enqueueMessage('Coupon not generated: Empty coupon code.', 'error');
			return;
		}

		if(empty($tag->value)){
			if($this->app->isAdmin()) $this->app->enqueueMessage('Coupon not generated: Empty coupon value.', 'error');
			return;
		}

		$start = '';
		$startColumn = '';
		if(!empty($tag->start) && !empty($tag->valstart)){
			$startColumn = ',`coupon_start_date`';
			if($tag->start == "chosen") $start = date( 'Y-m-d', acymailing_getTime($tag->valstart));
			else $start = date('Y-m-d', time() + $tag->valstart);
			$start = ','.$this->db->Quote($start);
		}

		$expiry = '';
		$expiryColumn = '';
		if(!empty($tag->expiry) && !empty($tag->valexpiry)){
			$expiryColumn = ',`coupon_expire_date`';
			if($tag->expiry == "chosen") $expiry = date('Y-m-d', acymailing_getTime($tag->valexpiry));
			else $expiry = date('Y-m-d', time() + $tag->valexpiry);
			$expiry = ','.$this->db->Quote($expiry);
		}

		$this->db->setQuery('INSERT INTO #__jshopping_coupons (`coupon_type`,`coupon_code`,`coupon_value`,`tax_id`,`used`,`for_user_id`'.$startColumn.$expiryColumn.',`finished_after_used`,`coupon_publish`)' .
					'VALUES ('.$this->db->Quote($tag->tcoupon).','.$this->db->Quote($tag->id).','.$this->db->Quote($tag->value).',0,0,'.intval($user->userid).$start.$expiry.','.intval($tag->type).',1)');
		$this->db->query();

		return $tag->id;
	}
}//endclass
?>