<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingJreviews extends JPlugin
{

	public function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'jreviews');
			$this->params = new JParameter( $plugin->params );
		}
	}

	public function acymailing_getPluginType(){
		$app = JFactory::getApplication();
		if($this->params->get('frontendaccess') == 'none' && !$app->isAdmin()) return;

		 $onePlugin = new stdClass();
		 $onePlugin->name = 'JReviews';
		 $onePlugin->function = 'acymailingjreviews_show';
		 $onePlugin->help = 'plugin-jreviews';

		 return $onePlugin;
	}

	public function acymailingjreviews_show(){

	 	$config = acymailing_config();
		if($config->get('version') < '4.8.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$my = JFactory::getUser();

		$paramBase = ACYMAILING_COMPONENT.'.jreviews';
		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order',	'a.id','cmd' );
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir',	'desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->contenttype = $app->getUserStateFromRequest( $paramBase.".contenttype", 'contenttype',$this->params->get('default_type','intro'),'string' );
		$pageInfo->author = $app->getUserStateFromRequest( $paramBase.".author", 'author',$this->params->get('default_author','0'),'string' );
		$pageInfo->titlelink = $app->getUserStateFromRequest( $paramBase.".titlelink", 'titlelink',$this->params->get('default_titlelink','1'),'string' );
		$pageInfo->lang = $app->getUserStateFromRequest( $paramBase.".lang", 'lang','','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict',$this->params->get('default_pict',1),'string' );
		$pageInfo->autopict = $app->getUserStateFromRequest( $paramBase.".pict", 'autopict',$this->params->get('default_pict',1),'string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pict", 'pictwidth',$this->params->get('maxwidth',150),'string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pict", 'pictheight',$this->params->get('maxheight',150),'string' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );

		$picts = array();
		$picts[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$pictureHelper = acymailing_get('helper.acypict');
		if($pictureHelper->available()) $picts[] = JHTML::_('select.option', "resized",JText::_('RESIZED'));
		$picts[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));


		$db = JFactory::getDBO();

		$searchFields = array('a.id','a.title','a.alias','a.created_by','b.name','b.username');
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
		}

		if(!empty($pageInfo->filter_cat)){
			$filters[] = "a.catid = ".$pageInfo->filter_cat;
		}

		if($this->params->get('displayart','all') == 'onlypub'){
			$filters[] = "a.state = 1";
		}else{
			$filters[] = "a.state != -2";
		}

		if(!ACYMAILING_J16){
			$filters[] = 'a.`access` <= '.intval($my->get('aid'));
		}else{
			$groups = implode(',', $my->getAuthorisedViewLevels());
			$filters[] = 'a.`access` IN ('.$groups.')';
		}

		if($this->params->get('frontendaccess') == 'author' && !$app->isAdmin()){
			$filters[] = "a.created_by = ".intval($my->id);
		}

		$whereQuery = '';
		if(!empty($filters)){
			$whereQuery = ' WHERE ('.implode(') AND (',$filters).')';
		}

		if(!ACYMAILING_J16){
			$query = 'SELECT SQL_CALC_FOUND_ROWS a.id,a.created,a.title,a.alias,a.catid,a.sectionid,b.name,b.username,a.created_by FROM '.acymailing_table('content',false).' as a';
		}else{
			$query = 'SELECT SQL_CALC_FOUND_ROWS a.id,a.created,a.title,a.alias,a.catid,b.name,b.username,a.created_by FROM '.acymailing_table('content',false).' as a';
		}
		$query .=' LEFT JOIN `#__users` AS b ON b.id = a.created_by';
		$query .= ' JOIN #__jreviews_categories AS jr_category ON a.catid = jr_category.id AND jr_category.`option` = \'com_content\' ';
		if(!empty($whereQuery)) $query.= $whereQuery;
		if(!empty($pageInfo->filter->order->value))
		{
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search))
		{
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		if(!ACYMAILING_J16)
		{
			$query = 'SELECT a.id, a.id as catid, a.title as category, b.title as section, b.id as secid from #__categories as a ';
			$query .= 'INNER JOIN #__sections as b on a.section = b.id ';
			$query .= 'JOIN #__jreviews_categories AS jr_category ON a.id = jr_category.id AND jr_category.`option` = "com_content" ';
			$query .= 'ORDER BY b.ordering,a.ordering';

			$db->setQuery($query);
			$categories = $db->loadObjectList('id');
			$categoriesValues = array();
			$categoriesValues[] = JHTML::_('select.option', '',JText::_('ACY_ALL'));
			$currentSec = '';
			foreach($categories as $catid => $oneCategorie)
			{
				if($currentSec != $oneCategorie->section)
				{
					if(!empty($currentSec))
						$this->values[] = JHTML::_('select.option', '</OPTGROUP>');
					$categoriesValues[] = JHTML::_('select.option', '<OPTGROUP>',$oneCategorie->section);
					$currentSec = $oneCategorie->section;
				}
				$categoriesValues[] = JHTML::_('select.option', $catid,$oneCategorie->category);
			}
		}else{
			$query = 'SELECT * from #__categories as a ';
			$query .= 'JOIN #__jreviews_categories AS jr_category ON a.id = jr_category.id AND jr_category.`option` = "com_content" ';
			$query .= 'WHERE a.`extension` = "com_content" ORDER BY lft ASC';

			$db->setQuery($query);
			$categories = $db->loadObjectList('id');
			$categoriesValues = array();
			$categoriesValues[] = JHTML::_('select.option', '',JText::_('ACY_ALL'));
			foreach($categories as $catid => $oneCategorie)
			{
				$categories[$catid]->title = str_repeat('- - ',$categories[$catid]->level).$categories[$catid]->title;
				$categoriesValues[] = JHTML::_('select.option', $catid,$categories[$catid]->title);
			}
		}

		$choice = array();
		$choice[] = JHTML::_('select.option', "1",JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0",JText::_('JOOMEXT_NO'));

		$contenttype = array();
		$contenttype[] = JHTML::_('select.option', "title",JText::_('TITLE_ONLY'));
		$contenttype[] = JHTML::_('select.option', "intro",JText::_('CATEGORY_VIEW'));
		$contenttype[] = JHTML::_('select.option', "full",JText::_('DETAILS_VIEW'));

		$contentfilter = array();
		$contentfilter[] = JHTML::_('select.option', "",JText::_('ACY_ALL'));
		$contentfilter[] = JHTML::_('select.option', "created",JText::_('ONLY_NEW_CREATED'));
		$contentfilter[] = JHTML::_('select.option', "modify",JText::_('ONLY_NEW_MODIFIED'));

		$orderValues = array();
		$orderValues[] = JHTML::_('select.option', "id,DESC",JText::_('ACY_ID'));
		$orderValues[] = JHTML::_('select.option', "ordering,ASC",JText::_('ACY_ORDERING'));
		$orderValues[] = JHTML::_('select.option', "created,DESC",JText::_('CREATED_DATE'));
		$orderValues[] = JHTML::_('select.option', "modified,DESC",JText::_('MODIFIED_DATE'));
		$orderValues[] = JHTML::_('select.option', "title,ASC",JText::_('FIELD_TITLE'));
		$orderValues[] = JHTML::_('select.option', "featured,DESC",'Featured articles');
		$orderValues[] = JHTML::_('select.option', "rand",JText::_('ACY_RANDOM'));

		$column = array();
		for($i=1;$i<11;$i++){
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'jreviews_tab');
		echo $tabs->startPanel( JText::_( 'JOOMLA_CONTENT' ), 'jreviews_content');

	?>
		<br style="font-size:1px"/>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass)
			{
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1)
				{
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}

				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				for(var i=0; i < document.adminForm.contenttype.length; i++)
				{
					 if(document.adminForm.contenttype[i].checked)
					 {
					 	selectedtype = document.adminForm.contenttype[i].value;
					 	otherinfo += '| type:'+document.adminForm.contenttype[i].value;
					 }
				}

				for(var i=0; i < document.adminForm.titlelink.length; i++)
				{
					 if(document.adminForm.titlelink[i].checked && document.adminForm.titlelink[i].value != '0')
					 {
					 	otherinfo += '| link';
					 }
				}

				if(document.adminForm.nbcomments.value && document.adminForm.nbcomments.value != 0)
				{
					otherinfo += '| comments:'+document.adminForm.nbcomments.value;
				}

				if(selectedtype != 'title')
				{
					for(var i=0; i < document.adminForm.author.length; i++){
						 if (document.adminForm.author[i].checked && document.adminForm.author[i].value != '0')
						 {
						 	otherinfo += '| author';
						 }
					}
					for(var i=0; i < document.adminForm.pict.length; i++)
					{
						 if (document.adminForm.pict[i].checked)
						 {
							otherinfo += '| pict:'+document.adminForm.pict[i].value;

							if(document.adminForm.pict[i].value == 'resized')
							{
								 document.getElementById('pictsize').style.display = '';
								 if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
								 if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
							 }else{
								 document.getElementById('pictsize').style.display = 'none';
							 }
						}
					}
				}

				if(window.document.getElementById('jflang')  && window.document.getElementById('jflang').value != ''){
					otherinfo += '|lang:';
					otherinfo += window.document.getElementById('jflang').value;
				}

				for(var i in selectedContents)
				{
					if(selectedContents[i] && !isNaN(i))
					{
						tag = tag + '{jreviews:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}

				setTag(tag);
			}
		//-->
		</script>
		<table width="100%" class="adminform">
			<tr>
				<td>
					<?php echo JText::_('DISPLAY'); ?>
				</td>
				<td colspan="2">
					<?php echo JHTML::_('acyselect.radiolist', $contenttype, 'contenttype' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?>
						</td>
				<td>
				<?php $jflanguages = acymailing_get('type.jflanguages');
						$jflanguages->onclick = 'onchange="updateTag();"';
						echo $jflanguages->display('lang',$pageInfo->lang); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td><?php echo JHTML::_('acyselect.radiolist', $choice, 'titlelink' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->titlelink); ?></td>
				<td>
				<?php echo JText::_('AUTHOR_NAME'); ?>
				 </td>
				<td><?php echo JHTML::_('acyselect.radiolist', $choice, 'author' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->author); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $picts, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('SEND_COMMENT').'<sub>('.JText::_('MAX_ARTICLE').')</sub>'; ?></td>
				<td nowrap="nowrap" valign="top">
					<input type="text" name="nbcomments" style="width:50px" value="0" onchange="updateTag();"/>
				</td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo JHTML::_('select.genericlist',   $categoriesValues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int) $pageInfo->filter_cat ); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th class="title">
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'ACY_AUTHOR'), 'b.name', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort',   JText::_( 'ACY_CREATED' ), 'a.created', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort',   JText::_( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					for($i = 0,$a = count($rows);$i<$a;$i++)
					{
						$row =& $rows[$i];
				?>
					<tr id="content<?php echo $row->id?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
						<?php
							$text = '<b>'.JText::_('JOOMEXT_ALIAS').': </b>'.$row->alias;
							echo acymailing_tooltip($text, $row->title, '', $row->title);
						?>
						</td>
						<td>
						<?php
							if(!empty($row->name)){
								$text = '<b>'.JText::_('JOOMEXT_NAME').' : </b>'.$row->name;
								$text .= '<br /><b>'.JText::_('ACY_USERNAME').' : </b>'.$row->username;
								$text .= '<br /><b>'.JText::_('ACY_ID').' : </b>'.$row->created_by;
								echo acymailing_tooltip($text, $row->name, '', $row->name);
							}
						?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo JHTML::_('date',  strip_tags($row->created), JText::_('DATE_FORMAT_LC4') ); ?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->id; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
	<?php
	echo $tabs->endPanel();
	echo $tabs->startPanel( JText::_( 'TAG_CATEGORIES' ), 'jreviews_auto');

		$type = JRequest::getString('type');

	?>
		<br style="font-size:1px"/>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedCategories = new Array();
		<?php if(!ACYMAILING_J16){ ?>
			function applyAutoContent(secid,catid,rowClass){
				if(selectedCategories[secid] && selectedCategories[secid][catid]){
					window.document.getElementById('content_sec'+secid+'_cat'+catid).className = rowClass;
					delete selectedCategories[secid][catid];
				}else{
					if(!selectedCategories[secid]) selectedCategories[secid] = new Array();
					if(secid == 0){
						for(var isec in selectedCategories){
							for(var icat in selectedCategories[isec]){
								if(selectedCategories[isec][icat] == 'content'){
									window.document.getElementById('content_sec'+isec+'_cat'+icat).className = 'row0';
									delete selectedCategories[isec][icat];
								}
							}
						}
					}else{
						if(selectedCategories[0] && selectedCategories[0][0]){
							window.document.getElementById('content_sec0_cat0').className = 'row0';
							delete selectedCategories[0][0];
						}

						if(catid == 0){
							for(var icat in selectedCategories[secid]){
								if(selectedCategories[secid][icat] == 'content'){
									window.document.getElementById('content_sec'+secid+'_cat'+icat).className = 'row0';
									delete selectedCategories[secid][icat];
								}
							}
						}else{
							if(selectedCategories[secid][0]){
								window.document.getElementById('content_sec'+secid+'_cat0').className = 'row0';
								delete selectedCategories[secid][0];
							}
						}
					}

					window.document.getElementById('content_sec'+secid+'_cat'+catid).className = 'selectedrow';
					selectedCategories[secid][catid] = 'content';
				}

				updateAutoTag();
			}
		<?php }else{ ?>
			function applyAutoContent(catid,rowClass){
				if(selectedCategories[catid]){
					window.document.getElementById('content_cat'+catid).className = rowClass;
					delete selectedCategories[catid];
				}else{
					window.document.getElementById('content_cat'+catid).className = 'selectedrow';
					selectedCategories[catid] = 'content';
				}

				updateAutoTag();
			}
		<?php } ?>

			function updateAutoTag(){
				tag = '{autojreviews:';
			<?php if(!ACYMAILING_J16){ ?>
				for(var isec in selectedCategories){
					for(var icat in selectedCategories[isec]){
						if(selectedCategories[isec][icat] == 'content'){
							if(icat != 0){
								tag += 'cat'+icat+'-';
							}else{
								tag += 'sec'+isec+'-';
							}
						}
					}
				}
			<?php }else{ ?>
				for(var icat in selectedCategories){
					if(selectedCategories[icat] == 'content'){
						tag += icat+'-';
					}
				}
			<?php } ?>

				if(document.adminForm.max_article.value && document.adminForm.max_article.value!=0){ tag += '| max:'+document.adminForm.max_article.value; }
				if(document.adminForm.contentorder.value){ tag += '| order:'+document.adminForm.contentorder.value; }

				if(document.adminForm.nbcommentsauto.value && document.adminForm.nbcommentsauto.value != 0)
				{
					tag += '| comments:'+document.adminForm.nbcommentsauto.value;
				}

			<?php if($type == 'autonews') { ?>
				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value!=0){ tag += '|min:'+document.adminForm.min_article.value; }
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){ tag += '| filter:'+document.adminForm.contentfilter.value; }
			<?php } ?>
				if(document.adminForm.meta_article && document.adminForm.meta_article.value){ tag += '| meta:'+document.adminForm.meta_article.value; }

				for(var i=0; i < document.adminForm.contenttypeauto.length; i++)
				{
					 if(document.adminForm.contenttypeauto[i].checked)
					 {
					 	selectedtype = document.adminForm.contenttypeauto[i].value;
					 	tag += '| type:'+document.adminForm.contenttypeauto[i].value;
					 }
				}
				for(var i=0; i < document.adminForm.titlelinkauto.length; i++){
					 if(document.adminForm.titlelinkauto[i].checked && document.adminForm.titlelinkauto[i].value != '0')
					 {
					 	tag += '| link';
					 }
				}
				if(selectedtype != 'title'){
					for(var i=0; i < document.adminForm.authorauto.length; i++){
						 if(document.adminForm.authorauto[i].checked && document.adminForm.authorauto[i].value != '0')
						 {
						 	tag += '| author';
						 }
					}
					for(var i=0; i < document.adminForm.autopict.length; i++)
					{
						if (document.adminForm.autopict[i].checked)
						{
							tag += '| pict:'+document.adminForm.autopict[i].value;
							if(document.adminForm.autopict[i].value == 'resized')
							{
								 document.getElementById('pictsizeauto').style.display = '';
								 if(document.adminForm.pictwidthauto.value) tag += '| maxwidth:'+document.adminForm.pictwidthauto.value;
								 if(document.adminForm.pictheightauto.value) tag += '| maxheight:'+document.adminForm.pictheightauto.value;
							}else{
								 document.getElementById('pictsizeauto').style.display = 'none';
							}
						}
					}
				}
				if(window.document.getElementById('jflangauto') && window.document.getElementById('jflangauto').value != ''){
					tag += '| lang:';
					tag += window.document.getElementById('jflangauto').value;
				}

				if(document.adminForm.cols.value)
				{
					tag += "| cols:"+document.adminForm.cols.value;
				}

				tag += '}';

				setTag(tag);
			}
		//-->
		</script>
		<table width="100%" class="adminform">
			<tr>
				<td>
					<?php echo JText::_('DISPLAY');?>
				</td>
				<td colspan="2">
					<?php echo JHTML::_('acyselect.radiolist', $contenttype, 'contenttypeauto' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', 'intro'); ?>
				</td>
				<td>
					<?php $jflanguages = acymailing_get('type.jflanguages');
						$jflanguages->onclick = 'onchange="updateAutoTag();"';
						$jflanguages->id = 'jflangauto';
						echo $jflanguages->display('langauto'); ?>
				</td>
			</tr>
			<tr>
				<td>
				<?php echo JText::_('CLICKABLE_TITLE'); ?>
				 </td>
				<td><?php echo JHTML::_('acyselect.radiolist', $choice, 'titlelinkauto' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', $pageInfo->titlelink); ?></td>
				<td>
				<?php echo JText::_('AUTHOR_NAME'); ?>
				 </td>
				<td><?php echo JHTML::_('acyselect.radiolist', $choice, 'authorauto' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', $pageInfo->author); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $picts, 'autopict' , 'size="1" onclick="updateAutoTag();"', 'value', 'text', $pageInfo->autopict); ?>
				<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidthauto" type="text" onchange="updateAutoTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheightauto" type="text" onchange="updateAutoTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('SEND_COMMENT').'<sub>('.JText::_('MAX_ARTICLE').')</sub>'; ?></td>
				<td nowrap="nowrap" valign="top">
					<input type="text" name="nbcommentsauto" style="width:50px" value="0" onchange="updateAutoTag();"/>
				</td>
			</tr>
			<tr>
				<td>
				<?php echo JText::_('MAX_ARTICLE'); ?>
				 </td>
				 <td>
					 <input type="text" name="max_article" style="width:50px" value="20" onchange="updateAutoTag();"/>
				</td>
				<td>
				<?php echo JText::_('ACY_ORDER'); ?>
				 </td>
				 <td>
				 	<?php echo JHTML::_('select.genericlist', $orderValues, 'contentorder' , 'size="1" onchange="updateAutoTag();" style="width:150px;"', 'value', 'text','id'); ?>
				</td>
			</tr>
			<?php if($this->params->get('metaselect')){ ?>
				<tr>
					<td>
					<?php echo JText::_('META_KEYWORDS'); ?>
					 </td>
					 <td colspan="3">
						 <input type="text" name="meta_article" style="width:200px" value="" onchange="updateAutoTag();"/>
					</td>
				</tr>
			<?php } ?>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td>
				<?php 	echo JText::_('MIN_ARTICLE'); ?>
				 </td>
				 <td>
				 <input type="text" name="min_article" style="width:50px" value="1" onchange="updateAutoTag();"/>
				</td>
				<td>
				<?php echo JText::_('JOOMEXT_FILTER'); ?>
				 </td>
				<td>
					 <?php echo JHTML::_('select.genericlist', $contentfilter, 'contentfilter' , 'size="1" onchange="updateAutoTag();"', 'value', 'text', $pageInfo->contentfilter); ?>
				</td>
			</tr>
			<?php } ?>
			<tr>
				<td valign="top"><?php echo JText::_('FIELD_COLUMNS'); ?></td>
				<td valign="top" colspan="3">
				 	<?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateAutoTag();" style="width:100px;"', 'value', 'text', '1'); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th class="title"></th>
				<?php if(!ACYMAILING_J16){ ?>
					<th class="title">
						<?php echo JText::_( 'SECTION'); ?>
					</th>
				<?php } ?>
					<th class="title">
						<?php echo JText::_( 'TAG_CATEGORIES'); ?>
					</th>
				</tr>
			</thead>
			<tbody>
				<?php
					$k = 0;
					if(!ACYMAILING_J16){
				?>
					<tr id="content_sec0_cat0" class="<?php echo "row$k"; ?>" onclick="applyAutoContent(0,0,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td style="font-weight: bold;">
						<?php
							echo JText::_('ACY_ALL');
						?>
						</td>
						<td style="text-align:center;font-weight: bold;">
						<?php
							echo JText::_('ACY_ALL');
						?>
						</td>
					</tr>

					<?php
					}

					$k = 1-$k;
					$currentSection = '';
					foreach($categories as $row)
					{
						if(!ACYMAILING_J16 && $currentSection != $row->section)
						{
							?>
							<tr id="content_sec<?php echo $row->secid ?>_cat0" class="<?php echo "row$k"; ?>" onclick="applyAutoContent(<?php echo $row->secid ?>,0,'<?php echo "row$k" ?>');" style="cursor:pointer;">
								<td class="acytdcheckbox"></td>
								<td style="font-weight: bold;">
									<?php
										echo $row->section;
									?>
								</td>
								<td style="text-align:center;font-weight: bold;">
									<?php
										echo JText::_('ACY_ALL');
									?>
								</td>
							</tr>
							<?php
							$k = 1-$k;
							$currentSection = $row->section;
						}
						if(!ACYMAILING_J16)
						{
							?>
							<tr id="content_sec<?php echo $row->secid ?>_cat<?php echo $row->catid?>" class="<?php echo "row$k"; ?>" onclick="applyAutoContent(<?php echo $row->secid ?>,<?php echo $row->catid ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
								<td class="acytdcheckbox"></td>
								<td>
								</td>
								<td>
								<?php
									echo $row->category;
								?>
								</td>
							</tr>
							<?php
						}else{
							?>
							<tr id="content_cat<?php echo $row->id ?>" class="<?php echo "row$k"; ?>" onclick="applyAutoContent(<?php echo $row->id ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
							<td class="acytdcheckbox"></td>
							<td>
								<?php
									echo $row->title;
								?>
							</td>
						</tr>
				<?php
						}
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
	<?php

		echo $tabs->endPanel();
		echo $tabs->endPane();
	//End of the function
	 }

	 public function acymailing_replacetags(&$email,$send = true)
	 {
		$this->_replaceAuto($email);
		 $this->_replaceArticles($email);
	 }

	 private function _replaceArticles(&$email)
	 {
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'jreviews');
		if(empty($tags))
		{
			return;
		}

		require_once JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php';

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more link:
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';


		// load JReviews config
		if(!defined('S2_ROOT')) define('S2_ROOT', JPATH_SITE.DS.'components'.DS.'com_s2framework');
		require_once(JPATH_SITE.DS.'components'.DS.'com_jreviews'.DS.'jreviews'.DS.'framework.php');
		require_once(JPATH_SITE.DS.'components'.DS.'com_s2framework'.DS.'s2framework'.DS.'libs'.DS.'object.php');
		require_once(JPATH_SITE.DS.'components'.DS.'com_s2framework'.DS.'s2framework'.DS.'libs'.DS.'controller'.DS.'component.php');

		$args = array();
		$args['app'] = 'jreviews';
		$jrapp = Sanitize::getString($args,'app','jreviews');
		S2App::import('Component','config',$jrapp);
		$this->jrConfig = new ConfigComponent();
		$controller = new stdClass();
		$this->jrConfig->startup($controller);

		//load JReviews fields
		$db = JFactory::getDBO();
		$db->setQuery('SELECT a.value, a.text, b.name FROM #__jreviews_fieldoptions AS a JOIN #__jreviews_fields AS b ON a.fieldid = b.fieldid');
		$fields = $db->loadObjectList();
		$this->jr_fields = array();
		if(!empty($fields)){
			foreach($fields as $oneField){
				$this->jr_fields[$oneField->name][$oneField->value] = $oneField->text;
			}
		}

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params)
		{
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content,true);
			$subjectreplace[$i] = strip_tags($content);
		}
		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
	 }

	 private function _replaceContent(&$tag){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		if(empty($tag->itemid)) $tag->itemid = $this->params->get('itemid');

		$result = '';

		//Load the article...
		$query = 'SELECT a.*,b.name as authorname, c.alias as catalias, c.title as cattitle FROM '.acymailing_table('content',false).' as a ';
		$query .= 'LEFT JOIN '.acymailing_table('users',false).' as b ON a.created_by = b.id ';
		$query .= 'LEFT JOIN '.acymailing_table('categories',false).' AS c ON c.id = a.catid ';
		$query .= 'WHERE a.id = '.intval($tag->id).' LIMIT 1';

		$db = JFactory::getDBO();
		$db->setQuery($query);
		$article = $db->loadObject();

		if(empty($article)){
			$app = JFactory::getApplication();
			if($app->isAdmin()) $app->enqueueMessage('The article "'.$tag->id.'" could not be loaded','notice');
			return $result;
		}

		//Ok we have an article then. Let's load the extra information from jReviews
		$db->setQuery('SELECT * FROM #__jreviews_content WHERE contentid = '.intval($tag->id));
		$extraValues = $db->loadObject();
		$completeId = $article->id;
		$completeCat = $article->catid;

		if(!empty($article->alias)) $completeId.=':'.$article->alias;
		if(!empty($article->catalias)) $completeCat .= ':'.$article->catalias;

		$link = ContentHelperRoute::getArticleRoute($completeId,$completeCat);

		//We store all fields values and we will replace them in the template... so the user can easily create a template for its jreviews item
		//You should add fields in your jReviews template like {mainpict} or {introtext} for example
		$allFields = array();
		foreach($article as $field => $value){
			$allFields['{'.$field.'}'] = $value;
		}
		$allFields['{link}'] = $link;


		$styleTitle = '';
		$styleTitleEnd = '';
		if($tag->type != "title"){
			$styleTitle = '<h2 class="acymailing_title">';
			$styleTitleEnd = '</h2>';
		}

		if(empty($tag->notitle)){
			if(!empty($tag->link)){
				$result .= '<a href="'.$link.'" ';
				if($tag->type != "title") $result .= 'style="text-decoration:none" name="content-'.$article->id.'" ';
				$result .= 'target="_blank" >'.$styleTitle.$article->title.$styleTitleEnd.'</a>';
			}else{
				$result .= $styleTitle.$article->title.$styleTitleEnd;
			}
		}

		//Add the author...
		if(!empty($tag->author)){
			$authorName = empty($article->created_by_alias) ? $article->authorname : $article->created_by_alias;
			if($tag->type == 'title') $result .= '<br />';
			$result .= '<span class="authorname">'.$authorName.'</span><br />';
		}

		if(!empty($tag->created)){
			if($tag->type == 'title') $result .= '<br />';
			$dateFormat = empty($tag->dateformat) ? JText::_('DATE_FORMAT_LC2') : $tag->dateformat;
			$result .= '<span class="createddate">'.JHTML::_( 'date', $article->created, $dateFormat).'</span><br />';
		}

		//All pictures:
		$pictures = array();

		//New way to load pictures
		$db->setQuery('SELECT * FROM #__jreviews_media WHERE listing_id = '.intval($article->id).' AND published = 1 AND approved = 1 AND media_type="photo" ORDER BY main_media DESC, ordering ASC');
		$mediaInfos = $db->loadObjectList();
		if(!empty($mediaInfos))
		{
			foreach($mediaInfos as $oneMedia)
			{
				if($this->jrConfig->media_store_photo == 's3')
				{
					$pictures[] = '<img src="http://'.$this->jrConfig->media_store_amazons3_photo.'.s3.amazonaws.com/'.$oneMedia->rel_path.$oneMedia->filename.'.'.$oneMedia->file_extension.'" hspace="5" alt="" style="margin:5px;" />';
				}else{
					$pictures[] = '<img src="'.ACYMAILING_LIVE.$this->jrConfig->media_store_local_path.rtrim($this->jrConfig->media_store_local_photo,'/').'/'.$oneMedia->rel_path.$oneMedia->filename.'.'.$oneMedia->file_extension.'" hspace="5" alt="" style="margin:5px;" />';
				}
			}
		}

		//That's the old way... we keep it just in case of...
		if(empty($pictures) && !empty($article->images)){
			$allPictures = explode("\n",$article->images);
			foreach($allPictures as $onePicture){
				$pictargs = explode('|',trim($onePicture). '|||||||');
				if(file_exists(ACYMAILING_ROOT.'images'.DS.'stories'.DS.str_replace('/',DS,$pictargs[0]))){
					$picturePath =  ACYMAILING_LIVE . 'images/stories/' . $pictargs[0];
				}elseif(file_exists(ACYMAILING_LIVE . 'images/' . $pictargs[0])){
					$picturePath = ACYMAILING_LIVE . 'images/' . $pictargs[0];
				}else{
					continue;
				}

				$pictures[] = '<img src="' . $picturePath . '" hspace="5" alt="" style="margin:5px;" border="' . intval($pictargs[5]) . '" />';
			}
		}

		if(empty($pictures)) $pictures[] = '<img src="'.ACYMAILING_LIVE.$this->jrConfig->media_general_default_image_path.'" hspace="5" alt="" style="margin:5px;"/>';

		//We add the {mainpict} tag in the available fields to easily create a customized view.
		$allFields['{mainpict}'] = empty($pictures) ? '' : reset($pictures);

		$content = '';
		if($tag->type != "title"){
			if(empty($tag->wrap)) $tag->wrap = $this->params->get('wordwrap', 0);
			$content .= $acypluginsHelper->wrapText($article->introtext, $tag);
		}
		if($tag->type == "full") $content .= $article->fulltext;
		if(!empty($tag->pict) && !empty($pictures)) $content = '<table cellspacing="0" cellpadding="0" border="0"><tr><td>'.$content.'</td><td valign="top">'.array_shift($pictures).'</td></tr></table>';

		$allFields['{otherpicts}'] = empty($pictures) ? '' : implode(' ',$pictures);
		$allFields['{content}'] = $content;

		$result .= $content;

		//Load the fields...
		if($tag->type != "title")
		{
			if(!isset($this->fields[$tag->type])){
				$db->setQuery('SELECT field.*, fieldgroup.title as grouptitle,fieldgroup.showtitle as groupshowtitle ' .
							'FROM #__jreviews_fields as field ' .
							'JOIN #__jreviews_groups as fieldgroup ' .
								'ON field.groupid = fieldgroup.groupid ' .
							'WHERE field.'.($tag->type == 'intro' ? 'listview' : 'contentview').'= 1 ' .
								'AND field.published = 1 ' .
							'ORDER BY fieldgroup.ordering ASC, field.ordering ASC');
				$this->fields[$tag->type] = $db->loadObjectList();
			}
			$currentGroup = 0;
			foreach($this->fields[$tag->type] as $i => $oneField)
			{
				if(!is_object($oneField->options)){
					$params = explode("\n",$oneField->options);
					$this->fields[$tag->type][$i]->options = new stdClass();
					foreach($params as $oneParam){
						list($var,$val) = explode('=', $oneParam);
						$this->fields[$tag->type][$i]->options->$var = trim($val);
					}
				}
				$fieldname = $oneField->name;
				if(!isset($extraValues->$fieldname) ||strlen($extraValues->$fieldname) < 1 || $extraValues->$fieldname == '0000-00-00 00:00:00') continue;
				//Ok we have a value... let's use it!
				if($currentGroup != $oneField->groupid)
				{
					if(!empty($currentGroup)) $result .= '</table></fieldset>';
					$result .= '<fieldset>';
					if($oneField->groupshowtitle) $result .= '<legend>'.$oneField->grouptitle.'</legend>';
					$result .= '<table border="0" cellspacing="10">';
					$currentGroup = $oneField->groupid;
				}
				//Let's display the field now!
				$val = nl2br($extraValues->$fieldname);

				if($oneField->type == 'date' && !empty($oneField->options->date_format))
					$val = strftime($oneField->options->date_format,strtotime($val));
				if(in_array($oneField->type,array('checkboxes','selectmultiple','select','radiobuttons')))
				{
					$val = str_replace('*',', ',trim($val,'*'));
				}

				$val = (!empty($this->jr_fields[$fieldname][$val])) ? $this->jr_fields[$fieldname][$val] : $val;

				$result .= '<tr><td valign="top"><span class="fieldname">'.($oneField->showtitle ? $oneField->title : '').'</span></td><td><span class="fieldvalue">'.$val.'</span></td></tr>';
				$allFields['{'.$fieldname.'}'] = $val;
			}
			if(!empty($currentGroup)) $result .= '</table></fieldset>';
		}

		foreach($extraValues as $i => $oneExtra){
			if(empty($allFields['{'.$i.'}'])){
				if(mb_substr_count($oneExtra, '*') == 2 && !empty($this->jr_fields[$i][trim($oneExtra, '*')])) $allFields['{'.$i.'}'] = $this->jr_fields[$i][trim($oneExtra, '*')];
				else $allFields['{'.$i.'}'] = trim($oneExtra, '*');
			}
		}

		if(empty($tag->onepict) && !empty($pictures) && !empty($tag->pict)){
			$picts = '<fieldset>'.implode(' ',$pictures).'</fieldset>';
			$allFields['{otherpicts}'] = $picts;
			$result .= $picts;
		}

		if(!empty($tag->comments))
		{
			$db->setQuery('SELECT title, comments FROM #__jreviews_comments WHERE pid = '.intval($tag->id).' ORDER BY created DESC LIMIT '.intval($tag->comments));
			$comments = $db->loadObjectList();
			if(!empty($comments))
			{
				$result .= '<fieldset><table border="0" cellspacing="10"><legend>'.JText::_('SEND_COMMENT').'</legend>';
				foreach($comments as $oneComment)
				{
					$result .= '<tr><td valign="top"><h3>'.$oneComment->title.'</h3></td></tr><tr><td style="text-align:justify;">'.strip_tags($oneComment->comments).'</td></tr>';
				}
				$result .= '</table></fieldset>';
			}
		}

		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'jreviews.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'jreviews.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($allFields),$allFields,$result);
		}

		if(isset($tag->pict) && $tag->pict == 'resized'){
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight',100) : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth',100) : $tag->maxwidth;
			if($pictureHelper->available()){
				$result = $pictureHelper->resizePictures($result);
			}elseif($app->isAdmin()){
				$app->enqueueMessage($pictureHelper->error,'notice');
			}
		}

		$result = $acypluginsHelper->removeJS($result);
		return $result;

	}

	private function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag,strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result)),$email->subject);
			}
		}
	}

	public function acymailing_generateautonews(&$email)
	{
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$db = JFactory::getDBO();
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'autojreviews');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags))
		{
			return $return;
		}

		foreach($tags as $oneTag => $parameter)
		{
			if(isset($this->tags[$oneTag]))
				continue;
			$allcats = explode('-',$parameter->id);
			//Load the articles based on all arguments...
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(!ACYMAILING_J16){
					$sectype = substr($oneCat,0,3);
					$num = substr($oneCat,3);
					if(empty($num)) continue;
					if($sectype=='cat'){
						$selectedArea[] = 'catid = '.(int) $num;
					}elseif($sectype=='sec'){
						$selectedArea[] = 'sectionid = '.(int) $num;
					}
				}else{
					if(empty($oneCat)) continue;
					$selectedArea[] = (int) $oneCat;
				}
			}
			$query = 'SELECT a.id FROM `#__content` AS a ';
			$query .= ' JOIN #__jreviews_categories AS jr_category ON a.catid = jr_category.id AND jr_category.`option` = \'com_content\' ';
			$query .= ' LEFT JOIN `#__jreviews_content` as b ON a.id = b.contentid ';
			$where = array();
			if(!empty($parameter->featured)){
				$where[] = 'b.featured > 0';
			}elseif(!empty($parameter->nofeatured)){
				$where[] = 'b.featured = 0';
			}

			if(!empty($selectedArea)){
				if(!ACYMAILING_J16){
					$where[] = implode(' OR ',$selectedArea);
				}else{
					$where[] = '`catid` IN ('.implode(',',$selectedArea).')';
				}
			}

			if(!empty($parameter->excludedcats)){
				$excludedCats = explode('-',$parameter->excludedcats);
				JArrayHelper::toInteger($excludedCats);
				$where[] = '`catid` NOT IN ("'.implode('","',$excludedCats).'")';
			}

			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				$condition = 'a.`publish_up` >\''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				$condition .= ' OR `created` >\''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				if($parameter->filter == 'modify'){
					$condition .= ' OR (';
					$condition .= ' `modified` > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
					if(!empty($parameter->maxpublished)) $condition .= ' AND a.`publish_up` > \''.date( 'Y-m-d H:i:s',time() - date('Z') - ((int)$parameter->maxpublished*60*60*24)).'\'';
					$condition .= ')';
				}

				$where[] = $condition;
			}

			//Handle a date range in the query
			if(!empty($parameter->maxcreated)){
				$date = strtotime($parameter->maxcreated);
				if(empty($date)){
					acymailing_display('Wrong date format ('.$parameter->maxcreated.' in '.$oneTag.'), please use YYYY-MM-DD','warning');
				}
				$where[] = 	'`created` < '.$db->Quote(date('Y-m-d H:i:s',$date));
			}

			if(!empty($parameter->mincreated)){
				$date = strtotime($parameter->mincreated);
				if(empty($date)){
					acymailing_display('Wrong date format ('.$parameter->mincreated.' in '.$oneTag.'), please use YYYY-MM-DD','warning');
				}
				$where[] = 	'`created` > '.$db->Quote(date('Y-m-d H:i:s',$date));
			}


			if(!empty($parameter->meta)){
				$allMetaTags = explode(',',$parameter->meta);
				$metaWhere = array();
				foreach($allMetaTags as $oneMeta){
					if(empty($oneMeta)) continue;
					$metaWhere[] = "`metakey` LIKE '%".acymailing_getEscaped($oneMeta,true)."%'";
				}
				if(!empty($metaWhere)) $where[] = implode(' OR ',$metaWhere);
			}

			$where[] = 'a.`publish_up` < \'' .date( 'Y-m-d H:i:s',$time - date('Z')).'\'';
			$where[] = 'a.`publish_down` > \''.date( 'Y-m-d H:i:s',$time - date('Z')).'\' OR a.`publish_down` = 0';
			$where[] = 'state = 1';
			//Access for J1.5.0 only
			if(!ACYMAILING_J16){
				if(isset($parameter->access)){
					$where[] = 'access <= '.intval($parameter->access);
				}else{
					if($this->params->get('contentaccess','registered') == 'registered') $where[] = 'access <= 1';
					elseif($this->params->get('contentaccess','registered') == 'public') $where[] = 'access = 0';
				}
			}elseif(isset($parameter->access)){
				//We set it only if the access is defined in the tag
				$where[] = 'access = '.intval($parameter->access);
			}

			if(!empty($parameter->jr_city))
			{
				$cities = explode(',',$parameter->jr_city);
				foreach($cities as $i =>$oneCity)
				{
					$cities[$i] = $db->Quote('*'.$oneCity.'*');
				}
				$where[] = 'b.jr_city IN ('.implode(',',$cities).')';
			}

			if(!empty($parameter->fieldfilter)){
				$filters = explode('+', $parameter->fieldfilter);
				foreach($filters as $oneFilter){
					$currentFilter = explode(',', $oneFilter);
					if(count($currentFilter) != 3) continue;
					$currentFilter[1] = str_replace(array('&lt;','&gt;'), array('<','>'), $currentFilter[1]);
					if(!in_array($currentFilter[1], array('=','LIKE','>','<','>=','<='))) continue;

					if($currentFilter[1] == 'LIKE') $where[] = 'b.`'.acymailing_secureField($currentFilter[0]).'` LIKE '.$db->Quote('%'.$currentFilter[2].'%');
					else $where[] = 'b.`'.acymailing_secureField($currentFilter[0]).'` '.$currentFilter[1].' '.$db->Quote($currentFilter[2]);
				}
			}

			$query .= ' WHERE ('.implode(') AND (',$where).')';
			if(!empty($parameter->order)){
				if($parameter->order == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY '.acymailing_secureField($ordering[0]).' '.acymailing_secureField($ordering[1]).' , a.id DESC';
				}
			}

			$start = '';
			if(!empty($parameter->start)) $start = intval($parameter->start).',';

			if(empty($parameter->max)) $parameter->max = 100;

			//We add a limit for the preview otherwise we could break everything
			$query .= ' LIMIT '.$start.(int) $parameter->max;

			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);

			if(!empty($parameter->min) && count($allArticles)< $parameter->min){
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough articles for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
			}

			$stringTag = '';
			if(!empty($allArticles)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autojreviews.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autojreviews.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the article tag one after the other in a table as they are already sorted
					$stringTag .= '<table cellspacing="0" cellpadding="0" border="0">';
					foreach($allArticles as $oneArticleId){
						$stringTag .= '<tr><td>';
						$args = array();
						$args[] = 'jreviews:'.$oneArticleId;
						if(!empty($parameter->comments)) $args[] = 'comments:'.$parameter->comments;
						if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
						if(!empty($parameter->link)) $args[] = 'link';
						if(!empty($parameter->author)) $args[] = 'author';
						if(!empty($parameter->autologin)) $args[] = 'autologin';
						if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
						if(!empty($parameter->notitle)) $args[] = 'notitle';
						if(!empty($parameter->created)) $args[] = 'created';
						if(!empty($parameter->itemid)) $args[] = 'itemid:'.$parameter->Itemid;
						if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						if(!empty($parameter->readmore)) $args[] = 'readmore:'.$parameter->readmore;
						if(!empty($parameter->dateformat)) $args[] = 'dateformat:'.$parameter->dateformat;
						if(!empty($parameter->template)) $args[] = 'template:'.$parameter->template;
						if(!empty($parameter->onepict)) $args[] = 'onepict';
						$stringTag .= '{'.implode('|',$args).'}';
						$stringTag .= '</td></tr>';
					}
					$stringTag .= '</table>';
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass