<?php
/**
 * @copyright	Copyright (C) 2009-2015 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingK2Store extends JPlugin
{
	function plgAcymailingK2Store(&$subject, $config){
		parent::__construct($subject, $config);
		$this->name = 'k2store';
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new acyParameter( $plugin->params );
		}

		$this->db = JFactory::getDBO();
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_k2store');
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
	 	if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !$app->isAdmin())) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'K2Store';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_k2store_show(){
		$config = acymailing_config();

		if($config->get('version') < '4.9.4'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();

		$lang = JFactory::getLanguage();
		$lang->load('com_k2store',JPATH_SITE);
		$lang->load('com_k2store',JPATH_ADMINISTRATOR);
		$lang->load('com_k2',JPATH_ADMINISTRATOR);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order','b.id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir','asc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_type = $app->getUserStateFromRequest( $paramBase.".filter_type", 'filter_type','','int' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id','string' );
		$pageInfo->contentorderdir = $app->getUserStateFromRequest( $paramBase.".contentorderdir", 'contentorderdir','DESC','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->pictauto = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS b.*, c.name AS cattitle ' .
				'FROM #__k2store_products AS a ' .
				'JOIN #__k2_items AS b ON a.product_id = b.id ' .
				'JOIN #__k2_categories AS c ON b.catid = c.id';

		//search fields...
		$searchFields = array('a.id','b.title','c.name');

		//apply search fields
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaycontent','all') == 'onlypub') $filters[] = 'b.published = 1';

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat)) $filters[] = 'b.catid = '.intval($pageInfo->filter_cat);

		//apply filters
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (',$filters).')';

		//apply ordering
		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;

		$this->db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);

		//load results
		$rows = $this->db->loadObjectList();

		//yellow highlighting on search matches
		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search,$rows);

		//pagination
		$this->db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $this->db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		//is this an auto newsletter or a simple one ?
		$type = JRequest::getString('type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass){
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1){
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('cat'+catid).className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						for(key in selectedCat)
						{
							if(!isNaN(key))
							{
								window.document.getElementById('cat'+key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat'+catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat'+catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				<?php
					//add the fields the user wants to be displayed
				?>
				for(var i=0; i < document.adminForm.cbdisplay.length; i++){
					if(!document.adminForm.cbdisplay[i].checked) continue;
					if(tmp == 0){
						tmp += 1;
						otherinfo += "| display:" + document.adminForm.cbdisplay[i].value;
					}else{
						otherinfo += ", " + document.adminForm.cbdisplay[i].value;
					}
				}

				if(document.adminForm.customfields){
					if(document.adminForm.customfields.length == undefined){
						if(document.adminForm.customfields.checked) otherinfo += "| custom:"+document.adminForm.customfields.value;
					}else{
						tmp=0;
						for(var i=0; i < document.adminForm.customfields.length; i++){
							if(!document.adminForm.customfields[i].checked) continue;
							if(tmp==0){
								tmp+=1;
								otherinfo += "| custom:" + document.adminForm.customfields[i].value;
							}else{
								otherinfo += ", " + document.adminForm.customfields[i].value;
							}
						}
					}
				}

				<?php
					//is the title clickable ?
				?>
				for(var i=0; i < document.adminForm.clickable.length; i++){
					 if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '0'){
						 otherinfo += '| nolink';
					 }
				}

				<?php
					//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value)){
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				<?php
					//do we have to add a "read more" button ?
				?>
				for(var i=0; i < document.adminForm.readmore.length; i++){
					if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '0'){
						otherinfo += '| noreadmore';
					}
				}

				<?php
					//picture management
				?>
				for(var i=0; i < document.adminForm.pict.length; i++){
					if(!document.adminForm.pict[i].checked) continue;
				 	if(document.adminForm.pict[i].value != '1') otherinfo += '| pict:'+document.adminForm.pict[i].value;

					if(document.adminForm.pict[i].value == 'resized'){
						document.getElementById('pictsize').style.display = '';
						if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
						if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
					}else{
						document.getElementById('pictsize').style.display = 'none';
					}
				}

				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{<?php echo $this->name; ?>:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto(){
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++){
					if(!document.adminForm.cbdisplayauto[i].checked) continue;
					if(tmp==0){
						tmp+=1;
						otherinfo += "| display:"+document.adminForm.cbdisplayauto[i].value;
					}else{
						otherinfo += ", "+document.adminForm.cbdisplayauto[i].value;
					}
				}

				if(document.adminForm.customfieldsauto){
					if(document.adminForm.customfieldsauto.length == undefined){
						if(document.adminForm.customfieldsauto.checked) otherinfo += "| custom:"+document.adminForm.customfieldsauto.value;
					}else{
						tmp=0;
						for(var i=0; i < document.adminForm.customfieldsauto.length; i++){
							if(!document.adminForm.customfieldsauto[i].checked) continue;
							if(tmp == 0){
								 tmp+=1;
								 otherinfo += "| custom:"+document.adminForm.customfieldsauto[i].value;
							}else{
								 otherinfo += ", "+document.adminForm.customfieldsauto[i].value;
							}
						}
					}
				}

				for(var i=0; i < document.adminForm.clickableauto.length; i++){
					if (document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '0'){
						 otherinfo += '| nolink';
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value)){
					otherinfo += "| wrap:"+document.adminForm.wrapauto.value;
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++){
					 if (document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '0'){
						 otherinfo += '| noreadmore';
					 }
				}

				for(var i=0; i < document.adminForm.autopict.length; i++){
					if(!document.adminForm.autopict[i].checked) continue;
					if(document.adminForm.autopict[i].value != '1') otherinfo += '| pict:'+document.adminForm.autopict[i].value;

					if(document.adminForm.autopict[i].value == 'resized'){
						document.getElementById('pictsizeauto').style.display = '';
						if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
						if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
					}else{
						document.getElementById('pictsizeauto').style.display = 'none';
					}
				}

				<?php
					//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value){
					otherinfo += "| cols:"+document.adminForm.cols.value;
				}

				<?php
					//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value){
					otherinfo += "| max:"+document.adminForm.max_article.value;
				}

				<?php
					//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value){
					otherinfo += "| order:"+document.adminForm.contentorder.value+","+document.adminForm.contentorderdir.value;
				}

				if(window.document.getElementById('jlang')  && window.document.getElementById('jlang').value != ''){
					otherinfo += '| lang:'+window.document.getElementById('jlang').value;
				}

				<?php if($type == 'autonews'){
					//minimum number of content for the newsletter to be displayed...
				?>
					if(document.adminForm.min_article.value){
						otherinfo += "| min:"+document.adminForm.min_article.value;
					}

					<?php
						//filter the content : only newly created/modified
					?>
					if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
						otherinfo += "| filter:"+document.adminForm.contentfilter.value;
					}
				<?php }
					//insert the tag
				?>
				tag = '{auto<?php echo $this->name; ?>:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat+'-';
					}
				}
				tag += otherinfo+'}<br />';

				setTag(tag);
			}
		//-->
		</script>
<?php
		// yes/no for the options
		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i=1;$i<11;$i++){
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		$fieldsDisplay = array();
		$fieldsDisplay[] = array('title' => 'title', 'label' => 'ACY_TITLE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'image', 'label' => 'ACY_IMAGE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'description', 'label' => 'ACY_DESCRIPTION', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'price', 'label' => 'K2STORE_ITEM_PRICE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'category', 'label' => 'ACY_CATEGORY', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'tags', 'label' => 'TAGS', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'rate', 'label' => 'K2_RATING', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'author', 'label' => 'ACY_AUTHOR', 'checked' => '');
		$fieldsDisplay[] = array('title' => 'options', 'label' => 'K2STORE_OPTIONS', 'checked' => '');

		$this->db->setQuery('SELECT id, name FROM #__k2_extra_fields WHERE published = 1 AND type != "header" AND type != "csv"');
		$customFields = $this->db->loadObjectList();

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane( $this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), $this->name.'_listings');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField){
						if($i == 5){
							echo '</tr><tr><td/>';
							$i = 1;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="'.$oneField['title'].'" id="'.$oneField['title'].'" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneField['title'].'">'.trim(JText::_($oneField['label']), ':').'</label></td>';
						$i++;
					}
					while($i != 5){
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<?php
				//handle custom fields
				if(!empty($customFields)){
					echo '<tr><td>'.JText::_('EXTRA_FIELDS').'</td>';
					$i = 1;
					foreach($customFields as $oneParam){
						if($i == 5){
							$i = 1;
							echo '</tr><tr><td/>' ;
						}
						echo '<td><input value="'.$oneParam->id.'" name="customfields" id="cf_'.$oneParam->id.'" type="checkbox" onclick="updateTag();"/>';
						echo '<label style="margin-left:5px" for="cf_'.$oneParam->id.'">'.$oneParam->name.'</label></td>';
						$i++;
					}
					while($i != 5){
						$i++;
						echo '<td/>';
					}
					echo '</tr>';
				}
			?>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="4">
						<?php
							echo $pagination->getListFooter();
							if(ACYMAILING_J30){
								$paginationNb = array();
								foreach(array(5,10,15,20,25,30,50,100) as $oneOption){
									$paginationNb[] = JHTML::_('select.option', $oneOption, $oneOption);
								}
								$paginationNb[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
								echo 'Display #'.JHTML::_('select.genericlist', $paginationNb, 'limit' , 'size="1" style="width:60px" onchange="Joomla.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
							}
							echo $pagination->getResultsCounter();
						?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					if(!empty($rows)){
						foreach($rows as $row){
				?>
							<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
								<td class="acytdcheckbox"></td>
								<td style="text-align:center;">
									<?php echo $row->title; ?>
								</td>
								<td style="text-align:center;">
									<?php echo $row->cattitle; ?>
								</td>
								<td style="text-align:center;">
									<?php echo $row->id; ?>
								</td>
							</tr>
				<?php
							// this enables to know if we have to set the line background grey or white
							$k = 1-$k;
						}
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />

		<?php
			echo $tabs->endPanel();
			// start category tab
			echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), $this->name.'_auto');
		?>

		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField){
						if($i%5 == 0){
							echo '</tr><tr><td/>';
							$i++;
						}
						if($i == 4){
							$jflanguages = acymailing_get('type.jflanguages');
							$jflanguages->onclick = 'onchange="updateTagAuto();"';
							$jflanguages->jid = 'jlang';
							echo '<td>'.$jflanguages->displayJLanguages('jlang').'</td></tr><tr><td/>';
							$i += 2;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField['title'].'" id="'.$oneField['title'].'auto" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField['title'].'auto">'.trim(JText::_($oneField['label']), ':').'</label></td>';
						$i++;
					}
					while($i%5 != 0){
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<?php
				//handle custom fields
				if(!empty($customFields)){
					echo '<tr><td>'.JText::_('EXTRA_FIELDS').'</td>';
					$i = 1;
					foreach($customFields as $oneParam){
						if($i == 5){
							$i = 1;
							echo '</tr><tr><td/>' ;
						}
						echo '<td><input value="'.$oneParam->id.'" name="customfieldsauto" id="autocf_'.$oneParam->id.'auto" type="checkbox" onclick="updateTagAuto();"/>';
						echo '<label style="margin-left:5px" for="autocf_'.$oneParam->id.'auto">'.$oneParam->name.'</label></td>';
						$i++;
					}
					while($i != 5){
						$i++;
						echo '<td/>';
					}
					echo '</tr>';
				}
			?>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
					<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap" nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					<?php
						$values = array('id' => 'ACY_ID', 'ordering' => 'ACY_ORDERING', 'created' => 'CREATED_DATE', 'modified' => 'MODIFIED_DATE', 'title' => 'FIELD_TITLE', 'item_price' => 'K2STORE_ITEM_PRICE');
						echo $this->acypluginsHelper->getOrderingField($values, $pageInfo->contentorder, $pageInfo->contentorderdir);
					?>
				</td>
			</tr>
			<?php if($type == 'autonews'){ ?>
			<tr>
				<td nowrap="nowrap">
					<?php 	echo JText::_('MIN_ARTICLE'); ?>
				</td nowrap="nowrap">
				<td nowrap="nowrap" colspan="2">
					<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('JOOMEXT_FILTER'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
				 	<?php $filter = acymailing_get('type.contentfilter'); $filter->onclick = 'updateTagAuto();'; echo $filter->display('contentfilter',$pageInfo->contentfilter,false); ?>
				</td>
			</tr>
			<?php }else{ ?>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap" colspan="4">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<?php $k=0; ?>
			<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td><?php echo JText::_('ACY_ALL'); ?></td>
			</tr>
			<?php
				if(!empty($this->catvalues)){
					foreach($this->catvalues as $oneCat){
						if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td class="acytdcheckbox"></td>
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
			<?php
						$k = 1 - $k;
					}
				}
			?>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->startPanel(JText::_('ACY_COUPON'),'vm_coupon');

		?>
		<script language="javascript" type="text/javascript">
		<!--
			function updateTagCoupon(){
				tagname = '{k2storecoupon:';

				tagname += document.adminForm.coupon_code.value;

				for(var i=0; i < document.adminForm.coupon_percent.length; i++){
					 if(document.adminForm.coupon_percent[i].checked){ tagname += '| tcoupon:'+document.adminForm.coupon_percent[i].value; }
				}

				tagname += '| value:'+document.adminForm.coupon_value.value;

				if(document.adminForm.coupon_name.value){
					tagname += '| name:'+document.adminForm.coupon_name.value;
				}

				if(document.adminForm.coupon_cat.value){
					tagname += '| categories:'+document.adminForm.coupon_cat.value;
				}

				if(document.adminForm.coupon_prod.value){
					tagname += '| products:'+document.adminForm.coupon_prod.value;
				}

				for(var i=0; i < document.adminForm.coupon_logged.length; i++){
					 if(document.adminForm.coupon_logged[i].checked && document.adminForm.coupon_logged[i].value == 1){ tagname += '| logged'; }
				}

				for(var i=0; i < document.adminForm.coupon_unique.length; i++){
					if(document.adminForm.coupon_unique[i].checked && document.adminForm.coupon_unique[i].value == 1){ tagname += '| unique'; }
				}

				for(var i=0; i < document.adminForm.start.length; i++){
					if(document.adminForm.start[i].checked && document.adminForm.start[i].value != '0'){
						tagname += '| start:'+document.adminForm.start[i].value;
						if(document.adminForm.start[i].value == 'chosen'){
							tagname += '| valstart:'+document.adminForm.to_start_date.value;
						}else{
							tagname += '| valstart:'+document.adminForm.start_date.value;
						}
					}
				}

				for(var i=0; i < document.adminForm.expiry.length; i++){
					if(document.adminForm.expiry[i].checked && document.adminForm.expiry[i].value != '0'){
						tagname += '| expiry:'+document.adminForm.expiry[i].value;
						if(document.adminForm.expiry[i].value == 'chosen'){
							tagname += '| valexpiry:'+document.adminForm.to_expiry_date.value;
						}else{
							tagname += '| valexpiry:'+document.adminForm.expiry_date.value;
						}
					}
				}

				if(document.adminForm.coupon_nbuse.value){
					tagname += '| nbuse:'+document.adminForm.coupon_nbuse.value;
				}

				if(document.adminForm.coupon_nbusecustomer.value){
					tagname += '| nbusecustomer:'+document.adminForm.coupon_nbusecustomer.value;
				}

				setTag(tagname+'}');
			}
		//-->
		</script>
		<?php
			$value = array();
		 	$value[] = JHTML::_('select.option', 'P',JText::_('K2STORE_VALUE_TYPE_PERCENTAGE'));
		 	$value[] = JHTML::_('select.option', 'F',JText::_('K2STORE_VALUE_TYPE_FIXED_PRICE'));
		 	$percent_total = JHTML::_('acyselect.radiolist', $value, 'coupon_percent' , 'onclick="updateTagCoupon();"', 'value', 'text', 'P');
	 	?>
		<table class="adminlist table table-striped table-hover" cellpadding="1">
			<tr><td><?php echo JText::_('K2STORE_COUPON_NAME'); ?></td><td><input id="coupon_name" onchange="updateTagCoupon();" type="text" style="width:160px"></td><td><?php echo JText::_('K2STORE_COUPON_CODE'); ?></td><td><input id="coupon_code" onchange="updateTagCoupon();" type="text" style="width:160px" value="[name][key][value]"></td></tr>
			<tr><td><?php echo JText::_('K2STORE_COUPON_VALUE'); ?></td><td><input id="coupon_value" onchange="updateTagCoupon();" type="text" style="width:50px" value=""></td><td><?php echo JText::_('K2STORE_COUPON_VALUE_TYPE'); ?></td><td><?php echo $percent_total; ?></td></tr>
			<tr>
				<td><?php echo JText::_('K2STORE_COUPON_VALID_FROM'); ?></td>
				<td>
					<input checked type="radio" name="start" id="start0" value="0" size="1" onclick="updateTagCoupon();">
					<label for="start0" id="start0-lbl" class="radiobtn"><?php echo JText::_('ACY_NONE'); ?></label><br />

					<input type="radio" name="start" id="startchosen" value="chosen" size="1" onclick="updateTagCoupon();">
					<?php echo JHTML::_('calendar', '', 'to_start_date','to_date','%Y-%m-%d',array('style'=>'width:80px', 'onchange'=>'updateTagCoupon()', 'onclick'=>'document.adminForm.start[1].checked = true;updateTagCoupon();')); ?>
					<br />

					<input type="radio" name="start" id="startdelayed" value="delayed" size="1" onclick="updateTagCoupon();">
					<?php
						$delayType = acymailing_get('type.delay');
						$delayType->onChange = "document.adminForm.start[2].checked = true;updateTagCoupon();";
						echo $delayType->display('start_date',7776000,3);
					?>
				</td>
				<td><?php echo JText::_('K2STORE_COUPON_VALID_TO'); ?></td>
				<td>
					<input checked type="radio" name="expiry" id="expiry0" value="0" size="1" onclick="updateTagCoupon();">
					<label for="expiry0" id="expiry0-lbl" class="radiobtn"><?php echo JText::_('ACY_NONE'); ?></label><br />

					<input type="radio" name="expiry" id="expirychosen" value="chosen" size="1" onclick="updateTagCoupon();">
					<?php echo JHTML::_('calendar', '', 'to_expiry_date','from_date','%Y-%m-%d',array('style'=>'width:80px', 'onchange'=>'updateTagCoupon()', 'onclick'=>'document.adminForm.expiry[1].checked = true;updateTagCoupon();')); ?>
					<br />

					<input type="radio" name="expiry" id="expirydelayed" value="delayed" size="1" onclick="updateTagCoupon();">
					<?php
						$delayType = acymailing_get('type.delay');
						$delayType->onChange = "document.adminForm.expiry[2].checked = true;updateTagCoupon();";
						echo $delayType->display('expiry_date',7776000,3);
					?>
				</td>
			</tr>
			<tr>
				<td><?php echo acymailing_tooltip('', JText::_('K2STORE_COUPON_PRODUCTS_HELP_TEXT'), '', JText::_('K2STORE_COUPON_PRODUCTS')); ?></td>
				<td><input id="coupon_prod" onchange="updateTagCoupon();" type="text" style="width:160px"></td>
				<td><?php echo acymailing_tooltip('', JText::_('K2STORE_COUPON_PRODUCT_CATEGORY_HELP_TEXT'), '', JText::_('K2STORE_COUPON_PRODUCT_CATEGORY')); ?></td>
				<td><input id="coupon_cat" onchange="updateTagCoupon();" type="text" style="width:160px"></td>
			</tr>
			<tr>
				<td><?php echo acymailing_tooltip('', JText::_('K2STORE_COUPON_MAXIMUM_USES_HELP_TEXT'), '', JText::_('K2STORE_COUPON_MAXIMUM_USES')); ?></td>
				<td><input id="coupon_nbuse" onchange="updateTagCoupon();" type="text" style="width:160px" value="1"></td>
				<td><?php echo acymailing_tooltip('', JText::_('K2STORE_COUPON_MAXIMUM_CUSTOMER_USES_HELP_TEXT'), '', JText::_('K2STORE_COUPON_MAXIMUM_CUSTOMER_USES')); ?></td>
				<td><input id="coupon_nbusecustomer" onchange="updateTagCoupon();" type="text" style="width:160px" value="1"></td>
			</tr>
			<tr>
				<td><?php echo acymailing_tooltip('', JText::_('Yes => create only one coupon for all your receivers<br/>No => create a coupon per receiver'), '', JText::_('Unique coupon')); ?></td>
				<td><?php echo JHTML::_('acyselect.booleanlist', 'coupon_unique', 'onchange="updateTagCoupon();"', false); ?></td>
				<td><?php echo acymailing_tooltip('', JText::_('K2STORE_COUPON_LOGGED_HELP_TEXT'), '', JText::_('K2STORE_COUPON_LOGGED')); ?></td>
				<td><?php echo JHTML::_('acyselect.booleanlist', 'coupon_logged', 'onchange="updateTagCoupon();"', false); ?></td>
			</tr>
		</table>

		<?php

		echo $tabs->endPanel();
		echo $tabs->endPane();
	 }

	private function _categories($filter_cat){
		//select all cats
		$this->db->setQuery('SELECT id, parent AS parent_id, name AS title FROM #__k2_categories ORDER BY id ASC');
		$cats = $this->db->loadObjectList();
		$this->cats = array();
		if(!empty($cats)){
			foreach($cats as $oneCat){
				$this->cats[$oneCat->parent_id][] = $oneCat;
			}
		}

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildren();
		return JHTML::_('select.genericlist',$this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	private function _handleChildren($parent_id = 0, $level = 0){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			$this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->title);
			$this->_handleChildren($cat->id,$level+1);
		}
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	private function _replaceOne(&$email){

		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags)) return;

		$this->newslanguage = new stdClass();
		if(!empty($email->language)){
			$this->db->setQuery('SELECT lang_id, lang_code FROM #__languages WHERE sef = '.$this->db->quote($email->language).' LIMIT 1');
			$this->newslanguage = $this->db->loadObject();
		}
		require_once(JPATH_ADMINISTRATOR.'/components/com_k2store/library/prices.php');
		$lang = JFactory::getLanguage();
		$lang->load('com_k2store',JPATH_ADMINISTRATOR);
		$lang->load('com_k2',JPATH_ADMINISTRATOR);
		$lang->load('com_k2',JPATH_SITE);

		$config = JComponentHelper::getParams('com_k2store');
		$this->db->setQuery('SELECT a.* FROM #__k2store_currency AS a JOIN #__k2store_storeprofiles AS b ON a.currency_code = b.config_currency');
		$this->currencySettings = $this->db->loadObject();
		if($this->currencySettings->currency_position == 'pre'){
			$this->pre = $this->currencySettings->currency_symbol;
			$this->post = '';
		}else{
			$this->pre = '';
			$this->post = $this->currencySettings->currency_symbol;
		}

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$tagsReplaced = array();
		foreach($tags as $i => $oneTag){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceContent($oneTag);
		}

		$this->acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	private function _replaceContent(&$tag){
		$app = JFactory::getApplication();

	 	// extract the fields selected
		if(!empty($tag->display)){
			$tag->display = explode(',',$tag->display);

			foreach($tag->display as $i => $oneDisplay){
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
		}

		if(!empty($tag->custom)){
			$tag->custom = explode(',',$tag->custom);

			foreach($tag->custom as $i => $oneDisplay){
				$tag->custom[$i] = trim($oneDisplay);
			}
			JArrayHelper::toInteger($tag->custom);
		}

		// load content
		$this->db->setQuery('SELECT a.*, b.p_id AS product_id, c.name AS cattitle, u.name AS authorname, r.rating_sum, r.rating_count ' .
							'FROM #__k2_items AS a ' .
							'JOIN #__k2store_products AS b ON a.id = b.product_id ' .
							'JOIN #__k2_categories AS c ON a.catid = c.id ' .
							'LEFT JOIN `#__users` AS u ON u.id = a.created_by ' .
							'LEFT JOIN `#__k2_rating` AS r ON a.id = r.itemID ' .
							'WHERE a.id = '.intval($tag->id).' LIMIT 1');
		$content = $this->db->loadObject();

		//In case of we could not load the article for any reason...
		if(empty($content)){
			if($app->isAdmin()) $app->enqueueMessage('The content "'.$tag->id.'" could not be loaded','notice');
			return '';
		}

		if(empty($tag->lang) && !empty($this->newslanguage) && !empty($this->newslanguage->lang_code)) $tag->lang = $this->newslanguage->lang_code.','.$this->newslanguage->lang_id;

		$this->acypluginsHelper->translateItem($content, $tag, 'k2_items');
		if(!empty($tag->lang)){
			//We will load the correct article in the jf tables
			$langid = (int) substr($tag->lang,strpos($tag->lang,',')+1);
			if(!empty($langid) && (file_exists(JPATH_SITE .DS. 'components' .DS. 'com_joomfish' .DS. 'helpers' .DS. 'defines.php') || file_exists(JPATH_SITE.DS.'components'.DS.'com_falang'))){
				$this->db->setQuery("SELECT value FROM ".((ACYMAILING_J16 && file_exists(JPATH_SITE.DS.'components'.DS.'com_falang')) ? '`#__falang_content`' : '`#__jf_content`')." WHERE `published` = 1 AND `reference_table` = 'k2_categories' AND `language_id` = $langid AND `reference_field` = 'name' AND `reference_id` = ".$content->catid);
				$translation = $this->db->loadResult();
				if(!empty($translation)) $content->cattitle = $translation;
			}
		}

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		// create the link for the title and the read more button
		$link = 'index.php?option=com_k2&view=item&id='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;
		$link = acymailing_frontendLink($link);
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

		// display the title
		if(!empty($tag->title) && !empty($content->title)){
			$result .= '<tr><td colspan="2"><h2 class="acymailing_title">';
			if(empty($tag->nolink)) $result .= '<a href="'.$link.'">';
			$result .= $content->title;
			if(empty($tag->nolink)) $result .= '</a>';
			$result .= '</h2></td></tr>';
		}

		// display the main text wraped or not
		$content->description = $content->introtext.(empty($tag->onlyintro) ? '<br />'.$content->fulltext : '');
		$md5picture = md5("Image".$content->id);
		//When we have a specific size, we will use the larger picture, not the small one.
		if(file_exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.$md5picture.'_S.jpg') && (empty($tag->pict) || $tag->pict != "resized")){
			$imagePath = JURI::root().'media/k2/items/cache/'.$md5picture.'_S.jpg';
		}elseif(file_exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.$md5picture.'_L.jpg')){
			$imagePath = JURI::root().'media/k2/items/cache/'.$md5picture.'_L.jpg';
		}

		if((!empty($tag->description) && !empty($content->description)) || (!empty($tag->image) && !empty($imagePath))){
			$result .= '<tr><td colspan="2">';
			if(!empty($tag->image) && !empty($imagePath)){
				$varFields['{imagePath}'] = $imagePath;
				$result .= '<a href="'.$link.'" target="_blank" style="text-decoration:none" ><img src="'.$imagePath.'" alt="'.$content->image_caption.'"'.(empty($tag->nofloat) ? ' style="float:left;"' : '').' /></a>';
			}

			if(!empty($tag->description) && !empty($content->description)){
				$result .= $this->acypluginsHelper->wrapText($content->description, $tag);
			}

			$result .= '</td></tr>';
		}

		if(!empty($tag->price)){
			$price_override = K2StorePrices::getPrice($content->product_id, 1);
			$original = $this->pre.number_format($price_override->product_baseprice, $this->currencySettings->currency_num_decimals, $this->currencySettings->currency_decimal, $this->currencySettings->currency_thousands).$this->post;
			$price = $this->pre.number_format($price_override->product_price, $this->currencySettings->currency_num_decimals, $this->currencySettings->currency_decimal, $this->currencySettings->currency_thousands).$this->post;

			if(empty($tag->onlyFinalPrice) && !empty($price_override->product_specialprice)) $price = '<strike>'.$original.'</strike> '.$price;
			$varFields['{price}'] = $price;
			$result .= '<tr><td colspan="2">'.JText::_('K2STORE_SRATE_PRICE').': '.$price.'</td></tr>';
		}

		if(!empty($tag->options)){
			$this->db->setQuery('SELECT a.*, b.optionvalue_name, c.option_name ' .
								'FROM #__k2store_product_optionvalues AS a ' .
								'JOIN #__k2store_optionvalues AS b ON a.optionvalue_id = b.optionvalue_id ' .
								'JOIN #__k2store_options AS c ON a.option_id = c.option_id ' .
								'WHERE a.product_id = '.intval($tag->id));
			$options = $this->db->loadObjectList();
			if(!empty($options)){
				$orderedOptions = array();
				foreach($options as $oneOPT){
					$orderedOptions[$oneOPT->option_name][] = $oneOPT->optionvalue_name.' ('.$oneOPT->product_optionvalue_prefix.' '.$this->pre.number_format($oneOPT->product_optionvalue_price, $this->currencySettings->currency_num_decimals, $this->currencySettings->currency_decimal, $this->currencySettings->currency_thousands).$this->post.')';
				}

				foreach($orderedOptions as $name => $oneOPT){
					$result .= '<tr><td valign="top">'.$name.'</td><td>';
					$varFields['{opt|'.$name.'}'] = '<table>';
					foreach($oneOPT as $possibility){
						$varFields['{opt|'.$name.'}'] .= '<tr><td>'.$possibility.'</td></tr>';
					}
					$varFields['{opt|'.$name.'}'] .= '</table>';
					$result .= $varFields['{opt|'.$name.'}'].'</td>';
				}
			}
		}

		if(!empty($tag->rate) && !empty($content->rating_count)){
			$varFields['{rating}'] = number_format(intval($content->rating_sum) / intval($content->rating_count), 2);
			$result .= '<tr><td colspan="2">'.JText::_('K2_RATING').': '.$varFields['{rating}'].' / 5.00</td></tr>';
		}

		if(!empty($tag->custom)){
			$content->extra_fields = json_decode($content->extra_fields);
			if(!empty($content->extra_fields)){
				$newFields = array();
				foreach($content->extra_fields as $oneField){
					$newFields[$oneField->id] = $oneField;
				}
				$content->extra_fields = $newFields;

				//Load the custom fields if we don't already have them...
				if(empty($this->customfields)){
					//Load the extra fields once
					$this->db->setQuery("SELECT * FROM #__k2_extra_fields WHERE `published` = 1 AND `type` NOT IN ('csv','header') ORDER BY `ordering` ASC");
					$this->customfields = $this->db->loadObjectList();
				}
				foreach($this->customfields as $oneField){
					if(!isset($content->extra_fields[$oneField->id]) || !isset($content->extra_fields[$oneField->id]->value)) continue;
					$disValue = '';
					if($oneField->type == 'date'){
						$dateFormat = (!ACYMAILING_J16) ? '%A, %d %B %Y': 'l, d F Y';
						$disValue = JHTML::_('date',$content->extra_fields[$oneField->id]->value,$dateFormat,false);
					}elseif($oneField->type == 'link'){
						$disValue = '<a target="_blank" href="'.$content->extra_fields[$oneField->id]->value[1].'" >'.$content->extra_fields[$oneField->id]->value[0].'</a>';
					}elseif(in_array($oneField->type, array('multipleSelect','select','radio'))){
						$object = json_decode($oneField->value);
						$myValues = $content->extra_fields[$oneField->id]->value;
						foreach($object as $oneObject){
							if((is_string($myValues) && $myValues == $oneObject->value) || is_array($myValues) && in_array($oneObject->value,$myValues)) $disValue .= $oneObject->name.', ';
						}
						$disValue = rtrim($disValue,', ');
					}elseif($oneField->type == 'image'){
						$disValue = '<img src="'.ltrim($content->extra_fields[$oneField->id]->value, '/').'" alt="" />';
					}elseif($oneField->type == 'labels'){
						$values = explode(',', $content->extra_fields[$oneField->id]->value);
						foreach($values as &$oneLabel){
							$oneLabel = '<a href="index.php?option=com_k2&view=itemlist&task=search&searchword='.$oneLabel.'">'.$oneLabel.'</a>';
						}
						$disValue = implode(' ', $values);
					}elseif(is_string($content->extra_fields[$oneField->id]->value)){
						$disValue = nl2br($content->extra_fields[$oneField->id]->value);
					}else{
						continue;
					}
					$varFields['{cf|'.$oneField->name.'}'] = $disValue;
					$result .= '<tr><td class="fieldname">'.$oneField->name.'</td><td class="fieldvalue">'.$disValue.'</td></tr>';
				}
			}
		}

		if(!empty($tag->category)) $result .= '<tr><td colspan="2">'.JText::_('K2_PUBLISHED_IN').' <a href="index.php?option=com_k2&view=itemlist&task=category&id='.$content->catid.'">'.$content->cattitle.'</a></td></tr>';
		if(!empty($tag->author)){
			$varFields['{author}'] = empty($content->created_by_alias) ? $content->authorname : $content->created_by_alias;
			$result .= '<tr><td class="acymailing_authorname" colspan="2">'.JText::_('K2_WRITTEN_BY').' <a rel="author" href="index.php?option=com_k2&view=itemlist&task=user&id='.$content->created_by.'">'.$varFields['{author}'].'</a></td></tr>';
		}

		if(!empty($tag->tags)){
			$this->db->setQuery('SELECT a.name FROM #__k2_tags AS a JOIN #__k2_tags_xref AS b ON a.id = b.tagID WHERE b.itemID = '.intval($tag->id));
			$tags = acymailing_loadResultArray($this->db);
			if(!empty($tags)){
				foreach($tags as &$oneTag){
					$oneTag = '<a href="index.php?option=com_k2&view=itemlist&task=tag&tag='.$oneTag.'">'.$oneTag.'</a>';
				}
				$result .= '<tr><td colspan="2">'.JText::_('K2_TAGGED_UNDER').' '.implode(', ', $tags).'</td></tr>';
			}
		}

		$varFields['{readmore}'] = '<a class="readmore_link" style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a>';
		if(empty($tag->noreadmore)) $result .= '<tr><td>'.$varFields['{readmore}'].'</td></tr>';

		$result .= '</table></div>';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $this->acypluginsHelper->removeJS($result);

		//resize or remove pictures
		$result = $this->acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	private function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		$time = time();

		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email,'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;
			$allcats = explode('-',$parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT a.id FROM #__k2_items AS a JOIN #__k2_categories AS b ON a.catid = b.id JOIN #__k2store_products AS c ON a.id = c.product_id ';

			$where = array();

			// load only needed content
			if(!empty($selectedArea)) $where[] = 'a.catid IN ('.implode(',',$selectedArea).')';

			// filter results created or modified
			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				$condition = 'a.created > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				if($parameter->filter == 'modified'){
					$condition .= ' OR a.modified > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				}
				$where[] = $condition;
			}
			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				$condition = '(`publish_up` > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\' AND `publish_up` < \''.date('Y-m-d H:i:s',$time - date('Z')).'\')';
				$condition .= ' OR (`created` > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\' AND `created` < \''.date('Y-m-d H:i:s',$time - date('Z')).'\')';
				if($parameter->filter == 'modify') $condition .= ' OR (`modified` > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\' AND `modified` < \''.date( 'Y-m-d H:i:s',$time - date('Z')).'\')';

				$where[] = $condition;
			}

			// Only published content
			if(empty($parameter->unpublished)) $where[] = 'a.published = 1';
			if(!empty($parameter->featured)) $where[] = 'a.featured = 1';
			if(!empty($parameter->nofeatured)) $where[] = 'a.featured = 0';
			if(!empty($parameter->lang)) $where[] = 'a.language = '.$this->db->Quote($parameter->lang);

			// Apply filters
			if(!empty($where)) $query .= ' WHERE ('.implode(') AND (',$where).')';

			// Ordering
			if(!empty($parameter->order)){
				$ordering = explode(',',$parameter->order);
				if($ordering[0] == 'rand'){
					$query .= ' ORDER BY rand()';
				}elseif($ordering[0] == 'item_price'){
					$query .= ' ORDER BY c.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}else{
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			$start = '';
			if(!empty($parameter->start)) $start = intval($parameter->start).',';
			if(empty($parameter->max)) $parameter->max = 20;
			//We add a limit for the preview otherwise we could break everything
			$query .= ' LIMIT '.$start.(int) intval($parameter->max);


			// load content IDs
			$this->db->setQuery($query);
			$allArticles = acymailing_loadResultArray($this->db);

			// Check the number of results
			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We will not generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough '.$this->name.' content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles)){
				// If the user created its own template...
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = $this->name.':'.$oneArticleId;
						unset($parameter->id);
						foreach($parameter as $key => $value){
							$args[] = $key.':'.((string)$value);
						}
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $this->acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}

	public function acymailing_replaceusertags(&$email,&$user,$send = true){
		$this->_replaceCoupon($email,$user,$send);
	}

	private function _replaceCoupon(&$email,&$user,$send){
		$tags = $this->acypluginsHelper->extractTags($email,'k2storecoupon');

		//If we didn't find anything...
		if(empty($tags)) return;

		$this->tags = array();
		foreach($tags as $oneTag => $parameter){
			//Don't need to process twice a tag we already have!
			if(isset($this->tags[$oneTag])) continue;
			if(empty($user->subid) || !$send){
				$this->tags[$oneTag] = '<i>Please check your e-mail to see the coupon</i>';
			}else{
				$this->tags[$oneTag] = $this->_generateCoupon($parameter,$user);
			}
		}

		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	private function _generateCoupon($tag, &$user){
		if(empty($tag->id) || empty($tag->value)) return 'Please enter at least the coupon code and the coupon value.';

		$key = JUserHelper::genrandompassword(5);
		$tag->value = str_replace(',','.',$tag->value);
		if(empty($tag->unique)){
			$tag->id = str_replace(array('[name]','[subid]','[email]','[key]','[value]'),array($user->name,$user->subid,$user->email,$key,$tag->value),$tag->id);
		}else{
			$tag->id = str_replace('[value]',$tag->value,$tag->id);

			$this->db->setQuery('SELECT coupon_id FROM #__k2store_coupons WHERE coupon_code = '.$this->db->Quote($tag->id).' AND (valid_from = "0000-00-00 00:00:00" OR valid_from < \''.date('Y-m-d H:i:s').'\') AND (valid_to = "0000-00-00 00:00:00" OR valid_to > \''.date('Y-m-d H:i:s').'\') LIMIT 1');
			$existingCoupon = $this->db->loadResult();
			if(!empty($existingCoupon)) return $tag->id;
		}

		$columns = '`coupon_code`,`value`,`state`,`value_type`,`max_uses`,`max_customer_uses`,`coupon_name`,`logged`';
		$values = $this->db->Quote($tag->id).','.$this->db->Quote($tag->value).',1,'.$this->db->Quote($tag->tcoupon).',';

		$values .= (empty($tag->nbuse) ? "''" : intval($tag->nbuse)).',';
		$values .= (empty($tag->nbusecustomer) ? "''" : intval($tag->nbusecustomer)).',';

		if(!empty($tag->name)) $values .= $this->db->Quote($tag->name);
		else $values .= $this->db->Quote($tag->id);

		if(empty($tag->logged)) $values .= ',0';
		else $values .= ',1';

		if(!empty($tag->categories)){
			$columns .= ',`product_category`';
			$values .= ','.$this->db->Quote($tag->categories);
		}

		if(!empty($tag->products)){
			$columns .= ',`products`';
			$values .= ','.$this->db->Quote($tag->products);
		}

		if(!empty($tag->start) && !empty($tag->valstart)){
			if($tag->start == "chosen") $start = date( 'Y-m-d H:i:s',acymailing_getTime($tag->valstart));
			else $start = date( 'Y-m-d H:i:s',time()+intval($tag->valstart));
			$columns .= ',`valid_from`';
			$values .= ','.$this->db->Quote($start);
		}

		if(!empty($tag->expiry) && !empty($tag->valexpiry)){
			if($tag->expiry == "chosen") $expiry = date( 'Y-m-d H:i:s',acymailing_getTime($tag->valexpiry));
			else $expiry = date( 'Y-m-d H:i:s',time()+intval($tag->valexpiry));
			$columns .= ',`valid_to`';
			$values .= ','.$this->db->Quote($expiry);
		}

		$this->db->setQuery('INSERT INTO #__k2store_coupons ('.$columns.') VALUES ('.$values.')');
		$this->db->query();

		return $tag->id;
	}

	function onAcyDisplayFilters(&$type,$context="massactions"){
		if(!$this->component_installed || $this->params->get('displayfilter_'.$context,true) == false) return;


		$bought = array();
		$bought[] = JHTML::_('select.option', '0', JText::_('ACY_DIDNOTBOUGHT'));
		$bought[] = JHTML::_('select.option', '1', JText::_('ACY_BOUGHT'));

		$app = JFactory::getApplication();
		$controller = $app->isAdmin() ? 'cpanel' : 'fronttag';

		$return = '<div id="filter__num__k2store">'.JHTML::_('select.genericlist', $bought, "filter[__num__][k2store][type]", 'class="inputbox" onchange="countresults(__num__)" size="1" style="max-width:150px"', 'value', 'text',1).' ';
		$return .= '<input readonly type="text" name="filter[__num__][k2store][product]" id="filter__num__k2storeproduct" class="inputbox" style="width:100px" size="1" value="'.JText::_('ACY_ONE_PRODUCT').'"/>' .
				'<input type="hidden" name="filter[__num__][k2store][productid]" id="filter__num__k2storeproductid" value="0"/>' .
				'<a class="modal" onclick="window.acymailing_js.openBox(this,\'index.php?option=com_acymailing&tmpl=component&ctrl='.$controller.'&task=plgtrigger&plg=k2store&fctName=displayk2storeArticles&param=__num__\'); return false;" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">' .
				'<img class="icon16" src="'.ACYMAILING_IMAGES.'icons/icon-16-edit.png" />' .
				'</a>';
		$return .= '<input readonly type="text" name="filter[__num__][k2store][cat]" id="filter__num__k2storecat" class="inputbox" style="width:100px" size="1" value="'.JText::_('ACY_ANY_CATEGORY').'"/>' .
				'<input type="hidden" name="filter[__num__][k2store][catid]" id="filter__num__k2storecatid" value="0"/>' .
				'<a class="modal" onclick="window.acymailing_js.openBox(this,\'index.php?option=com_acymailing&tmpl=component&ctrl='.$controller.'&task=plgtrigger&plg=k2store&fctName=displayk2storeCategories&param=__num__\'); return false;" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">' .
				'<img class="icon16" src="'.ACYMAILING_IMAGES.'icons/icon-16-edit.png" />' .
				'</a>';

		//Load status
		$this->db->setQuery('SELECT orderstatus_id, orderstatus_name FROM #__k2store_orderstatuses');
		$allStatus = $this->db->loadObjectList();

		if(!empty($allStatus)){
			foreach($allStatus as &$j){
				$j->orderstatus_name = JText::_($j->orderstatus_name);
			}
			$firstStatus = new stdClass();
			$firstStatus->orderstatus_name = JText::_('ALL_STATUS');
			$firstStatus->orderstatus_id = '';
			array_unshift($allStatus,$firstStatus);
		}

		$return .= ' '.JHTML::_('select.genericlist',   $allStatus, "filter[__num__][k2store][status]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'orderstatus_id', 'orderstatus_name');

		//Load payment methods
		$this->db->setQuery('SELECT shipping_method_id, shipping_method_name FROM #__k2store_shippingmethods ORDER BY shipping_method_name ASC');
		$allShipments = $this->db->loadObjectList();
		if(!empty($allShipments)){
			$firstShipment = new stdClass();
			$firstShipment->shipping_method_name = JText::_('ACY_ALL');
			$firstShipment->shipping_method_id = '0';
			array_unshift($allShipments,$firstShipment);

			$return .= ' '.JHTML::_('select.genericlist',   $allShipments, "filter[__num__][k2store][shipment]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'shipping_method_id', 'shipping_method_name');
		}

		//Load payment methods
		$this->db->setQuery('SELECT element, name FROM #__extensions WHERE folder = "k2store" AND element LIKE "payment_%" ORDER BY name ASC');
		$allPayments = $this->db->loadObjectList();

		$firstPayment = new stdClass();
		$firstPayment->name = JText::_('ACY_ALL');
		$firstPayment->element = '0';
		array_unshift($allPayments,$firstPayment);

		$return .= ' '.JHTML::_('select.genericlist',   $allPayments, "filter[__num__][k2store][payment]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'element', 'name');
		$return .= '<br /> <input type="text" name="filter[__num__][k2store][creationdateinf]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:100px" /> < '.JText::_('CREATED_DATE').' < <input type="text" name="filter[__num__][k2store][creationdatesup]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:100px" />';
		$return .= '</div>';
		$type['k2store'] = 'K2Store';

		return $return;
	}

	function onAcyProcessFilterCount_k2store(&$query,$filter,$num){
		$this->onAcyProcessFilter_k2store($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_k2store(&$query,$filter,$num){
		//We load all users who bought and will do a ! IN if the user didn't buy
		//We use the user_email as the user may not have uid
		$datesVar = array('creationdatesup','creationdateinf');
		foreach($datesVar as $oneDate){
			if(empty($filter[$oneDate])) continue;
			$filter[$oneDate] = acymailing_replaceDate($filter[$oneDate]);
			if(!is_numeric($filter[$oneDate]) && strtotime($filter[$oneDate]) !== false) $filter[$oneDate] = strtotime($filter[$oneDate]);
			if(is_numeric($filter[$oneDate])) $filter[$oneDate] = strftime('%Y-%m-%d %H:%M:%S',$filter[$oneDate]);
		}

		$lj1 = '#__k2store_orders AS k2order'.$num.' ON sub'.(empty($filter['type']) ? $num : '').'.userid = k2order'.$num.'.user_id';
		if(!empty($filter['payment'])) $lj1 .= ' AND k2order'.$num.'.orderpayment_type = '.$this->db->Quote($filter['payment']);
		if(!empty($filter['creationdateinf'])) $lj1 .= ' AND k2order'.$num.'.created_date > '.$query->db->Quote($filter['creationdateinf']);
		if(!empty($filter['creationdatesup'])) $lj1 .= ' AND k2order'.$num.'.created_date < '.$query->db->Quote($filter['creationdatesup']);

		JArrayHelper::toInteger($filter);

		if(!empty($filter['status'])) $lj1 .= ' AND k2order'.$num.'.order_state_id = '.$filter['status'];
		if(!empty($filter['shipment'])) $lj1 .= ' AND k2order'.$num.'.shipping_method_id = '.$filter['shipment'];

		if(!empty($filter['productid']) || !empty($filter['catid'])){
			$lj2 = '#__k2store_orderitems AS k2orderitem'.$num.' ON k2order'.$num.'.order_id = k2orderitem'.$num.'.order_id';
			if(!empty($filter['productid'])){
				$lj2 .= ' AND k2orderitem'.$num.'.product_id = '.$filter['productid'];
			}else{
				$lj2 .= ' JOIN #__k2_items AS k2item'.$num.' ON k2orderitem'.$num.'.product_id = k2item'.$num.'.id AND k2item'.$num.'.catid = '.$filter['catid'];
			}
		}

		if(empty($filter['type'])){
			$query->where['k2store'.$num] = 'sub.userid NOT IN (SELECT sub'.$num.'.userid FROM #__acymailing_subscriber AS sub'.$num.' JOIN '.$lj1.(empty($lj2) ? '' : ' JOIN '.$lj2).')';
		}else{
			$query->join['k2store'.$num] = $lj1;
			if(!empty($lj2)) $query->join['k2storeitem'.$num] = $lj2;
		}
	}

	function onAcydisplayk2storeArticles($num){
		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'k2storearts';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order', 'id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc',	'word' );
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));

		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );

		$searchMap = array('b.title','b.introtext','c.name');

		$query = 'SELECT SQL_CALC_FOUND_ROWS b.*, c.name AS cattitle ' .
				'FROM #__k2store_products AS a ' .
				'JOIN #__k2_items AS b ON a.product_id = b.id ' .
				'JOIN #__k2_categories AS c ON b.catid = c.id';

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchMap)." LIKE $searchVal";
		}
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (',$filters).')';

		if(!empty ($pageInfo->filter->order->value)) {
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}else{
			$query .= ' ORDER BY b.title ASC';
		}

		$this->db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $this->db->loadObjectList();

		//pagination
		$this->db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $this->db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );
	 ?>

	 <script language="javascript" type="text/javascript">
	 <!--
		function addProduct(selectedId, selectedName){
			parent.window.document.getElementById("filter<?php echo $num; ?>k2storeproduct").value = selectedName;
			parent.window.document.getElementById("filter<?php echo $num; ?>k2storeproductid").value = selectedId;

			parent.countresults(<?php echo $num; ?>);
			parent.acymailing_js.closeBox(true);
		}
	-->
	</script>

	<div id="acy_content">
		<div class="acytagpopup">
			<form action="#" method="post" name="adminForm"  id="adminForm"  autocomplete="off">
			 	<table class="adminlist table table-striped table-hover adminform" cellpadding="1" width="100%">
					<tr>
						<td width="100%">
							<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="search" value="<?php echo htmlspecialchars($pageInfo->search, ENT_COMPAT, 'UTF-8');?>" class="text_area" />
							<button class="btn" onclick="document.adminForm.limitstart.value=0;document.adminForm.task.value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
						</td>
					</tr>
				</table>
				<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
					<thead>
							<th/>
							<th class="title titlename">
								<?php echo JHTML::_('grid.sort', JText::_( 'ACY_NAME'), 'b.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
							</th>
							<th class="title titledesc">
								<?php echo JHTML::_('grid.sort', JText::_( 'ACY_DESCRIPTION'), 'b.introtext', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
							</th>
							<th class="title titlecat">
								<?php echo JHTML::_('grid.sort',   JText::_( 'TAG_CATEGORIES' ), 'c.name', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
							</th>
							<th class="title titleid">
								<?php echo JHTML::_('grid.sort',   JText::_( 'ACY_ID' ), 'b.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
							</th>
						</tr>
					</thead>
					<tbody>
						<?php if(empty($pageInfo->limit->start)){ ?>
							<tr style="cursor:pointer;" class="<?php echo "row0"; ?>" onclick="addProduct(0,'<?php echo JText::_('ACY_ONE_PRODUCT'); ?>');">
								<td class="acytdcheckbox"></td>
								<td align="center">
									<?php
										echo JText::_('ACY_ONE_PRODUCT');
									?>
								</td>
								<td align="center">
									<?php
										echo JText::_('FIELD_DEFAULT');
									?>
								</td>
								<td/>
								<td align="center">0</td>
							</tr>
						<?php }
							$k = 1;
							for($i = 0,$a = count($rows);$i<$a;$i++){
								$row = $rows[$i];
						?>
							<tr style="cursor:pointer;" class="<?php echo "row$k"; ?>" onclick="addProduct(<?php echo $row->id; ?>,'<?php echo htmlspecialchars(str_replace("'", "", $row->title), ENT_COMPAT | ENT_IGNORE, 'UTF-8'); ?>');">
								<td class="acytdcheckbox"></td>
								<td align="center">
									<?php
										echo $row->title;
									?>
								</td>
								<td align="center">
									<?php
										if(!empty($row->introtext)) echo substr(strip_tags(html_entity_decode($row->introtext),'<br>'),0,200).'...';
									?>
								</td>
								<td align="center">
									<?php
										echo $row->cattitle;
									?>
								</td>
								<td align="center">
									<?php
										echo $row->id;
									?>
								</td>
							</tr>
						<?php
								$k = 1-$k;
							}
						?>
					</tbody>
					<tfoot>
						<tr>
							<td colspan="5">
								<?php
									echo $pagination->getListFooter();
									if(ACYMAILING_J30){
										$paginationNb = array();
										foreach(array(5,10,15,20,25,30,50,100) as $oneOption){
											$paginationNb[] = JHTML::_('select.option', $oneOption, $oneOption);
										}
										$paginationNb[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
										echo 'Display #'.JHTML::_('select.genericlist', $paginationNb, 'limit' , 'size="1" style="width:60px" onchange="Joomla.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
									}
									echo $pagination->getResultsCounter();
								?>
							</td>
						</tr>
					</tfoot>
				</table>
				<input type="hidden" name="boxchecked" value="0" />
				<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
				<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
			</form>
		</div>
	</div>
	<?php
	}

	function onAcydisplayk2storeCategories($num){
		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'k2storecats';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order', 'id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc',	'word' );
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));

		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int');

		$query = 'SELECT SQL_CALC_FOUND_ROWS id, name FROM #__k2_categories';

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$query .= ' WHERE name LIKE '.$searchVal;
		}

		if(!empty($pageInfo->filter->order->value)) {
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}else{
			$query .= ' ORDER BY ordering';
		}

		$this->db->setQuery($query,$pageInfo->limit->start, $pageInfo->limit->value);
		$rows = $this->db->loadObjectList();

		//pagination
		$this->db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $this->db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

	 ?>

	 <script language="javascript" type="text/javascript">
	 <!--
		function addCategory(selectedId, selectedName){
			parent.window.document.getElementById("filter<?php echo $num; ?>k2storecat").value = selectedName;
			parent.window.document.getElementById("filter<?php echo $num; ?>k2storecatid").value = selectedId;

			parent.countresults(<?php echo $num; ?>);
			parent.acymailing_js.closeBox(true);
		}
	-->
	</script>

	<div id="acy_content">
		<div class="acytagpopup">
			<form action="#" method="post" name="adminForm"  id="adminForm"  autocomplete="off">
			 	<table class="adminlist table table-striped table-hover adminform" cellpadding="1" width="100%">
					<tr>
						<td width="100%">
							<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="search" value="<?php echo htmlspecialchars($pageInfo->search, ENT_COMPAT, 'UTF-8');?>" class="text_area" />
							<button class="btn" onclick="document.adminForm.limitstart.value=0;document.adminForm.task.value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
						</td>
					</tr>
				</table>
				<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
					<thead>
							<th/>
							<th class="title titlename">
								<?php echo JHTML::_('grid.sort', JText::_( 'ACY_NAME'), 'name', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
							</th>
							<th class="title titledesc">
								<?php echo JHTML::_('grid.sort', JText::_( 'ACY_DESCRIPTION'), 'description', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
							</th>
							<th class="title titleid">
								<?php echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
							</th>
						</tr>
					</thead>
					<tfoot>
						<tr>
							<td colspan="5">
								<?php
									echo $pagination->getListFooter();
									if(ACYMAILING_J30){
										$paginationNb = array();
										foreach(array(5,10,15,20,25,30,50,100) as $oneOption){
											$paginationNb[] = JHTML::_('select.option', $oneOption, $oneOption);
										}
										$paginationNb[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
										echo 'Display #'.JHTML::_('select.genericlist', $paginationNb, 'limit' , 'size="1" style="width:60px" onchange="Joomla.submitform();"', 'value', 'text', $pageInfo->limit->value).'<br />';
									}
									echo $pagination->getResultsCounter();
								?>
							</td>
						</tr>
					</tfoot>
					<tbody>
						<?php if(empty($pageInfo->limit->start)){ ?>
								<tr style="cursor:pointer;" class="<?php echo "row0"; ?>" onclick="addCategory(0,'<?php echo JText::_('ACY_ANY_CATEGORY'); ?>');">
									<td class="acytdcheckbox"></td>
									<td align="center">
										<?php
											echo JText::_('ACY_ANY_CATEGORY');
										?>
									</td>
									<td align="center">
										<?php
											echo JText::_('FIELD_DEFAULT');
										?>
									</td>
									<td align="center">N/A</td>
								</tr>
						<?php }
							$k = 1;
							for($i = 0,$a = count($rows);$i<$a;$i++){
								$row = $rows[$i];
						?>
							<tr style="cursor:pointer;" class="<?php echo "row$k"; ?>" onclick="addCategory(<?php echo $row->id; ?>,'<?php echo htmlspecialchars(str_replace("'", "", $row->name), ENT_COMPAT | ENT_IGNORE, 'UTF-8'); ?>');">
								<td class="acytdcheckbox"></td>
								<td align="center">
									<?php
										echo $row->name;
									?>
								</td>
								<td align="center">
									<?php
										if(!empty($row->description)) echo substr(strip_tags(html_entity_decode($row->description),'<br>'),0,200).'...';
									?>
								</td>
								<td align="center">
									<?php
										echo $row->id;
									?>
								</td>
							</tr>
						<?php
								$k = 1-$k;
							}
						?>
					</tbody>
				</table>
				<input type="hidden" name="boxchecked" value="0" />
				<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
				<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
			</form>
		</div>
	</div>
	<?php
	}
}//endclass
?>