<?php

class plgAcymailingListowner extends JPlugin
{

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'listowner');
			$this->params = new JParameter( $plugin->params );
		}
	}

	function onAcyUnsubscribe($subid,$listids){
		$this->sendNotif($subid,$listids,'notification_unsub');
	}

	function onAcySubscribe($subid,$listids){
		$this->sendNotif($subid,$listids,'notification_created');
	}

	private function sendNotif($subid,$listids,$alias){

		$app = JFactory::getApplication();
		if($app->isAdmin()) return;
		//Check the parameters...
		if(!$this->params->get($alias,1)) return;

		$notifiedLists = $this->params->get('lists', 'All');
		if(strtolower($notifiedLists) == 'none') return;
		if(strtolower($notifiedLists) != 'all'){
			$notify = false;
			$lists = explode(',', $notifiedLists);
			foreach($lists as $oneList){
				if(in_array($oneList, $listids)){
					$notify = true;
					break;
				}
			}
			if(!$notify) return;
		}

		$db = JFactory::getDBO();
		$db->setQuery('SELECT b.subid, a.name FROM #__acymailing_list as a JOIN #__acymailing_subscriber as b ON a.userid = b.userid WHERE a.listid IN (\''.implode('\',\'',$listids).'\') AND b.userid > 0 GROUP BY b.subid');
		$owners = $db->loadObjectList();

		if(!empty($owners)){
			$subscriberClass=acymailing_get('class.subscriber');
			$subscriber = $subscriberClass->get($subid);
			$mailer = acymailing_get('helper.mailer');
			$mailer->report = false;
			$mailer->autoAddUser = true;
			$mailer->checkConfirmField = false;
			$ipClass = acymailing_get('helper.user');
			$subscriber->ip = $ipClass->getIP();

			foreach($subscriber as $map => $value){
				$mailer->addParam('user:'.$map,$value);
			}

			if(!empty($subscriber->subid)){
				$listSubClass= acymailing_get('class.listsub');
				if(method_exists($listSubClass,'getSubscriptionString')){
					$mailer->addParam('user:subscription',$listSubClass->getSubscriptionString($subscriber->subid));
					$mailer->addParam('user:subscriptiondates',$listSubClass->getSubscriptionString($subscriber->subid, true));
				}
			}

			foreach($owners as $oneUser){
				$mailer->addParam('listname',$oneUser->name);
				$mailer->sendOne($alias,$oneUser->subid);
			}
		}

	}

}//endclass