<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingnewsfeeds extends JPlugin{
	public function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin =& JPluginHelper::getPlugin('acymailing', 'newsfeeds');
			$this->params = new acyParameter($plugin->params);
		}
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
	}

	public function acymailing_getPluginType(){
		$onePlugin = new stdClass();
		$onePlugin->name = 'News Feeds';
		$onePlugin->function = 'acymailingtagnewsfeeds_show';
		$onePlugin->help = 'plugin-newsfeeds';

		return $onePlugin;
	}

	public function acymailingtagnewsfeeds_show(){

		$config = acymailing_config();
		if($config->get('version') < '5.2.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		$app = JFactory::getApplication();
		$pageInfo = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.newsfeeds';
		$pageInfo->link = $app->getUserStateFromRequest($paramBase.".link", 'link', '1', 'string');
		$pageInfo->automaxvalue = $app->getUserStateFromRequest($paramBase.".max", 'max', '20', 'int');
		$pageInfo->pict = $app->getUserStateFromRequest($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->pictheight = $app->getUserStateFromRequest($paramBase.".pictheight", 'pictheight', $this->params->get('maxheight', 150), 'string');
		$pageInfo->pictwidth = $app->getUserStateFromRequest($paramBase.".pictwidth", 'pictwidth', $this->params->get('maxwidth', 150), 'string');
		$pageInfo->contentfilter = $app->getUserStateFromRequest($paramBase.".contentfilter", 'contentfilter', 'created', 'string');

		$picts = array();
		$picts[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$picts[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$picts[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$contentfilter = array();
		$contentfilter[] = JHTML::_('select.option', "", JText::_('ACY_ALL'));
		$contentfilter[] = JHTML::_('select.option', "created", JText::_('ONLY_NEW_CREATED'));

		$type = JRequest::getString('type');
		?>
		<script language="javascript" type="text/javascript">
			<!--
			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var tmp = 0;

				for(var i = 0; i < document.adminForm.cbdisplay.length; i++){
					if(document.adminForm.cbdisplay[i].checked){
						if(tmp == 0){
							tmp += 1;
							otherinfo += "| display:";
							otherinfo += document.adminForm.cbdisplay[i].value;
						}else{
							otherinfo += ", ";
							otherinfo += document.adminForm.cbdisplay[i].value;
						}
					}
				}

				if(document.adminForm.max_article.value && document.adminForm.max_article.value != 0){
					otherinfo += '| max:' + document.adminForm.max_article.value;
				}

				for(var i = 0; i < document.adminForm.link.length; i++){
					if(document.adminForm.link[i].checked && document.adminForm.link[i].value == 1){
						otherinfo += "| link";
					}
				}

				for(var i = 0; i < document.adminForm.pict.length; i++){
					if(document.adminForm.pict[i].checked){
						otherinfo += '| pict:' + document.adminForm.pict[i].value;
						if(document.adminForm.pict[i].value == 'resized'){
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value)){
					otherinfo += "| wrap:" + document.adminForm.wrap.value;
				}

				<?php if($type == 'autonews'){ ?>
				if(document.adminForm.min_article.value){
					otherinfo += "| min:" + document.adminForm.min_article.value;
				}
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
					otherinfo += "| filter:" + document.adminForm.contentfilter.value;
				}
				<?php } ?>

				if(document.adminForm.url.value){
					tag = '{newsfeeds:' + document.adminForm.url.value + otherinfo + '}<br />';
				}
				setTag(tag);
			}
			//-->
		</script>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<td>
						<?php echo JText::_('URL'); ?>
					</td>
					<td colspan="3">
						<?php echo 'http://'; ?><input type="text" name="url" style="width:300px" value="" placeholder="www..." onchange="updateTag();"/>
					</td>
				</tr>
				<tr>
					<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="title" id="title" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="title" id="title-lbl"><?php echo JText::_('FIELD_TITLE');?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="description" id="description" onclick="updateTag();"/><label style="margin-left:5px" for="description" id="description-lbl"><?php echo JText::_('ACY_DESCRIPTION'); ?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="content" id="content" checked="checked" onclick="updateTag();"/><label style="margin-left:5px" for="content" id="content-lbl"><?php echo JText::_('DISPLAY');?></label></td>
				</tr>
				<tr>
					<td/>
					<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="author" id="author" onclick="updateTag();"/><label style="margin-left:5px" for="author" id="author-lbl"><?php echo JText::_('ACY_AUTHOR');?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="date" id="date" onclick="updateTag();"/><label style="margin-left:5px" for="date" id="date-lbl"><?php echo JText::_('CREATED_DATE');?></label></td>
					<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="enclosure" id="enclosure" onclick="updateTag();"/><label style="margin-left:5px" for="enclosure" id="enclosure-lbl">Enclosure (<?php echo JText::_('ACY_IMAGE');?>)</label></td>
				</tr>
				<tr>
					<td>
						<?php echo JText::_('CLICKABLE_TITLE'); ?>
					</td>
					<td>
						<?php echo JHTML::_('acyselect.radiolist', $choice, 'link', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->link); ?>
					</td>
					<td nowrap="nowrap" colspan="2">
						<?php echo JText::sprintf('TRUNCATE_AFTER', '<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?>
					</td>
				</tr>
				<tr>
					<td valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
					<td valign="top" colspan="3"><?php echo JHTML::_('acyselect.radiolist', $picts, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
						<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?>><br/><?php echo JText::_('CAPTCHA_WIDTH') ?>
							<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
							x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
							<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
						</span>
					</td>
				</tr>
				<tr>
					<td>
						<?php echo JText::_('MAX_ARTICLE'); ?>
					</td>
					<td colspan="3">
						<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTag();"/>
					</td>
				</tr>
				<?php if($type == 'autonews'){ ?>
					<tr>
						<td>
							<?php echo JText::_('MIN_ARTICLE'); ?>
						</td>
						<td>
							<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTag();"/>
						</td>
						<td nowrap="nowrap">
							<?php echo JText::_('JOOMEXT_FILTER'); ?>
						</td>
						<td nowrap="nowrap">
							<?php echo JHTML::_('select.genericlist', $contentfilter, 'contentfilter', 'size="1" onchange="updateTag();"', 'value', 'text', $pageInfo->contentfilter); ?>
						</td>
					</tr>
				<?php } ?>
			</table>
		</div>
	<?php
	}

	public function acymailing_replacetags(&$email, $send = true){
		$this->acymailing_generateautonews($email);
	}

	public function acymailing_generateautonews(&$email){
		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		$acypluginsHelper = acymailing_get('helper.acyplugins');
		jimport('simplepie.simplepie');
		//load the tags
		$tags = $acypluginsHelper->extractTags($email, 'newsfeeds');
		if(empty($tags)) return $return;

		$this->tags = array();
		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE', true).'" />';

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params){
			// Clean the cache to avoid blank pages
			if($cache = JFactory::getCache('feed_parser')) $cache->clean();

			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i], $return, $email);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content, true);
			$subjectreplace[$i] = trim(strip_tags($content));
		}
		$email->body = str_replace(array_keys($htmlreplace), $htmlreplace, $email->body);
		$email->altbody = str_replace(array_keys($textreplace), $textreplace, $email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace), $subjectreplace, $email->subject);
		return $return;
	}

	private function _replaceContent(&$tag, &$return, &$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$app = JFactory::getApplication();

		$result = '';
		$time = time();

		if(!empty($tag->display)){
			$tag->display = explode(',', $tag->display);
			foreach($tag->display as $index => $oneOption){
				$tmp = trim($oneOption);
				$tag->$tmp = true;
			}
			unset($tag->display);
		}

		// get RSS parsed object
		if(!empty($tag->id) && !preg_match('/^http/i', $tag->id)) $tag->id = 'http://'.$tag->id;
		$tag->id = str_replace('&amp;', '&', $tag->id);

		$baseURL = 'http://'.parse_url($tag->id, PHP_URL_HOST);

		$rssDoc = simplexml_load_file($tag->id);

		if($rssDoc == false){
			if($app->isAdmin()) $app->enqueueMessage('The Feed could not be loaded', 'notice');
			$return->status = false;
			$return->message = 'The Feed could not be loaded, we blocked the Smart-Newsletter generation';
			return $result;
		}

		$maxArticle = empty($tag->max) ? 20 : $tag->max;

		$resultfeeds = array();
		$nbFeed = 0;
		foreach($rssDoc->channel->item as $oneFeed){
			if($nbFeed >= $maxArticle) break;
			if(!empty($tag->filter) && !empty($email->params['lastgenerateddate']) && (strtotime($oneFeed->pubDate->__toString()) - date('Z') <= $email->params['lastgenerateddate'])) continue;

			$nbFeed++;

			$resultTitle = '';
			$resultContent = '';
			if(empty($tag->notitle) && !empty($tag->title)){
				if(empty($tag->description) && empty($tag->content) && empty($tag->author) && empty($tag->date)){
					$styleTitle = '';
					$styleTitleEnd = '';
				}else{
					$styleTitle = '<h2 class="acymailing_title">';
					$styleTitleEnd = '</h2>';
				}

				$resultTitle = $styleTitle.$oneFeed->title->__toString().$styleTitleEnd;
				if(!empty($tag->link) && strlen($oneFeed->link->__toString()) > 0){
					$resultTitle = '<a href="'.$oneFeed->link->__toString().'" style="text-decoration:none" name="newsfeeds" target="_blank" >'.$resultTitle.'</a>';
				}
				$resultTitle = '<tr><td colspan="2">'.$resultTitle.'</td></tr>';
			}

			$image = '';
			if(!empty($tag->enclosure) && $oneFeed->enclosure){
				$url = $oneFeed->enclosure['url']->__toString();
				if(in_array(substr($url, strlen($url)-4, 4), array('.jpg', '.gif', '.png', 'jpeg'))){
					$image = '<img src="'.$url.'" '.(empty($tag->nostyle) ? 'style="float:left;" ' : '').'/>';
				}
			}

			$description = '';
			if(!empty($tag->description) && $oneFeed->description){
				$description = $oneFeed->description->__toString();
				$description = $this->acypluginsHelper->wrapText($description, $tag);

				if(!empty($tag->wpmore) && strpos($description, '<span></span>') != false) $description = substr($description, 0, strpos($description, '<span></span>'));
			}

			if(!empty($image) || !empty($description)){
				$resultContent .= '<tr><td colspan="2">'.$image.str_replace('&apos;', "'", $description).'</td></tr>';
			}

			$dcTags = $oneFeed->children('http://purl.org/dc/elements/1.1/');

			$authors = $oneFeed->children('author');
			if(strlen($authors->__toString()) == 0){
				$authors = $dcTags->creator;
			}else $authors = $oneFeed->creator;

			if(!empty($tag->author) && strlen($authors->__toString()) > 0){
				$resultContent .= '<tr><td><b>'.JText::_('ACY_AUTHOR').'</b> :</td>';
				$tmp = 0;
				foreach($authors as $oneAuthor){
					if($tmp == 0){
						$resultContent .= '<td>'.$oneAuthor->__toString().'</td>';
					}else{
						$resultContent .= '</tr><tr><td/><td>'.$oneAuthor->__toString().'</td>';
					}
					$tmp++;
				}
				$resultContent .= '</tr>';
			}

			if(!empty($tag->date) && $oneFeed->pubDate){
				$resultContent .= '<tr><td><b>'.JText::_('CREATED_DATE').'</b> :</td><td>'.str_replace('&apos;', "'", $oneFeed->pubDate->__toString()).'</td></tr>';
			}

			if(!empty($tag->readmore)) $resultContent .= '<tr><td colspan="2"><a class="readmore_link" style="text-decoration:none;" target="_blank" href="'.$oneFeed->link->__toString().'"><span class="acymailing_readmore">'.(empty($tag->readmoretext) ? $this->readmore : $tag->readmoretext).'</span></a></td></tr>';

			if(!empty($resultContent)){
				$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">'.$resultTitle.$resultContent.'</table></div>';
			}else $result = strip_tags($resultTitle, '<a>');

			if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'newsfeeds.php')){
				ob_start();
				require(ACYMAILING_MEDIA.'plugins'.DS.'newsfeeds.php');
				$result = ob_get_clean();
			}

			$resultfeeds[] = $result;
		}
		if(!empty($tag->min) && $nbFeed < $tag->min){
			//We won't generate the Newsletter
			$return->status = false;
			$return->message = 'Not enough content for the rss '.$tag->id.' : '.$nbFeed.' / '.$tag->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
		}
		$result = $acypluginsHelper->getFormattedResult($resultfeeds, $tag);
		$result = $acypluginsHelper->managePicts($tag, $result);

		$result = str_replace(array('href="/', 'src="/'), array('href="'.$baseURL.'/', 'src="'.$baseURL.'/'), $result);

		return $result;
	}
}//endclass