<?php


/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingPhocadownload extends JPlugin{
	function __construct(& $subject, $config){
		parent::__construct($subject, $config);
		if(!isset ($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'phocadownload');
			$this->params = new acyParameter($plugin->params);
		}
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
		if($this->params->get('frontendaccess') == 'none' && !$app->isAdmin()){
			return;
		}
		$onePlugin = new stdClass();
		$onePlugin->name = 'PhocaDownload';
		$onePlugin->function = 'acymailingphocadownload_show';
		$onePlugin->help = 'plugin-phocadownload';
		return $onePlugin;
	}

	function acymailingphocadownload_show(){
		$config = acymailing_config();
		if($config->get('version') < '5.5.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		$lang = JFactory::getLanguage();
		$lang->load('com_phocadownload', JPATH_SITE);
		$app = JFactory::getApplication();

		$pageInfo = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.phocadownload';

		$pageInfo->filter->order->value = $app->getUserStateFromRequest($paramBase.".filter_order", 'filter_order', 'a.title', 'cmd');
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest($paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word');
		$pageInfo->search = $app->getUserStateFromRequest($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->titlelink = $app->getUserStateFromRequest($paramBase.".titlelink", 'titlelink', '1', 'string');
		$pageInfo->download = $app->getUserStateFromRequest($paramBase.".download", 'download', '1', 'string');
		$pageInfo->contenttype = $app->getUserStateFromRequest($paramBase.".contenttype", 'contenttype', 'intro', 'string');
		$pageInfo->limit->value = $app->getUserStateFromRequest($paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->autotitlelink = $app->getUserStateFromRequest($paramBase.".autotitlelink", 'autotitlelink', '1', 'string');
		$pageInfo->automaxvalue = $app->getUserStateFromRequest($paramBase.".max", 'max', '20', 'int');
		$pageInfo->contentfilter = $app->getUserStateFromRequest($paramBase.".contentfilter", 'contentfilter', 'created', 'string');
		$pageInfo->contentorder = $app->getUserStateFromRequest($paramBase.".contentorder", 'contentorder', 'id', 'string');
		$pageInfo->autocontenttype = $app->getUserStateFromRequest($paramBase.".autocontenttype", 'autocontenttype', 'intro', 'string');
		$pageInfo->downloadauto = $app->getUserStateFromRequest($paramBase.".download", 'download', '1', 'string');
		$pageInfo->cols = $app->getUserStateFromRequest($paramBase.".cols", 'cols', '1', 'string');

		$pageInfo->pictheight = $app->getUserStateFromRequest($paramBase.".pictheight", 'pictheight', $this->params->get('maxheight', 150), 'string');
		$pageInfo->pictwidth = $app->getUserStateFromRequest($paramBase.".pictwidth", 'pictwidth', $this->params->get('maxwidth', 150), 'string');
		$pageInfo->autopict = $app->getUserStateFromRequest($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->pict = $app->getUserStateFromRequest($paramBase.".pict", 'pict', '1', 'string');

		$db = JFactory::getDBO();

		$searchFields = array('a.id', 'a.title', 'b.title', 'a.filename');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart', 'all') == 'onlypub'){
			$filters[] = "a.published = 1";
		}else{
			$filters[] = "a.published != -2";
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*,b.*,a.title AS file_title,a.id as fileId FROM `#__phocadownload` AS a '.'JOIN `#__phocadownload_categories` AS b ON a.catid = b.id ';

		if(!empty($pageInfo->filter_cat)){
			$filters[] = "a.catid = ".$pageInfo->filter_cat;
		}

		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (', $filters).')';
		}

		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search, $rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		$type = JRequest::getString('type');
		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();

			function applyContent(contentid, rowClass){
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';

				for(var i = 0; i < document.adminForm.contenttype.length; i++){
					if(document.adminForm.contenttype[i].checked){
						selectedtype = document.adminForm.contenttype[i].value;
						otherinfo += '|type:' + document.adminForm.contenttype[i].value;
					}
				}

				if(selectedtype != 'title'){
					for(var i = 0; i < document.adminForm.pict.length; i++){
						if(document.adminForm.pict[i].checked){
							otherinfo += '|pict:' + document.adminForm.pict[i].value;
							if(document.adminForm.pict[i].value == 'resized'){
								document.getElementById('pictsize').style.display = '';
								if(document.adminForm.pictwidth.value) otherinfo += '|maxwidth:' + document.adminForm.pictwidth.value;
								if(document.adminForm.pictheight.value) otherinfo += '|maxheight:' + document.adminForm.pictheight.value;
							}else{
								document.getElementById('pictsize').style.display = 'none';
							}
						}
					}
				}

				for(var i = 0; i < document.adminForm.titlelink.length; i++){
					if(document.adminForm.titlelink[i].checked && document.adminForm.titlelink[i].value != 0){
						otherinfo += '|link'
					}
				}

				for(var i = 0; i < document.adminForm.download.length; i++){
					if(document.adminForm.download[i].checked && document.adminForm.download[i].value != 0){
						otherinfo += '|download';
					}
				}

				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0){
					otherinfo += "|wrap:" + document.adminForm.wrap.value;
				}

				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{phocadownload:' + selectedContents[i] + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}


			var selectedCategories = new Array();

			<?php if(!ACYMAILING_J16){ ?>
			function applyAuto(secid, catid, rowClass){
				if(selectedCategories[secid] && selectedCategories[secid][catid]){
					window.document.getElementById('content_sec' + secid + '_cat' + catid).className = rowClass;
					delete selectedCategories[secid][catid];
				}else{
					if(!selectedCategories[secid]) selectedCategories[secid] = new Array();
					if(secid == 0){
						for(var isec in selectedCategories){
							for(var icat in selectedCategories[isec]){
								if(selectedCategories[isec][icat] == 'content'){
									window.document.getElementById('content_sec' + isec + '_cat' + icat).className = 'row0';
									delete selectedCategories[isec][icat];
								}
							}
						}
					}else{
						if(selectedCategories[0] && selectedCategories[0][0]){
							window.document.getElementById('content_sec0_cat0').className = 'row0';
							delete selectedCategories[0][0];
						}
						if(catid == 0){
							for(var icat in selectedCategories[secid]){
								if(selectedCategories[secid][icat] == 'content'){
									window.document.getElementById('content_sec' + secid + '_cat' + icat).className = 'row0';
									delete selectedCategories[secid][icat];
								}
							}
						}else{
							if(selectedCategories[secid][0]){
								window.document.getElementById('content_sec' + secid + '_cat0').className = 'row0';
								delete selectedCategories[secid][0];
							}
						}
					}
					window.document.getElementById('content_sec' + secid + '_cat' + catid).className = 'selectedrow';
					selectedCategories[secid][catid] = 'content';
				}
				updateTagAuto();
			}
			<?php }else{ ?>
			function applyAuto(catid, rowClass){
				if(selectedCategories[catid]){
					window.document.getElementById('content_cat' + catid).className = rowClass;
					delete selectedCategories[catid];
				}else{
					window.document.getElementById('content_cat' + catid).className = 'selectedrow';
					selectedCategories[catid] = 'content';
				}
				updateTagAuto();
			}
			<?php } ?>

			function updateTagAuto(){
				tag = '{autophocadownload:';
				<?php if(!ACYMAILING_J16){ ?>
				for(var isec in selectedCategories){
					for(var icat in selectedCategories[isec]){
						if(selectedCategories[isec][icat] == 'content'){
							if(icat != 0){
								tag += 'cat' + icat + '-';
							}else{
								tag += 'sec' + isec + '-';
							}
						}
					}
				}
				<?php }else{ ?>
				for(var icat in selectedCategories){
					if(selectedCategories[icat] == 'content'){
						tag += icat + '-';
					}
				}
				<?php } ?>
				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value != 0){
					tag += '|min:' + document.adminForm.min_article.value;
				}
				if(document.adminForm.max_article.value && document.adminForm.max_article.value != 0){
					tag += '|max:' + document.adminForm.max_article.value;
				}
				for(var i = 0; i < document.adminForm.contenttypeauto.length; i++){
					if(document.adminForm.contenttypeauto[i].checked){
						selectedtype = document.adminForm.contenttypeauto[i].value;
						tag += '|type:' + document.adminForm.contenttypeauto[i].value;
					}
				}
				for(var i = 0; i < document.adminForm.downloadauto.length; i++){
					if(document.adminForm.downloadauto[i].checked && document.adminForm.downloadauto[i].value != 0){
						tag += '|download';
					}
				}
				if(selectedtype != 'title'){
					for(var i = 0; i < document.adminForm.autopict.length; i++){
						if(document.adminForm.autopict[i].checked){
							tag += '|pict:' + document.adminForm.autopict[i].value;
							if(document.adminForm.autopict[i].value == 'resized'){
								document.getElementById('pictsizeauto').style.display = '';
								if(document.adminForm.pictwidthauto.value) tag += '|maxwidth:' + document.adminForm.pictwidthauto.value;
								if(document.adminForm.pictheightauto.value) tag += '|maxheight:' + document.adminForm.pictheightauto.value;
							}else{
								document.getElementById('pictsizeauto').style.display = 'none';
							}
						}
					}
				}
				for(var i = 0; i < document.adminForm.autotitlelink.length; i++){
					if(document.adminForm.autotitlelink[i].checked && document.adminForm.autotitlelink[i].value != 0){
						tag += '|link';
					}
				}

				if(document.adminForm.cols.value){
					tag += '|cols:' + document.adminForm.cols.value;
				}
				if(document.adminForm.contentorder.value){
					tag += '|order:' + document.adminForm.contentorder.value;
				}
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
					tag += '|filter:' + document.adminForm.contentfilter.value;
				}
				if(document.adminForm.autowrap.value && document.adminForm.autowrap.value != 0){
					tag += "|wrap:" + document.adminForm.autowrap.value;
				}

				tag += '}';
				setTag(tag);
			}
			//-->
		</script>
		<?php


		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$ordering = array();
		$ordering[] = JHTML::_('select.option', "id,DESC", JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "ordering,ASC", JText::_('ACY_ORDERING'));
		$ordering[] = JHTML::_('select.option', "date,DESC", JText::_('CREATED_DATE'));
		$ordering[] = JHTML::_('select.option', "title,ASC", JText::_('FIELD_TITLE'));

		$contenttype = array();
		$contenttype[] = JHTML::_('select.option', "title", JText::_('TITLE_ONLY'));
		$contenttype[] = JHTML::_('select.option', "intro", JText::_('CATEGORY_VIEW'));
		$contenttype[] = JHTML::_('select.option', "full", JText::_('DETAILS_VIEW'));

		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = JHTML::_('select.option', "$i", $i);
		}

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('phocadownload_tab');
		echo $tabs->startPanel(JText::_('TAG_ELEMENTS'), 'phocadownload_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY'); ?></td>
				<td colspan="3"><?php echo JHTML::_('acyselect.radiolist', $contenttype, 'contenttype', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?></td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('CLICKABLE_TITLE'); ?>
				</td>
				<td>
					<?php echo JHTML::_('acyselect.radiolist', $choice, 'titlelink', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->titlelink); ?>
				</td>
				<td>
					<?php echo JText::_('ACY_DOWNLOAD'); ?>
				</td>
				<td>
					<?php echo JHTML::_('acyselect.radiolist', $choice, 'download', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->download); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('DISPLAY_PICTURES'); ?>
				</td>
				<td>
					<?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?>><br/>
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER', '<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search; ?>" class="text_area" onchange="document.adminForm.submit();"/>
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_('JOOMEXT_GO'); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_('JOOMEXT_RESET'); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
			<tr>
				<th class="title">
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('FIELD_TITLE'), 'a.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('ACY_FILES'), 'a.filename', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title titleid">
					<?php echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
			</tr>
			</thead>
			<tfoot>
			<tr>
				<td colspan="5">
					<?php echo $pagination->getListFooter(); ?>
					<?php echo $pagination->getResultsCounter(); ?>
				</td>
			</tr>
			</tfoot>
			<tbody>
			<?php


			$k = 0;
			for($i = 0, $a = count($rows); $i < $a; $i++){
				$row = &$rows[$i];
				?>
				<tr id="content<?php echo $row->fileId; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->fileId.",'row$k'" ?>);" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php


						$text = '<b>'.JText::_('JOOMEXT_ALIAS').' : </b>'.$row->title;
						echo acymailing_tooltip($text, $row->description, '', $row->file_title);
						?>
					</td>
					<td>
						<?php echo $row->filename; ?>
					</td>
					<td>
						<?php


						if(!empty($row->title)){
							$text = '<b>'.JText::_('TAG_CATEGORIES', true).' : </b>'.$row->title;
							echo acymailing_tooltip($text, $row->title, '', $row->title);
						}
						?>
					</td>
					<td align="center" style="text-align:center">
						<?php echo $row->fileId; ?>
					</td>
				</tr>
				<?php


				$k = 1 - $k;
			}
			?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php


		echo $tabs->endPanel();
		echo $tabs->startPanel(JText::_('TAG_CATEGORIES'), 'phocadownload_auto');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY'); ?></td>
				<td colspan="3"><?php echo JHTML::_('acyselect.radiolist', $contenttype, 'contenttypeauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autocontenttype); ?></td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('CLICKABLE_TITLE'); ?>
				</td>
				<td>
					<?php echo JHTML::_('acyselect.radiolist', $choice, 'autotitlelink', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autotitlelink); ?>
				</td>
				<td>
					<?php echo JText::_('ACY_DOWNLOAD'); ?>
				</td>
				<td>
					<?php echo JHTML::_('acyselect.radiolist', $choice, 'downloadauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->downloadauto); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('DISPLAY_PICTURES'); ?>
				</td>
				<td>
					<?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
					<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br/>
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $this->params->get('maxwidth', '150'); ?>" style="width:30px;"/>
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $this->params->get('maxheight', '150'); ?>" style="width:30px;"/>
				</span>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER', '<input type="text" name="autowrap" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td>
					<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
				<td>
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td>
					<?php echo JHTML::_('select.genericlist', $ordering, 'contentorder', 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews'){ ?>
				<tr>
					<td>
						<?php echo JText::_('MIN_ARTICLE'); ?>
					</td>
					<td>
						<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
					</td>
					<td>
						<?php echo JText::_('ACY_FILTER'); ?>
					</td>
					<td>
						<?php $filter = acymailing_get('type.contentfilter');
						$filter->onclick = 'updateTagAuto();';
						echo $filter->display('contentfilter', $pageInfo->contentfilter); ?>
					</td>
				</tr>
			<?php } ?>
			<tr>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td colspan="3">
					<?php echo JHTML::_('select.genericlist', $column, 'cols', 'size="1" style="width:50px" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
			<tr>
				<th class="title">
				</th>
				<?php if(!ACYMAILING_J16){ ?>
					<th class="title">
						<?php echo JText::_('SECTION'); ?>
					</th>
				<?php } ?>
				<th class="title">
					<?php echo JText::_('TAG_CATEGORIES'); ?>
				</th>
			</tr>
			</thead>
			<tbody>
			<?php


			$k = 0;
			if(!ACYMAILING_J16){
				?>
				<tr id="content_sec0_cat0" class="<?php echo "row$k"; ?>" onclick="applyAuto(0,0,'<?php echo "row$k" ?>');" style="cursor:pointer;">
					<td style="font-weight: bold;">
						<?php


						echo JText::_('ACY_ALL');
						?>
					</td>
					<td style="text-align:center;font-weight: bold;">
						<?php


						echo JText::_('ACY_ALL');
						?>
					</td>
				</tr>
				<?php
			}
			$k = 1 - $k;
			$currentSection = '';

			if(!ACYMAILING_J16){
				$version = $this->categories;
			}else $version = $this->categoriesValues;

			foreach($version as $row){
				if(!ACYMAILING_J16 && $currentSection != $row->section){
					?>
					<tr id="content_sec<?php echo $row->secid ?>_cat0" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $row->secid ?>,0,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td style="font-weight: bold;">
							<?php


							echo $row->section;
							?>
						</td>
						<td style="text-align:center;font-weight: bold;">
							<?php


							echo JText::_('ACY_ALL');
							?>
						</td>
					</tr>
					<?php

					$k = 1 - $k;
					$currentSection = $row->section;
				}
				if(!ACYMAILING_J16){
					?>
					<tr id="content_sec<?php echo $row->secid ?>_cat<?php echo $row->catid ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $row->secid ?>,<?php echo $row->catid ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td>
						</td>
						<td>
							<?php
							echo $row->category;
							?>
						</td>
					</tr>
					<?php
				}else{
					?>
					<tr id="content_cat<?php echo $row->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $row->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
							<?php
							echo($row->text);
							?>
						</td>
					</tr>
					<?php
				}
				$k = 1 - $k;
			}
			?>
			</tbody>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		$db = JFactory::getDBO();

		if(!ACYMAILING_J16){
			$query = 'SELECT a.id, a.id as catid, a.title as category, b.title as section, b.id as secid from #__phocadownload_categories as a ';
			$query .= 'INNER JOIN #__phocadownload_sections as b on a.section = b.id ORDER BY b.ordering,a.ordering';
			$db->setQuery($query);
			$this->categories = $db->loadObjectList('id');
			$this->categoriesValues = array();
			$this->categoriesValues[] = JHTML::_('select.option', '', JText::_('ACY_ALL'));
			$currentSec = '';
			foreach($this->categories as $catid => $oneCategorie){
				if($currentSec != $oneCategorie->section){
					if(!empty($currentSec)){
						$this->values[] = JHTML::_('select.option', '</OPTGROUP>');
					}
					$this->categoriesValues[] = JHTML::_('select.option', '<OPTGROUP>', $oneCategorie->section);
					$currentSec = $oneCategorie->section;
				}
				$this->categoriesValues[] = JHTML::_('select.option', $catid, '-- '.$oneCategorie->category);
			}
		}else{
			$query = 'SELECT parent_id,id, id as catid,title from #__phocadownload_categories ';
			$db->setQuery($query);
			$this->categories = $db->loadObjectList('id');
			$this->cats = array();
			$this->categoriesValues = array();
			$this->categoriesValues[] = JHTML::_('select.option', 0, JText::_('ACY_ALL'));
			foreach($this->categories as $oneCat){
				$this->cats[$oneCat->parent_id][] = $oneCat;
			}
			$this->handleChildrens();
		}
		return JHTML::_('select.genericlist', $this->categoriesValues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int)$filter_cat);
	}

	/**
	 * JVERSION > 1.5
	 */
	function handleChildrens($parentId = 0, $level = 0){
		if(!empty($this->cats[$parentId])){
			foreach($this->cats[$parentId] as $cat){
				$this->categoriesValues[] = JHTML::_('select.option', $cat->id, str_repeat(" - - ", $level).$cat->title);
				$this->handleChildrens($cat->id, $level + 1);
			}
		}
	}

	function acymailing_replacetags(& $email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(& $email){
		$match = '#{phocadownload:(.*)}#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)){
				continue;
			}
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])){
				unset ($results[$var]);
			}
		}

		//If we didn't find anything...
		if(!$found){
			return;
		}

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset ($htmlreplace[$oneTag])){
					continue;
				}

				$content = $this->_replaceContent($allresults, $i);
				$htmlreplace[$oneTag] = $content;
				$textreplace[$oneTag] = $this->mailerHelper->textVersion($content, true);
				$subjectreplace[$oneTag] = strip_tags($content);
			}
		}

		$email->body = str_replace(array_keys($htmlreplace), $htmlreplace, $email->body);
		$email->altbody = str_replace(array_keys($textreplace), $textreplace, $email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace), $subjectreplace, $email->subject);
	}

	function _replaceContent(& $results, $i){
		$lang = JFactory::getLanguage();
		$lang->load('com_phocadownload', JPATH_SITE);
		$result = '';

		//1 : Transform the tag properly...
		$arguments = explode('|', strip_tags($results[1][$i]));
		$tag = null;
		$tag->id = intval($arguments[0]);
		for($i = 1, $a = count($arguments); $i < $a; $i++){
			$args = explode(':', $arguments[$i]);
			if(isset ($args[1])){
				$tag->{$args[0]} = $args[1];
			}else{
				$tag->{$args[0]} = true;
			}
		}
		//2 : Load the Joomla article... with the author, the section and the categories to create nice links
		$query = 'SELECT a.*,b.*,a.description AS descr,a.title AS file_title,a.id as fileId,a.alias AS filealias FROM `#__phocadownload` AS a '.'JOIN `#__phocadownload_categories` AS b ON a.catid = b.id '.'WHERE a.id = "'.intval($tag->id).'" LIMIT 1';
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$article = $db->loadObject();

		//In case of we could not load the article for any reason...
		$app = JFactory::getApplication();
		if(empty($article)){
			if($app->isAdmin()){
				$app->enqueueMessage('The document "'.$tag->id.'" could not be loaded', 'notice');
			}
			return $result;
		}

		$itemid = $this->params->get('ItemId', "");

		if(!empty($itemid)){
			$link = 'index.php?option=com_phocadownload&view=category&id='.$article->id.':'.$article->alias.'&Itemid='.$itemid;
			$linkdownload = 'index.php?option=com_phocadownload&view=category&download='.$article->fileId.':'.$article->filealias.'&id='.$article->fileId.':'.$article->filealias.'&Itemid='.$itemid;
		}else{
			$link = 'index.php?option=com_phocadownload&view=category&id='.$article->id.':'.$article->alias.'&Itemid=0';
			$linkdownload = 'index.php?option=com_phocadownload&view=category&download='.$article->fileId.':'.$article->filealias.'&id='.$article->fileId.':'.$article->filealias.'&Itemid=0';
		}
		if(!empty($tag->autologin)){
			$link .= '&user={usertag:username|urlencode}&passw={usertag:password|urlencode}';
			$linkdownload .= '&user={usertag:username|urlencode}&passw={usertag:password|urlencode}';
		}
		$link = acymailing_frontendLink($link);

		//Add the title with a link or not on it.
		//If we add a link, we add in the same time a name="content-CONTENTID" so that we will be able to parse the content to create a nice summary

		$styleTitle = '<h2 class="acymailing_title">';
		$styleTitleEnd = '</h2>';

		$resultTitle = '';
		if(empty($tag->notitle)){
			if(!empty($tag->link)){
				if(!empty($article->image_filename)){
					$resultTitle .= '<img src="images/phocadownload/'.$article->image_filename.'"  style="float:left;height: 16px; width: 16px;"/>';
				}
				$resultTitle .= '<a href="'.$link.'" ';
				if($tag->type != "title"){
					$resultTitle .= 'style="text-decoration:none" name="phocadownload-'.$article->fileId.'" ';
				}
				$resultTitle .= 'target="_blank" >'.$styleTitle.$article->file_title.$styleTitleEnd.'</a>';
			}else{
				if(!empty($article->image_filename)){
					$resultTitle .= '<img src="images/phocadownload/'.$article->image_filename.'" style="float:left;height: 16px; width: 16px; "/>';
				}
				$resultTitle .= $styleTitle.$article->file_title.$styleTitleEnd;
				if(!empty($article->image_filename_spec1)){
					$resultTitle .= '<img src="images/phocadownload/'.$article->image_filename_spec1.'" />';
				}
				if(!empty($article->image_filename_spec2)){
					$resultTitle .= '<img src="images/phocadownload/'.$article->image_filename_spec2.'" />';
				}
			}
		}
		if(!empty($tag->download)){
			$download = '<a style="text-decoration:none;" target="_blank" href="'.$linkdownload.'"><span class="acymailing_readmore">'.JText::_('ACY_DOWNLOAD').'</span></a>';
		}else{
			$download = '';
		}

		if($tag->type != "title"){

			$wordwrap = empty($tag->wrap) ? $this->params->get('wordwrap', 0) : $tag->wrap;
			if(!empty($wordwrap)){
				$newintrotext = strip_tags($article->descr, '<br><img>');
				$numChar = strlen($newintrotext);
				if($numChar > $wordwrap){
					$stop = strlen($newintrotext);
					for($i = $wordwrap; $i < $numChar; $i++){
						if($newintrotext[$i] == " "){
							$stop = $i;
							$forceReadMore = true;
							break;
						}
					}
					$article->descr = substr($newintrotext, 0, $stop).'...';
				}
			}
			if($tag->type == "intro"){
				if(!empty($article->thumbnail)){
					$result .= '<img src="images/jdownloads/screenshots/'.$article->thumbnail.'" style="float:right;margin-left:5px;"/>';
				}
				$result .= $article->descr."<br />";
			}else{
				$result .= '<div>';

				if(!empty($article->descr)){
					$result .= $article->descr;
				}
				$result .= '</div><table  width="100%" border="0" cellpadding="0" cellspacing="0">';
				if(!empty($article->filename)){
					$result .= '<tr><td class="fieldname" >'.JText::_('ACY_FILES').' :</td><td class="fieldvalue" >'.$article->filename.'</td>';
					if(file_exists(ACYMAILING_ROOT.'administrator'.DS.'components'.DS.'com_phocadownload'.DS.'helpers'.DS.'phocadownload.php')){
						include_once(ACYMAILING_ROOT.'administrator'.DS.'components'.DS.'com_phocadownload'.DS.'helpers'.DS.'phocadownload.php');
						$result .= '<td class="fieldname" >'.JText::_('FIELD_SIZE').' :</td><td class="fieldvalue" >'.PhocaDownloadHelper::getFileSizeReadable($article->filesize).'</td></tr>';
					}else{
						include_once(ACYMAILING_ROOT.'administrator'.DS.'components'.DS.'com_phocadownload'.DS.'libraries'.DS.'phocadownload'.DS.'file'.DS.'file.php');
						$result .= '<td class="fieldname" >'.JText::_('FIELD_SIZE').' :</td><td class="fieldvalue" >'.PhocaDownloadFile::getFileSizeReadable($article->filesize).'</td></tr>';
					}
				}
				if(!empty($article->date)){
					$result .= '<tr><td class="fieldname" >'.JText::_('ACY_CREATED').' :</td><td class="fieldvalue" >'.acymailing_getDate(acymailing_getTime($article->date)).'</td>';
				}
				$result .= "</table>";
			}
			$result = $resultTitle.$result;

			if(!empty($article->image_filename_spec1)){
				$result .= '<img src="images/phocadownload/'.$article->image_filename_spec1.'" />';
			}
			if(!empty($article->image_filename_spec2)){
				$result .= '<img src="images/phocadownload/'.$article->image_filename_spec2.'" />';
			}
			$result .= '<br />'.$download;
			$result = '<div class="acymailing_content">'.$result.'</div>';
		}else{
			$result = $resultTitle.$result.$download;
		}

		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'phocadownload.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'phocadownload.php');
			$result = ob_get_clean();
		}

		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$result = $acypluginsHelper->removeJS($result);

		if(isset ($tag->pict)){
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight', 150) : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth', 150) : $tag->maxwidth;
			if($tag->pict == '0'){
				$result = $pictureHelper->removePictures($result);
			}elseif($tag->pict == 'resized'){
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error, 'notice');
				}
			}
		}
		return $result;
	}

	function _replaceAuto(& $email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags), $this->tags, $email->body);
			if(!empty($email->altbody)){
				$email->altbody = str_replace(array_keys($this->tags), $this->tags, $email->altbody);
			}
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag, strip_tags(str_replace('</tr><tr>', ' | ', $result)), $email->subject);
			}
		}
	}

	function acymailing_generateautonews(& $email){

		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		$time = time();

		//Check if we should generate the SmartNewsletter or not...
		$match = '#{autophocadownload:(.*)}#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)){
				continue;
			}
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])){
				unset ($results[$var]);
			}
		}

		//If we didn't find anything... so we won't try to stop the generation
		if(!$found){
			return $return;
		}

		$this->tags = array();
		$db = JFactory::getDBO();

		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset ($this->tags[$oneTag])){
					continue;
				}

				$arguments = explode('|', strip_tags($allresults[1][$i]));
				//The first argument is a list of sections and cats...
				$allcats = explode('-', $arguments[0]);
				$parameter = new stdClass();
				for($i = 1; $i < count($arguments); $i++){
					$args = explode(':', $arguments[$i]);
					$arg0 = $args[0];
					if(isset ($args[1])){
						$parameter->$arg0 = $args[1];
					}else{
						$parameter->$arg0 = true;
					}
				}
				//Load the articles based on all arguments...
				$selectedArea = array();
				$parentID = '';
				foreach($allcats as $oneCat){
					if(!ACYMAILING_J16){
						$sectype = substr($oneCat, 0, 3);
						$num = substr($oneCat, 3);
						if(empty($num)){
							continue;
						}
						if($sectype == 'cat'){
							$selectedArea[] = 'catid = '.intval($num);
						}elseif($sectype == 'sec'){
							$selectedArea[] = 'sectionid = '.intval($num);
						}
					}else{
						if(empty($oneCat)){
							continue;
						}
						$selectedArea[] = 'catid = '.intval($oneCat);
					}
				}

				//We also include subcats... this works only for J1.6 or superior
				if(ACYMAILING_J16 && !empty($parameter->subcats) && !empty($selectedArea)){
					$db->setQuery('SELECT id,parent_id FROM #__phocadownload_categories');
					$cats = $db->loadObjectList();
					$tmp = 1;
					while($tmp != 0){
						$tmp = 0;
						foreach($cats as $oneCat){
							if(in_array('catid = '.$oneCat->parent_id, $selectedArea) && !in_array('catid = '.$oneCat->id, $selectedArea)){
								$tmp++;
								$selectedArea[] = 'catid = '.$oneCat->id;
							}
						}
					}
				}

				$query = 'SELECT id FROM #__phocadownload';
				$where = array();
				if(!empty($selectedArea)){
					$where[] = implode(' OR ', $selectedArea);
				}

				if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
					$where[] = '`date` > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
				}

				if($this->params->get('contentaccess', 'registered') == 'registered'){
					$where[] = 'access <= 1';
				}elseif($this->params->get('contentaccess', 'registered') == 'public') $where[] = 'access = 0';

				$where[] = "published = 1";
				$where[] = "approved = 1";

				$query .= ' WHERE ('.implode(') AND (', $where).')';
				if(!empty($parameter->order)){
					$ordering = explode(',', $parameter->order);
					$query .= ' ORDER BY `'.acymailing_secureField($ordering[0]).'` '.acymailing_secureField($ordering[1]);
				}
				if(!empty($parameter->max)){
					$query .= ' LIMIT '.intval($parameter->max);
				}elseif(empty($email->params['lastgenerateddate'])) $query .= ' LIMIT 20';
				//We add a limit for the preview otherwise we could break everything
				$db->setQuery($query);
				$allArticles = acymailing_loadResultArray($db);

				if(!empty($parameter->min) && count($allArticles) < $parameter->min){
					//We won't generate the Newsletter
					$return->status = false;
					$return->message = 'Not enough PhocaDownload content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
				}

				$stringTag = '';
				if(!empty($allArticles)){
					if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autophocadownload.php')){
						ob_start();
						require(ACYMAILING_MEDIA.'plugins'.DS.'autophocadownload.php');
						$stringTag = ob_get_clean();
					}else{
						//we insert the article tag one after the other in a table as they are already sorted
						$arrayElements = array();
						foreach($allArticles as $oneArticleId){
							$stringTag .= '<tr><td>';
							$args = array();
							$args[] = 'phocadownload:'.$oneArticleId;
							if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
							if(!empty($parameter->link)) $args[] = 'link';
							if(!empty($parameter->download)) $args[] = 'download';
							if(!empty($parameter->autologin)) $args[] = 'autologin';
							if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
							if(!empty($parameter->notitle)) $args[] = 'notitle';
							if(!empty($parameter->created)) $args[] = 'created';
							if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
							if(isset ($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
							if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
							if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
							if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
							if(!empty($parameter->readmore)) $args[] = 'readmore:'.$parameter->readmore;
							$arrayElements[] = '{'.implode('|', $args).'}';
						}
						$acypluginsHelper = acymailing_get('helper.acyplugins');
						$stringTag = $acypluginsHelper->getFormattedResult($arrayElements, $parameter);
					}
				}
				$this->tags[$oneTag] = $stringTag;
			}
		}
		return $return;
	}
} //endclass