<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingPlgbirthday extends JPlugin{
	var $success = false;

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
	}

	function onAcyCronTrigger(){
		$config =& acymailing_config();
		$birthPluginData = $config->get('birthplugin', '');
		if(empty($birthPluginData)) return 'Birthday plugin: No table or Newsletter specified (did you create at least one setup?)';

		$savedConfig = json_decode($birthPluginData, true);
		if(empty($savedConfig)) return 'Birthday plugin: No table or Newsletter specified (did you create at least one setup?)';

		$messages = array();
		$db = JFactory::getDBO();
		foreach($savedConfig as $oneSetup){
			if(!empty($this->test) && $oneSetup['id'] != $this->test) continue;
			$mailid = intval($oneSetup['mailid']);
			$tabletype = $oneSetup['birthdaytable'];

			//Do we have lists IDs as well?
			$listids = explode(',', $oneSetup['listids']);
			$subscription = array();
			if(!empty($listids)){
				foreach($listids as $oneList){
					$oneList = intval($oneList);
					if(empty($oneList)) continue;
					$subscription[$oneList] = $oneList;
				}
			}

			$join = '';
			$where = '';
			if(!empty($subscription)){
				$join = ' JOIN #__acymailing_listsub as listsub ON sub.subid = listsub.subid ';
				$where = ' listsub.listid IN ('.implode(',', $subscription).') AND listsub.status = 1 AND ';
			}

			$field = $oneSetup['birthdayfield'];

			//One day ahead
			$birthday = time() + 86400 + (intval($oneSetup['nbdays']) * 86400);
			$birthdayDay = date('d', $birthday);
			$birthdayMonth = date('m', $birthday);

			$senddate = acymailing_getTime(date('Y').'-'.$birthdayMonth.'-'.$birthdayDay.' '.$oneSetup['sendtime']) - (intval($oneSetup['nbdays']) * 86400);

			if($tabletype == 'jomsocial'){
				if(empty($field)) $field = 'FIELD_BIRTHDAY';
				$fieldName = $db->Quote($field);
				$db->setQuery("SELECT `id` FROM `#__community_fields` WHERE `name` = $fieldName OR `id` = $fieldName OR `fieldcode` = $fieldName LIMIT 1");
				$fieldId = $db->loadResult();
				if(empty($fieldId)){
					$messages[] = 'Birthday plugin: No field found in JomSocial with the name '.$fieldName;
					continue;
				}
				$db->setQuery('SELECT `user_id` FROM `#__community_fields_values` WHERE `field_id` = '.intval($fieldId).' AND DAY(`value`) = '.$db->Quote($birthdayDay).' AND MONTH(`value`)='.$db->Quote($birthdayMonth).' AND YEAR(`value`) > 1901');
				$alluserids = acymailing_loadResultArray($db);
				if(empty($alluserids)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in JomSocial';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.userid IN ('.implode(',', $alluserids).')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'cb'){
				if(empty($field)){
					$messages[] = 'Birthday plugin: There is no default field in CB for the birthday, please specify your CB field';
					continue;
				}
				$fieldName = $db->Quote($field);
				$db->setQuery("SELECT `name` FROM `#__comprofiler_fields` WHERE `name` = $fieldName OR `fieldid` = $fieldName OR `tablecolumns` = $fieldName OR `title` = $fieldName LIMIT 1");
				$fieldId = $db->loadResult();
				if(empty($fieldId)){
					$messages[] = 'Birthday plugin: No field found in CB with the name '.$fieldName;
					continue;
				}
				$db->setQuery('SELECT `id` FROM `#__comprofiler` WHERE DAY(`'.$fieldId.'`) = '.$db->Quote($birthdayDay).' AND MONTH(`'.$fieldId.'`)='.$db->Quote($birthdayMonth).' AND YEAR(`'.$fieldId.'`) > 1901');
				$alluserids = acymailing_loadResultArray($db);
				if(empty($alluserids)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in Community Builder';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.userid IN ('.implode(',', $alluserids).')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'acymailing'){
				if(empty($field)){
					$messages[] = 'Birthday plugin: There is no default field in AcyMailing for the birthday, please specify your AcyMailing field';
					continue;
				}
				$fieldName = $db->Quote($field);
				$db->setQuery("SELECT * FROM `#__acymailing_fields` WHERE `fieldname` = $fieldName OR `namekey` = $fieldName OR `fieldid` = $fieldName LIMIT 1");
				$fieldObject = $db->loadObject();
				if(empty($fieldObject->namekey)){
					$messages[] = 'Birthday plugin: No field found in AcyMailing with the name '.$fieldName;
					continue;
				}
				if(!empty($fieldObject->options)) $fieldObject->options = unserialize($fieldObject->options);
				if(empty($fieldObject->options['format']) OR $fieldObject->type == 'birthday' OR substr($fieldObject->options['format'], 0, 8) == '%Y-%m-%d'){
					$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' DAY(sub.`'.$fieldObject->namekey.'`) = '.$db->Quote($birthdayDay).' AND MONTH(sub.`'.$fieldObject->namekey.'`)='.$db->Quote($birthdayMonth).' AND sub.enabled = 1 AND sub.accept = 1';
				}else{
					$conditionDate = strftime(str_replace(array('%y', '%Y'), 'XXXX', $fieldObject->options['format']), $birthday);
					$queryDate = str_replace('XXXX', '%', $conditionDate);
					if(strpos($conditionDate, '%') !== false || (strpos($queryDate, '%') !== 0 AND strpos($queryDate, '%') !== (strlen($queryDate) - 1))){
						$messages[] = 'Birthday plugin: Could not handle the format '.$fieldObject->options['format'].' for the specified AcyMailing birthday field';
						continue;
					}
					$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.`'.$fieldObject->namekey.'` LIKE '.$db->Quote($queryDate).' AND sub.enabled = 1 AND sub.accept = 1';
				}
			}elseif($tabletype == 'vm'){
				if(empty($field)){
					$messages[] = 'Birthday plugin: There is no default field in VirtueMart for the birthday, please specify your VirtueMart field';
					continue;
				}

				if(!ACYMAILING_J16){
					$tableInfos = acymailing_getColumns('#__vm_user_info');
				}else{
					$tableInfos = acymailing_getColumns('#__virtuemart_userinfos');
				}

				$fields = array_keys($tableInfos);
				if(!in_array($field, $fields)){
					$messages[] = 'Birthday plugin: The field "'.$field.'" is not in the list of available VirtueMart fields : '.implode(' | ', $fields);
					continue;
				}
				if(!ACYMAILING_J16){
					$db->setQuery('SELECT `user_email` FROM `#__vm_user_info` WHERE DAY(`'.$field.'`) = '.$db->Quote($birthdayDay).' AND MONTH(`'.$field.'`)='.$db->Quote($birthdayMonth).' AND YEAR(`'.$field.'`) > 1901');
				}else{
					$db->setQuery('SELECT juser.`email` FROM `#__virtuemart_userinfos` as vm JOIN #__users as juser ON juser.id = vm.virtuemart_user_id WHERE DAY(vm.`'.$field.'`) = '.$db->Quote($birthdayDay).' AND MONTH(vm.`'.$field.'`)='.$db->Quote($birthdayMonth).' AND YEAR(vm.`'.$field.'`) > 1901');
				}
				$alluserids = acymailing_loadResultArray($db);
				if(empty($alluserids)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in VirtueMart';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.email IN (\''.implode("','", $alluserids).'\')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'jss'){
				if(empty($field)) $field = 'dob';
				$tableInfos = acymailing_getColumns('#__jss_users');
				$fields = array_keys($tableInfos);
				if(!in_array($field, $fields)){
					$messages[] = 'Birthday plugin: The field "'.$field.'" is not in the list of available jSocialSuite fields : '.implode(' | ', $fields);
					continue;
				}
				$db->setQuery('SELECT `user_id` FROM `#__jss_users` WHERE DAY(`'.$field.'`) = '.$db->Quote($birthdayDay).' AND MONTH(`'.$field.'`)='.$db->Quote($birthdayMonth).' AND YEAR(`'.$field.'`) > 1901');
				$alluserids = acymailing_loadResultArray($db);
				if(empty($alluserids)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in jSocialSuite';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.userid IN ('.implode(',', $alluserids).')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif(in_array($tabletype, array('kunena', 'fb'))){
				if(empty($field)) $field = 'birthdate';
				$tableInfos = acymailing_getColumns('#__'.$tabletype.'_users');
				$fields = array_keys($tableInfos);
				if(!in_array($field, $fields)){
					$messages[] = 'Birthday plugin: The field "'.$field.'" is not in the list of available '.$tabletype.' fields : '.implode(' | ', $fields);
					continue;
				}
				$db->setQuery('SELECT `userid` FROM `#__'.$tabletype.'_users` WHERE DAY(`'.$field.'`) = '.$db->Quote($birthdayDay).' AND MONTH(`'.$field.'`)='.$db->Quote($birthdayMonth).' AND YEAR(`'.$field.'`) > 1901');
				$alluserids = acymailing_loadResultArray($db);
				if(empty($alluserids)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in '.$tabletype;
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.userid IN ('.implode(',', $alluserids).')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'extendedreg'){
				if(empty($field)){
					$messages[] = 'Birthday plugin: There is no default field in ExtendedReg for the birthday, please specify your ExtendedReg field';
					continue;
				}
				$tableInfos = acymailing_getColumns('#__extendedreg_users');
				$fields = array_keys($tableInfos);
				$field = strtolower($field);
				if(!in_array($field, $fields)){
					$messages[] = 'Birthday plugin: The field "'.$field.'" is not in the list of available ExtendedReg fields : '.implode(' | ', $fields);
					continue;
				}
				$db->setQuery('SELECT `user_id` FROM `#__extendedreg_users` WHERE DAY(`'.$field.'`) = '.$db->Quote($birthdayDay).' AND MONTH(`'.$field.'`)='.$db->Quote($birthdayMonth).' AND YEAR(`'.$field.'`) > 1901');
				$alluserids = acymailing_loadResultArray($db);
				if(empty($alluserids)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in ExtendedReg';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.userid IN ('.implode(',', $alluserids).')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'mightyreg'){
				if(empty($field)){
					$messages[] = 'Birthday plugin: There is no default field in Mighty Registration for the birthday, please specify your Mighty Registration field';
					continue;
				}
				$fieldName = $db->Quote($field);
				$db->setQuery("SELECT `id` FROM `#__juser_extended_fields` WHERE `title` = $fieldName OR `id` = $fieldName OR `alias` = $fieldName LIMIT 1");
				$fieldId = $db->loadResult();
				if(empty($fieldId)){
					$messages[] = 'Birthday plugin: No field found in Mighty Registration with the name '.$fieldName;
					continue;
				}
				$db->setQuery('SELECT `user_id` FROM `#__juser_extended_data` WHERE `field_id` = '.intval($fieldId).' AND DAY(`fvalue`) = '.$db->Quote($birthdayDay).' AND MONTH(`fvalue`)='.$db->Quote($birthdayMonth).' AND YEAR(`fvalue`) > 1901');
				$alluserids = acymailing_loadResultArray($db);
				if(empty($alluserids)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in Mighty Registration';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.userid IN ('.implode(',', $alluserids).')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'civicrm'){
				//Load the prefix from the import file.
				$importHelper = acymailing_get('helper.import');
				if(!method_exists($importHelper, 'setciviprefix')){
					$messages[] = 'Please update AcyMailing to its latest version';
					continue;
				}
				$importHelper->setciviprefix();
				if(empty($field)) $field = 'birth_date';
				$db->setQuery('SELECT `email` FROM '.$importHelper->civiprefix.'email AS mail JOIN '.$importHelper->civiprefix.'contact AS contact ON mail.contact_id = contact.id  WHERE  DAY(`'.$field.'`) = '.$db->Quote($birthdayDay).' AND MONTH(`'.$field.'`)='.$db->Quote($birthdayMonth).' AND YEAR(`'.$field.'`) > 1901');
				$allmails = acymailing_loadResultArray($db);
				if($allmails === null){
					$messages[] = $db->getErrorMsg();
					continue;
				}
				if(empty($allmails)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in CiviCRM';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.email IN ("'.implode('","', $allmails).'") AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'ajaxregister'){
				if(empty($field)) $field = '3';
				$fieldName = $db->Quote($field);
				$db->setQuery("SELECT `id` FROM `#__ajaxregister_fields` WHERE `label` = $fieldName OR `id` = $fieldName LIMIT 1");
				$fieldId = $db->loadResult();
				if(empty($fieldId)){
					$messages[] = 'Birthday plugin: No field found in AJAX Register with the name '.$fieldName.'. Please specify the field ID directly (example : 3)';
					continue;
				}
				$db->setQuery('SELECT `user_id` FROM `#__ajaxregister_field_values` WHERE `field_id` = '.intval($fieldId).' AND DAY(`value`) = '.$db->Quote($birthdayDay).' AND MONTH(`value`)='.$db->Quote($birthdayMonth).' AND YEAR(`value`) > 1901');
				$alluserids = acymailing_loadResultArray($db);
				if(empty($alluserids)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in Ajax register';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.userid IN ('.implode(',', $alluserids).')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'joomla'){
				//We hard code it for Joomla
				$field = 'profile.dob';
				$fieldName = $db->Quote($field);
				$db->setQuery('SELECT `user_id` FROM `#__user_profiles` WHERE `profile_key` = '.$fieldName.' AND DAY(TRIM(BOTH \'"\' FROM `profile_value`)) = '.$db->Quote($birthdayDay).' AND MONTH(TRIM(BOTH \'"\' FROM `profile_value`))='.$db->Quote($birthdayMonth).' AND YEAR(TRIM(BOTH \'"\' FROM `profile_value`)) > 1901');
				$alluserids = acymailing_loadResultArray($db);
				if(empty($alluserids)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in Joomla';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.userid IN ('.implode(',', $alluserids).')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'hikashop'){
				if(empty($field)){
					$messages[] = 'Birthday plugin: There is no default field in HikaShop for the birthday, please specify your HikaShop field';
					continue;
				}
				$fieldName = $db->Quote($field);
				$db->setQuery("SELECT * FROM `#__hikashop_field` WHERE (`field_realname` = $fieldName OR `field_namekey` = $fieldName OR `field_id` = $fieldName ) AND field_table = 'user' LIMIT 1");
				$fieldObject = $db->loadObject();
				if(empty($fieldObject->field_namekey)){
					$messages[] = 'Birthday plugin: No field found in HikaShop with the name '.$fieldName;
					continue;
				}
				if(!empty($fieldObject->field_options)) $fieldObject->field_options = unserialize($fieldObject->field_options);
				if(empty($fieldObject->field_options['format']) OR $fieldObject->field_type == 'birthday' OR substr($fieldObject->field_options['format'], 0, 8) == '%Y-%m-%d'){
					$selectUsers = 'SELECT user_email FROM #__hikashop_user WHERE DAY(`'.$fieldObject->field_namekey.'`) = '.$db->Quote($birthdayDay).' AND MONTH(`'.$fieldObject->field_namekey.'`)='.$db->Quote($birthdayMonth);
				}else{
					$conditionDate = strftime(str_replace(array('%y', '%Y'), 'XXXX', $fieldObject->field_options['format']), $birthday);
					$queryDate = str_replace('XXXX', '%', $conditionDate);
					if(strpos($conditionDate, '%') !== false || (strpos($queryDate, '%') !== 0 AND strpos($queryDate, '%') !== (strlen($queryDate) - 1))){
						$messages[] = 'Could not handle the format '.$fieldObject->field_options['format'].' in the specified HikaShop birthday field';
						continue;
					}
					$selectUsers = 'SELECT user_email FROM #__hikashop_user WHERE `'.$fieldObject->namekey.'` LIKE '.$db->Quote($queryDate);
				}
				$db->setQuery($selectUsers);
				$alluserids = acymailing_loadResultArray($db);
				if(empty($alluserids)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in HikaShop';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.email IN (\''.implode("','", $alluserids).'\')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'eventbooking'){
				if(empty($field)){
					$messages[] = 'Birthday plugin: There is no default field in EventBooking for the birthday, please specify your EventBooking field';
					continue;
				}
				$fieldName = $db->Quote($field);
				$db->setQuery("SELECT `id` FROM `#__eb_fields` WHERE `name` = $fieldName OR `id` = $fieldName OR `title` = $fieldName LIMIT 1");
				$fieldId = $db->loadResult();
				if(empty($fieldId)){
					$messages[] = 'Birthday plugin: No field found in EventBooking with the name '.$fieldName;
					continue;
				}
				$db->setQuery('SELECT b.`email` FROM `#__eb_field_values` as a JOIN #__eb_registrants as b ON a.registrant_id = b.id WHERE a.`field_id` = '.intval($fieldId).' AND DAY(a.`field_value`) = '.$db->Quote($birthdayDay).' AND MONTH(a.`field_value`)='.$db->Quote($birthdayMonth).' AND YEAR(a.`field_value`) > 1901');
				$allemails = acymailing_loadResultArray($db);
				if(empty($allemails)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in EventBooking';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.email IN (\''.implode("','", $allemails).'\')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'easysocial'){
				if(empty($field)){
					$messages[] = 'Birthday plugin: There is no default field in EasySocial for the birthday, please specify the birthday field\'s ID or unique key visible in the table "social_fields"';
					continue;
				}

				$fieldName = $db->Quote($field);
				$db->setQuery("SELECT `id` FROM `#__social_fields` WHERE `unique_key` = $fieldName OR `id` = $fieldName LIMIT 1");
				$fieldId = $db->loadResult();
				if(empty($fieldId)){
					$messages[] = 'Birthday plugin: No field found in EasySocial with the id or unique key '.$fieldName;
					continue;
				}

				$db->setQuery('SELECT a.email FROM #__users AS a JOIN #__social_fields_data AS b ON a.id = b.uid WHERE b.field_id = '.intval($fieldId).' AND b.raw LIKE \'%-'.$birthdayMonth.'-'.$birthdayDay.' %\'');
				$allemails = acymailing_loadResultArray($db);
				if(empty($allemails)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in EasySocial';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.email IN (\''.implode("','", $allemails).'\')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'joomshopping'){
				if(empty($field)){
					$db->setQuery('SELECT a.email FROM #__users AS a JOIN #__jshopping_users AS b ON a.id = b.user_id WHERE b.birthday LIKE \'%-'.$birthdayMonth.'-'.$birthdayDay.'\'');
				}else{
					$tableFields = acymailing_getColumns('#__jshopping_users');
					$fields = array_keys($tableFields);
					if(!in_array($field, $fields)){
						$messages[] = 'Birthday plugin: The field "'.$field.'" is not in the list of available JoomShopping fields : '.implode(' | ', $fields);
						continue;
					}
					$db->setQuery('SELECT a.email FROM #__users AS a JOIN #__jshopping_users AS b ON a.id = b.user_id WHERE b.'.acymailing_secureField($field).' LIKE \'%-'.$birthdayMonth.'-'.$birthdayDay.'\'');
				}
				$allemails = acymailing_loadResultArray($db);
				if(empty($allemails)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in JoomShopping';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.email IN (\''.implode("','", $allemails).'\')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'fabrik'){
				if(empty($field) || !strpos($field, ',')){
					$messages[] = 'Birthday plugin: Fabrik: Please enter the "full element name" of the email field then the birthday field (separated by a coma) in the "Birthday field" option in this plugin\'s configuration.';
					continue;
				}

				$fields = explode(',', $field);
				$tablename = substr($fields[0], 0, strpos($fields[0], '___'));
				$emailfield = substr($fields[0], strpos($fields[0], '___') + 3);
				$birthdayfield = substr($fields[1], strpos($fields[1], '___') + 3);

				$db->setQuery('SELECT '.acymailing_secureField($emailfield).' FROM `'.$tablename.'` WHERE '.acymailing_secureField($birthdayfield).' LIKE \'%-'.$birthdayMonth.'-'.$birthdayDay.'%\'');
				$allemails = acymailing_loadResultArray($db);
				if(empty($allemails)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.email IN (\''.implode("','", $allemails).'\')  AND sub.enabled = 1 AND sub.accept = 1';
			}elseif($tabletype == 'easyprofile'){
				if(empty($field)){
					$messages[] = 'Birthday plugin: There is no default field in EasyProfile for the birthday, please specify the birthday field\'s alias visible in the table "jsn_users" or when editing the birthday field';
					continue;
				}

				$db->setQuery('SELECT id FROM #__jsn_users WHERE '.acymailing_secureField($field).' LIKE \'%-'.$birthdayMonth.'-'.$birthdayDay.' %\' AND id != 0');
				$allids = acymailing_loadResultArray($db);

				if(empty($allids)){
					$messages[] = 'Birthday plugin: No user with '.$birthdayDay.'-'.$birthdayMonth.' as birthday in EasyProfile';
					continue;
				}
				$finalQuery = 'INSERT IGNORE INTO `#__acymailing_queue` (`subid`,`mailid`,`priority`,`senddate`) SELECT sub.`subid`,'.$mailid.',1,'.$senddate.' FROM `#__acymailing_subscriber` as sub '.$join.' WHERE '.$where.' sub.userid IN (\''.implode("','", $allids).'\')  AND sub.enabled = 1 AND sub.accept = 1';
			}else{
				$messages[] = 'Unknown table specified: '.$tabletype;
				continue;
			}

			$this->success = true;

			$db->setQuery($finalQuery);
			$db->query();
			$nbInserted = $db->getAffectedRows();
			$messages[] = 'Birthday plugin: '.$nbInserted.' birthday e-mails inserted in the queue for '.$birthdayDay.'-'.$birthdayMonth.' using the '.$tabletype.' birthday';
		}

		return implode('<br />', $messages);
	}

	function onAcyPlgbirthday(){
		$app = JFactory::getApplication();
		if(!$app->isAdmin()) return;

		// Get the previously saved setups
		$config =& acymailing_config();
		if($config->get('version') < '5.0.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}
		$birthPluginData = $config->get('birthplugin', '');

		// Get the current ID
		$thisId = 1;
		if(!empty($birthPluginData)){
			$savedConfig = json_decode($birthPluginData, true);
			if(!empty($savedConfig)) $thisId = max(array_keys($savedConfig)) + 1;
		}

		// Test the setup
		if(JRequest::getString('action', '') == 'test'){
			$this->test = JRequest::getInt('id');

			$messages = array();
			$messages[] = 'Mailid : '.intval($savedConfig[$this->test]['mailid']);
			$messages[] = 'Table : '.$savedConfig[$this->test]['birthdaytable'];
			$messages[] = 'Field : '.$savedConfig[$this->test]['birthdayfield'];

			$messages[] = $this->onAcyCronTrigger();

			$nextDate = $config->get('cron_plugins_next');
			if(!empty($nextDate)) $messages[] = ' ('.JText::_('NEXT_RUN').' : '.acymailing_getDate($nextDate, '%d %B %H:%M').')';

			acymailing_display($messages, ($this->success ? 'success' : 'error'));
		}

		// Save the setup
		if(JRequest::getString('action', '') == 'save'){
			$newSetup = array('mailid' => JRequest::getInt('mailid', ''), 'nbdays' => JRequest::getInt('nbdays', '0'), 'sendtime' => JRequest::getString('sendtime', '8:00'), 'birthdaytable' => JRequest::getString('birthdaytable', ''), 'birthdayfield' => JRequest::getString('birthdayfield', ''), 'listids' => JRequest::getString('listids', ''), 'id' => JRequest::getInt('id'));
			if(empty($newSetup['mailid']) || empty($newSetup['birthdaytable'])){
				acymailing_display(JText::_('FILL_ALL'), 'error');
			}else{
				if(!empty($savedConfig)){
					$savedConfig[$newSetup['id']] = $newSetup;
				}else $savedConfig = array($newSetup['id'] => $newSetup);

				$newConfig = new stdClass();
				$newConfig->birthplugin = json_encode($savedConfig);
				$config->save($newConfig);
				acymailing_display(JText::_('JOOMEXT_SUCC_SAVED'), 'success');
			}
			$thisId++;
		}

		// Delete a setup
		if(JRequest::getString('action', '') == 'delete'){
			$idToDelete = JRequest::getInt('id', '0');
			unset($savedConfig[$idToDelete]);

			$newConfig = new stdClass();
			$newConfig->birthplugin = json_encode($savedConfig);
			$config->save($newConfig);
			acymailing_display(JText::sprintf('SUCC_DELETE_ELEMENTS', 1), 'success');
		}

		?>

		<script language="javascript" type="text/javascript">
			<!--
			function setaction(action, id){
				document.getElementById('action').value = action;
				document.getElementById('id').value = id;
			}
			//-->
		</script>
		<div id="iframelists"></div>
		<div id="maincontent" style="border:1px solid rgb(233, 233, 233);height:98%;">
			<form method="post" name="adminForm" id="adminForm">
				<div id="formarea" style="width:100%;height:215px;text-align: center;">
					<?php if(JRequest::getString('action', '') == 'edit'){ ?>
						<div style="float:right;">
							<button class="btn btn-primary" type="button" onclick="submitbutton();"><?php echo JText::_('ACY_EDIT'); ?></button>
							<button style="margin:20px 35px 20px 0px;" class="btn btn-primary" type="button" onclick="setaction('cancel',0);submitbutton();"><?php echo JText::_('ACY_CANCEL'); ?></button>
						</div>
					<?php }else{ ?>
						<button style="float:right;margin:20px 35px 20px 0px;" class="btn btn-primary" type="button" onclick="submitbutton();"><?php echo JText::_('ACY_SAVE'); ?></button>
					<?php } ?>
					<table style="width:100%;">
						<?php
						// Display the creation form
						$form = JForm::getInstance('birthday', JPATH_SITE.DS.'components'.DS.'com_acymailing'.DS.'params'.DS.'birthday.xml');
						$fields = $form->getFieldset('birthdayparams');

						// Edit a setup
						if(JRequest::getString('action', '') == 'edit'){
							$thisId = JRequest::getInt('id');
							$fields['mailid']->value = $savedConfig[$thisId]['mailid'];
							$fields['birthdaytable']->value = $savedConfig[$thisId]['birthdaytable'];
							$fields['sendtime']->value = $savedConfig[$thisId]['sendtime'];
							$fields['birthdayfield']->value = $savedConfig[$thisId]['birthdayfield'];
							$fields['nbdays']->value = $savedConfig[$thisId]['nbdays'];
							$fields['listids']->value = $savedConfig[$thisId]['listids'];
						}

						$iFrame = "'<iframe src=\'index.php?option=com_acymailing&tmpl=component&ctrl=chooselist&popup=0&task=listids&values=".$fields['listids']->value."\' width=\'98%\' height=\'100%\' scrolling=\'auto\'></iframe>'";
						$script = "var openLists = true;
									function displayLists(){
										var box=$('iframelists');
										if(openLists){
											box.innerHTML = ".$iFrame.";
											box.setStyle('display','block');
										}

										try{
											var fx = box.effects({duration: 1500, transition: Fx.Transitions.Quart.easeOut});
											if(openLists){
												fx.start({'height': 300});
											}else{
												fx.start({'height': 0}).chain(function(){
													box.innerHTML = '';
													box.setStyle('display','none');
												});
											};
										}catch(err){
											box.style.height = '300px';
											var myVerticalSlide = new Fx.Slide('iframelists');
											if(openLists){
												myVerticalSlide.slideIn();
											}else{
												myVerticalSlide.slideOut().chain(function(){
													box.innerHTML='';
													box.setStyle('display','none');
												});
											}
										}
										openLists = !openLists;
									}";
						$doc = JFactory::getDocument();
						$doc->addScriptDeclaration($script);

						?>
						<tr>
							<td><?php echo $fields['mailid']->label; ?></td>
							<td><?php echo $fields['mailid']->input; ?></td>
							<td><?php echo $fields['birthdaytable']->label; ?></td>
							<td><?php echo $fields['birthdaytable']->input; ?></td>
						</tr>
						<tr>
							<td><?php echo $fields['sendtime']->label; ?></td>
							<td><?php echo $fields['sendtime']->input; ?></td>
							<td><?php echo $fields['birthdayfield']->label; ?></td>
							<td><?php echo $fields['birthdayfield']->input; ?></td>
						</tr>
						<tr>
							<td style="width:15%;"><?php echo $fields['nbdays']->label; ?></td>
							<td><?php echo $fields['nbdays']->input; ?></td>
							<td><?php echo $fields['listids']->label; ?></td>
							<td>
								<input class="inputbox" id="paramslistids" name="listids" type="text" style="width:122px" value="<?php echo $fields['listids']->value; ?>">
								<button class="btn" style="margin-top:-10px;" onclick="displayLists();return false"><?php echo JText::_('SELECT'); ?></button>
							</td>
						</tr>
					</table>
				</div>
				<div id="listarea" style="text-align: center;box-shadow: 0px -4px 4px -4px rgba(0, 0, 0, 0.3);padding: 10px 0px 10px 0px;">
					<?php
					// Display the list of saved configurations
					if(!empty($savedConfig)){
						$mailClass = acymailing_get('class.mail');
						echo '<table style="width:100%"><tr><th>'.$fields['birthdaytable']->label.'</th><th>'.$fields['mailid']->label.'</th><th>'.$fields['acymailing']->label.'</th><th>'.JText::_('ACY_EDIT').'</th><th>'.JText::_('ACY_DELETE').'</th></tr>';
						foreach($savedConfig as $oneSetup){
							$style = '';
							if(JRequest::getString('action', '') == 'edit' && $thisId == $oneSetup['id']) $style = ' style="background-color:gainsboro;"';
							echo '<tr'.$style.'><td>'.$oneSetup['birthdaytable'].'</td>';
							$thisMail = $mailClass->get($oneSetup['mailid']);
							echo '<td>'.$thisMail->subject.'</td>
									<td><button class="acymailing_button" type="button" onclick="setaction(\'test\','.$oneSetup['id'].');submitbutton();">'.JText::_('ABTESTING_TEST').'</button></td>
									<td><button class="acymailing_button" type="button" onclick="setaction(\'edit\','.$oneSetup['id'].');submitbutton();">'.JText::_('ACY_EDIT').'</button></td>
									<td><button class="acymailing_button" type="button" onclick="setaction(\'delete\','.$oneSetup['id'].');submitbutton();">'.JText::_('ACY_DELETE').'</button></td>
								</tr>';
						}
						echo '</table>';
					}
					?>
				</div>
				<input type="hidden" name="action" id="action" value="save">
				<input type="hidden" name="id" id="id" value="<?php echo $thisId; ?>">
			</form>
		</div>
	<?php
	}
}//endclass