<?php
/**
 * @copyright	Copyright (C) 2009-2015 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die();

require_once JPATH_ADMINISTRATOR . '/components/com_finder/helpers/indexer/adapter.php';

class PlgAcymailingPlgfinder extends FinderIndexerAdapter
{
	protected $context = 'AcyMailing';
	protected $extension = 'com_acymailing';
	protected $layout = 'newsletter';
	protected $type_title = 'Newsletter';
	protected $table = '#__acymailing_mail';
	protected $autoloadLanguage = true;

	function onAcyBeforeMailDelete(&$elements){
		if(empty($elements)) return;
		foreach($elements as &$oneElement){
			$oneElement = trim($oneElement, "'");
		}
		$db = JFactory::getDBO();
		$db->setQuery('SELECT link_id FROM #__finder_links WHERE url LIKE "index.php?option=com_acymailing&ctrl=archive&task=view&mailid='.implode('" OR url LIKE "index.php?option=com_acymailing&ctrl=archive&task=view&mailid=', $elements).'"');
		$links = acymailing_loadResultArray($db);
		if(empty($links)) return;
		foreach($links as &$oneLink){
			$this->indexer->remove($oneLink);
		}
	}

	function onAcyBeforeMailCreate(&$mail){
		$this->indexMail($mail);
	}

	function onAcyBeforeMailModify(&$mail){
		$this->indexMail($mail);
	}

	protected function setup(){}
	protected function index(FinderIndexerResult $item, $format = 'html'){}

	protected function indexMail(&$mail){
		if(JComponentHelper::isEnabled($this->extension) == false || empty($mail->body)) return;
		$array = array();
		$item = JArrayHelper::toObject($array, 'FinderIndexerResult');

		$item->url = 'index.php?option=com_acymailing&ctrl=archive&task=view&mailid='.$mail->mailid;
		$item->route = $item->path = $item->url;
		$item->body = $mail->body;
		if(!empty($mail->summary)){
			$item->summary = $mail->summary;
		}else{
			$item->summary = substr(strip_tags($mail->body), 0, 350);
		}
		$item->description = $item->summary;
		$item->type_id = $this->type_id;
		$item->title = $mail->subject;
		$item->published = empty($mail->published) ? 0 : 1;
		$item->access = empty($mail->visible) ? 0 : 1;
		$item->state = $item->published;
		$title = $this->getItemMenuTitle($item->url);
		if(!empty($title) && $this->params->get('use_menu_title', true)) $item->title = $title;
		$item->addTaxonomy('Type', 'Newsletter');
		$item->language = empty($mail->language) ? '*' : $mail->language;
		$item->addTaxonomy('Language', $item->language);
		FinderIndexerHelper::getContentExtras($item);
		if(ACYMAILING_J30) $this->indexer->index($item);
		else FinderIndexer::index($item);
	}
}