<?php
/**
 * @copyright	Copyright (C) 2009-2015 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingRedshop extends JPlugin
{
	function plgAcymailingRedshop(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'redshop');
			$this->params = new acyParameter( $plugin->params );
		}
	}

	function onAcyDisplayFilters(&$type,$context="massactions"){

		if($this->params->get('displayfilter_'.$context,true) == false) return;


		$db = JFactory::getDBO();
		$db->setQuery("SELECT `product_id` as value, CONCAT(`product_id`,' ( ',`product_name`,' ) ') as text FROM #__redshop_product ORDER BY `product_id` ASC");
		$allProducts = $db->loadObjectList();
		if(!empty($allProducts)){
			$selectOne = null;
			$selectOne->value = 0;
			$selectOne->text = JText::_('ACY_ONE_PRODUCT');
			array_unshift($allProducts,$selectOne);
		}

		$redshopbuy = array();
		$redshopbuy[] = JHTML::_('select.option', '0', JText::_('ACY_DIDNOTBOUGHT') );
		$redshopbuy[] = JHTML::_('select.option', '1', JText::_('ACY_BOUGHT') );


		//RedShop Groups
		$redshopgroupsparams = acymailing_get('type.operatorsin');
		$redshopgroupsparams->js = 'onchange="countresults(__num__)"';
		$operators = acymailing_get('type.operators');
		$operators->extra = 'onchange="countresults(__num__)"';
		$db->setQuery('SELECT `shopper_group_id` as value, `shopper_group_name` as text FROM `#__redshop_shopper_group` ORDER BY `shopper_group_name` ASC');
		$redshopgroups = $db->loadObjectList();

		//RedShop  Fields
		$fields = acymailing_getColumns('#__redshop_users_info');
		$redshopfield = array();
		foreach($fields as $oneField => $fieldType){
			$redshopfield[] = JHTML::_('select.option',$oneField,$oneField);
		}

		//Status
		$db->setQuery('SELECT order_status_code as code, order_status_name as name FROM `#__redshop_order_status` WHERE `published` = 1');
		$allStatus = $db->loadObjectList();
		if(!empty($allStatus)){
			$firstStatus = null;
			$firstStatus->name = JText::_('ALL_STATUS');
			$firstStatus->code = '';
			array_unshift($allStatus,$firstStatus);
		}

		$return = '';
		if(!empty($allProducts)){
			$return .= '<div id="filter__num__redshoporder">'.JHTML::_('select.genericlist', $redshopbuy, "filter[__num__][redshoporder][type]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text',1).' ';
			$return .= JHTML::_('select.genericlist',   $allProducts, "filter[__num__][redshoporder][product]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text').' '.JHTML::_('select.genericlist',   $allStatus, "filter[__num__][redshoporder][status]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'code', 'name');
			$return .= '<br /> <input type="text" name="filter[__num__][redshoporder][creationdateinf]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" /> < '.JText::_('CREATED_DATE').' < <input type="text" name="filter[__num__][redshoporder][creationdatesup]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" />';
			$return .= '</div>';
			$type['redshoporder'] = 'RedShop : '.JText::_('ACY_PRODUCTS');
		}

		if(!empty($redshopgroups)){
			$return .= '<div id="filter__num__redshopgroups">'.$redshopgroupsparams->display("filter[__num__][redshopgroups][type]").' ';
			$return .= JHTML::_('select.genericlist', $redshopgroups, "filter[__num__][redshopgroups][group]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
			$return .= '</div>';
			$type['redshopgroups'] = 'RedShop : '.JText::_('SHOPPER_GROUP');
		}

		if(!empty($redshopfield)){
			$return .= '<div id="filter__num__redshopfield">'.JHTML::_('select.genericlist',   $redshopfield, "filter[__num__][redshopfield][map]", 'class="inputbox" size="1" onchange="countresults(__num__)"', 'value', 'text');
			$return .= ' '.$operators->display("filter[__num__][redshopfield][operator]").' <input class="inputbox" type="text" name="filter[__num__][redshopfield][value]" style="width:200px" value="" onchange="countresults(__num__)" >';
			$return .= '</div>';
			$type['redshopfield'] = 'RedShop : '.JText::_('FIELD');
		}

		return $return;
	}

	function onAcyProcessFilterCount_redshopfield(&$query,$filter,$num){
		$this->onAcyProcessFilter_redshopfield($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_redshopfield(&$query,$filter,$num){
		$myquery = "SELECT DISTINCT a.user_email FROM #__redshop_users_info as a WHERE a.user_email LIKE '%@%' AND ".$query->convertQuery('a',$filter['map'],$filter['operator'],$filter['value']);
		$query->db->setQuery($myquery);
		$allEmails  = acymailing_loadResultArray($query->db);
		if(empty($allEmails)) $allEmails[] = 'none';

		$myquery = "SELECT DISTINCT a.user_id FROM #__redshop_users_info as a WHERE a.user_id > 0 AND ".$query->convertQuery('a',$filter['map'],$filter['operator'],$filter['value']);
		$query->db->setQuery($myquery);
		$allUserids  = acymailing_loadResultArray($query->db);
		if(empty($allEmails)) $allEmails[] = 'none';
		if(empty($allUserids)) $allUserids[] = '-1';

		$query->where[] = "sub.email IN ('".implode("','",$allEmails)."') OR sub.userid IN ('".implode("','",$allUserids)."')";

	}

	function onAcyProcessFilterCount_redshopgroups(&$query,$filter,$num){
		$this->onAcyProcessFilter_redshopgroups($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_redshopgroups(&$query,$filter,$num){
		$myquery = 'SELECT DISTINCT b.`user_email`,b.user_id FROM `#__redshop_shopper_group` as a JOIN `#__redshop_users_info` as b on a.`shopper_group_id` = b.`shopper_group_id` WHERE a.`shopper_group_id` = '.intval($filter['group']);
		$query->db->setQuery($myquery);
		$allUsers  = $query->db->loadObjectList();
		$allEmails = array('none');
		$allUserids = array('-1');
		foreach($allUsers as $oneUser){
			if($oneUser->user_id>0) $allUserids[] = $oneUser->user_id;
			if(strpos($oneUser->user_email,'@')) $allEmails[] = $oneUser->user_email;
		}
		$query->where[] = "sub.email ".(($filter['type'] == 'IN') ? 'IN' : 'NOT IN')." ('".implode("','",$allEmails)."') ".(($filter['type'] == 'IN') ? 'OR' : 'AND')." ( sub.userid ".(($filter['type'] == 'IN') ? 'IN' : 'IS NULL OR sub.userid NOT IN')." ('".implode("','",$allUserids)."') )";
	}

	function onAcyProcessFilterCount_redshoporder(&$query,$filter,$num){
		$this->onAcyProcessFilter_redshoporder($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_redshoporder(&$query,$filter,$num){
		//We load all users who bought and will do a ! IN if the user didn't bought
		//We use the user_email as the user may not have uid

		$myquery = "SELECT DISTINCT b.user_email FROM #__redshop_order_item as a LEFT JOIN #__redshop_users_info as b on a.user_info_id = b.users_info_id ";
		$where = array();

		if(!empty($filter['product']) AND is_numeric($filter['product']))  $where[] = "a.product_id = ".(int) $filter['product'];

		$datesVar = array('creationdatesup','creationdateinf');
		foreach($datesVar as $oneDate){
			if(empty($filter[$oneDate])) continue;
			$filter[$oneDate] = acymailing_replaceDate($filter[$oneDate]);
			if(!is_numeric($filter[$oneDate])) $filter[$oneDate] = strtotime($filter[$oneDate]);
		}
		if(!empty($filter['creationdateinf'])) $where[] = ' a.cdate > '.$filter['creationdateinf'];
		if(!empty($filter['creationdatesup'])) $where[] = ' a.cdate < '.$filter['creationdatesup'];
		if(!empty($filter['status'])) $where[] = "a.`order_status` = ".$query->db->Quote($filter['status']);

		if(!empty($where)) $myquery .= 'WHERE '.implode(' AND ',$where);

		$query->db->setQuery($myquery);
		$allEmails  = acymailing_loadResultArray($query->db);
		//Just to avoid no result...
		if(empty($allEmails)) $allEmails[] = 'none';
		if(empty($filter['type'])){
			//Not in!
			$query->where[] =  "sub.email NOT IN ('".implode("','",$allEmails)."')";
		}else{
			$query->where[] =  "sub.email IN ('".implode("','",$allEmails)."')";
		}
	}
}//endclass
