<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingRokdownloads extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'rokdownloads');
			$this->params = new acyParameter( $plugin->params );
		}
	}

	function acymailing_getPluginType() {
		$app = JFactory::getApplication();
	 	if($this->params->get('frontendaccess') == 'none' AND !$app->isAdmin()) return;
	 	$onePlugin = new stdClass();
	 	$onePlugin->name = 'RokDownloads';
	 	$onePlugin->function = 'acymailingrokdownloads_show';
	 	$onePlugin->help = 'plugin-rokdownloads';
	 	return $onePlugin;
	 }
	 function acymailingrokdownloads_show(){

	 	$config = acymailing_config();
		if($config->get('version') < '4.0.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$lang = JFactory::getLanguage();
		$lang->load('com_rokdownloads',JPATH_SITE);
		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.rokdownloads';

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order',	'id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir',	'desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->titlelink = $app->getUserStateFromRequest( $paramBase.".titlelink", 'titlelink','|link','string' );
		$pageInfo->download = $app->getUserStateFromRequest( $paramBase.".download", 'download','|download','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','|pict:1','string' );
		$pageInfo->contenttype = $app->getUserStateFromRequest( $paramBase.".contenttype", 'contenttype','|type:intro','string' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->autotitlelink = $app->getUserStateFromRequest( $paramBase.".autotitlelink", 'autotitlelink','|link','string' );
		$pageInfo->autopict = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','|pict:1','string' );
		$pageInfo->automaxvalue = $app->getUserStateFromRequest( $paramBase.".max", 'max','20','int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','|filter:created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','|order:id','string' );
		$pageInfo->autocontenttype = $app->getUserStateFromRequest( $paramBase.".autocontenttype", 'autocontenttype','|type:intro','string' );
		$pageInfo->downloadauto = $app->getUserStateFromRequest( $paramBase.".download", 'download','|download','string' );

		$db = JFactory::getDBO();

		$searchFields = array('id','name','path','filesize');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.$db->getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart','all') == 'onlypub'){
			$filters[] = "published = 1";
		}
		else{
			$filters[] = "published != -2";
		}
		$filters[] = "folder != 1";

		$query = 'SELECT * FROM #__rokdownloads';

		if(!empty($pageInfo->filter_cat)){
			$query2 = 'SELECT * FROM #__rokdownloads WHERE id='.$pageInfo->filter_cat;
			$db->setQuery($query2);
			$cats = $db->loadObject();
			$filters[] = "lft > ".$cats->lft. " AND rgt < ".$cats->rgt;
		}
		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (',$filters).')';
		}

		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$type = JRequest::getString('type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass){
				if(selectedContents[contentid]){
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[contentid];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents[contentid] = 'content';
				}

				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				for(var i=0; i < document.adminForm.contenttype.length; i++){
					 if (document.adminForm.contenttype[i].checked){ selectedtype = document.adminForm.contenttype[i].value; otherinfo += document.adminForm.contenttype[i].value; }
				}
				if(selectedtype != '|type:title'){
					for(var i=0; i < document.adminForm.pict.length; i++){
						 if (document.adminForm.pict[i].checked){ otherinfo += document.adminForm.pict[i].value; }
					}
				}
				for(var i=0; i < document.adminForm.titlelink.length; i++){
					 if (document.adminForm.titlelink[i].checked){ otherinfo += document.adminForm.titlelink[i].value; }
				}
				for(var i=0; i < document.adminForm.download.length; i++){
					if (document.adminForm.download[i].checked){ otherinfo += document.adminForm.download[i].value; }
				}
				for(var i in selectedContents){
					if(selectedContents[i] == 'content'){
						tag = tag + '{rokdownloads:'+i+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass){
				if(selectedCat[catid]){
					window.document.getElementById('cat'+catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat'+catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}

				updateTagAuto();
			}

			function updateTagAuto(){
				tag = '{autorokdownloads:';

				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat+'-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value!=0){ tag += '|min:'+document.adminForm.min_article.value; }
				if(document.adminForm.max_article.value && document.adminForm.max_article.value!=0){ tag += '|max:'+document.adminForm.max_article.value; }
				for(var i=0; i < document.adminForm.contenttypeauto.length; i++){
					 if (document.adminForm.contenttypeauto[i].checked){ selectedtype = document.adminForm.contenttypeauto[i].value; tag += document.adminForm.contenttypeauto[i].value; }
				}
				for(var i=0; i < document.adminForm.downloadauto.length; i++){
					if (document.adminForm.downloadauto[i].checked){ tag += document.adminForm.downloadauto[i].value; }
				}
				if(selectedtype != '|type:title'){
					for(var i=0; i < document.adminForm.autopict.length; i++){
						 if (document.adminForm.autopict[i].checked){ tag += document.adminForm.autopict[i].value; }
					}
				}
				for(var i=0; i < document.adminForm.autotitlelink.length; i++){
					 if (document.adminForm.autotitlelink[i].checked){ tag += document.adminForm.autotitlelink[i].value; }
				}

				if(document.adminForm.contentorder.value){ tag += document.adminForm.contentorder.value; }
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){ tag += document.adminForm.contentfilter.value; }

				tag += '}';

				setTag(tag);
			}
		//-->
		</script>
		<?php
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "|pict:1",JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "|pict:resized",JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "|pict:0",JText::_('JOOMEXT_NO'));

		$ordering = array();
		$ordering[] = JHTML::_('select.option', "|order:id,DESC",JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "|order:created_time,DESC",JText::_('CREATED_DATE'));
		$ordering[] = JHTML::_('select.option', "|order:modified_time,DESC",JText::_('MODIFIED_DATE'));
		$ordering[] = JHTML::_('select.option', "|order:displayname,ASC",JText::_('FIELD_TITLE'));

		$contenttype = array();
		$contenttype[] = JHTML::_('select.option', "|type:title",JText::_('TITLE_ONLY'));
		$contenttype[] = JHTML::_('select.option', "|type:intro",JText::_('CATEGORY_VIEW'));
		$contenttype[] = JHTML::_('select.option', "|type:full",JText::_('DETAILS_VIEW'));

		$download = array();
		$download[] = JHTML::_('select.option', "|download",JText::_('JOOMEXT_YES'));
		$download[] = JHTML::_('select.option', "",JText::_('JOOMEXT_NO'));

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'rokdownloads_tab');
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), 'rokdownloads_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td colspan="3"><?php echo JHTML::_('select.radiolist', $contenttype, 'contenttype' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?></td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td>
					<?php $titlelinkType = acymailing_get('type.titlelink'); echo $titlelinkType->display('titlelink',$pageInfo->titlelink);?>
				</td>
				 <td>
				<?php echo JText::_('DOWNLOAD'); ?>
				 </td>
				 <td>
				 	<?php echo JHTML::_('select.radiolist', $download, 'download' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->download); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td colspan="3">
					<?php echo JHTML::_('select.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', '|pict:resized');?>
				</td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'displayname', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'ATTACHED_FILES'), 'name', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'CREATED_DATE'), 'created_time', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					for($i = 0,$a = count($rows);$i<$a;$i++){
						$row =& $rows[$i];
				?>
					<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
						<td>
						<?php
							$text = '<b>'.JText::_('JOOMEXT_ALIAS').' : </b>'.$row->displayname;
							$text .= '<br /><b>'.JText::_('ACY_USERNAME',true).' : </b>'.$row->created_by;
							echo acymailing_tooltip($text, $row->introtext, '', $row->displayname);
						?>
						</td>
						<td>
							<?php echo $row->name; ?>
						</td>
						<td>
							<?php echo $row->created_time; ?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->id; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
	<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), 'rokdownloads_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td colspan="3"><?php echo JHTML::_('select.radiolist', $contenttype, 'contenttypeauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autocontenttype); ?></td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td>
					<?php $titlelinkType = acymailing_get('type.titlelink'); $titlelinkType->onclick='updateTagAuto();'; echo $titlelinkType->display('autotitlelink',$pageInfo->autotitlelink);?>
				</td>
				<td>
				<?php echo JText::_('DOWNLOAD'); ?>
				 </td>
				 <td>
				 	<?php echo JHTML::_('select.radiolist', $download, 'downloadauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->downloadauto); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td colspan="3">
				<?php echo JHTML::_('select.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict);?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('MAX_ARTICLE'); ?>
				 </td>
				 <td>
				 	<input name="max_article" size="10" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
				<td>
				<?php echo JText::_('ACY_ORDER'); ?>
				 </td>
				 <td>
				 	<?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td>
				<?php 	echo JText::_('MIN_ARTICLE'); ?>
				 </td>
				 <td>
				 <input name="min_article" size="10" value="1" onchange="updateTagAuto();"/>
				</td>
				<td>
				<?php echo JText::_('ACY_FILTER'); ?>
				 </td>
				 <td>
				 	<?php $filter = acymailing_get('type.contentfilter'); $filter->onclick='updateTagAuto();'; echo $filter->display('contentfilter',$pageInfo->contentfilter); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
		<table class="adminlist" cellpadding="1" width="100%">
		<?php $k=0; foreach($this->catvalues as $oneCat){
			 if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	 }

	 function _categories($filter_cat){
		//select all cats
		$db = JFactory::getDBO();
		$query = "select DISTINCT node.id as child, node.displayname as childname, node.path as childpath " .
			"FROM #__rokdownloads as node " .
			"WHERE folder = 1 " .
			"ORDER BY node.lft ";
		$db->setQuery($query);
		$mosetCats = $db->loadObjectList();
		$this->catvalues = array();
		foreach($mosetCats as $oneCat){
			if($oneCat->childpath == "/"){
				$this->catvalues[] = JHTML::_('select.option',1,JText::_('ACY_ALL'));
			}
			else{
				$this->catvalues[] = JHTML::_('select.option', $oneCat->child,str_replace("/"," / ",trim($oneCat->childpath,'/')));
			}
		}
		return JHTML::_('select.genericlist',   $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int) $filter_cat);
	 }

	 function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
 		$this->_replaceOne($email);
	 }

	 function _replaceOne(&$email){
		$match = '#{rokdownloads:(.*)}#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything...
		if(!$found) return;

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset($htmlreplace[$oneTag])) continue;

				$content = $this->_replaceContent($allresults,$i);
				$htmlreplace[$oneTag] = $content;
				$textreplace[$oneTag] = $this->mailerHelper->textVersion($content,true);
				$subjectreplace[$oneTag] = strip_tags($content);
			}
		}

		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
	 }

	 function _replaceContent(&$results,$i){

		$result= '';

		//1 : Transform the tag properly...
		$arguments = explode('|',strip_tags($results[1][$i]));
		$tag = new stdClass();
		$tag->id = (int) $arguments[0];
		$tag->itemid = $this->params->get('ItemId',0);
		for($i=1,$a=count($arguments);$i<$a;$i++){
			$args = explode(':',$arguments[$i]);
			if(isset($args[1])){
				$tag->{$args[0]} = $args[1];
			}else{
				$tag->{$args[0]} = true;
			}
		}
		//2 : Load the Joomla article... with the author, the section and the categories to create nice links
		$query = 'SELECT * FROM #__rokdownloads WHERE id='.$tag->id;
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$article = $db->loadObject();


		//In case of we could not load the article for any reason...
		$app = JFactory::getApplication();
		if(empty($article)){
			if($app->isAdmin()){
				$app->enqueueMessage('The document "'.$tag->id.'" could not be loaded','notice');
			}
			return $result;
		}

		$link = 'index.php?option=com_rokdownloads&view=file&Itemid='.$tag->itemid.'&id='.$article->id;
		$linkdownload = 'index.php?option=com_rokdownloads&view=file&Itemid='.$tag->itemid.'&task=download&id='.$article->id;

		$link = acymailing_frontendLink($link);
		$linkdownload = acymailing_frontendLink($linkdownload);

		$styleTitle = '<h2 class="acymailing_title" >';
		$styleTitleEnd = '</h2>';

		$resultTitle = '';
		if(empty($tag->notitle)){
			if(!empty($tag->link)){
				if(!empty($article->thumbnail)){
					$resultTitle .= '<img alt="'.$article->displayname.'" src="images/rokdownload_thumbs/'.$article->thumbnail.'" style="overflow:auto;float:left;margin:5px;" />';
				}
				$resultTitle .= '<a href="'.$link.'" ';
				if($tag->type != "title") $resultTitle .= 'style="text-decoration:none" name="rokdownloads-'.$article->id.'" ';
				$resultTitle .= 'target="_blank" >'.$styleTitle.$article->displayname.$styleTitleEnd.'</a>';
			}else{
				$resultTitle = '<img alt="'.$article->displayname.'" src="images/rokdownload_thumbs/'.$article->thumbnail.'" style="overflow:auto;margin:5px;float:left;" />';
				$resultTitle .= $styleTitle.$article->displayname.$styleTitleEnd;
			}
		}
		if(!empty($tag->download)){
			$download = '<a style="text-decoration:none;" target="_blank" href="'.$linkdownload.'"><span class="acymailing_readmore">'.JText::_('DOWNLOAD').'</span></a>';

		}else{
			$download = '';
		}
		$query = 'SELECT * FROM #__rokdownloads AS a ' .
					 'LEFT JOIN #__users AS u ON a.created_by = u.id ' .
					 'WHERE a.id='.$tag->id;
		$db->setQuery($query);
		$users = $db->loadObject();

		if($tag->type != "title"){

			if($tag->type == "intro"){
				if(!empty($article->introtext)){
					$result .= $article->introtext;
				}
			}
			else{
				$result .='<div>';
				if(!empty($article->introtext)){
					$result .= $article->introtext;
				}
				if(!empty($article->fulltext)){
					$result .= $article->fulltext;
				}

				include_once(ACYMAILING_ROOT.'components'.DS.'com_rokdownloads'.DS.'models'.DS.'file.php');
				$size = RokdownloadsModelFile::_filesize_format($article->filesize);

				$result .= '</div><table  width="100%" border="0" cellpadding="0" cellspacing="0">';
					if(!empty($article->name)){
						$result .= '<tr><td class="fieldname" >'.JText::_('ACY_FILES').' :</td><td class="fieldvalue" >'.$article->name.'</td>';
						$result .= '<td class="fieldname" >'.JText::_('FILESIZE').' :</td><td class="fieldvalue" >'.$size.'</td></tr>';
					}
					if(!empty($article->created_by)){

						$result .= '<tr><td class="fieldname" >'.JText::_('ACY_CREATED').' :</td><td class="fieldvalue" >'.$users->username.'</td>';
					}
					if(!empty($article->created_time)){
						$result .= '<td class="fieldname" >'.JText::_('ACY_PUBLISHED').' :</td><td class="fieldvalue" >'.$article->created_time.'</td></tr>';
					}

					if(!empty($article->modified_by)){
						$result .= '<tr><td class="fieldname" >'.JText::_('ACTION_MODIFIED').' :</td><td class="fieldvalue" >'.$users->username.'</td>';
						$result .= '<td class="fieldname" >'.JText::_('MODIFIED_DATE').' :</td><td class="fieldvalue" >'.$article->modified_time.'</td></tr>';
					}
					$result .= "</table>";
			}

			$result = $resultTitle.$result.$download;
			$result = '<div class="acymailing_content">'.$result.'</div>';
		}else{
			$result = $resultTitle.$result.$download;
		}


		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'rokdownloads.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'rokdownloads.php');
			$result = ob_get_clean();
		}

		if($this->params->get('removejs','yes') == 'yes'){
			$result = $this->_removeJS($result);

		}
		if(isset($tag->pict)){
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight',150) : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth',150) : $tag->maxwidth;
			if($tag->pict == '0'){
				$result = $pictureHelper->removePictures($result);
			}elseif($tag->pict == 'resized'){
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}
		}




		return $result;

	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag,strip_tags(str_replace('</tr><tr>',' | ',$result)),$email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email){

		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		$time = time();


		//Check if we should generate the SmartNewsletter or not...
		$match = '#{autorokdownloads:(.*)}#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything... so we won't try to stop the generation
		if(!$found) return $return;

		$this->tags = array();
		$db = JFactory::getDBO();

		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($this->tags[$oneTag])) continue;

				$arguments = explode('|',strip_tags($allresults[1][$i]));
				//The first argument is a list of sections and cats...
				$allcats = explode('-',$arguments[0]);
				$parameter = new stdClass();
				for($i=1;$i<count($arguments);$i++){
					$args = explode(':',$arguments[$i]);
					$arg0 = $args[0];
					if(isset($args[1])){
						$parameter->$arg0 = $args[1];
					}else{
						$parameter->$arg0 = true;
					}
				}
				//Load the articles based on all arguments...
				$selectedArea = array();
				foreach($allcats as $oneCat){
					if(empty($oneCat)) continue;
					$selectedArea[] = (int) $oneCat;
				}

				$query = 'SELECT id FROM #__rokdownloads ';
				$where = array();
				if(!empty($selectedArea)){
					$query2 = 'SELECT * FROM #__rokdownloads WHERE id IN ('.implode(',',$selectedArea).') ';
					$db->setQuery($query2);
					$cats = $db->loadObject();
					$where[] = "lft > ".$cats->lft. " AND rgt < ".$cats->rgt;

				}
				$where[] = "folder != 1";
				if(!empty($parameter->filter) AND !empty($email->params['lastgenerateddate'])){
					$datenow =& JFactory::getDate($email->params['lastgenerateddate']);
					if(ACYMAILING_J30)
						$date = $datenow->format("%Y-%m-%d %H:%M:%S");
					else
						$date = $datenow->toFormat("%Y-%m-%d %H:%M:%S");
					$condition = '`created_time` >\''.$date.'\'';
					if($parameter->filter == 'modify'){
						$condition .= ' OR `modified_time` > \''.$date.'\'';
					}
					$where[] = $condition;
				}

				if($this->params->get('contentaccess','registered') == 'registered') $where[] = 'access <= 1';
				elseif($this->params->get('contentaccess','registered') == 'public') $where[] = 'access = 0';

				$where[] = "published = 1";


				$query .= ' WHERE ('.implode(') AND (',$where).')';
				if(!empty($parameter->order)){
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY `'.acymailing_secureField($ordering[0]).'` '.acymailing_secureField($ordering[1]);
				}
				if(!empty($parameter->max)) $query .= ' LIMIT '.(int) $parameter->max;
				elseif(empty($email->params['lastgenerateddate'])) $query .= ' LIMIT 20';
				//We add a limit for the preview otherwise we could break everything

				$db->setQuery($query);
				$allArticles = $db->loadResultArray();

				if(!empty($parameter->min) AND count($allArticles)< $parameter->min){
					//We won't generate the Newsletter
					$return->status = false;
					$return->message = 'Not enough RokDownloads content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
				}

				$stringTag = '';
				if(!empty($allArticles)){
					if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autorokdownloads.php')){
						ob_start();
						require(ACYMAILING_MEDIA.'plugins'.DS.'autorokdownloads.php');
						$stringTag = ob_get_clean();
					}else{
						//we insert the article tag one after the other in a table as they are already sorted
						$stringTag .= '<table cellspacing="0" cellpadding="0" border="0">';
						foreach($allArticles as $oneArticleId){
							$stringTag .= '<tr><td>';
							$args = array();
							$args[] = 'rokdownloads:'.$oneArticleId;
							if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
							if(!empty($parameter->link)) $args[] = 'link';
							if(!empty($parameter->download)) $args[] = 'download';
							if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
							if(!empty($parameter->notitle)) $args[] = 'notitle';
							if(!empty($parameter->created)) $args[] = 'created';
							if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
							if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
							if(isset($parameter->itemid)) $args[] = 'itemid:'.$parameter->itemid;
							if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
							if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
							if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
							if(!empty($parameter->readmore)) $args[] = 'readmore:'.$parameter->readmore;
							$stringTag .= '{'.implode('|',$args).'}';
							$stringTag .= '</td></tr>';
						}
						$stringTag .= '</table>';
					}
				}

				$this->tags[$oneTag] = $stringTag;
			}
		}

		return $return;
	}

	function _removeJS($text){
		//Remove the picture... normal process
		$text = preg_replace("#(onmouseout|onmouseover|onclick|onfocus|onload|onblur) *= *\"(?:(?!\").)*\"#iU",'',$text);
		$text =  preg_replace("#< *script(?:(?!< */ *script *>).)*< */ *script *>#isU",'',$text);
		return $text;
	}
}//endclass