<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingSobipro extends JPlugin{

	var $categories;
	//Will store the fields displayed for the intro
	var $fieldsintro = array();
	//Will store the fields displayed for the full detail view
	var $fieldsfull = array();
	//Store the language here
	var $sobiTrans = array();

	public function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'sobipro');
			$this->params = new JParameter($plugin->params);
		}
	}

	public function acymailing_getPluginType(){

		$onePlugin = new stdClass();
		$onePlugin->name = 'SobiPro';
		$onePlugin->function = 'acymailingsobipro_show';
		$onePlugin->help = 'plugin-sobipro';

		return $onePlugin;
	}

	public function acymailingsobipro_show(){

		$config = acymailing_config();
		if($config->get('version') < '5.2.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.sobipro';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest($paramBase.".filter_order", 'filter_order', 'a.id', 'cmd');
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest($paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->contenttype = $app->getUserStateFromRequest($paramBase.".contenttype", 'contenttype', 'intro', 'string');
		$pageInfo->author = $app->getUserStateFromRequest($paramBase.".author", 'author', '', 'string');
		$pageInfo->titlelink = $app->getUserStateFromRequest($paramBase.".titlelink", 'titlelink', 'link', 'string');
		$pageInfo->lang = $app->getUserStateFromRequest($paramBase.".lang", 'lang', '', 'string');
		$pageInfo->pict = $app->getUserStateFromRequest($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->autotitlelink = $app->getUserStateFromRequest($paramBase.".autotitlelink", 'autotitlelink', 'link', 'string');
		$pageInfo->automaxvalue = $app->getUserStateFromRequest($paramBase.".max", 'max', '', 'int');
		$pageInfo->contentfilter = $app->getUserStateFromRequest($paramBase.".contentfilter", 'contentfilter', '|filter:created', 'string');
		$pageInfo->contentorder = $app->getUserStateFromRequest($paramBase.".contentorder", 'contentorder', '|order:id', 'string');
		$pageInfo->autocontenttype = $app->getUserStateFromRequest($paramBase.".autocontenttype", 'autocontenttype', 'intro', 'string');
		$pageInfo->pictheight = $app->getUserStateFromRequest($paramBase.".pictheight", 'pictheight', $this->params->get('maxheight', 150), 'string');
		$pageInfo->pictwidth = $app->getUserStateFromRequest($paramBase.".pictwidth", 'pictwidth', $this->params->get('maxwidth', 150), 'string');

		$pageInfo->limit->value = $app->getUserStateFromRequest($paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest($paramBase.'.limitstart', 'limitstart', 0, 'int');

		$picts = array();
		$picts[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$pictureHelper = acymailing_get('helper.acypict');
		if($pictureHelper->available()) $picts[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$picts[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$db = JFactory::getDBO();
		$filters = array();

		$searchFields = array('a.id', 'b.baseData');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart', 'all') == 'onlypub'){
			$filters[] = 'a.state = 1';
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS a.id, a.nid, a.name, b.baseData AS basename, u.username '.'FROM `#__sobipro_object` AS a '.'LEFT JOIN `#__sobipro_field_data` AS b ON a.id = b.sid '.'LEFT JOIN `#__sobipro_field` AS c ON b.fid = c.fid '.'LEFT JOIN `#__users` AS u ON a.owner = u.id ';

		$filters[] = 'a.oType = "entry"';
		$filters[] = 'c.position = 1';

		if(!empty($pageInfo->filter_cat)){
			$query .= 'LEFT JOIN #__sobipro_relations AS d ON a.id = d.id ';
			$filters[] = 'd.pid = '.$pageInfo->filter_cat;
		}

		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (', $filters).')';
		}

		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir.' , c.priority ASC';
		}

		$db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search, $rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		$contenttype = array();
		$contenttype[] = JHTML::_('select.option', "title", JText::_('TITLE_ONLY'));
		$contenttype[] = JHTML::_('select.option', "intro", JText::_('CATEGORY_VIEW'));
		$contenttype[] = JHTML::_('select.option', "full", JText::_('DETAILS_VIEW'));

		//Title link params
		$titlelink = array();
		$titlelink[] = JHTML::_('select.option', "link", JText::_('JOOMEXT_YES'));
		$titlelink[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));


		jimport('joomla.html.pagination');
		$pagination = new JPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('sobipro_tab');
		echo $tabs->startPanel(JText::_('TAG_ELEMENTS'), 'sobipro_content');

		?>
		<br style="font-size:1px"/>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				if(selectedContents[contentid]){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[contentid];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents[contentid] = 'content';
				}

				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				for(var i = 0; i < document.adminForm.contenttype.length; i++){
					if(document.adminForm.contenttype[i].checked){
						selectedtype = document.adminForm.contenttype[i].value;
						otherinfo += '|type:' + document.adminForm.contenttype[i].value;
					}
				}
				for(var i = 0; i < document.adminForm.titlelink.length; i++){
					if(document.adminForm.titlelink[i].checked && document.adminForm.titlelink[i].value.length > 1){
						otherinfo += '|' + document.adminForm.titlelink[i].value;
					}
				}
				if(selectedtype != 'title'){
					for(var i = 0; i < document.adminForm.pict.length; i++){
						if(document.adminForm.pict[i].checked){
							otherinfo += '|pict:' + document.adminForm.pict[i].value;
							if(document.adminForm.pict[i].value == 'resized'){
								document.getElementById('pictsize').style.display = '';
								if(document.adminForm.pictwidth.value) otherinfo += '|maxwidth:' + document.adminForm.pictwidth.value;
								if(document.adminForm.pictheight.value) otherinfo += '|maxheight:' + document.adminForm.pictheight.value;
							}else{
								document.getElementById('pictsize').style.display = 'none';
							}
						}
					}
				}

				for(var i in selectedContents){
					if(selectedContents[i] == 'content'){
						tag = tag + '{sobipro:' + i + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}
			//-->
		</script>
		<table width="100%" class="adminform">
			<tr>
				<td>
					<?php echo JText::_('DISPLAY'); ?>
				</td>
				<td colspan="2">
					<?php echo JHTML::_('acyselect.radiolist', $contenttype, 'contenttype', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?>
				</td>
				<td>

				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('CLICKABLE_TITLE'); ?>
				</td>
				<td>
					<?php echo JHTML::_('acyselect.radiolist', $titlelink, 'titlelink', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->titlelink); ?>
				</td>
				<td>

				</td>
				<td>

				</td>
			</tr>
			<tr>
				<td><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td colspan="3"><?php echo JHTML::_('acyselect.radiolist', $picts, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
					<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?>><br/><?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						× <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
				</td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search; ?>" class="text_area" onchange="document.adminForm.submit();"/>
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_('JOOMEXT_GO'); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_('JOOMEXT_RESET'); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
			<tr>
				<th class="title">
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('FIELD_TITLE'), 'a.name', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort', JText::_('ACY_AUTHOR'), 'u.username', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
				<th class="title titleid">
					<?php echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
				</th>
			</tr>
			</thead>
			<tfoot>
			<tr>
				<td colspan="4">
					<?php echo $pagination->getListFooter(); ?>
					<?php echo $pagination->getResultsCounter(); ?>
				</td>
			</tr>
			</tfoot>
			<tbody>
			<?php
			$k = 0;
			for($i = 0, $a = count($rows); $i < $a; $i++){
				$row =& $rows[$i];
				?>
				<tr id="content<?php echo $row->id ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'" ?>);" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php
						if(!empty($row->name) && $row->name != 'No name'){
							$title = $row->name;
						}elseif(!empty($row->basename)){
							$utitle = @unserialize(base64_decode($row->basename));
							if(is_array($utitle) && isset($utitle[0])){
								if(!is_numeric($utitle[0])){
									$title = $utitle[0];
								}else{
									$title = $row->nid;
								}
							}else{
								$title = $row->basename;
							}
						}else{
							$title = $row->nid;
						}
						echo $title;
						?>
					</td>
					<td>
						<?php
						echo $row->username;
						?>
					</td>
					<td align="center">
						<?php echo $row->id; ?>
					</td>
				</tr>
				<?php
				$k = 1 - $k;
			}
			?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php
		echo $tabs->endPanel();
		echo $tabs->startPanel(JText::_('TAG_CATEGORIES'), 'sobipro_auto');


		$ordering = array();
		$ordering[] = JHTML::_('select.option', "|order:id,DESC", JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "|order:ordering,ASC", JText::_('ACY_ORDERING'));
		$ordering[] = JHTML::_('select.option', "|order:title,ASC", JText::_('FIELD_TITLE'));

		$type = JRequest::getString('type');

		?>
		<br style="font-size:1px"/>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(selectedCat[catid]){
					window.document.getElementById('cat' + catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat' + catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}

				updateAutoTag();
			}

			function updateAutoTag(){
				tag = '{autosobipro:';

				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value != 0){
					tag += '|min:' + document.adminForm.min_article.value;
				}
				if(document.adminForm.max_article.value && document.adminForm.max_article.value != 0){
					tag += '|max:' + document.adminForm.max_article.value;
				}
				if(document.adminForm.contentorder.value){
					tag += document.adminForm.contentorder.value;
				}
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
					tag += document.adminForm.contentfilter.value;
				}
				if(document.adminForm.meta_article && document.adminForm.meta_article.value){
					tag += '|meta:' + document.adminForm.meta_article.value;
				}

				for(var i = 0; i < document.adminForm.contenttypeauto.length; i++){
					if(document.adminForm.contenttypeauto[i].checked){
						selectedtype = document.adminForm.contenttypeauto[i].value;
						tag += '|type:' + document.adminForm.contenttypeauto[i].value;
					}
				}
				for(var i = 0; i < document.adminForm.titlelinkauto.length; i++){
					if(document.adminForm.titlelinkauto[i].checked && document.adminForm.titlelinkauto[i].value.length > 1){
						tag += '|' + document.adminForm.titlelinkauto[i].value;
					}
				}
				if(selectedtype != 'title'){
					for(var i = 0; i < document.adminForm.pictauto.length; i++){
						if(document.adminForm.pictauto[i].checked){
							tag += '|pict:' + document.adminForm.pictauto[i].value;
							if(document.adminForm.pictauto[i].value == 'resized'){
								document.getElementById('pictsizeauto').style.display = '';
								if(document.adminForm.pictwidthauto.value) tag += '|maxwidth:' + document.adminForm.pictwidthauto.value;
								if(document.adminForm.pictheightauto.value) tag += '|maxheight:' + document.adminForm.pictheightauto.value;
							}else{
								document.getElementById('pictsizeauto').style.display = 'none';
							}
						}
					}
				}

				tag += '}';

				setTag(tag);
			}
			//-->
		</script>
		<table width="100%" class="adminform">
			<tr>
				<td>
					<?php echo JText::_('DISPLAY'); ?>
				</td>
				<td colspan="2">
					<?php echo JHTML::_('acyselect.radiolist', $contenttype, 'contenttypeauto', 'size="1" onclick="updateAutoTag();"', 'value', 'text', $pageInfo->autocontenttype); ?>
				</td>
				<td>

				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('CLICKABLE_TITLE'); ?>
				</td>
				<td>
					<?php echo JHTML::_('acyselect.radiolist', $titlelink, 'titlelinkauto', 'size="1" onclick="updateAutoTag();"', 'value', 'text', $this->params->get('default_titlelink', 'link')); ?>
				</td>
				<td>

				</td>
				<td>

				</td>
			</tr>
			<tr>
				<td><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td><?php echo JHTML::_('acyselect.radiolist', $picts, 'pictauto', 'size="1" onclick="updateAutoTag();"', 'value', 'text', "1"); ?>
					<span id="pictsizeauto" <?php if($this->params->get('default_pict', '1') != 'resized') echo 'style="display:none;"'; ?> ><br/><?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateAutoTag();" value="<?php echo $this->params->get('maxwidth', '150'); ?>" style="width:30px;"/>
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateAutoTag();" value="<?php echo $this->params->get('maxheight', '150'); ?>" style="width:30px;"/>
				</span>
				</td>
				<td></td>
				<td></td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td>
					<input type="text" name="max_article" style="width:50px" value="20" onchange="updateAutoTag();"/>
				</td>
				<td>
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td>
					<?php echo JHTML::_('select.genericlist', $ordering, 'contentorder', 'size="1" style="width:150px;" onchange="updateAutoTag();"', 'value', 'text'); ?>
				</td>
			</tr>
			<?php if($type == 'autonews'){ ?>
				<tr>
					<td>
						<?php echo JText::_('MIN_ARTICLE'); ?>
					</td>
					<td>
						<input type="text" name="min_article" style="width:50px" value="1" onchange="updateAutoTag();"/>
					</td>
					<td>
						<?php echo JText::_('JOOMEXT_FILTER'); ?>
					</td>
					<td>
						<?php $filters = array();
						$filters[] = JHTML::_('select.option', "", JText::_('ACY_ALL'));
						$filters[] = JHTML::_('select.option', "|filter:created", JText::_('ONLY_NEW_CREATED'));
						$filters[] = JHTML::_('select.option', "|filter:modified", JText::_('ONLY_NEW_MODIFIED'));
						echo JHTML::_('select.genericlist', $filters, 'contentfilter', 'size="1" onclick="updateAutoTag();"', 'value', 'text', '|filter:created'); ?>
					</td>
				</tr>
			<?php } ?>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<?php
			$k = 0;
			foreach($this->catvalues as $oneCat){
				if(empty($oneCat->value)) continue;
				?>
				<tr <?php if($oneCat->value != '<OPTGROUP>'){
					echo 'id="cat'.$oneCat->value.'" class="row'.$k.'" onclick="applyAuto('.$oneCat->value.',\'row'.$k.'\');" style="cursor:pointer;"';
				} ?> >
					<td <?php if($oneCat->value != '<OPTGROUP>'){
						echo 'class="acytdcheckbox"';
					} ?> ></td>
					<td>
						<?php
						if($oneCat->value == '<OPTGROUP>'){
							echo '<b>'.$oneCat->text.'</b>';
						}else{
							echo $oneCat->text;
						}
						?>
					</td>
				</tr>
				<?php $k = 1 - $k;
			} ?>
		</table>
		<?php

		echo $tabs->endPanel();

		echo $tabs->startPanel(JText::_('RECEIVER_INFORMATION'), 'sobipro_infos'); ?>
		<script language="javascript" type="text/javascript">
			function applyTag(tagname){
				var string = '{sobitag:' + tagname + '}';
				setTag(string);
				insertTag();
			}
		</script>
		<?php

		$text = '<table class="adminlist table table-striped table-hover" cellpadding="1">';
		$text .= '<tr style="cursor:pointer" class="row1" onclick="applyTag(\'sid\');" ><td class="acytdcheckbox"></td><td>sid</td></tr>';

		$db = JFactory::getDBO();
		$db->setQuery('SELECT DISTINCT nid, fieldType FROM #__sobipro_field');
		$fields = $db->loadObjectList();
		$k = 0;
		include_once(ACYMAILING_ROOT.'components'.DS.'com_sobipro'.DS.'lib'.DS.'sobi.php');
		foreach($fields as $onefield){
			$type = '';
			if(!method_exists('Sobi', 'Initialise')){
				if($onefield->fieldType == 'calendar') $type = '|type:time';
				if(strpos(strtolower($onefield->nid), 'date') !== false) $type = '|type:date';
			}
			$text .= '<tr style="cursor:pointer" class="row'.$k.'" onclick="applyTag(\''.$onefield->nid.$type.'\');" ><td class="acytdcheckbox"></td><td>'.$onefield->nid.'</td></tr>';
			$k = 1 - $k;
		}
		$text .= '</table>';
		echo $text;

		echo $tabs->endPanel();
		echo $tabs->endPane();
		//End of the function
	}

	private function _categories($filter_cat){
		//select all cats
		$db = JFactory::getDBO();
		$db->setQuery('SELECT id,name,parent FROM #__sobipro_object WHERE oType!="entry"');
		$mosetCats = $db->loadObjectList();
		$this->cats = array();
		foreach($mosetCats as $oneCat){
			$this->cats[$oneCat->parent][] = $oneCat;
		}
		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0, JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist', $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int)$filter_cat);
	}

	private function _handleChildrens($parent_id = 0, $level = 0){
		if(!empty($this->cats[$parent_id])){
			foreach($this->cats[$parent_id] as $cat){
				if($cat->parent == 0){
					$this->catvalues[] = JHTML::_('select.option', '<OPTGROUP>', $cat->name);
				}else{
					$this->catvalues[] = JHTML::_('select.option', $cat->id, str_repeat(" - - ", $level).$cat->name);
				}
				$this->_handleChildrens($cat->id, $level + 1);
			}
		}
	}

	public function acymailing_replacetags(&$email, $send = true){
		$this->_replaceAuto($email);
		$this->_replaceArticles($email);
	}

	function _replaceArticles(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		$lang = JFactory::getLanguage();
		$lang->load('com_sobipro', JPATH_SITE);

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, 'sobipro');
		if(empty($tags)){
			return;
		}
		$db = JFactory::getDBO();
		$db->setQuery('Select * FROM #__sobipro_config WHERE sKey="currency" ');
		$this->currency = $db->loadObject();

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params){
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content, true);
			$subjectreplace[$i] = strip_tags($content);
		}
		$email->body = str_replace(array_keys($htmlreplace), $htmlreplace, $email->body);
		$email->altbody = str_replace(array_keys($textreplace), $textreplace, $email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace), $subjectreplace, $email->subject);
	}

	private function _replaceContent($tag){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$result = '';

		//2 : Load the Joomla article... with the author, the section and the categories to create nice links
		$db->setQuery('SELECT a.* FROM #__sobipro_object as a WHERE a.id = '.intval($tag->id).' LIMIT 1');
		$article = $db->loadObject();

		//In case of we could not load the article for any reason...
		if(empty($article)){
			if($app->isAdmin()){
				$app->enqueueMessage('The article "'.$tag->id.'" could not be loaded', 'notice');
			}
			return $result;
		}

		//Load extra fields:
		$db->setQuery('SELECT a.*,d.* FROM #__sobipro_field as a '.'LEFT JOIN #__sobipro_field_data as d on a.fid = d.fid '.'WHERE d.sid = '.intval($tag->id));
		$fieldresults = $db->loadObjectList();
		$extraValues = array();
		$idTitle = 0;
		if(!empty($fieldresults)){
			foreach($fieldresults as $oneField){
				if($oneField->nid == 'field_name' || ($oneField->position == 1 && $oneField->priority == 1)){
					$idTitle = $oneField->fid;
				}elseif(empty($idTitle) && ($oneField->position == 1 || $oneField->priority == 1)){
					$idTitle = $oneField->fid;
				}
				$extraValues[$oneField->fid][] = $oneField;
			}
		}

		$link = 'index.php?option=com_sobipro&sid='.$tag->id;
		$link = acymailing_frontendLink($link);
		//Add the title with a link or not on it.

		$styleTitle = '<h2 class="acymailing_title">';
		$styleTitleEnd = '</h2>';
		$resultTitle = '';
		if(empty($tag->notitle) && !empty($extraValues[$idTitle])){
			if(!empty($article->name) && $article->name != 'No name' && $article->name != JText::_('SP.ENTRY_NO_NAME')){
				$title = $article->name;
			}else{
				//The title can be a base64_encode(serialize(real_title)) or a simple text
				if(!empty($idTitle)){
					$title = $extraValues[$idTitle][0]->baseData;
					$testTitle = @unserialize(base64_decode($title));
					if(is_array($testTitle) && isset($testTitle[0])){
						if(!is_numeric($testTitle[0])){
							$title = $testTitle[0];
						}else{
							$title = $article->nid;
						}
					}
				}else{
					$title = $article->nid;
				}
			}
			if(!empty($tag->link)){
				$result .= '<a href="'.$link.'" style="text-decoration:none" name="sobiprocontent-'.$article->id.'" target="_blank" >'.$styleTitle.$title.$styleTitleEnd.'</a>';
			}else{
				$result .= $styleTitle.$title.$styleTitleEnd;
			}
		}

		unset($extraValues[$idTitle]);

		//We add the intro text
		if($tag->type != "title"){
			if(empty($this->sobiTrans)){
				$db->setQuery('SELECT sKey,sValue,fid FROM #__sobipro_language WHERE oType IN (\'fields\',\'field_option\') AND language  LIKE "%'.JFactory::getLanguage()->getDefault().'%" ');
				$this->sobiTrans = $db->loadObjectList('sKey');
			}
			if($tag->type == "intro"){
				//intro view
				if(empty($this->fieldsintro)){
					$db->setQuery('SELECT a.*,b.* FROM #__sobipro_field as a '.'LEFT JOIN #__sobipro_language as b ON a.fid = b.fid '.'WHERE b.sKey!="description" '.'AND a.showIn IN ("both","vCard") '.'GROUP BY a.fid '.'ORDER BY a.position');
					$this->fieldsintro = $db->loadObjectList();
				}
				$result .= $this->_displayFields($extraValues, $this->fieldsintro);
			}else{
				//detail view
				if(empty($this->fieldsfull)){
					$db->setQuery('SELECT a.*,b.* FROM #__sobipro_field as a '.'LEFT JOIN #__sobipro_language as b ON a.fid = b.fid '.'WHERE b.sKey!="description" '.'AND a.showIn IN ("both","details") '.'GROUP BY a.fid '.'ORDER BY a.position');
					$this->fieldsfull = $db->loadObjectList();
				}
				$result .= $this->_displayFields($extraValues, $this->fieldsfull);
			}

			$result = '<div class="acymailing_content">'.$result.'</div>';
		}

		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'sobipro.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'sobipro.php');
			$result = ob_get_clean();
		}

		$result = $acypluginsHelper->removeJS($result);

		//We have our content... lets check the pictures options
		if(isset($tag->pict)){
			$pictureHelper = acymailing_get('helper.acypict');
			if($tag->pict == '0'){
				$result = $pictureHelper->removePictures($result);
			}elseif($tag->pict == 'resized'){
				$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight', 150) : $tag->maxheight;
				$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth', 150) : $tag->maxwidth;
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error, 'notice');
				}
			}
		}

		return $result;
	}


	private function _displayFields(&$extraValues, $fields){

		$result = '<table cellspacing="5" cellpadding="0" border="0" >';
		$db = JFactory::getDBO();
		$picture = '';
		$desc = '';

		if(!isset($this->suffixs)){
			$db->setQuery('SELECT * FROM #__sobipro_language WHERE sKey="suffix" AND language LIKE "%'.JFactory::getLanguage()->getDefault().'%" ');
			$this->suffixs = $db->loadObjectList('fid');
		}

		foreach($fields as $oneField){
			if(!isset($extraValues[$oneField->fid][0])) continue;

			$textField = '';

			foreach($extraValues[$oneField->fid] as $num => $oneValue){
				if(!empty($num)) $textField .= ',';
				if($oneValue->fieldType == "inbox"){
					$textField .= ' <span class="'.$oneField->sKey.'_value">';
					$textField .= (isset($this->sobiTrans[$oneValue->baseData]) ? $this->sobiTrans[$oneValue->baseData]->sValue : $oneValue->baseData);
					if(!empty($this->suffixs[$oneField->fid]->sValue)){
						if($this->suffixs[$oneField->fid]->sValue == "[cfg:payments.currency]"){
							$textField .= ' '.$this->currency->sValue;
						}else{
							$textField .= ' '.$this->suffixs[$oneField->fid]->sValue;
						}
					}
					$textField .= '</span>';
				}
				if($oneValue->fieldType == "textarea"){
					if(!empty($oneField->withLabel) AND !empty($oneField->sValue)){
						$textField .= (isset($this->sobiTrans[$oneValue->baseData]) ? $this->sobiTrans[$oneValue->baseData]->sValue : $oneValue->baseData);
					}else{
						$desc .= (isset($this->sobiTrans[$oneValue->baseData]) ? $this->sobiTrans[$oneValue->baseData]->sValue : $oneValue->baseData);
					}
				}

				if($oneValue->fieldType == "select" OR $oneValue->fieldType == "chbxgroup" OR $oneValue->fieldType == "multiselect" OR $oneValue->fieldType == "radio"){
					$db->setQuery('SELECT * FROM #__sobipro_field_option_selected WHERE fid="'.$oneValue->fid.'" AND sid="'.$oneValue->sid.'" ');
					$options = $db->loadObjectList();
					$nbRows = count($options);
					if($nbRows <= 1){
						$textField .= ' <span class="'.$oneField->sKey.'_value">';
						if(!empty($options[0]->optValue)){
							$textField .= ' '.(isset($this->sobiTrans[$options[0]->optValue]) ? $this->sobiTrans[$options[0]->optValue]->sValue : $options[0]->optValue);
						}
						$textField .= '</span>';
					}else{
						$textField .= '<ul>';
						foreach($options as $oneOption){
							$textField .= ' <li><span  class="'.$oneField->sKey.'_value">';
							if(!empty($oneOption->optValue)){
								$textField .= ' '.(isset($this->sobiTrans[$oneOption->optValue]) ? $this->sobiTrans[$oneOption->optValue]->sValue : $oneOption->optValue);
							}
							$textField .= '</span></li>';
						}
						$textField .= '</ul>';
					}
				}
				if($oneValue->fieldType == "image"){
					$decodedValue = base64_decode($oneValue->baseData);
					if(function_exists('gzinflate')){
						if(($inflateValue = @gzinflate($decodedValue))){
							$text = unserialize($inflateValue);
						}else{
							$text = unserialize($decodedValue);
						}
					}
					$picture .= '<img src="'.$text['image'].'" alt="" style="margin:5px;float:left;" />';
				}
				if($oneValue->fieldType == "url"){
					$textField .= ' <span  class="'.$oneField->sKey.'_value">';
					$text = unserialize(base64_decode($oneValue->baseData));
					$label = !empty($text['label']) ? $text['label'] : $text['protocol'].'://'.$text['url'];
					$textField .= '<a href="'.$text['protocol'].'://'.$text['url'].'" target="_BLANK" >'.$label.'</a>';
					$textField .= '</span>';
				}
				if($oneValue->fieldType == "email"){
					$textField .= '<span  class="'.$oneField->sKey.'_value">';
					$text = unserialize(base64_decode($oneValue->baseData));
					$label = !empty($text['label']) ? $text['label'] : $text['url'];
					$textField .= '<a href="mailto:'.$text['url'].'" >'.$label.'</a>';
					$textField .= '</span>';
				}
			}

			if(strlen($textField) == 0) continue;

			//Check on the real text...
			$realText = trim(strip_tags($textField));
			if(strlen($realText) == 0) continue;

			if(!empty($oneField->withLabel) AND !empty($oneField->sValue) AND $oneField->fieldType != "image"){
				$result .= '<tr><td valign="top"><b><span  class="'.$oneField->sKey.'_label">'.$oneField->sValue.': </span></b></td><td>'.$textField.'</td></tr>';
			}else{
				$result .= '<tr><td></td><td>'.$textField.'</td></tr>';
			}
		}

		$result = $picture.$desc.$result.'</table>';

		return $result;
	}

	private function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags), $this->tags, $email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags), $this->tags, $email->altbody);
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag, strip_tags(str_replace('</tr><tr>', ' | ', $result)), $email->subject);
			}
		}
	}

	public function acymailing_generateautonews(&$email){

		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		$time = time();


		//Check if we should generate the SmartNewsletter or not...
		$match = '#{autosobipro:(.*)}#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything... so we won't try to stop the generation
		if(!$found) return $return;

		$this->tags = array();
		$db = JFactory::getDBO();

		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($this->tags[$oneTag])) continue;

				$arguments = explode('|', strip_tags($allresults[1][$i]));
				//The first argument is a list of sections and cats...
				$allcats = explode('-', $arguments[0]);
				$parameter = new stdClass();
				for($i = 1; $i < count($arguments); $i++){
					$args = explode(':', $arguments[$i]);
					$arg0 = $args[0];
					if(isset($args[1])){
						$parameter->$arg0 = $args[1];
					}else{
						$parameter->$arg0 = true;
					}
				}
				//Load the articles based on all arguments...
				$selectedArea = array();
				foreach($allcats as $oneCat){
					if(empty($oneCat)) continue;
					$selectedArea[] = intval($oneCat);
				}
				$query = 'SELECT DISTINCT a.id FROM `#__sobipro_object` as a ';
				$where = array();
				if(!empty($selectedArea)){
					$query .= 'JOIN #__sobipro_relations AS b ON a.id = b.id ';
					$where[] = 'b.pid IN ('.implode(',', $selectedArea).')';
				}

				if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
					$condition = 'a.`createdTime` >\''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
					if($parameter->filter == 'modified'){
						$condition .= ' OR a.`updatedTime` > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\'';
					}

					$where[] = $condition;
				}

				$where[] = 'a.state = 1';
				$where[] = 'a.oType="entry"';

				$query .= ' WHERE ('.implode(') AND (', $where).')';
				if(!empty($parameter->order)){
					$ordering = explode(',', $parameter->order);
					$query .= ' ORDER BY a.`'.acymailing_secureField($ordering[0]).'` '.acymailing_secureField($ordering[1]);
				}

				$start = '';
				if(!empty($parameter->start)) $start = intval($parameter->start).',';

				if(!empty($parameter->max)){
					$query .= ' LIMIT '.$start.(int)$parameter->max;
				}elseif(empty($email->params['lastgenerateddate'])) $query .= ' LIMIT '.$start.'20';
				//We add a limit for the preview otherwise we could break everything

				$db->setQuery($query);
				$allArticles = acymailing_loadResultArray($db);

				if(!empty($parameter->min) AND count($allArticles) < $parameter->min){
					//We won't generate the Newsletter
					$return->status = false;
					$return->message = 'Not enough articles for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
				}

				$stringTag = '';
				if(!empty($allArticles)){
					if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autosobipro.php')){
						ob_start();
						require(ACYMAILING_MEDIA.'plugins'.DS.'autosobipro.php');
						$stringTag = ob_get_clean();
					}else{
						//we insert the article tag one after the other in a table as they are already sorted
						$arrayElements = array();
						foreach($allArticles as $oneArticleId){
							$args = array();
							$args[] = 'sobipro:'.$oneArticleId;
							if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
							if(!empty($parameter->link)) $args[] = 'link';
							if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
							if(!empty($parameter->notitle)) $args[] = 'notitle';
							if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
							if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
							if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
							$arrayElements[] .= '{'.implode('|', $args).'}';
						}

						$acypluginsHelper = acymailing_get('helper.acyplugins');
						$stringTag = $acypluginsHelper->getFormattedResult($arrayElements, $parameter);
					}
				}

				$this->tags[$oneTag] = $stringTag;
			}
		}

		return $return;
	}

	public function acymailing_replaceusertags(&$email, &$user, $send = true){
		$match = '#(?:{|%7B)sobitag:(.*)(?:}|%7D)#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			if(empty($results[$var][0])) unset($results[$var]);
		}
		if(!$found) return;
		$db = JFactory::getDBO();
		$tags = array();

		$pluginsHelper = acymailing_get('helper.acyplugins');

		$this->getFieldsId();
		$this->resSql = null;
		$this->filter = array();
		$filters = array('DATEDIFF=', 'DATEDIFF<', 'DATEDIFF>', 'LIKE', '=', '<', '>', '<=', '>=', '<>');


		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($tags[$oneTag])) continue;
				$arguments = explode('|', $allresults[1][$i]);
				$field = $arguments[0];
				unset($arguments[0]);
				$mytag = new stdClass();
				$mytag->default = $this->params->get('default_'.$field, '');
				$mytag->type = '';
				if(!empty($arguments)){
					foreach($arguments as $onearg){
						$args = explode(':', $onearg);
						if(isset($args[1])){
							$mytag->{$args[0]} = $args[1];
						}else{
							$mytag->{$args[0]} = 1;
						}
					}
				}
				$tagWhere = '';
				$resSql = new stdClass();

				if(!empty($mytag->where)){
					$tagWhere = $mytag->where;
				}

				if(!empty($tagWhere) && empty($this->filter[$tagWhere])){
					$this->filter[$tagWhere] = array();
					$mytag->where = str_replace(array('&lt;', '&gt;'), array('<', '>'), $mytag->where);
					$this->filter[$tagWhere]['array'] = explode(';', $mytag->where);
					foreach($this->filter[$tagWhere]['array'] as $i => $element){
						$this->filter[$tagWhere]['array'][$i] = trim($element);
					}

					if(!empty($this->filter[$tagWhere]['array'][0]) && !empty($this->filter[$tagWhere]['array'][1]) && in_array($this->filter[$tagWhere]['array'][1], $filters) && !empty($this->filter[$tagWhere]['array'][2])){
						$fieldName = ' c.nid = '.$db->quote($this->filter[$tagWhere]['array'][0]).' AND ';
						if($this->filter[$tagWhere]['array'][1] == 'LIKE'){
							$this->filter[$tagWhere]['where'] = $fieldName.'b.baseData LIKE '.$db->quote($this->filter[$tagWhere]['array'][2]);
						}elseif($this->filter[$tagWhere]['array'][1] == 'DATEDIFF='){
							$this->filter[$tagWhere]['where'] = $fieldName.'DATEDIFF(FROM_UNIXTIME(b.baseData),NOW()) = '.intval($this->filter[$tagWhere]['array'][2]);
						}elseif($this->filter[$tagWhere]['array'][1] == 'DATEDIFF<'){
							$this->filter[$tagWhere]['where'] = $fieldName.'DATEDIFF(FROM_UNIXTIME(b.baseData),NOW()) < '.intval($this->filter[$tagWhere]['array'][2]);
						}elseif($this->filter[$tagWhere]['array'][1] == 'DATEDIFF>'){
							$this->filter[$tagWhere]['where'] = $fieldName.'DATEDIFF(FROM_UNIXTIME(b.baseData),NOW()) > '.intval($this->filter[$tagWhere]['array'][2]);
						}else{
							$this->filter[$tagWhere]['where'] = $fieldName.'b.baseData '.$this->filter[$tagWhere]['array'][1].' '.$db->quote($this->filter[$tagWhere]['array'][2]);
						}
					}else{
						$tagWhere = '';
					}
				}

				if((empty($tagWhere) && empty($this->resSql)) || (!empty($tagWhere) && empty($this->filter[$tagWhere]['resSql']))){
					if(!empty($user->email)){
						$query = 'SELECT a.sid, a.section FROM #__sobipro_field_data AS a ';
						if(!empty($tagWhere)){
							$query .= 'JOIN #__sobipro_field_data AS b '.'ON b.sid = a.sid '.'JOIN #__sobipro_field AS c '.'ON b.fid = c.fid ';
						}
						$query .= 'WHERE a.baseData = '.$db->Quote($user->email).' AND a.fid IN ("'.implode('","', $this->fidEmail).'") ';
						if(!empty($tagWhere)){
							$query .= 'AND '.$this->filter[$tagWhere]['where'];
						}
						$query .= ' ORDER BY a.updatedTime DESC';
						$result = $db->setQuery($query);
						if(!empty($result)){
							if(!empty($tagWhere)){
								$this->filter[$tagWhere]['resSql'] = $db->loadObject();
							}else{
								$this->resSql = $db->loadObject();
							}
						}
					}
					// If no entry found corresponding to the email, getting entry corresponding to the author
					if(((empty($tagWhere) && empty($this->resSql)) || (!empty($tagWhere) && empty($this->filter[$tagWhere]['resSql']))) && !empty($user->userid)){
						$query = 'SELECT a.sid, a.section FROM #__sobipro_field_data AS a ';
						if(!empty($tagWhere)){
							$query .= 'JOIN #__sobipro_field_data AS b '.'ON b.sid = a.sid '.'JOIN #__sobipro_field AS c '.'ON b.fid = c.fid ';
						}
						$query .= 'WHERE a.createdBy='.intval($user->userid);
						if(!empty($tagWhere)){
							$query .= ' AND '.$this->filter[$tagWhere]['where'];
						}
						$query .= ' ORDER BY a.sid DESC LIMIT 1';
						$db->setQuery($query);
						$result = $db->loadObject();
						if(!empty($result)){
							if(!empty($tagWhere)){
								$this->filter[$tagWhere]['resSql'] = $result;
							}else{
								$this->resSql = $result;
							}
						}
					}
				}

				if(empty($tagWhere) && !empty($this->resSql)){
					$resSql = $this->resSql;
				}elseif(!empty($tagWhere) && !empty($this->filter[$tagWhere]['resSql'])){
					$resSql = $this->filter[$tagWhere]['resSql'];
				}

				if(!empty($resSql->sid)){
					$sobiSid = $resSql->sid;
					$section = $resSql->section;

					// Preparing data with sobipro functions
					include_once(ACYMAILING_ROOT.'components'.DS.'com_sobipro'.DS.'lib'.DS.'sobi.php');
					if(method_exists('Sobi', 'Initialise')){
						Sobi::Initialise($sobiSid);
						SPLoader::loadClass('models.entry');
						$classEntry = new SPEntry();
						// Putting @ to avoid warning triggered by sobipro
						$classEntry = @$classEntry->load($sobiSid);
						$classEntry->loadFields($section);
						$fields = $classEntry->getFields('name');
						$updateSobi = false;
					}else{
						$updateSobi = true;
					}
				}else{
					$replaceme = $mytag->default;
					$pluginsHelper->formatString($replaceme, $mytag);
					$tags[$oneTag] = $replaceme;
					continue;
				}
				$query = 'SELECT a.BaseData, b.nid, b.fieldType, b.fid FROM #__sobipro_field_data as a LEFT JOIN #__sobipro_field as b ON a.fid = b.fid WHERE a.sid = '.intval($sobiSid);
				$db->setQuery($query);
				$sobiUser = $db->loadObjectList('nid');

				// Getting field data with Sobipro functions
				if(!$updateSobi){
					if(!empty($fields[$field])){
						$struct = $fields[$field]->struct();
					}

					if(!empty($fields[$field]) && !empty($struct['_data'])){
						$replaceme = $struct['_data'];
					}else{
						$replaceme = $mytag->default;
					}
				}else{
					// Getting data the old way (can't retrieve data with Sobipro functions with this version)
					if(isset($sobiUser[$field]->BaseData) && !empty($sobiUser[$field]->BaseData)){
						$replaceme = $sobiUser[$field]->BaseData;
					}elseif(isset($sobiUser[$field]->BaseData)){
						// Load fields from other table
						$db->setQuery('SELECT ldata.sValue, ldata.sKey '.'FROM #__sobipro_field_option_selected AS sdata '.'LEFT JOIN #__sobipro_field_data AS fdata '.'ON sdata.fid = fdata.fid '.'LEFT JOIN #__sobipro_language AS ldata '.'ON sdata.optValue = ldata.sKey '.'WHERE ( sdata.fid ='.$sobiUser[$field]->fid.' ) '.'AND ( sdata.sid ='.$sobiSid.' ) '.'AND ( fdata.sid ='.$sobiSid.' ) '.'AND ( ldata.oType =\'field_option\' ) '.'AND ( ldata.fid ='.$sobiUser[$field]->fid.' ) ');
						$fieldres = $db->loadObject();
						if(!empty($fieldres)){
							$replaceme = $fieldres->sValue;
						}else $replaceme = $mytag->default;
					}else{
						$replaceme = $mytag->default;
					}
				}

				if($field == 'sid') $replaceme = $sobiSid;

				// Images new version of sobi
				if(!$updateSobi && !empty($sobiUser[$field]->fieldType) && $sobiUser[$field]->fieldType == 'image' && !empty($replaceme['img']['_attributes']['src'])){
					$imgPath = $replaceme['img']['_attributes']['src'];
					$replaceme = '<img style="margin:5px" src="'.$imgPath.'" />';
				}
				// Images ancienne version de sobi
				if($updateSobi && !empty($sobiUser[$field]->fieldType) && $sobiUser[$field]->fieldType == 'image'){
					$replacemeDecoded = base64_decode($replaceme);
					$sobiImage = unserialize($replacemeDecoded);
					if(file_exists(ACYMAILING_ROOT.$sobiImage['image'])){
						$replaceme = '<img style="margin:5px" alt="" src="'.$sobiImage['image'].'" />';
					}
				}

				// Handling date format
				if($updateSobi && !empty($sobiUser[$field]->fieldType) && $sobiUser[$field]->fieldType == 'calendar'){
					$format = (!empty($mytag->format) ? $mytag->format : 'm/d/Y');
					$replaceme = date($format, $sobiUser[$field]->BaseData);
				}

				$pluginsHelper->formatString($replaceme, $mytag);

				$tags[$oneTag] = $replaceme;
			}
		}
		foreach($results as $var => $allresults){
			$email->$var = str_replace(array_keys($tags), $tags, $email->$var);
		}
	}//endfct


	function onAcyDisplayFilters(&$type){
		$db = JFactory::getDBO();
		$db->setQuery("SELECT `groupName`,`gid` FROM #__sobipro_user_group ORDER BY `groupName` ASC");
		$allGroups = $db->loadObjectList();
		$db->setQuery('SELECT nid, fid FROM #__sobipro_field');
		$fields = $db->loadObjectList('fid');

		$return = '';

		if(!empty($allGroups)){
			$firstGroup = new stdClass();
			$firstGroup->groupName = JText::_('ACY_ALL');
			$firstGroup->gid = 0;
			array_unshift($allGroups, $firstGroup);

			$type['sobipro_groups'] = 'SobiPro Groups';

			$inoperator = acymailing_get('type.operatorsin');

			$return .= '<div id="filter__num__sobipro_groups">';
			$inoperator->js = 'onchange="countresults(__num__)"';
			$return .= $inoperator->display("filter[__num__][sobipro_groups][type]").' '.JHTML::_('select.genericlist', $allGroups, "filter[__num__][sobipro_groups][plan]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'gid', 'groupName');
			$return .= '<br /><input type="text" name="filter[__num__][sobipro_groups][subscription_date_inf]" onchange="countresults(__num__)" value=""/> < '.JText::_('CREATED_DATE').' < <input type="text" name="filter[__num__][sobipro_groups][subscription_date_sup]" onchange="countresults(__num__)" value="" />';
			$return .= '<br /><input type="text" name="filter[__num__][sobipro_groups][expiry_date_inf]" onchange="countresults(__num__)" value="'.date('Y-m-d').'"/> < '.JText::_('EXPIRY_DATE').' < <input type="text" name="filter[__num__][sobipro_groups][expiry_date_sup]" onchange="countresults(__num__)" value="" />';

			$return .= '</div>';
		}

		if(!empty($fields)){
			$type['sobipro_users'] = 'SobiPro Users';

			foreach($fields as $oneField => $fieldType){
				$field[] = JHTML::_('select.option', $oneField, $fieldType->nid);
			}
			$field[] = JHTML::_('select.option', 'validSince', 'validSince');
			$field[] = JHTML::_('select.option', 'validUntil', 'validUntil');
			$field[] = JHTML::_('select.option', 'approved', 'approved');
			$field[] = JHTML::_('select.option', 'confirmed', 'confirmed');

			$operators = acymailing_get('type.operators');
			$operators->extra = 'onchange="countresults(__num__)"';
			$return .= '<div id="filter__num__sobipro_users">'.JHTML::_('select.genericlist', $field, "filter[__num__][sobipro_users][map]", 'class="inputbox" size="1" onchange="countresults(__num__)"', 'value', 'text');
			$return .= ' '.$operators->display("filter[__num__][sobipro_users][operator]").' <input onchange="countresults(__num__)" class="inputbox" type="text" name="filter[__num__][sobipro_users][value]" style="width:200px" value=""></div>';
		}
		return $return;
	}

	public function onAcyProcessFilterCount_sobipro_groups(&$query, $filter, $num){
		$db = JFactory::getDBO();
		$lj = "SELECT count(sub.subid) FROM #__acymailing_subscriber as sub LEFT JOIN ";
		$lj .= $this->_wherelj($filter, $num);

		$operator = ($filter['type'] == 'IN') ? 'IS NOT NULL' : "IS NULL";
		$lj .= " WHERE sobipro$num.`uid` ".$operator;

		$db->setQuery($lj);
		$nbSubscribers = $db->loadResult();
		return JText::sprintf('SELECTED_USERS', $nbSubscribers);
	}

	public function onAcyProcessFilter_sobipro_groups(&$query, $filter, $num){

		$query->leftjoin['sobipro_groups_'.$num] = $this->_wherelj($filter, $num);

		$operator = ($filter['type'] == 'IN') ? 'IS NOT NULL' : "IS NULL";
		$query->where[] = "sobipro$num.`uid` ".$operator;
	}

	private function _wherelj($filter, $num){
		$db = JFactory::getDBO();
		$lj = "`#__sobipro_users_relation` as sobipro$num ON sobipro$num.`uid` = sub.`userid`";
		if(!empty($filter['group'])){
			$lj .= " AND sobipro$num.gid = ".$filter['plan'];
		}

		if(!empty($filter['subscription_date_inf'])){
			$filter['subscription_date_inf'] = acymailing_replaceDate($filter['subscription_date_inf']);
			if(is_numeric($filter['subscription_date_inf'])) $filter['subscription_date_inf'] = date('Y-m-d H:i', $filter['subscription_date_inf']);
			$lj .= " AND sobipro$num.`validSince` > ".$db->Quote($filter['subscription_date_inf']);
		}
		if(!empty($filter['subscription_date_sup'])){
			$filter['subscription_date_sup'] = acymailing_replaceDate($filter['subscription_date_sup']);
			if(is_numeric($filter['subscription_date_sup'])) $filter['subscription_date_sup'] = date('Y-m-d H:i', $filter['subscription_date_sup']);
			$lj .= " AND sobipro$num.`validSince` < ".$db->Quote($filter['subscription_date_sup']);
		}
		if(!empty($filter['expiry_date_inf'])){
			$filter['expiry_date_inf'] = acymailing_replaceDate($filter['expiry_date_inf']);
			if(is_numeric($filter['expiry_date_inf'])) $filter['expiry_date_inf'] = date('Y-m-d H:i', $filter['expiry_date_inf']);
			$lj .= " AND sobipro$num.`validUntil` > ".$db->Quote($filter['expiry_date_inf']);
		}
		if(!empty($filter['expiry_date_sup'])){
			$filter['expiry_date_sup'] = acymailing_replaceDate($filter['expiry_date_sup']);
			if(is_numeric($filter['expiry_date_sup'])) $filter['expiry_date_sup'] = date('Y-m-d H:i', $filter['expiry_date_sup']);
			$lj .= " AND sobipro$num.`validUntil` < ".$db->Quote($filter['expiry_date_sup']);
		}

		return $lj;
	}

	public function onAcyProcessFilterCount_sobipro_users(&$query, $filter, $num){
		$this->onAcyProcessFilter_sobipro_users($query, $filter, $num);
		return JText::sprintf('SELECTED_USERS', $query->count());
	}

	public function onAcyProcessFilter_sobipro_users(&$query, $filter, $num){
		$filter['value'] = acymailing_replaceDate($filter['value']);
		$this->getFieldsId();

		if(!is_numeric($filter['map'])){
			if(in_array($filter['map'], array('validSince', 'validUntil'))){
				$filter['value'] = acymailing_getDate((!is_numeric($filter['value']) ? acymailing_getTime($filter['value']) : $filter['value']), 'Y-m-d');
			}
			$myquery = 'SELECT DISTINCT a.id FROM #__sobipro_object AS a WHERE '.$query->convertQuery('a', $filter['map'], $filter['operator'], $filter['value']);
		}else{
			$myquery = 'SELECT DISTINCT a.sid FROM #__sobipro_field_data AS a WHERE a.fid = '.intval($filter['map']).' AND '.$query->convertQuery('a', 'baseData', $filter['operator'], $filter['value']);
		}

		$query->db->setQuery($myquery);
		$allSid = acymailing_loadResultArray($query->db);

		if(is_numeric($filter['map'])){
			$query->db->setQuery('SELECT DISTINCT a.sid FROM #__sobipro_field_option_selected AS a WHERE a.fid = '.intval($filter['map']).' AND '.$query->convertQuery('a', 'optValue', $filter['operator'], $filter['value']));
			$allSidOpt = acymailing_loadResultArray($query->db);

			$allSid = array_merge($allSid, $allSidOpt);
		}

		if(empty($allSid)) $allSid[] = -1;

		$query->db->setQuery('SELECT DISTINCT baseData FROM #__sobipro_field_data WHERE sid IN ('.implode(',', $allSid).') AND fid IN ("'.implode('","', $this->fidEmail).'") AND baseData LIKE "%@%.%" ');
		$allUserEmailSobipro = acymailing_loadResultArray($query->db);
		if(empty($allUserEmailSobipro)) $allUserEmailSobipro[] = -1;

		$query->where[] = 'sub.email IN ("'.implode('","', $allUserEmailSobipro).'")';
	}

	private function getFieldsId(){
		$this->fidEmail = array();
		$db = JFactory::getDBO();
		$db->setQuery('SELECT a.fid, a.nid, a.fieldType, a.section, b.name, a.filter '.'FROM #__sobipro_field AS a '.'JOIN #__sobipro_object AS b '.'ON a.section = b.id '.'WHERE (a.fieldType = "inbox" AND a.filter = "email") '.'ORDER BY a.section');
		$nidResult = $db->loadObjectList();
		foreach($nidResult as $oneResult){
			if(($oneResult->fieldType == 'inbox' && $oneResult->filter == 'email') && !in_array($oneResult->fid, $this->fidEmail)){
				$this->fidEmail[] = $oneResult->fid;
			}
		}
	}
}//endclass