<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingTagjevents extends JPlugin{
	var $searchFields = array('rpt.rp_id', 'detail.evdet_id', 'detail.description', 'detail.summary', 'detail.contact', 'detail.location');
	var $selectedFields = array('rpt.*', 'detail.*');

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'tagjevents');
			$this->params = new acyParameter($plugin->params);
		}

		//check if the component is installed
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_jevents');
	}

	function acymailing_getPluginType(){
		$app = JFactory::getApplication();
		if(!$this->component_installed || ($this->params->get('frontendaccess') == 'none' && !$app->isAdmin())) return;
		$onePlugin = new stdClass();
		$onePlugin->name = JText::_('JOOMEXT_EVENT').' <small>(jEvents)</small>';
		$onePlugin->function = 'acymailingtagjevents_show';
		$onePlugin->help = 'plugin-tagjevents';
		return $onePlugin;
	}

	function acymailingtagjevents_show(){
		$config = acymailing_config();
		$app = JFactory::getApplication();
		if($config->get('version') < '5.2.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		$lang = JFactory::getLanguage();
		$lang->load('com_jevents', JPATH_SITE);
		if(file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jevlocations')) $lang->load('com_jevents', JPATH_ADMINISTRATOR);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.tagjevents';
		$pageInfo->filter->order->value = $app->getUserStateFromRequest($paramBase.".filter_order", 'filter_order', 'rpt.startrepeat', 'cmd');
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest($paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->contenttype = $app->getUserStateFromRequest($paramBase.".contenttype", 'contenttype', 'full', 'string');
		$pageInfo->lang = $app->getUserStateFromRequest($paramBase.".lang", 'lang', '', 'string');
		$pageInfo->contenttypeauto = $app->getUserStateFromRequest($paramBase.".contenttypeauto", 'contenttypeauto', 'full', 'string');
		$pageInfo->langauto = $app->getUserStateFromRequest($paramBase.".langauto", 'langauto', '', 'string');
		$pageInfo->pictheight = $app->getUserStateFromRequest($paramBase.".pictheight", 'pictheight', $this->params->get('maxheight', 150), 'string');
		$pageInfo->pictwidth = $app->getUserStateFromRequest($paramBase.".pictwidth", 'pictwidth', $this->params->get('maxwidth', 150), 'string');
		$pageInfo->limit->value = $app->getUserStateFromRequest($paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->pict = $app->getUserStateFromRequest($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->autopict = $app->getUserStateFromRequest($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->readmore = $app->getUserStateFromRequest($paramBase.".readmore", 'readmore', '1', 'string');
		$pageInfo->autoreadmore = $app->getUserStateFromRequest($paramBase.".autoreadmore", 'autoreadmore', '1', 'string');
		$pageInfo->wrap = $app->getUserStateFromRequest($paramBase.".wrap", 'wrap', '0', 'string');
		$pageInfo->clickable = $app->getUserStateFromRequest($paramBase.".clickable", 'clickable', '1', 'string');
		$pageInfo->clickableauto = $app->getUserStateFromRequest($paramBase.".clickableauto", 'clickableauto', '1', 'string');
		$pageInfo->cols = $app->getUserStateFromRequest($paramBase.".cols", 'cols', '1', 'string');
		$pageInfo->pluginFields = $app->getUserStateFromRequest($paramBase.".pluginFields", 'pluginFields', '1', 'string');
		$pageInfo->pluginFieldsauto = $app->getUserStateFromRequest($paramBase.".pluginFieldsauto", 'pluginFieldsauto', '1', 'string');
		$pageInfo->location = $app->getUserStateFromRequest($paramBase.".location", 'location', '0', 'string');
		$pageInfo->exactlocation = $app->getUserStateFromRequest($paramBase.".exactlocation", 'exactlocation', '0', 'string');
		$pageInfo->contentorder = $app->getUserStateFromRequest($paramBase.".contentorder", 'contentorder', 'id', 'string');
		$pageInfo->contentorderdir = $app->getUserStateFromRequest($paramBase.".contentorderdir", 'contentorderdir', 'DESC', 'string');

		$db = JFactory::getDBO();

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $this->searchFields)." LIKE $searchVal";
		}

		//we hide past events but we remove one day just to make sure we won't hide something we should not!
		if($this->params->get('hidepastevents', 'yes') == 'yes'){
			$filters[] = 'rpt.`endrepeat` >= '.$db->Quote(date('Y-m-d', time() - 86400));
		}

		$whereQuery = '';
		if(!empty($filters)){
			$whereQuery = ' WHERE ('.implode(') AND (', $filters).')';
		}

		$query = 'SELECT SQL_CALC_FOUND_ROWS '.implode(',', $this->selectedFields).' FROM `#__jevents_repetition` as rpt ';
		$query .= 'JOIN `#__jevents_vevent` as ev ON rpt.eventid = ev.ev_id ';
		$query .= 'JOIN `#__jevents_vevdetail` AS detail ON ev.detail_id=detail.evdet_id ';

		if(!empty($whereQuery)) $query .= $whereQuery;
		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search, $rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		$picts = array();
		$picts[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$picts[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$picts[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$contenttype = array();
		$contenttype[] = JHTML::_('select.option', "title", JText::_('TITLE_ONLY'));
		$contenttype[] = JHTML::_('select.option', "full", JText::_('FULL_TEXT'));

		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = JHTML::_('select.option', "$i", $i);
		}

		//handle custom fields
		if(ACYMAILING_J16 && file_exists(JPATH_SITE.DS.'plugins'.DS.'jevents'.DS.'jevcustomfields')){
			$db->setQuery('SELECT params FROM #__extensions WHERE element = "jevcustomfields"');
			$jevCFParams = $db->loadObject();
			if(!empty($jevCFParams->params)){
				$template = json_decode($jevCFParams->params)->template;
			}
			if(!empty($template)){
				$xmlfile = JPATH_SITE.DS.'plugins'.DS.'jevents'.DS.'jevcustomfields'.DS.'customfields'.DS.'templates'.DS.$template;
				if(file_exists($xmlfile)){
					$xml = simplexml_load_file($xmlfile);
					$jevCf = $xml->xpath('//fields/fieldset/field');
				}
			}
		}

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('jevents_tab');
		echo $tabs->startPanel(JText::_('JOOMEXT_EVENT'), 'jevents_event');

		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyEvent(eventid, rowClass){
				var tmp = selectedContents.indexOf(eventid)
				if(tmp != -1){
					window.document.getElementById('content' + eventid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content' + eventid).className = 'selectedrow';
					selectedContents.push(eventid);
				}
				updateEventTag();
			}

			function updateEventTag(){
				var tag = '';
				var otherinfo = '';
				var already = 0;

				for(var i = 0; i < document.adminForm.contenttype.length; i++){
					if(document.adminForm.contenttype[i].checked){
						selectedtype = document.adminForm.contenttype[i].value;
						otherinfo += '|type:' + document.adminForm.contenttype[i].value;
					}
				}

				if(document.adminForm.customfields){
					for(var i = 0; i < document.adminForm.customfields.length; i++){
						if(document.adminForm.customfields[i].checked){
							if(already == 0){
								otherinfo += '| custom:' + document.adminForm.customfields[i].value;
								already++;
							}else{
								otherinfo += ', ' + document.adminForm.customfields[i].value;
							}
						}
					}
				}

				for(var i = 0; i < document.adminForm.clickable.length; i++){
					if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value != 0){
						otherinfo += '| clickable';
					}
				}

				if(document.adminForm.pluginFields){
					for(var i = 0; i < document.adminForm.pluginFields.length; i++){
						if(document.adminForm.pluginFields[i].checked){
							otherinfo += '| pluginFields:' + document.adminForm.pluginFields[i].value;
						}
					}
				}

				for(var i = 0; i < document.adminForm.readmore.length; i++){
					if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value != 0){
						otherinfo += '| readmore';
					}
				}

				for(var i = 0; i < document.adminForm.pict.length; i++){
					if(document.adminForm.pict[i].checked){
						otherinfo += '| pict:' + document.adminForm.pict[i].value;
						if(document.adminForm.pict[i].value == 'resized'){
							document.getElementById('pictsize').style.display = '';
							if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidth.value;
							if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				if(window.document.getElementById('jflang') && window.document.getElementById('jflang').value != ''){
					otherinfo += '| lang:';
					otherinfo += window.document.getElementById('jflang').value;
				}

				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value)){
					otherinfo += "| wrap:" + document.adminForm.wrap.value;
				}

				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{jevents:' + selectedContents[i] + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}
			//-->
		</script>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<td>
						<?php echo JText::_('DISPLAY'); ?>
					</td>
					<td colspan="2">
						<?php echo JHTML::_('acyselect.radiolist', $contenttype, 'contenttype', 'size="1" onclick="updateEventTag();"', 'value', 'text', $pageInfo->contenttype); ?>
					</td>
					<td>
						<?php $jflanguages = acymailing_get('type.jflanguages');
						$jflanguages->onclick = 'onchange="updateEventTag();"';
						echo $jflanguages->display('lang', $pageInfo->lang); ?>
					</td>
				</tr>
				<?php
				//handle custom fields
				if(!empty($jevCf)){
					echo '<tr><td>'.JText::_('EXTRA_FIELDS').'</td>';
					$cpt = 1;
					foreach($jevCf as $oneParam){
						if(!empty($oneParam->attributes()->name) && !empty($oneParam->attributes()->label)){
							if($cpt == 4){
								$cpt = 1;
								echo '</tr><tr><td/>';
							}
							echo '<td><input value="'.$oneParam->attributes()->name.'" name="customfields" id="cf_'.$oneParam->attributes()->name.'" type="checkbox" onclick="updateEventTag();" /> ';
							echo '<label for="cf_'.$oneParam->attributes()->name.'">'.$oneParam->attributes()->label.'</label></td>';
							$cpt++;
						}
					}
					while($cpt != 4){
						$cpt++;
						echo '<td/>';
					}
					echo '</tr>';
				}
				?>
				<tr>
					<td><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
					<td><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore', 'size="1" onclick="updateEventTag();"', 'value', 'text', $pageInfo->readmore); ?>
					<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER', '<input type="text" name="wrap" style="width:50px" value="0" onchange="updateEventTag();"/>'); ?></td>
				</tr>

				<tr>
					<td valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
					<td valign="top"><?php echo JHTML::_('acyselect.radiolist', $picts, 'pict', 'size="1" onclick="updateEventTag();"', 'value', 'text', $pageInfo->pict); ?>
						<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?>><br/>
							<?php echo JText::_('CAPTCHA_WIDTH') ?>
							<input name="pictwidth" type="text" onchange="updateEventTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
							<input name="pictheight" type="text" onchange="updateEventTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
					</td>
					<td valign="top"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
					<td valign="top"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable', 'size="1" onclick="updateEventTag();"', 'value', 'text', $pageInfo->clickable); ?></td>
				</tr>
				<?php if((ACYMAILING_J16 && file_exists(JPATH_SITE.DS.'plugins'.DS.'jevents'.DS.'jevfiles'.DS.'jevfiles.php')) || (!ACYMAILING_J16 && file_exists(JPATH_SITE.DS.'plugins'.DS.'jevents'.DS.'jevfiles.php'))){ ?>
					<tr>
						<td><?php echo JText::_('ACY_FILES'); ?></td>
						<td colspan="3"><?php echo JHTML::_('acyselect.radiolist', $choice, 'pluginFields', 'size="1" onclick="updateEventTag();"', 'value', 'text', $pageInfo->pluginFields); ?>
					</tr>
				<?php } ?>
			</table>
		</div>
		<div class="onelineblockoptions">
			<table class="acymailing_table_options">
				<tr>
					<td width="100%">
						<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search; ?>" class="text_area" onchange="document.adminForm.submit();"/>
						<button class="acymailing_button_grey" onclick="this.form.submit();"><?php echo JText::_('JOOMEXT_GO'); ?></button>
						<button class="acymailing_button_grey" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_('JOOMEXT_RESET'); ?></button>
					</td>
				</tr>
			</table>

			<table class="acymailing_table" cellpadding="1" width="100%">
				<thead>
				<tr>
					<th/>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('FIELD_TITLE'), 'detail.summary', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('ACY_DESCRIPTION'), 'detail.description', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_('FIELD_DATE'), 'rpt.startrepeat', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort', JText::_('ACY_ID'), 'rpt.rp_id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
				</tr>
				</thead>
				<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
				</tfoot>
				<tbody>
				<?php
				$k = 0;
				for($i = 0, $a = count($rows); $i < $a; $i++){
					$row =& $rows[$i];
					?>
					<tr id="content<?php echo $row->rp_id; ?>" class="<?php echo "row$k"; ?>" onclick="applyEvent(<?php echo $row->rp_id ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
							<?php echo $row->summary; ?>
						</td>
						<td>
							<?php
							$tag = new stdClass();
							$tag->wrap = 200;
							echo acymailing_absoluteURL($this->acypluginsHelper->wrapText($row->description, $tag));
							if(!empty($row->location)) echo '<br /><b>'.$row->location.'</b>';
							?>
						</td>
						<td align="center">
							<?php echo acymailing_getDate(acymailing_getTime($row->startrepeat), JText::_('DATE_FORMAT_LC')); ?>
						</td>
						<td align="center">
							<?php echo $row->rp_id; ?>
						</td>
					</tr>
					<?php
					$k = 1 - $k;
				}
				?>
				</tbody>
			</table>
		</div>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php
		echo $tabs->endPanel();
		echo $tabs->startPanel(JText::_('UPCOMING_EVENTS'), 'jevents_auto');
		$type = JRequest::getString('type');

		if(!ACYMAILING_J16){
			$db->setQuery('SELECT a.*,b.* FROM `#__jevents_categories` as a LEFT JOIN `#__categories` as b ON a.id = b.id');
		}else{
			$db->setQuery("SELECT b.* FROM `#__categories` as b WHERE b.extension = 'com_jevents' AND b.published >= 0");
		}

		$categories = $db->loadObjectList('id');

		?>
		<br style="font-size:1px"/>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedCat = new Array();
			function applyAutoEvent(catid, rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('event_cat' + catid).className == 'selectedrow'){
						window.document.getElementById('event_catall').className = rowClass;
					}else{
						window.document.getElementById('event_cat' + catid).className = 'selectedrow';
						for(key in selectedCat){
							if(!isNaN(key)){
								window.document.getElementById('event_cat' + key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('event_catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('event_cat' + catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('event_cat' + catid).className = 'selectedrow';
						selectedCat[catid] = 'event';
					}
				}
				updateTag();
			}

			function updateTag(){
				var already = 0;
				var tag = '{autojevents:';
				for(var icat in selectedCat){
					if(selectedCat[icat] == 'event'){
						tag += icat + '-';
					}
				}

				if(document.adminForm.customfieldsauto){
					for(var i = 0; i < document.adminForm.customfieldsauto.length; i++){
						if(document.adminForm.customfieldsauto[i].checked){
							if(already == 0){
								tag += '| custom:' + document.adminForm.customfieldsauto[i].value;
								already++;
							}else{
								tag += ', ' + document.adminForm.customfieldsauto[i].value;
							}
						}
					}
				}

				for(var i = 0; i < document.adminForm.clickableauto.length; i++){
					if(document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value != 0){
						tag += '| clickable';
					}
				}

				if(document.adminForm.pluginFieldsauto){
					for(var i = 0; i < document.adminForm.pluginFieldsauto.length; i++){
						if(document.adminForm.pluginFieldsauto[i].checked){
							tag += '| pluginFields:' + document.adminForm.pluginFieldsauto[i].value;
						}
					}
				}

				for(var i = 0; i < document.adminForm.autoreadmore.length; i++){
					if(document.adminForm.autoreadmore[i].checked && document.adminForm.autoreadmore[i].value != 0){
						tag += '| readmore';
					}
				}

				for(var i = 0; i < document.adminForm.contenttypeauto.length; i++){
					if(document.adminForm.contenttypeauto[i].checked){
						selectedtype = document.adminForm.contenttypeauto[i].value;
						tag += '| type:' + document.adminForm.contenttypeauto[i].value;
					}
				}

				for(var i = 0; i < document.adminForm.pictauto.length; i++){
					if(document.adminForm.pictauto[i].checked){
						tag += '| pict:' + document.adminForm.pictauto[i].value;
						if(document.adminForm.pictauto[i].value == 'resized'){
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) tag += '| maxwidth:' + document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) tag += '| maxheight:' + document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}


				if(window.document.getElementById('jflangauto') && window.document.getElementById('jflangauto').value != ''){
					tag += '| lang:' + window.document.getElementById('jflangauto').value;
				}

				if(document.adminForm.contentorder.value){
					tag += "| order:" + document.adminForm.contentorder.value + "," + document.adminForm.contentorderdir.value;
				}

				if(document.adminForm.cols.value){
					tag += '| cols:' + document.adminForm.cols.value;
				}
				if(document.adminForm.autowrap.value && document.adminForm.autowrap.value != 0){
					tag += "| wrap:" + document.adminForm.autowrap.value;
				}
				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value != 0){
					tag += '| min:' + document.adminForm.min_article.value;
				}
				if(document.adminForm.max_article.value && document.adminForm.max_article.value != 0){
					tag += '| max:' + document.adminForm.max_article.value;
				}
				if(document.adminForm.mindelayevent && document.adminForm.mindelayevent.value && document.adminForm.mindelayevent.value > 0){
					tag += '| mindelay:' + document.adminForm.mindelayevent.value;
				}
				if(document.adminForm.delayevent && document.adminForm.delayevent.value && document.adminForm.delayevent.value > 0){
					tag += '| delay:' + document.adminForm.delayevent.value;
				}
				if(document.adminForm.from_date && document.adminForm.from_date.value){
					tag += '| from:' + document.adminForm.from_date.value;
				}
				if(document.adminForm.to_date && document.adminForm.to_date.value){
					tag += '| to:' + document.adminForm.to_date.value;
				}
				<?php if(file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jevlocations')){ ?>
				if(document.adminForm.location.value && document.adminForm.location.value != 0){
					tag += '| location:' + document.adminForm.location.value;
				}
				if(document.adminForm.exactlocation.value && document.adminForm.exactlocation.value != 0){
					tag += '| exactlocation:' + document.adminForm.exactlocation.value;
				}
				<?php } ?>
				tag += '}';

				setTag(tag);
			}
			//-->
		</script>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<td>
						<?php echo JText::_('DISPLAY'); ?>
					</td>
					<td colspan="2">
						<?php echo JHTML::_('acyselect.radiolist', $contenttype, 'contenttypeauto', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttypeauto); ?>
					</td>
					<td>
						<?php $jflanguages = acymailing_get('type.jflanguages');
						$jflanguages->onclick = 'onchange="updateTag();"';
						$jflanguages->id = 'jflangauto';
						echo $jflanguages->display('langauto', $pageInfo->langauto); ?>
					</td>
				</tr>
				<?php
				//handle custom fields
				if(!empty($jevCf)){
					echo '<tr><td>'.JText::_('EXTRA_FIELDS').'</td>';
					$cpt = 1;
					foreach($jevCf as $oneParam){
						if(!empty($oneParam->attributes()->name) && !empty($oneParam->attributes()->label)){
							if($cpt == 4){
								$cpt = 1;
								echo '</tr><tr><td/>';
							}
							echo '<td><input value="'.$oneParam->attributes()->name.'" name="customfieldsauto" id="cfauto_'.$oneParam->attributes()->name.'" type="checkbox" onclick="updateTag();" /> ';
							echo '<label for="cfauto_'.$oneParam->attributes()->name.'">'.$oneParam->attributes()->label.'</label></td>';
							$cpt++;
						}
					}
					while($cpt != 4){
						$cpt++;
						echo '<td/>';
					}
					echo '</tr>';
				}
				?>
				<tr>
					<td><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
					<td><?php echo JHTML::_('acyselect.radiolist', $choice, 'autoreadmore', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->autoreadmore); ?></td>
					<td nowrap="nowrap" colspan="2"><?php echo JText::sprintf('TRUNCATE_AFTER', '<input type="text" name="autowrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
				</tr>
				<tr>
					<td valign="top" nowrap="nowrap"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
					<td valign="top" nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $picts, 'pictauto', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->autopict); ?>
						<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br/>
							<?php echo JText::_('CAPTCHA_WIDTH') ?>
							<input name="pictwidthauto" type="text" onchange="updateTag();" value="<?php echo $this->params->get('maxwidth', '150'); ?>" style="width:30px;"/>
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
							<input name="pictheightauto" type="text" onchange="updateTag();" value="<?php echo $this->params->get('maxheight', '150'); ?>" style="width:30px;"/>
				</span>
					</td>
					<td valign="top"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
					<td valign="top"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				</tr>
				<?php if((ACYMAILING_J16 && file_exists(JPATH_SITE.DS.'plugins'.DS.'jevents'.DS.'jevfiles'.DS.'jevfiles.php')) || (!ACYMAILING_J16 && file_exists(JPATH_SITE.DS.'plugins'.DS.'jevents'.DS.'jevfiles.php'))){ ?>
					<tr>
						<td><?php echo JText::_('ACY_FILES'); ?></td>
						<td colspan="3"><?php echo JHTML::_('acyselect.radiolist', $choice, 'pluginFieldsauto', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pluginFieldsauto); ?>
					</tr>
				<?php }
				if(file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jevlocations')){
					//handle locations
					$location = array();
					$db->setQuery('SELECT loc_id, title FROM #__jev_locations');
					$locs = $db->loadObjectList();
					$location[] = JHTML::_('select.option', 0, JText::_('ACY_ALL'));
					foreach($locs as $oneLoc){
						$location[] = JHTML::_('select.option', $oneLoc->loc_id, $oneLoc->title);
					}
					?>
					<tr>
						<td>
							<?php echo JText::_('JEV_EVENT_ADRESSE').' ('.JText::_('JEV_EVENT_CATEGORY').')'; ?>
						</td>
						<td>
							<?php echo JHTML::_('select.genericlist', $location, 'location', 'size="1" style="width:150px" onchange="updateTag();"', 'value', 'text', $pageInfo->location); ?>
						</td>
						<td>
							<?php echo JText::_('JEV_EVENT_ADRESSE'); ?>
						</td>
						<td>
							<?php echo JHTML::_('select.genericlist', $location, 'exactlocation', 'size="1" style="width:150px" onchange="updateTag();"', 'value', 'text', $pageInfo->exactlocation); ?>
						</td>
					</tr>
				<?php } ?>
				<tr>
					<td>
						<?php echo JText::_('MAX_ARTICLE'); ?>
					</td>
					<td>
						<input type="text" name="max_article" style="width:50px" value="20" onchange="updateTag();"/>
					</td>
					<td>
						<?php echo JText::_('FIELD_COLUMNS'); ?>
					</td>
					<td>
						<?php echo JHTML::_('select.genericlist', $column, 'cols', 'size="1" style="width:50px" onchange="updateTag();"', 'value', 'text', $pageInfo->cols); ?>
					</td>
				</tr>
				<tr>
				<?php if($type == 'autonews'){ ?>
						<td>
							<?php echo JText::_('MIN_ARTICLE'); ?>
						</td>
						<td>
							<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTag();"/>
						</td>
				<?php } ?>
						<td nowrap="nowrap">
							<?php echo JText::_('ACY_ORDER'); ?>
						</td>
						<td nowrap="nowrap"<?php if($type != 'autonews'){ echo ' colspan="3"'; }?>>
							<?php
							$values = array('rp_id' => 'ACY_ID', 'startrepeat' => 'JEV_EVENT_STARTDATE', 'endrepeat' => 'JEV_EVENT_ENDDATE', 'summary' => 'FIELD_TITLE');
							echo $this->acypluginsHelper->getOrderingField($values, $pageInfo->contentorder, $pageInfo->contentorderdir, 'updateTag');
							?>
						</td>
					</tr>
				<?php if($type == 'autonews'){ ?>
					<tr>
						<td>
							<?php echo JText::_('ACY_FROM_DATE'); ?>
						</td>
						<td>
							<?php $delayType = acymailing_get('type.delay');
							$delayType->onChange = "updateTag();";
							echo $delayType->display('mindelayevent', 0, 3); ?>
						</td>
						<td nowrap="nowrap">
							<?php echo JText::_('ACY_TO_DATE'); ?>
						</td>
						<td nowrap="nowrap">
							<?php $delayType = acymailing_get('type.delay');
							$delayType->onChange = "updateTag();";
							echo $delayType->display('delayevent', 7776000, 3); ?>
						</td>
					</tr>
				<?php }else{ ?>
					<tr>
						<td>
							<?php echo JText::_('ACY_FROM_DATE'); ?>
						</td>
						<td>
							<?php echo JHTML::_('calendar', '', 'from_date', 'from_date', '%Y-%m-%d', array('style' => 'width:80px', 'onchange' => 'updateTag();')); ?>
						</td>
						<td>
							<?php echo JText::_('ACY_TO_DATE'); ?>
						</td>
						<td>
							<?php echo JHTML::_('calendar', '', 'to_date', 'to_date', '%Y-%m-%d', array('style' => 'width:80px', 'onchange' => 'updateTag();')); ?>
						</td>
					</tr>
				<?php } ?>
			</table>
		</div>
		<div class="onelineblockoptions">
			<table class="acymailing_table" cellpadding="1" width="100%">
				<?php $k = 0; ?>
				<tr id="event_catall" class="<?php echo "row$k"; ?>" onclick="applyAutoEvent('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
					<td class="acytdcheckbox"/>
					<td>
						<?php
						echo JText::_('ACY_ALL');
						?>
					</td>
				</tr>
				<?php
				foreach($categories as $oneCat){ ?>
					<tr id="event_cat<?php echo $oneCat->id ?>" class="<?php echo "row$k"; ?>" onclick="applyAutoEvent(<?php echo $oneCat->id ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"/>
						<td>
							<?php
							if(!empty($oneCat->parent_id) && !empty($categories[$oneCat->parent_id])) echo $categories[$oneCat->parent_id]->title.' => ';
							echo $oneCat->title;
							?>
						</td>
					</tr>
					<?php $k = 1 - $k;
				} ?>
			</table>
		</div>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
		//End of the function
	}

	function acymailing_replacetags(&$email, $send = true){
		$this->_replaceAuto($email);
		$this->_replaceEvents($email);
	}

	function _replaceEvents(&$email){
		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, 'jevents');

		if(empty($tags)) return;

		$lang = JFactory::getLanguage();
		$lang->load('com_jevents', JPATH_SITE);

		$this->newslanguage = new stdClass();
		if(!empty($email->language)){
			$db = JFactory::getDBO();
			$db->setQuery('SELECT lang_id, lang_code FROM #__languages WHERE sef = '.$db->quote($email->language).' LIMIT 1');
			$this->newslanguage = $db->loadObject();
		}

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');
		if(!ACYMAILING_J16){
			$config = JFactory::getConfig();
			$this->timeoffset = $config->getValue('config.offset');
		}

		//Set the read more link:
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE', true).'" />';

		if((ACYMAILING_J16 && file_exists(JPATH_SITE.DS.'plugins'.DS.'jevents'.DS.'jevfiles'.DS.'jevfiles.php')) || (!ACYMAILING_J16 && file_exists(JPATH_SITE.DS.'plugins'.DS.'jevents'.DS.'jevfiles.php'))) {
			$JEVplugin = JPluginHelper::getPlugin('jevents', 'jevfiles');
			$JEVparams = new acyParameter($JEVplugin->params);
			$this->imgFolder = ACYMAILING_LIVE . 'images/' . trim($JEVparams->get('folder', 'jevents'), '/') . '/';
		}

		$tagsReplaced = array();
		foreach($tags as $i => $params){
			if(isset($tagsReplaced[$i])) continue;
			$tagsReplaced[$i] = $this->_replaceEvent($tags[$i]);
		}

		$this->acypluginsHelper->replaceTags($email, $tagsReplaced, true);
	}

	function _replaceEvent(&$tag){

		$app = JFactory::getApplication();
		if(empty($tag->itemid)){
			$tag->itemid = $this->params->get('itemid', 0);
		}
		//1 : Load the informations of the product...
		$query = 'SELECT rpt.*,detail.*,cat.title as category, ev.catid, ev.uid FROM `#__jevents_repetition` as rpt ';
		$query .= ' JOIN `#__jevents_vevent` as ev ON rpt.eventid = ev.ev_id ';
		$query .= ' JOIN `#__jevents_vevdetail` AS detail ON rpt.eventdetail_id = detail.evdet_id ';
		$query .= 'LEFT JOIN `#__categories` as cat ON cat.id = ev.catid ';
		$query .= 'WHERE rpt.rp_id = '.intval($tag->id).' LIMIT 1';

		$db = JFactory::getDBO();
		$db->setQuery($query);
		$event = $db->loadObject();

		//We just loaded the article but we may need to translate it depending on tag->lang...
		if(empty($tag->lang) && !empty($this->newslanguage) && !empty($this->newslanguage->lang_code)) $tag->lang = $this->newslanguage->lang_code.','.$this->newslanguage->lang_id;

		$this->acypluginsHelper->translateItem($event, $tag, 'jevents_vevdetail', $event->evdet_id);

		if(empty($event)){
			if($app->isAdmin()) $app->enqueueMessage('The event "'.$tag->id.'" could not be loaded', 'notice');
			return '';
		}

		//Do we need to load the location from somewhere else?
		if(file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jevlocations') && !empty($event->location) && is_numeric($event->location)){
			$query = 'SELECT title,street,postcode,city,state,country FROM `#__jev_locations` WHERE loc_id = '.intval($event->location);
			$db->setQuery($query);
			$location = $db->loadObject();
			if(!empty($location)){
				foreach($location as $prop => $value){
					$event->$prop = $value;
				}
				$event->location = $location->title;
			}
		}

		$varFields = array();
		foreach($event as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}
		if(ACYMAILING_J16){
			$startdate = JHTML::_('date', $event->startrepeat, JText::_('DATE_FORMAT_LC'), null);
			$enddate = JHTML::_('date', $event->endrepeat, JText::_('DATE_FORMAT_LC'), null);
		}else{
			$startdate = JHTML::_('date', strtotime($event->startrepeat) - date('Z'), JText::_('DATE_FORMAT_LC'), $this->timeoffset);
			$enddate = JHTML::_('date', strtotime($event->endrepeat) - date('Z'), JText::_('DATE_FORMAT_LC'), $this->timeoffset);
		}
		$starttime = substr($event->startrepeat, 11, 5);
		$endtime = substr($event->endrepeat, 11, 5);

		if($starttime == '00:00'){
			$starttime = '';
			$endtime = '';
		}elseif($event->noendtime){
			$endtime = '';
		}

		$cfg = JComponentHelper::getParams("com_jevents");
		$useStdTime = $cfg->get('com_calUseStdTime');

		if(!empty($useStdTime)){
			if(!empty($starttime)) $starttime = strtolower(strftime("%#I:%M%p", strtotime($event->startrepeat)));
			if(!empty($endtime)) $endtime = strtolower(strftime("%#I:%M%p", strtotime($event->endrepeat)));
		}

		$date = $startdate;
		if(!empty($starttime)) $date .= ' '.$starttime;
		if($startdate == $enddate){
			if(!empty($endtime)) $date .= ' - '.$endtime;
		}else{
			$date .= ' - '.$enddate;
			if(!empty($endtime)) $date .= ' '.$endtime;
		}
		$varFields['{date}'] = $date;


		$link = ACYMAILING_LIVE.'index.php?option=com_jevents&task=icalrepeat.detail&evid='.intval($event->rp_id);
		if(!empty($tag->itemid)){
			$link .= '&Itemid='.intval($tag->itemid);
		}else{
			$areaCats = array();
			$areaCats[] = $event->catid;
			$db->setQuery('SELECT id, parent_id FROM #__categories');
			$cats = $db->loadObjectList('id');
			$position = $event->catid;
			while($cats[$position]->parent_id != 0){
				$areaCats[] = $cats[$position]->parent_id;
				$position = $cats[$position]->parent_id;
			}
			$menuId = '';
			$db->setQuery('SELECT id, params FROM #__menu WHERE link LIKE "index.php?option=com_jevents&view=cat&layout=listevents"');
			$menus = $db->loadObjectList();
			if(!empty($menus)){
				foreach($menus as $i => $menu){
					$menus[$i]->params = json_decode($menus[$i]->params);
					if(empty($menus[$i]->params->catidnew)) continue;
					foreach($menus[$i]->params->catidnew as $oneCatid){
						if(in_array($oneCatid, $areaCats)){
							$menuId = $menus[$i]->id;
							break;
						}
					}
					if($menuId != '') break;
				}
			}

			if(!empty($menuId)){
				$link .= '&Itemid='.intval($menuId);
			}else{
				$summary = str_replace('-', ' ', $event->summary);
				$summary = trim(strtolower($summary));
				$summary = preg_replace('/(\s|[^A-Za-z0-9\-])+/', '-', $summary);
				$summary = trim($summary, '-');
				$time = explode('-', substr($event->startrepeat, 0, strpos($event->startrepeat, ' ')));
				$link = 'index.php?option=com_jevents&task=icalrepeat.detail&evid='.intval($event->rp_id).'&year='.intval($time[0]).'&month='.intval($time[1]).'&day='.intval($time[2]).'&title='.$summary.'&uid='.$event->uid;
			}
		}
		if(!empty($tag->lang)) $link .= '&lang='.substr($tag->lang, 0, strpos($tag->lang, ','));
		$varFields['{link}'] = $link;

		$result = '<table cellspacing="0" cellpadding="0" border="0" width="100%">';

		$event->summary = '<h2 class="acymailing_title">'.$event->summary.'</h2>';
		if(!empty($tag->clickable)) $event->summary = '<a target="_blank" href="'.$link.'">'.$event->summary.'</a>';
		$result .= '<tr><td>'.$event->summary.'</td></tr>';

		$event->description = $this->acypluginsHelper->wrapText($event->description, $tag);
		$varFields['{wrapeddescription}'] = $event->description;

		if($tag->type == 'full'){
			$result .= '<tr><td><span class="eventdate">'.$date.'</span></td></tr>';

			$result .= '<tr><td class="eventdescription">'.$event->description.'</td></tr>';
			if(!empty($event->location)) $result .= '<tr><td><span class="eventlocation">'.JText::_('JEV_EVENT_ADRESSE').' : '.$event->location.'</span></td></tr>';

			//handle custom fields
			if(!empty($tag->custom)){
				//extract wanted fields
				$tag->custom = explode(',', $tag->custom);
				foreach($tag->custom as $i => $oneField){
					$tag->custom[$i] = trim($oneField);
				}
				
				//first retrieve which template is selected in jevents plugin for custom fields
				$db->setQuery('SELECT params FROM #__extensions WHERE element = "jevcustomfields"');
				$jevCFParams = $db->loadObject();
				if(!empty($jevCFParams->params)) $template = json_decode($jevCFParams->params)->template;

				//load available custom fields
				if(!empty($template)){
					$xmlfile = JPATH_SITE.DS.'plugins'.DS.'jevents'.DS.'jevcustomfields'.DS.'customfields'.DS.'templates'.DS.$template;
					if(file_exists($xmlfile)){
						$xml = simplexml_load_file($xmlfile);
						$jevCf = $xml->xpath('//fields/fieldset/field');
						$customFields = array();
						foreach($jevCf as $i => $oneField){
							$name = (string)$oneField->attributes()->name;
							$customFields[$name] = new stdClass();
							$customFields[$name]->label = (string)$oneField->attributes()->label;
							$customFields[$name]->type = (string)$oneField->attributes()->type;

							if(empty($oneField->option)) continue;

							$customFields[$name]->options = array();
							foreach($oneField->option as $oneOption){
								$customFields[$name]->options[] = $oneOption;
							}
						}
					}
				}

				//load values
				$db->setQuery('SELECT name, value FROM #__jev_customfields WHERE evdet_id = '.intval($event->evdet_id));
				$customVDB = $db->loadObjectList();
				foreach($customVDB as $oneField){
					$varFields['{'.$oneField->name.'}'] = $oneField->value;
				}

				$customValues = array();
				foreach($customVDB as $oneCustomValue){
					$customValues[$oneCustomValue->name] = $oneCustomValue->value;
				}

				//display custom fields
				if(!empty($customValues)){
					foreach($tag->custom as $oneCustom){
						$label = (!empty($customFields[$oneCustom]->label)) ? $customFields[$oneCustom]->label : $oneCustom;
						//i.e. "if this fields have different possible values"
						if(!empty($customFields[$oneCustom]->options)){
							$multipleValues = explode(',', $customValues[$oneCustom]);

							//all this block is made to replace the keys by the label in the field's values
							$orderedValues = array();
							foreach($multipleValues as $oneValue){
								$orderedValues[$oneValue] = $oneValue;
							}

							$possibleValues = array();
							foreach($customFields[$oneCustom]->options as $oneOption){
								$possibleValues[(string)$oneOption->attributes()->value] = (string)$oneOption;
							}

							foreach($orderedValues as $key => $j){
								$orderedValues[$key] = $possibleValues[$key];
							}
							$customValues[$oneCustom] = implode(', ', $orderedValues);
						}elseif($customFields[$oneCustom]->type == 'jevrurl'){ //we want a link !
							$customValues[$oneCustom] = '<a href="'.$customValues[$oneCustom].'">'.$customValues[$oneCustom].'</a>';
						}elseif($customFields[$oneCustom]->type == 'jevrcalendar'){//comprehensible display
							$customValues[$oneCustom] = acymailing_getDate(acymailing_getTime($customValues[$oneCustom]), JText::_('DATE_FORMAT_LC'));
						}elseif($customFields[$oneCustom]->type == 'jevruser'){//we do not want the user id but its name
							$db->setQuery('SELECT name FROM #__users WHERE id = '.intval($customValues[$oneCustom]));
							$user = acymailing_loadResultArray($db);
							$customValues[$oneCustom] = (empty($user[0])) ? $customValues[$oneCustom] : $user[0];
						}elseif($customFields[$oneCustom]->type == 'jevcfboolean'){
							$customValues[$oneCustom] = empty($customValues[$oneCustom]) ? JText::_('JOOMEXT_NO') : JText::_('JOOMEXT_YES');
						}

						if(empty($customValues[$oneCustom]) && in_array($customFields[$oneCustom]->type, array('jevcfuser','jevcfyoutube','jevcfupdatable','jevcfdblist','jevcftext','jevcfimage','jevcffile','jevcfhtml','jevcfeventflag','jevcfnotes'))){
							unset($customValues[$oneCustom]);
						}

						if(isset($customValues[$oneCustom])) $result .= '<tr><td><span class="jev_cf_"'.$oneCustom.'>'.$label.' : '.$customValues[$oneCustom].'</span></td></tr>';
					}
				}
			}
			if(!empty($event->contact)) $result .= '<tr><td><span class="eventcontact">'.$event->contact.'</span></td></tr>';
			if(!empty($event->extra_info)) $result .= '<tr><td><span class="eventextra">'.$event->extra_info.'</span></td></tr>';
		}

		if((ACYMAILING_J16 && file_exists(JPATH_SITE.DS.'plugins'.DS.'jevents'.DS.'jevfiles'.DS.'jevfiles.php')) || (!ACYMAILING_J16 && file_exists(JPATH_SITE.DS.'plugins'.DS.'jevents'.DS.'jevfiles.php'))){

			if(in_array($db->getPrefix().'jev_files_combined', $db->getTableList())){
				$db->setQuery('SELECT * FROM `#__jev_files_combined` WHERE ev_id = (SELECT eventid FROM #__jevents_repetition WHERE rp_id = '.intval($tag->id).')');
				$filesRow = $db->loadObject();

				if(!empty($filesRow)){
					for($i = 1 ; $i < 30 ; $i++){
						if(!empty($filesRow->{'imagename'.$i})){
							$varFields['{imgpath'.$i.'}'] = $this->imgFolder.$filesRow->{'imagename'.$i};
							$result .= '<tr><td><a target="_blank" href="'.$varFields['{imgpath'.$i.'}'].'"><img src="'.$varFields['{imgpath'.$i.'}'].'"/></a></td></tr>';
						}

						if(!empty($filesRow->{'filename'.$i})){
							$varFields['{filepath'.$i.'}'] = $this->imgFolder.$filesRow->{'filename'.$i};
							if(!empty($tag->pluginFields)) $files[] = '<tr><td><a target="_blank" href="'.$varFields['{filepath'.$i.'}'].'">'.(empty($filesRow->{'filename'.$i}) ?  : $filesRow->{'filetitle'.$i}).'</a></td></tr>';
						}
					}
					if(!empty($files)) $result .= implode('', $files);
				}
			}else{
				$db->setQuery('SELECT * FROM `#__jev_files` WHERE ev_id = (SELECT eventid FROM #__jevents_repetition WHERE rp_id = '.intval($tag->id).') ORDER BY filetype DESC');
				$files = $db->loadObjectList();

				if(!empty($files)){
					foreach ($files as $i => $oneFile) {
						if (empty($oneFile->filename)) continue;

						$varFields['{imgpath' . $i . '}'] = $this->imgFolder . $oneFile->filename;
						if ($oneFile->filetype == 'file') {
							if(!empty($tag->pluginFields)) $result .= '<tr><td><a target="_blank" href="'.$varFields['{imgpath'.$i.'}'].'">'.$oneFile->filetitle.'</a></td></tr>';
						} else {
							$result .= '<tr><td><a target="_blank" href="'.$varFields['{imgpath'.$i.'}'].'"><img src="'.$varFields['{imgpath'.$i.'}'].'"/></a></td></tr>';
						}
					}
				}
			}
		}

		if(!empty($tag->readmore)){
			$readMoreText = empty($this->readmore) ? JText::_('JOOMEXT_READ_MORE') : $this->readmore;
			$varFields['{readmore}'] = '<a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$readMoreText.'</span></a>';
			$result .= '<tr><td><br />'.$varFields['{readmore}'].'</td></tr>';
		}

		$result = '<div class="acymailing_content" >'.$result.'</table></div>';

		//Check if the template exists...
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'tagjevents.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'tagjevents.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields), $varFields, $result);
		}

		$result = $this->acypluginsHelper->removeJS($result);
		$result = $this->acypluginsHelper->managePicts($tag, $result);

		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function _handleChildrens($parent_id){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			$this->catvalues[] = $cat->id;
			$this->_handleChildrens($cat->id);
		}
	}

	function acymailing_generateautonews(&$email){
		$db = JFactory::getDBO();
		$time = time();

		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, 'autojevents');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;

			if(empty($parameter->order)) $parameter->order = 'startrepeat,ASC';
			if(empty($parameter->from)) $parameter->from = date('Y-m-d H:i:s', $time);

			$allcats = explode('-', $parameter->id);
			//Load the articles based on all arguments...
			$selectedArea = array();

			if(!empty($parameter->location)){
				$db->setQuery('SELECT catid FROM #__jev_locations WHERE loc_id = '.intval($parameter->location));
				$loc = $db->loadResult();

				$db->setQuery('SELECT * FROM #__categories WHERE extension LIKE "com_jevents"');
				$mosetCats = $db->loadObjectList();
				$this->cats = array();
				foreach($mosetCats as $oneCat){
					$this->cats[$oneCat->parent_id][] = $oneCat;
				}

				$this->catvalues = array();
				$this->catvalues[] = $loc;
				$this->_handleChildrens($loc);
				$allcats = array_merge($allcats, $this->catvalues);
			}

			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = 'ev.`catid` = '.intval($oneCat);
			}


			$query = 'SELECT rpt.rp_id FROM `#__jevents_repetition` AS rpt ';
			$query .= ' JOIN `#__jevents_vevent` AS ev ON rpt.eventid = ev.ev_id ';
			if(isset($parameter->priority) || isset($parameter->exactlocation) || strpos($parameter->order, 'summary') !== false){
				$query .= ' JOIN `#__jevents_vevdetail` as evdet ON ev.detail_id = evdet.evdet_id ';
			}

			$where = array();
			if(!empty($selectedArea)){
				$where[] = implode(' OR ', $selectedArea);
			}

			if(!empty($parameter->exactlocation)){
				$where[] = 'evdet.location = '.intval($parameter->exactlocation);
			}

			if(isset($parameter->priority)){
				//we check if the values are integer values
				$parameter->priority = explode(',', $parameter->priority);
				JArrayHelper::toInteger($parameter->priority);
				$where[] = 'evdet.priority IN ('.implode(',', $parameter->priority).')';
			}
			$where[] = 'ev.`state` = 1';

			if(!empty($parameter->addcurrent)){
				//not finished and next events
				$where[] = 'rpt.`endrepeat` >= '.$db->Quote($parameter->from);
			}else{
				//not started events
				$where[] = 'rpt.`startrepeat` >= '.$db->Quote($parameter->from);
			}

			//should we display only events starting in the sending day ?
			if(!empty($parameter->todaysevent)){
				$where[] = 'rpt.`startrepeat` <= '.$db->Quote(date('Y-m-d 23:59:59', $time));
			}

			if(!empty($parameter->mindelay)) $where[] = 'rpt.`startrepeat` >= '.$db->Quote(date('Y-m-d H:i:s', $time + $parameter->mindelay));
			if(!empty($parameter->delay)) $where[] = 'rpt.`startrepeat` <= '.$db->Quote(date('Y-m-d H:i:s', $time + $parameter->delay));
			if(!empty($parameter->to)) $where[] = 'rpt.`startrepeat` <= '.$db->Quote($parameter->to);

			//This access level check should be done for J1.5 only
			if(!ACYMAILING_J16){
				if($this->params->get('contentaccess', 'registered') == 'registered'){
					$where[] = 'ev.`access` <= 1';
				}elseif($this->params->get('contentaccess', 'registered') == 'public') $where[] = 'ev.`access` = 0';
			}elseif(isset($parameter->access)){
				//We set it only if the access is defined in the tag
				$where[] = 'ev.`access` = '.intval($parameter->access);
			}

			if(!empty($parameter->created) && !empty($email->params['lastgenerateddate'])){
				$where[] = 'ev.created > \''.date('Y-m-d H:i:s', $email->params['lastgenerateddate'] - date('Z')).'\' AND ev.created < \''.date('Y-m-d H:i:s', $time - date('Z')).'\'';
			}

			$query .= ' WHERE ('.implode(') AND (', $where).')';

			$ordering = explode(',', $parameter->order);
			if($ordering[0] == 'rand'){
				$query .= ' ORDER BY rand()';
			}else{
				//We add a second ordering in case of the user choose to order by category.
				$query .= ' ORDER BY '.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
			}

			if(!empty($parameter->max)) $query .= ' LIMIT '.intval($parameter->max);

			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);

			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough events for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autojevents.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autojevents.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the article tag one after the other in a table as they are already sorted
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$stringTag .= '<tr><td>';
						$args = array();
						$args[] = 'jevents:'.$oneArticleId;
						if(isset($parameter->pluginFields)) $args[] = 'pluginFields:'.$parameter->pluginFields;
						if(!empty($parameter->custom)) $args[] = 'custom:'.$parameter->custom;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->clickable)) $args[] = 'clickable';
						if(isset($parameter->readmore)) $args[] = 'readmore';
						if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
						if(!empty($parameter->itemid)) $args[] = 'itemid:'.$parameter->itemid;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|', $args).'}';
					}
					$stringTag = $this->acypluginsHelper->getFormattedResult($arrayElements, $parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}

	function onAcyDisplayFilters(&$type){
		$acyconfig = acymailing_config();
		$type['jevents'] = 'JEvents & RSVP event';
		if(version_compare($acyconfig->get('version'), '4.9.4', '<')) return '<div id="filter__num__jevents">Please update AcyMailing, the Jevents plugin may not work properly with this version</div>';
		if(!$this->component_installed) return '<div id="filter__num__jevents">You must install JEvent and RSVP to use this filter</div>';
		if(!file_exists(JPATH_SITE.DS.'components'.DS.'com_rsvppro')) return '<div id="filter__num__jevents">This filter uses the JEvents\' RSVP plugin, you must install it first</div>';

		$lang = JFactory::getLanguage();
		$lang->load('com_rsvppro', JPATH_ADMINISTRATOR);

		$db = JFactory::getDBO();
		$db->setQuery('SELECT at.id, evdet.summary 
						FROM #__jevents_vevdetail AS evdet 
						JOIN #__jevents_vevent AS ev ON ev.detail_id = evdet.evdet_id
						JOIN #__jev_attendance AS at ON ev.ev_id = at.ev_id
						ORDER BY evdet.summary ASC');
		$allEvents = (array)$db->loadObjectList();
		$eventList = array();
		if(!empty($allEvents)){
			foreach($allEvents as $oneEvent){
				$eventList[] = JHTML::_('select.option', $oneEvent->id, $oneEvent->summary);
			}
		}else{
			$eventList[] = JHTML::_('select.option', '<OPTGROUP>', "No event");
			$eventList[] = JHTML::_('select.option', '</OPTGROUP>');
		}

		$attend = array();
		$attend[] = JHTML::_('select.option', '-1', JText::_('RSVP_ALL_REGISTERED_USERS'));
		$attend[] = JHTML::_('select.option', '1', JText::_('RSVP_IS_CONFIRMED'));
		$attend[] = JHTML::_('select.option', '0', JText::_('RSVP_PENDING'));

		$return = '<div id="filter__num__jevents">';
		$return .= JText::_('JOOMEXT_EVENT').' '.JHTML::_('select.genericlist', $eventList, 'filter[__num__][jevents][id]', 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
		$return .= '<br />'.JText::_('RSVP_CONFIRMED').' '.JHTML::_('select.genericlist', $attend, 'filter[__num__][jevents][attending]', 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
		$return .= '<br /><input type="text" name="filter[__num__][jevents][subdateinf]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:70px;" /> < '.JText::_('RSVP_EVENT_REGISTRATION_DATE').' < <input type="text" name="filter[__num__][jevents][subdatesup]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:70px;"/></div>';
		return $return;
	}

	function onAcyProcessFilterCount_jevents(&$query, $filter, $num){
		$this->onAcyProcessFilter_jevents($query, $filter, $num);
		return JText::sprintf('SELECTED_USERS', $query->count());
	}

	function onAcyProcessFilter_jevents(&$query, $filter, $num){
		if(!$this->component_installed) return;

		if(!empty($filter['subdateinf'])){
			$filter['subdateinf'] = acymailing_replaceDate($filter['subdateinf']);
			if(!is_numeric($filter['subdateinf'])) $filter['subdateinf'] = strtotime($filter['subdateinf']);
			if(!empty($filter['subdateinf'])) $query->where[] = 'jev_attendees'.$num.'.created > '.$query->db->quote(date('Y-m-d H:i:s', $filter['subdateinf']));
		}

		if(!empty($filter['subdatesup'])){
			$filter['subdatesup'] = acymailing_replaceDate($filter['subdatesup']);
			if(!is_numeric($filter['subdatesup'])) $filter['subdatesup'] = strtotime($filter['subdatesup']);
			if(!empty($filter['subdatesup'])) $query->where[] = 'jev_attendees'.$num.'.created < '.$query->db->quote(date('Y-m-d H:i:s', $filter['subdatesup']));
		}

		$myquery = '#__jev_attendees AS jev_attendees'.$num.' ON jev_attendees'.$num.'.email_address = sub.email OR (jev_attendees'.$num.'.user_id = sub.userid AND jev_attendees'.$num.'.user_id != 0)';
		$query->join[] = $myquery;
		$query->where[] = 'jev_attendees'.$num.'.at_id = '.intval($filter['id']);
		if($filter['attending'] != -1){
			$query->where[] = 'jev_attendees'.$num.'.attendstate = '.intval($filter['attending']);
		}
	}

}//endclass