<?php
/**
 * @copyright    Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingUniversaltag extends JPlugin{

	public function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'universaltag');
			$this->params = new JParameter($plugin->params);
		}
	}

	public function acymailing_getPluginType(){

		$onePlugin = new stdClass();
		$onePlugin->name = 'Load data...';
		$onePlugin->function = 'acymailinguniversaltag_show';
		$onePlugin->help = 'plugin-universaltag';

		return $onePlugin;
	}

	public function acymailinguniversaltag_show(){

		$config = acymailing_config();
		if($config->get('version') < '4.9.4'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		$app = JFactory::getApplication();

		$pageInfo = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.universaltag';
		$pageInfo->table = $app->getUserStateFromRequest($paramBase.".table", 'table', '', 'cmd');

		//Let's display a list of tables you can use...
		$db = JFactory::getDBO();

		try{
			$db->setQuery('SHOW DATABASES');
			$allDatabases = acymailing_loadResultArray($db);
			array_unshift($allDatabases, '');
		}catch(Exception $e){
			$allDatabases = '';
		}

		$pageInfo->db = $app->getUserStateFromRequest($paramBase.".db", 'db', '', 'cmd');
		$query = 'SHOW TABLES';
		if(!empty($pageInfo->db)) $query .= ' FROM `'.$pageInfo->db.'`';
		$db->setQuery($query);
		$allTables = acymailing_loadResultArray($db);
		array_unshift($allTables, '');

		if(empty($allDatabases)){
			if(empty($pageInfo->db)){
				$db->setQuery('SELECT DATABASE()');
				$pageInfo->db = $db->loadResult();
			}
			$allDatabases = array($pageInfo->db);
		}
		?>

		<script language="javascript" type="text/javascript">
			<!--
			function updateTag(){
				tag = '{loaddata:';
				if(document.adminForm.db && document.adminForm.db.value){
					tag += document.adminForm.db.value + '.';
				}
				tag += document.adminForm.table.value;
				tag += '|fields:';
				for(var i = 0; i < document.adminForm.fields.length; i++){
					if(document.adminForm.fields[i].checked){
						tag += document.adminForm.fields[i].value + ', ';
					}
				}
				if(document.adminForm.where_map.value.length > 0){
					tag += '|where1:' + document.adminForm.where_map.value + ',' + document.adminForm.where_operator.value + ',' + document.adminForm.where_value.value;
				}
				tag += '|order:' + document.adminForm.orderby.value + ',' + document.adminForm.order.value;
				if(document.adminForm.start.value > 0) tag += '|start:' + document.adminForm.start.value;
				if(document.adminForm.limit.value > 0) tag += '|limit:' + document.adminForm.limit.value;
				if(document.adminForm.template.value) tag += '|template:' + document.adminForm.template.value;
				tag += '}';
				setTag(tag);
			}
			//-->
		</script>
		<table width="100%" class="adminform">
			<?php if(!empty($allDatabases)){ ?>
				<tr>
					<td>
						<?php echo JText::_('DATABASE'); ?>
					</td>
					<td>
						<select name="db" onchange="document.adminForm.table.value = ''; document.adminForm.submit();">
							<?php foreach($allDatabases as $oneDB){
								echo '<option '.($pageInfo->db == $oneDB ? 'selected="selected"' : '').' value="'.$oneDB.'">'.$oneDB.'</option>';
							} ?>
						</select>
					</td>
				</tr>
			<?php } ?>
			<tr>
				<td>
					<?php echo JText::_('TABLENAME'); ?>
				</td>
				<td>
					<select name="table" onchange="document.adminForm.submit();">
						<?php foreach($allTables as $oneTable){
							echo '<option '.($pageInfo->table == $oneTable ? 'selected="selected"' : '').' value="'.$oneTable.'">'.$oneTable.'</option>';
						}?>
					</select>
				</td>
			</tr>

			<?php

			if(empty($pageInfo->table)){
				echo '</table>';
				return;
			}

			$myTable = $pageInfo->table;
			if(!empty($pageInfo->db)) $myTable = '`'.$pageInfo->db.'`.'.$pageInfo->table;
			//Load fields from this table:
			$db->setQuery('SHOW FIELDS FROM '.$myTable);
			$fields = $db->loadObjectList();

			if(empty($fields)){
				echo '</table>';
				return;
			}
			?>
			<tr>
				<td><?php echo JText::_('DISP_FIELDS'); ?></td>
				<td><?php foreach($fields as $oneField){
						echo '<p style="float:left;padding:0px 10px;margin:0px;"><input type="checkbox" onclick="updateTag()" name="fields" value="'.$oneField->Field.'" id="'.$oneField->Field.'" /><label for="'.$oneField->Field.'"> '.$oneField->Field.'</label></p>';
					} ?></td>
			</tr>
			<tr>
				<td>Where</td>
				<td>
					<?php
					$field = array();
					$field[] = JHTML::_('select.option', '', ' - - - ');
					foreach($fields as $oneField){
						$field[] = JHTML::_('select.option', $oneField->Field, $oneField->Field);
					}
					$operators = acymailing_get('type.operators');
					$operators->extra = 'onchange="updateTag()"';
					echo JHTML::_('select.genericlist', $field, "where_map", 'onchange="updateTag()" class="inputbox" style="width:120px;" size="1"', 'value', 'text');
					echo $operators->display("where_operator").' <input onchange="updateTag()" class="inputbox" type="text" name="where_value" style="width:100px" value="">';

					?>
				</td>
			</tr>
			<tr>
				<td><?php echo JText::_('ACY_ORDER'); ?></td>
				<td>
					<select name="orderby" onchange="updateTag();" style="width:120px;">
						<option value="rand()"><?php echo JText::_('ACY_RANDOM'); ?></option>
						<?php foreach($fields as $oneField){
							echo '<option value="'.$oneField->Field.'">'.$oneField->Field.'</option>';
						}?>
					</select>
					<select name="order" onchange="updateTag();" style="width:100px;">
						<option value="desc">DESC</option>
						<option value="asc">ASC</option>
					</select>
				</td>
			</tr>
			<tr>
				<td><?php echo JText::_('MAX_ARTICLE'); ?></td>
				<td>
					<input type="text" style="width:50px" value="10" name="limit" onchange="updateTag();"/>
				</td>
			</tr>
			<tr>
				<td>Start</td>
				<td>
					<input type="text" style="width:50px" value="0" name="start" onchange="updateTag();"/>
				</td>
			</tr>
			<tr>
				<td><?php echo JText::_('ACY_TEMPLATE'); ?></td>
				<td>
					<?php
					jimport('joomla.filesystem.folder');
					//Available templates
					$availableTemplates = array();
					$availableTemplates['table'] = 'table';
					if(is_dir(ACYMAILING_MEDIA.'plugins')){
						$templates = JFolder::files(ACYMAILING_MEDIA.'plugins', '.php$');
					}
					if(!empty($templates)){
						foreach($templates as $oneTemplate){
							$oneTemplate = str_replace('.php', '', $oneTemplate);
							$availableTemplates[] = JHTML::_('select.option', $oneTemplate, $oneTemplate);
						}
					}

					echo JHTML::_('select.genericlist', $availableTemplates, 'template', 'class="inputbox" size="1" style="width:120px;" onchange="updateTag();"');

					?>

				</td>
			</tr>
		</table>
	<?php
	}

	public function acymailing_replacetags(&$email, $send = true){
		return $this->replacetags($email);
	}

	public function acymailing_replaceusertags(&$email, &$user, $send = true){
		return $this->replacetags($email, $user);
	}

	private function replacetags(&$email, $user = null){
		$match = '#{loaddata:(.*)}#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything...
		if(!$found) return;

		//We will need the mailer class as well
		$mailerHelper = acymailing_get('helper.mailer');

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset($htmlreplace[$oneTag])) continue;

				//Is it a personal tag or a tag embed into another tag?
				if(strpos($oneTag, '[') || strpos($allresults[1][$i], '{')){
					//This is a personal tag and we don't have user... so it will be process later on
					if(empty($user)) continue;
					//Let's replace the data directly in the query then... it's a personal tag
					$toreplace = array();
					foreach($user as $oneProp => $oneVal){
						//That should never happen but well... just to make sure...
						if(empty($oneProp) || !is_string($oneProp)) continue;
						$toreplace['['.strtolower($oneProp).']'] = $oneVal;
					}
					$toreplace['[day]'] = '{day}';
					$toreplace['[month]'] = '{month}';
					$toreplace['[year]'] = '{year}';
					$toreplace['[time]'] = '{time}';
					$allresults[1][$i] = str_replace(array_keys($toreplace), $toreplace, $allresults[1][$i]);
				}

				$article = $this->_replaceContent($allresults, $i);
				$htmlreplace[$oneTag] = $article;
				$textreplace[$oneTag] = $mailerHelper->textVersion($article);
				$subjectreplace[$oneTag] = strip_tags($article);
			}
		}

		$email->body = str_replace(array_keys($htmlreplace), $htmlreplace, $email->body);
		$email->altbody = str_replace(array_keys($textreplace), $textreplace, $email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace), $subjectreplace, $email->subject);
	}

	private function _replaceContent(&$results, $i){
		//1 : Transform the tag properly...
		$arguments = explode('|', strip_tags($results[1][$i]));
		$tag = new stdClass();
		if(strpos($arguments[0], '.')){
			$tablePath = explode('.', $arguments[0]);
			$tag->table = '`'.acymailing_secureField($tablePath[0]).'`.'.acymailing_secureField($tablePath[1]);
		}else{
			$tag->table = acymailing_secureField($arguments[0]);
		}
		for($i = 1, $a = count($arguments); $i < $a; $i++){
			$args = explode(':', $arguments[$i]);
			if(isset($args[1])){
				$tag->{$args[0]} = $args[1];
			}else{
				$tag->{$args[0]} = true;
			}
		}

		if(empty($tag->template)){
			return 'Please specify a template';
		}

		if(empty($tag->fields)){
			return 'Please specify the selected fields ';
		}

		$fields = explode(',', trim($tag->fields, ' ,'));
		foreach($fields as $i => $oneField){
			$fields[$i] = trim($oneField);
			if(preg_match('|[^a-z0-9#_.-]|i', $fields[$i]) !== 0){
				return 'Field not secured : '.$fields[$i];
			}
		}
		if(count($fields) == 1 && !empty($tag->action) && in_array($tag->action, array('SUM'))){
			$query = 'SELECT '.strtoupper($tag->action).'(`'.implode('`,`', $fields).'`) FROM '.$tag->table.' as mytable ';
		}else{
			$query = 'SELECT `'.implode('`,`', $fields).'` FROM '.$tag->table.' as mytable ';
		}
		$where = array();
		//Just to load the acyquery class
		acymailing_get('class.filter');
		$queryObject = new acyQuery();
		for($a = 1; $a < 11; $a++){
			$tagvar = 'where'.$a;
			if(empty($tag->$tagvar)) continue;
			list($var, $ope, $val) = explode(',', $tag->$tagvar);
			$where[] = $queryObject->convertQuery('mytable', $var, $ope, $val);
		}
		if(!empty($where)){
			$query .= ' WHERE ('.implode(') AND (', $where).')';
		}

		if(!empty($tag->order)){
			list($orderby, $order) = explode(',', $tag->order);
			if(preg_match('#(delete|update|join|select)#i', $orderby) !== 0){
				return 'Condition not allowed : '.$orderby;
			}
			$order = acymailing_secureField(trim($order));
			$query .= ' ORDER BY '.trim($orderby).' '.$order;
		}

		$tag->start = empty($tag->start) ? 0 : intval($tag->start);
		$tag->limit = empty($tag->limit) ? 0 : intval($tag->limit);

		$db = JFactory::getDBO();
		$db->setQuery($query, $tag->start, $tag->limit);
		$elements = $db->loadObjectList();
		if($elements === null){
			return $db->getErrorMsg();
		}
		//No element found
		if(empty($elements)) return "";

		$templatePath = ACYMAILING_MEDIA.'plugins'.DS.trim(preg_replace('#[^a-z0-9_]#i', '', $tag->template)).'.php';

		$return = '';

		if(file_exists($templatePath)){
			if(empty($tag->nostructure)) $return = '<table border="0" cellpadding="0" cellspacing="0" width="100%">';
			foreach($elements as $element){
				if(empty($tag->nostructure)) $return .= '<tr><td class="acymailing_content">';
				ob_start();
				require($templatePath);
				$return .= ob_get_clean();
				if(empty($tag->nostructure)) $return .= '</td></tr>';
			}
			if(empty($tag->nostructure)) $return .= '</table>';
		}elseif($tag->template == 'table'){
			//Table display
			if(empty($tag->nostructure)) $return = '<table border="0" cellpadding="0" cellspacing="5">';
			if(empty($tag->noheader) && empty($tag->nostructure)) $return .= '<tr><th>'.implode('</th><th>', array_keys((array)$elements[0])).'</th></tr>';
			foreach($elements as $element){
				if(empty($tag->nostructure)) $return .= '<tr><td>';
				$return .= empty($tag->nostructure) ? implode('</td><td>', (array)$element) : implode(' ', (array)$element);
				if(empty($tag->nostructure)) $return .= '</td></tr>';
			}
			if(empty($tag->nostructure)) $return .= '</table>';
		}else{
			return 'Template not found : '.$templatePath;
		}


		return $return;
	}
}