<?php

class plgAcymailingusergroup extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'usergroup');
			$this->params = new JParameter( $plugin->params );
		}
	}

	function onAcyDisplayActions(&$type){
	 	$type['acyusergroup'] = JText::_('ACY_GROUP');
		if(!ACYMAILING_J16) $content = '<div id="action__num__acyusergroup">The usergroup plugin does not work with J1.5... It\'s time to update Joomla!</div>';
		else{
			$db = JFactory::getDBO();
			$db->setQuery('SELECT a.*, a.title as text, a.id as value FROM #__usergroups AS a ORDER BY a.lft ASC');
			$groups = $db->loadObjectList('id');
			$defaultVal = new stdClass();
			$defaultVal->level = 0;
			$defaultVal->text = '- - -';
			$defaultVal->value = 0;
			array_unshift($groups, $defaultVal);
			foreach($groups as $id => $group){
				if(empty($group->parent_id) || !isset($groups[$group->parent_id])) continue;
				$groups[$id]->level = intval(@$groups[$group->parent_id]->level) + 1;
				$groups[$id]->text = str_repeat('- - ',$groups[$id]->level).$groups[$id]->text;
			}

			$content = '<div id="action__num__acyusergroup">Remove users from the group : '.JHTML::_('select.genericlist',   $groups, "action[__num__][acyusergroup][remove]", 'class="inputbox" size="1"', 'value', 'text');
			$content .= '<br />Add users to the group : '.JHTML::_('select.genericlist',   $groups, "action[__num__][acyusergroup][add]", 'class="inputbox" size="1"', 'value', 'text').'</div>';
		}

		$status = array();
		$status[] = JHTML::_('select.option','0', JText::_('ENABLED'));
		$status[] = JHTML::_('select.option','1', JText::_('DISABLED'));

		$content .= '<div id="action__num__joomlauserstatus">Set users as '.JHTML::_('select.genericlist', $status, "action[__num__][joomlauserstatus][status]", 'class="inputbox" size="1"', 'value', 'text').'</div>';

	 	$type['joomlauserstatus'] = JText::_('Joomla user status');

	 	return $content;
	}

	function onAcyProcessAction_acyusergroup($cquery,$action,$num){
		$return = '';
		if(empty($action['remove']) && empty($action['add'])) return 'No option selected';

		$query = 'SELECT sub.userid FROM #__acymailing_subscriber AS sub ';

		if(!empty($cquery->join))
			$query .= ' JOIN '.implode(' JOIN ',$cquery->join);
		if(!empty($cquery->leftjoin))
			$query .= ' LEFT JOIN '.implode(' LEFT JOIN ',$cquery->leftjoin);
		if(!empty($cquery->where))
			$query .= ' WHERE ('.implode(') AND (',$cquery->where).')';
		$cquery->db->setQuery($query);
		$cquery->db->query();
		$userIds = acymailing_loadResultArray($cquery->db);
		if(empty($userIds)) return;

		if(!empty($action['remove'])){
			$query = 'DELETE FROM #__user_usergroup_map WHERE user_id IN ('.implode(', ', $userIds).') AND group_id = '.intval($action['remove']);
			$cquery->db->setQuery($query);
			$cquery->db->query();
			$nbAffected = $cquery->db->getAffectedRows();
			$return .= $nbAffected.' users removed from the chosen group<br />';
		}

		if(!empty($action['add'])){
			$query = 'INSERT IGNORE INTO #__user_usergroup_map (user_id, group_id) SELECT userid, '.intval($action['add']).' FROM #__acymailing_subscriber WHERE userid IN('.implode(', ', $userIds).') ';
			$cquery->db->setQuery($query);
			$cquery->db->query();
			$nbAffected = $cquery->db->getAffectedRows();
			$return .= $nbAffected.' users added to the chosen group<br />';
		}

		return $return;
	}

	function onAcyProcessAction_joomlauserstatus($cquery,$action,$num){
		$action['status'] = intval($action['status']);

		$query = 'SELECT sub.userid FROM #__acymailing_subscriber AS sub ';

		if(!empty($cquery->join)) $query .= ' JOIN '.implode(' JOIN ',$cquery->join);
		if(!empty($cquery->leftjoin)) $query .= ' LEFT JOIN '.implode(' LEFT JOIN ',$cquery->leftjoin);
		$cquery->where['joomlauserstatus'] = 'sub.userid != 0';
		if(!empty($cquery->where)) $query .= ' WHERE ('.implode(') AND (',$cquery->where).')';
		unset($cquery->where['joomlauserstatus']);
		$cquery->db->setQuery($query);
		$cquery->db->query();
		$userIds = acymailing_loadResultArray($cquery->db);
		if(empty($userIds)) return;

		$cquery->db->setQuery('UPDATE #__users SET `block` = '.$action['status'].' WHERE `id` IN ('.implode(',', $userIds).') AND `block` != '.$action['status']);
		$cquery->db->query();
		$nbAffected = $cquery->db->getAffectedRows();
		if(empty($action['status'])) return $nbAffected.' users enabled.';
		else return $nbAffected.' users disabled.';
	}
}//endclass