<?php
/**
 * @copyright	Copyright (C) 2009-2011 ACYBA SAS - All rights reserved.
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgSearchAcymailingsearch extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('search', 'acymailingsearch');
			jimport('joomla.html.parameter');
			$this->params = new acyParameter( $plugin->params );
		}
	}

	function onContentSearchAreas(){
		return $this->onSearchAreas();
	}

	function onContentSearch($text, $phrase='', $ordering='', $areas=null){
		return $this->onSearch($text,$phrase,$ordering, $areas);
	}

	function &onSearchAreas(){
		$areas = array('acymailingsearch' => 'Newsletters');
		return $areas;
	}

	function onSearch($text, $phrase = '', $ordering = '', $areas = null){
		if(!include_once(rtrim(JPATH_ADMINISTRATOR,DIRECTORY_SEPARATOR).DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_acymailing'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'helper.php')) return array();

		$db	= JFactory::getDBO();

		if(is_array($areas) && !array_intersect($areas, array_keys($this->onSearchAreas())) ) return array();

	 	$limit = $this->params->def( 'search_limit', 50 );
		$text = trim($text);
		if($text == '') return array();

		$wheres = array();
		switch ($phrase){
			case 'exact':
				$text		= $db->Quote( '%'.$db->getEscaped( $text, true ).'%', false );
				$wheres2 	= array();
				$wheres2[] 	= 'a.subject LIKE '.$text;
				$wheres2[] 	= 'a.body LIKE '.$text;
				$wheres2[] 	= 'a.altbody LIKE '.$text;
				$where 		= '(' . implode( ') OR (', $wheres2 ) . ')';
				break;

			case 'all':
			case 'any':
			default:
				$words = explode( ' ', $text );
				$wheres = array();
				foreach ($words as $word) {
					$word		= $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
					$wheres2 	= array();
					$wheres2[] 	= 'a.subject LIKE '.$word;
					$wheres2[] 	= 'a.body LIKE '.$word;
					$wheres2[] 	= 'a.altbody LIKE '.$word;
					$wheres[] 	= implode( ' OR ', $wheres2 );
				}
				$where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
				break;
		}

		switch ($ordering){
			case 'oldest':
				$order = 'a.created ASC';
				break;
				case 'category':
				$order = 'b.ordering ASC';
				break;
			case 'alpha':
				$order = 'a.subject ASC';
				break;

			default:
				$order = 'a.created DESC';
				break;
		}

		// Get lists the user can see (enterprise version)
		$listAuthorized = '';
		if(acymailing_level(3)){
			$listsClass = acymailing_get('class.list');
			$allLists = $listsClass->getLists('listid');
			$allLists = $listsClass->onlyAllowedLists($allLists);
			foreach($allLists as $key => $oneList){
				$listAuthorized .= $key . ',';
			}
			if(strlen($listAuthorized) > 0) $listAuthorized = ' AND b.listid IN (' . substr($listAuthorized, 0, strlen($listAuthorized) - 1) . ') ';
		}

		//First we need to
		// search articles
		$query = 'SELECT "2" AS browsernav, a.*, b.listid, b.name as section, b.alias as listalias FROM `#__acymailing_list` as b ';
		$query .= 'LEFT JOIN `#__acymailing_listmail` as c ON b.listid = c.listid ';
		$query .= 'LEFT JOIN `#__acymailing_mail` as a ON c.mailid = a.mailid ';
		$query .= ' WHERE ( '.$where.' ) AND b.published = 1 AND b.visible = 1 AND a.type="news" AND a.published = 1 AND a.visible = 1 ' . $listAuthorized . ' GROUP BY a.mailid ORDER BY '. $order;
		$db->setQuery( $query, 0, $limit );
		$newsletters = $db->loadObjectList();

		if(empty($newsletters)) return array();

		$return = array();

		foreach($newsletters as $key => $item){
			$newsletters[$key]->href = acymailing_completeLink('archive&task=view&listid='.$item->listid.'-'.$item->listalias.'&mailid='.$item->mailid.'-'.$item->alias);
			$newsletters[$key]->title = $newsletters[$key]->subject;
			if(version_compare(JVERSION,'1.6.0','>=')){
				$newsletters[$key]->created = acymailing_getDate($item->created,'%Y-%m-%d %H:%M:%S');
			}else{
				$newsletters[$key]->created = acymailing_getDate($item->created,1);
			}
			$newsletters[$key]->text = ($item->html && !empty($item->body)) ? $item->body : nl2br($item->altbody);
			if(searchHelper::checkNoHTML($newsletters[$key], $text, array('title', 'text'))) {
				$return[] = $newsletters[$key];
			}
		}
		return $return;
	}
}