<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
 
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

// check for component
$file = JPATH_ROOT . DIRECTORY_SEPARATOR . 'administrator' . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_autotweet' . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'autotweetbase.php';
if(!file_exists($file)) return;

//We need to load the autotweetbase.
require_once($file);

/**
 * AcyMailing extension plugin for AutoTweet.
 *
	*/
class plgSystemAutotweetAcyMailing extends plgAutotweetBase
{
	function __construct( &$subject, $params ){
		parent::__construct( $subject, $params );
	}

	/**
	 * auto-tweet Acy Newsletter when they are sent...
	 */
	function onAcySendNewsletter($mailid){
		//We just sent a Newsletter with Acy...
		//Let's publish it on Facebook/twitter...

		$lists = $this->params->get('lists');
		if(!empty($lists) && strtolower($lists) != 'all'){
			if(strtolower($lists) == 'none') return;
			$lists = explode(',', $lists);
			JArrayHelper::toInteger($lists);

			$listmailClass = acymailing_get('class.listmail');
			$maillists = $listmailClass->getLists($mailid);

			$selected = false;
			foreach($maillists as $oneList){
				if(in_array($oneList->listid, $lists)) $selected = true;
			}
			if(!$selected) return;
		}

		$mailClass = acymailing_get('class.mail');
		$newsletter = $mailClass->get($mailid);

		$url = acymailing_frontendLink('index.php?option=com_acymailing&ctrl=archive&task=view&mailid='.$newsletter->mailid.'-'.$newsletter->alias);
		//Sorry but no picture yet.
		$image_url = '';
		//ID, date, title, subject, 0?, url, image, json object
		$native_object = json_encode($newsletter);
		$date = date('Y-m-d',$newsletter->senddate);
		if($date == '1970-01-01') $date = JFactory::getDate()->toSql();
		$this->postStatusMessage($mailid, $date, $newsletter->subject , 0, $url, $image_url, $native_object);
	}

	function getData($mailid, $typeinfo){
		// typeinfo is not used (one message type only)

		$data = array ('is_valid' => false);

		$file = rtrim(JPATH_ADMINISTRATOR,DIRECTORY_SEPARATOR).DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_acymailing'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'helper.php';
		if(!file_exists($file)) return $data;
		include_once($file);

		$mailClass = acymailing_get('helper.mailer');
		$mailClass->loadedToSend = false;
		$newsletter = $mailClass->load($mailid);
		if (empty($mailid) || empty($newsletter->mailid)) return $data;

		//Load the lists attached to the Newsletter...
		$listMailClass = acymailing_get('class.listmail');
		$lists = $listMailClass->getReceivers($newsletter->mailid,false);
		$catids = array();
		foreach($lists as $oneList){
			$catids[] = $oneList->listid;
		}

		$url = acymailing_frontendLink('index.php?option=com_acymailing&ctrl=archive&task=view&mailid='.$newsletter->mailid.'-'.$newsletter->alias);
		$image_url = '';
		$author = $newsletter->username;

		// use title or text as twitter message
		$title = $newsletter->subject;
		$text = $title;

		$hashtags = '';


		// return values
		$data = array (
			'title'		=> $title,
			'text'		=> $text,
			'hashtags'	=> $hashtags,
			'url'		=> $url, // allready done when msg is inserted in queue
			'image_url'	=> $image_url, // allready done when msg is inserted in queue
			'fulltext'	=> $newsletter->body,
			'catids'	=> $catids,
			'author'	=> $author,
			'is_valid'	=> true
		);

		return $data;
	}

	public function getExtendedData($id, $typeinfo, &$native_object){
		return $this->getData($id, $typeinfo);
	}
}